*CMZ :          05/07/96  11.32.14  by  Hartwig Albrecht
*CMZ :  2.01/03 07/02/96  14.22.24  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  19.25.45  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   05/10/95

      SUBROUTINE ALFRIT (LRPART)

************************************************************************
*
* Description: generate one FRITIOF event
*
* Called from: ALEVNT
*
* External references: LUND, PYTHIA
*
* Arguments in/out description
* LRPART    in     required particle
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "jets/LUJETS.fi"
#include "pyth/PYSUBS.fi"
#include "pyth/PYPARS.fi"

      INTEGER NSRC, I, LRPART

#include "arte/Arte.ff"

C loop over generated events until requested particle found

      CALL ALSAVE
      MSEL = 1

      DO 20 NSRC = 1, 1000

        IF (NSRC .EQ. 20)  CALL MEMESC (71345, 10, ILARGEST,
     +    'ALFRIT: more than 20 searches for the requested particle')

        IF (TARGETMAT .EQ. 'N ')  CALL MEERRC (132654,
     +    'ALFRIT: Fritiof with neutron target not supported')

C FRITIOF !

        CALL FREVENT ('FIXT', 'P', TARGETMAT, HERAEBEAM)

C search for the requested particle

        IF (LRPART .EQ. 0)  GO TO 30
        DO 10 I = 1, N
          IF (K(I,2) .EQ. LRPART)  GO TO 30
 10     CONTINUE

 20   CONTINUE

      CALL MEMESC (325476, 10, 100,
     +  'ALFRIT: more than 1000 searches for the requested particle')
      GO TO 80

C fill Arte tables

 30   CALL ALMCIN
      CALL ALFSTO
 80   CALL ALREST

      END

************************************************************************
* End of ALFRIT
************************************************************************
