>NAME ATKUIP

>MENU /ARTE
>GUIDANCE
Program control.

>COMMAND RUN
>GUIDANCE
Start / continue the program.
Loop over events.
.
Special action: the data definition task starts if a DDEFINITION
command (q.v.) has been given before.
>ACTION KAEXEC
>PARAMETER
+
NEVENTS 'number of events' I D=0

>COMMAND GEAN
>GUIDANCE
HERA-B detector simulation on (default) / off (initial setting).
>ACTION KAGEAN
>PARAMETER
+
SWITCH 'on/off' C D='on'

>COMMAND MIMP
>GUIDANCE
Impact point calculation in Geant on (default; initial setting) / off.
>ACTION KAMIMP
>PARAMETER
+
SWITCH 'on/off' C D='on'

>Command GSEL
>Guidance
Select superlayers or groups of superlayers for digitization etc.
 Groups are:
 SIDE  all sensitive detectors in vertex detector region
 MAGN  all sensitive detectors in magnet field region
 PATT  all sensitive detectors in pattern recognition region
 FLTR  all sensitive detectors in first level trigger
>Action KAGSEL
>Parameter
SEL 'names of selected superlayers' C VARARG LOOP

>COMMAND TIMELIMIT
>GUIDANCE
Estimated time for program termination.
Example:
 TIMELIMIT 5
Batch job stops event processing when less than 5 seconds are left.
>ACTION KATIME
>PARAMETER
+
TIME 'time in sec' R D=5.

>Menu /GRAPHICS
>Guidance
Event display

>Command PRISM
>Guidance
Initialize event display; declare the name of the metafile.
Example:
 PRISM metaph.ps        name of the metafile is explicitely given.
 PRISM                  standard name consisting of program name, process id.
>Action KAPRIS
>PARAMETER
+
METANAME 'name of the metafile' C D=' '
METATYPE 'type of metafile (e.g. -112: landscape)' I D=-112
KWTYPE 'type of graphics workstation (e.g. 0 for query)' I D=2

>Command METAFILE
>Guidance
Activate/deactivate metafile.
Example:
 META                (on is default)
 META ON
 METAFILE OFF
>Action KAMETA
>PARAMETER
+
ONOFF 'on or off' C D='on'

>Command CLEAR
>Guidance
clears event display window.
>Action KACLEA

>COMMAND HBOOK
>GUIDANCE
Declare the histogram output file.
For the time being, only one histogram file is forseen;
the name of the top directory is ARTE.
 Options:  -N  create new file
           -U  update existing file
           -O  overwrite old file (corresponds to option ' ' in HROPEN)
           -X  exchange format (machine independent)
Example:
 HBOOK myhist.hbook -U
>ACTION KAHBOO
>PARAMETER
+
NAME 'file name' C D=' '
OPTION 'options NUOX' C D=' '

>MENU /LUND
>GUIDANCE
Lund event generator: Jetset; Pythia; Fritiof.

>COMMAND LUND
>GUIDANCE
Initialize Lund event generator: Jetset; Pythia; Fritiof.
>ACTION KALUND
>PARAMETER
PHYS1 'bb/cc/inelastic/Jpsi' C D=' '
+
PHYS2 'inelastic' C D=' '
MIX 'number of inelastic events to be mixed to cc/bb' R D=4.
OPTION 'requested particle' C D=' '

>Command PHASESPACE
>Guidance
Generates phase space particles
>Action KAPHSP
>Parameter
CPART 'Arte name of the wanted particle' C D='mu-'
PMIN  'minimal momentum' R D=10.
PMAX  'maximal momentum' r D=10.
THMIN 'minimal polar angle' R D=0.010
THMAX 'maximal polar angle' R D=0.250
PHIMIN 'minimal azimut angle' R D=0.
PHIMAX 'maximal azimut angle' R D=6.283185307

>COMMAND SEEDLUND
>GUIDANCE
Set the seed for the Lund random number generator.
The generator is RANECU (CERNLIB V114) which needs exactly 2 positive
integer  numbers as seed. Arte generates an automatical seed if
both numbers or the whole SEEDLUND command are omitted.
>ACTION KASEED
>PARAMETER
+
SEED1 '1st random seed' I D=0
SEED2 '2nd random seed' I D=0

>COMMAND BEGdecay
>GUIDANCE
Begin of the decay table for a specific particle.
>ACTION KABDEC
>PARAMETER
NAME 'particle name' C

>COMMAND DECAY
>GUIDANCE
Describe one decay channel for a specific particle.
>ACTION KADECA
>PARAMETER
MDME1 'switch' I
MDME2 'matrix element' I
BRAT 'branching ratio' R
+
NAME1 'particle name' C D=' '
NAME2 'particle name' C D=' '
NAME3 'particle name' C D=' '
NAME4 'particle name' C D=' '
NAME5 'particle name' C D=' '

>COMMAND ENDdecay
>GUIDANCE
End of the decay table for a specific particle.
>ACTION KAEDEC
>PARAMETER
NAME 'particle name' C

>Command channel
>Parameters
mother 'Particle with special decay' C D=' '
nchannels 'Number of Channels' I D=0
mixing '=1 if mother is a mixing meson' I D=0
>Guidance
Special treatment of the decay chain of LUNDRPART becomes important
in the case of neutral mesons, which mix.
The decay tables should be given as valid for the anti-meson.
Reading from top of the decay table, *nchannels* channels will belong to the 
decay of *mother* (and will be switched on if initially off). The rest
of the channels will be switched off.
For the anti-meson, the decay tables will be kept in their initial forms.
>Action KACHAN

>COMMAND EBEAM
>GUIDANCE
Set the energy of the HERA proton beam [GeV].
>ACTION KAEBEA
>PARAMETER
EBEAM 'beam energy' R D=820.

>COMMAND TARGET
>GUIDANCE
Define target material.
>ACTION KATARG
>PARAMETER
MAT 'target material' C D='AL'

>COMMAND LUGIVE
>GUIDANCE
Set the value of variables in LUJETS of LUDAT1...4 of the Lund program.
Equivalent to the Fortran statement CALL LUGIVE ('LUVAR=VALUE')
>ACTION KALUGI
>PARAMETER
ASSIGN 'assignment statement enclosed in apostrophes' C D=' '

>COMMAND EVENTNO
>GUIDANCE
Set event/run(/experiment) number for MC events.
The experiment number must be negative; it indicates the lab
where the events have been produced (see InstId in print-out header).
 ...
>ACTION KAEVEN
>PARAMETER
EVENT 'event number' I D=1
RUN 'run number' I D=0
+
EXP 'experiment number' I D=0

>MENU /LIST
>GUIDANCE
List, print, type, etc.

>HELP_ITEM DESTINATION
>GUIDANCE
Declaration the print-out destination of list/print commands.
It can be given by the options -t (terminal), -p (printer), -l (log file)
or a combination (e.g.: -pl). In batch jobs: -t is converted to -p; -tp
to -p.

>COMMAND LTITLE
>GUIDANCE
List program title.
.
>ACTION KALTIT
>PARAMETER
+
OPTION 'print destination' C D='tp'

>COMMAND LIOSTATUS
>GUIDANCE
List name and status of input/output files.
(Note: LIO prints the present knowlegde on the files;
the INQUIRE command updates the information for opened files.)
.
The parameter (logical unit number / symbolic name) can be omitted:
loop over all logical units known to the system. Examples:
 LIO
 LIO 3
 LIO prnt
 LIO 3 -L

Output description:
 LUN: logical unit number (1...99)
 SYMB: symbolic name (known only inside the program)
 IOS: input-output-status as determined by OPEN etc.
      -1  IOS unknown;
       0  ok;
      >0  error.
       r  reserved; file name may not be known.
       n  named: file name known.
       o  OPENed
       w  rewound
       e  end-of-file condition: File should be closed but probably is not.
       c  CLOSEed
       f  formatted
       b  unformatted (binary)
 Zebra flags:
       I  input
       O  output
       A  alpha format
       X  exchange format
 RECL: record length (direct access); 0: sequential
 NREC: number of records read/written
 NAME: file name
>ACTION KALIOS
>PARAMETER
+
LUNSYM 'logical unit number or symbolic name' C D='0'
OPTION 'print destination' C D='tp'

>COMMAND LTABLES
>GUIDANCE
List names, hierarchy, and iostatus of tables and relations.
 Examples:
 LTABLES       list information for all banks
 LTABLES MCHD  list information for bank EVHD only.
Only those tables can be accessed which are established
by a CALL MMTABL (...,'NAME',...) in the program.
 Description of the print-output:
 Link   link number
 Name   table name
 Div    Zebra division (evnt / const)
 Head   Header table for I/O
 Sup1   1st superior table
 Sup2   2nd superior table (only for relations)
 Input  # read from input files
 Output # written to output files
 io     input:   table will be accepted on input files if not explicitely
                 disabled for specific files.
                 Keyword <input> missing: table will be skipped on input.
        /input:  table is flagged for input but one of the superior tables
                 is not: discarded on input files.
        output, /output: corresponding to input, /input.
        All other keyword indicate symbolic names.
        File names preceded by a slash: table is flagged for I/O but one
                 of the superior tables is not: no I/O.
        The characters < (for input) and/or > (for output) are
        appended to symbolic names in case this status is known.
 sub    names of subordinate tables
>ACTION KALTAB
>PARAMETER
+
NAME 'table name' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LZEBRA
>GUIDANCE
List content of Zebra array Q/IQ or of a specified table.
.
Examples
 LZEBRA 10000 30           list 30 words, starting at word 10000
 LZEBRA 10000              list 20 words (default), starting at word 10000
 LZEBRA MVER 40            list 40 words, starting at table MVER
 LZEBRA MVER 0             list the whole table MVER
>ACTION KALZEB
>PARAMETER
LOCNAME 'location within array Q/IQ or table name' C D=' '
+
NWORDS 'nwords' I D=20
OPTION 'print destination' C D='tp'

>COMMAND LROW
>GUIDANCE
List one row of a table / a whole table.
>ACTION KALROW
>PARAMETER
NAME 'table name' C D=' '
+
NROW 'nrow / 0 -> all rows' I D=1
NCOLUMNS 'ncolumns / 0 -> all cols' I D=0
OPTION 'print destination' C D='tp'

>COMMAND LMESSAGE
>GUIDANCE
List errors, warning, messages.
.
The message text appears as in the 1st occurrence of the message;
later modifications to the message are not taken into account.
>ACTION KALMES
>PARAMETER
+
OPTION 'print destination' C D='tp'

>COMMAND LEVHD
>GUIDANCE
List event header table EVHD.
>ACTION KALEVH
>PARAMETER
+
OPTION 'print destination' C D='tp'

>COMMAND LMCTRUTH
>GUIDANCE
List Monte-Carlo truth: tables MTRA and MVER
.
 Examples:
   LMCT        list all particles and vertices
   LMCT 57     list particle 57 in table MTRA and its kin
   lMCT B+     list all B+ mesons and their kin
>ACTION KALMCT
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LMIMP
>GUIDANCE
List Monte Carlo Impact Points (MIMP)
Examples:
 LMIMP 0       list all MIMPs (lengthy!)
 LMIMP 4712    list MIMP 4712
 LMIMP -15     list MIMPs belonging to MC track (MTRA) 15.
>ACTION KALMIM
>PARAMETER
+
MIMP 'mimp / -mtra' I D=1
OPTION 'print destination' C D='tp'

>COMMAND LTOPP
>GUIDANCE
List ARTE Table of Particle Properties.
.
 Examples:
   LTOPP       list the properties all particles
   LTOPP 57    list particle 57 (whatever it is)
   ltopp PI+   list the properties of the pi+
>ACTION KALTOP
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LUTOPP
>GUIDANCE
List Lund Table of Particle Properties.
Lund and Arte tables should have the same content after initialization .
.
 Examples:
   LUTOPP       list the properties all particles
   LUTOPP 57    list particle 57 (whatever it is)
   lutopp PI+   list the properties of the pi+
>ACTION KALUTO
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LDECAY
>GUIDANCE
List ARTE Particle decay table.
>ACTION KALDEC
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LUDECAY
>GUIDANCE
List Lund Particle decay table.
Lund and Arte tables should have the same content after initialization .
>ACTION KALUDE
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LLUND
>GUIDANCE
List an event created by Lund and stored in COMMON /LUJETS/
(SUBROUTINE LULIST).
>ACTION KALLUN
>PARAMETER
+
MLIST 'what to be listed' I D=1
OPTION 'print destination' C D='tp'

>COMMAND LDdefin
>GUIDANCE
list the data definition table DDEF.
The listing is written in the format of Data Definition commands
and may serve as input for the next job.
>ACTION KALDDE
>PARAMETER
+
OPTION 'print destination' C D='tp'

>MENU /IO
>GUIDANCE
Input/output control

>COMMAND IOFILE
>GUIDANCE
Associate a file to a logical unit or symbolic name.
This command does NOT perform any action like OPEN!
A scratch file which will automatically be deleted when the program
stops is indicated by typing a blank space ' ' instead of a file
name.
.
Several file commands for the same logical unit / symbolic name
are allowed (= concatenation).
This indicates that several files will be read/written in
sequential order.
.
An unused (= not reserved; see DECLARE command) unit number will be chosen
if (i) the symbolic name
rather than a unit number is given and (ii) the unit number is
not yet declared by a preceding DECLARE command.
.
The options are effective for Zebra I/O
only. Interesting options are -I (input only), -O (output only), and -IO
(input and output allowed). -L specifies the machine-independent format
and should be used everywhere. -X means 
the so-called exchange format which is not really machine-independent.
-N corresponds to native format (machine-dependent).
Almost every character and some digits
have their particular meaning: read the 5 or 6 pages of the FZFILE
description in the Zebra manual. Formatted Zebra I/O is
requested by -A which stands for Alfa (most likely, this means Alpha).
>ACTION KAIOFI
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C
+
FILE   'file name' C D=' '
MAX    'output: maximum file size (Mbyte)' R D=0.
OPTION 'Zebra I/O options' C D=' '

>COMMAND IOMIX
>GUIDANCE
Mix events from up to four event input files.
.
Number of events N > 0: Poisson distribution; N < 0: delta
distribution at |N|.
Examples:
 IOMIX -2         Mix exactly two events from file EVIN1
 IOMIX -1 5       Mix 1 event from EVIN1 and N events from file EVIN2
                  (N = Poisson distributed; mean = 5)
 IOMIX -1 3 -1 5  use all 4 event input files EVIN1 ... EVIN4
 IOMIX 0          disable mixPHYS2 'inelastic' c D=' 'ing
>ACTION KAIOMI
>PARAMETER
NEV1 'events from evin1' R D=0
+
NEV2 'events from evin2' R D=0
NEV3 'events from evin3' R D=0
NEV4 'events from evin4' R D=0

>COMMAND IOFARM
>GUIDANCE
Route event input/output to the specific farm io.
>ACTION KAIOFA
>PARAMETER
+
INOUT1 'input or output' C D=' '
INOUT2 'input or output' C D=' '

>COMMAND IOTABLE
>GUIDANCE
Modify the input/output status of a table.
This command enables or disables I/O on specific files or on all files.
The initial I/O settings for each table and their hierachy (superior and
subordinate tables) are provided in the program. The full tree of
subordinate tables is affected by changing the status of their superior
table. Subordinate tables can only be read or written if their superior
tables are read or written from/to the same file.
.
The I/O files are denoted by their symbolic names. A slash (/)
preceding the name means disable.
The symbolic names INPUT and OUTPUT stand for the set of all input or
output files, respectively, and not for individual files.
Examples (TNAM stands for an arbitrary table name, OUT1 for a file):
.
 IOTAB OUT1 TNAM        Table TNAM is marked for output on the file
                        with the symbolic name OUT1 (Let us assume that
                        OUT1 is an output and not an input file; this
                        can be declared in the command FILE or,
                        at latest, when you read or write on/to
                        this file).
                        This option may be overruled by the option
                        /OUTPUT (see below).
                        Subordinate tables are accepted or not according
                        to their own I/O status.
 IOTAB /OUT1 TNAM       Output to OUT1 is disabled for table TNAM and for
                        ALL SUBORDINATE (!) tables. A subsequent command ...
 IOTAB OUT1 TNAM        ... enables output for OUT1 itself and, for all
                        subordinate tables, it reestablishes the previous
                        status with respect to OUT1.
 IOTAB 'OUT1 /OUT2 TNAM' Several names can be enclosed in '...'.
 IOTAB INPUT  TNAM      The table TNAM will be accepted on any input file
                        if not explicitely disabled for a specific file.
 IOTAB /INPUT  TNAM     The table TNAM and ALL SUBORDINATE TABLES (!) will
                        be skipped ON ALL (!) input files. This is a
                        very harsh operation which overrules the
                        options for all individual input files and
                        for all subordinate tables... but it can easily
                        withdrawn by typing IOTABLE TNAM INPUT.
 Correspondingly:
 IOTAB OUTPUT TNAM
 IOTAB /OUTPUT TNAM

>ACTION KAIOTA
>PARAMETER
IOS  'input,output (/means not)' C
NAME 'table name' C

>COMMAND DECLARE
>GUIDANCE
Declare a logical unit number to be reserved and/or
declare its symbolic name.
.
The symbolic name (for IBM dinosaurs: DDNAME) is a
specification if logical I/O streams and not the name of the files
themselves. In almost all commands you have the choice
to specify files either by their unit
number or by their symbolic name - the latter one is
easier to remember.
.
A reserved unit number will not be used by ARTE until explicitely
required by the user.  Necessary, e.g., if the unit number is used
by an auxiliar program system.
 Example:
 DECLARE 90
 A range of units can be reserved:
 DECLARE 90 99
 If only one unit number is specified (i.e. not for ranges of units),
 the symbolic name can be specified as 2nd parameter:
 DECLARE 7 logf
 The 3rd parameter (optional) may contain some comment:
 DECLARE 90 99 reserved
 DECLARE 90 XYZ 'used by program package XYZ'
>ACTION KADECL
>PARAMETER
LUN 'logical unit number' I R=1:99
+
LUNSYM 'logical unit number (range) or symbolic name' C D=' '
FILE   'file name or comment (optional)' C D=' '

>COMMAND OPEN
>GUIDANCE
Open file.
For concatenated files (see FILE command), this acts upon the
first file which has not yet been opened.
.
The file name(s) has(have) to be declared by a preceding
IOFILE command. For a sequential file, the 2nd parameter
(RECLENGTH) has to be omitted or set to 0.
 Options: X  program stops if open not successful (batch);
             continue or stop in interactive sessions.
          B  binary (unformatted)
          F  formatted; 'F' and 'B' are mutually exlusive
          N  new: file must not yet exist
          O  old: file must exist
          ON (or neither N nor O): file may or may not exist
          AO append to an existing file
          A  append (if file exists) or create new file (if not)
Examples (note that only file names are case-sensitive):
 FILE SCRATCH
 OPEN SCRATCH
 file 66 direct.access
 OPEN   66 1024 -N
 DECLARE  77 FORT77
 file     77 uvw
 file   fort77 xyz
 open   FORT77 -o ... opens uvw
 CLOSE      77
 open       77 -O ... opens xyz
 close  FORT77
 open 77          ... warning (no more files)

>ACTION KAOPEN
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C
+
RECLENGTH 'record length for direct access data' I D=0
OPTION 'option (combination of XBFONA)' C OPTION D=' '

>COMMAND CLOSE
>GUIDANCE
Close file.
A 2nd CLOSE goes forward to the next file in a concatenation chain
(if there is any).
>ACTION KACLOS
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C

>COMMAND SKIP
>GUIDANCE
Skip records on input files.
On event input files: skip event records. All other types of
records will be accepted.
>ACTION KASKIP
>PARAMETER
+
NSKIP 'number of records to be skipped' I D=1
LUNSYM 'logical unit number (range) or symbolic name' C D='EVIN1'

>COMMAND REWIND
>GUIDANCE
Rewind file; go back to a previous file.
.
The 1st REWIND rewinds to the 1st record on a file. A 2nd REWIND
and all following ones go back to the previous file in a concatenation
chain (if there is any).
>ACTION KAREWI
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C

>COMMAND INQUIRE
>GUIDANCE
Inquire file status.
If the file is OPEN: the information on the file is updated.
If the file is not OPEN: same action as LIOSTATUS (q.v.).
.
The logical unit number or symbolic name is required. Examples:
 INQUIRE 3
 INQUIRE prnt -p
>ACTION KAINQU
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C D=' '
+
OPTION 'print destination' C D='tp'

>MENU /CONSTANTS
>GUIDANCE
Particle properties etc.

>COMMAND ToPP
>GUIDANCE
Extend / modify Table of Particle Properties.
>ACTION KATOPP
>PARAMETER
NAME 'particle name' C
ANTI 'name of anti-particle' C
+
MASS 'particle mass' R D=-999
CHARGE 'particle charge' I D=-999
COLOUR 'colour' I D=-999
DECAY 'decay flag' I D=-999
WIDTH 'particle width' R D=-999.
TRUNC 'truncate Breit-Wigner' R D=-999.
LUND 'Lund code' I D=-999
GEANT 'Geant code' I D=-999
GEANTA 'Geant code for the antiparticle' I D=-999

>MENU /MM
>GUIDANCE
ARTE memory management system (based on Zebra).

>COMMAND MMREAD
>GUIDANCE
Read one record from a sequential Zebra file.
The event input/output files are taboo!
>ACTION KAMMRE
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C

>COMMAND MMWRITE
>GUIDANCE
Write one record to a sequential Zebra file.
The event input/output files are taboo!
>ACTION KAMMWR
>PARAMETER
LOGSYM 'logical unit number or symbolic name' C
TABLE  'table name' C

>COMMAND MMDROP
>GUIDANCE
Drop an ARTE table.
>ACTION KAMMDR
>PARAMETER
TABLE  'table name' C

>MENU /Ddefinition
>GUIDANCE
Data definition

>COMMAND Ddinit
>GUIDANCE
Must precede any other data definition command.
Modifying the data definition has no effect for the present job
but only for future ones!
.
Every CMZ deck containing DD commands must start with DDINIT.
A job executing the DDINIT command is not usable for normal event processing:
a subsequent RUN command starts doing all the DD buisiness rather than
to loop over events.
.
Note: using the full ARTE program for the data definition task
is a quick and dirty solution. It would be by far more elegant
to write a small, dedicated program but ... (any volunteer ?).
>ACTION KADINI

>COMMAND Dtable
>GUIDANCE
Describe a table.
.
Presently available Zebra divisions are:
 C  Constant division: dropping of this table is under user control
 E  Event division: automatic fast dropping ('MQWIPE') after
    event processing.
>ACTION KADTAB
>PARAMETER
NAME 'table name' C
EXT  'extension when booking space' I D=0
DIVISION 'Zebra division' C
+
TEXT 'table description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Dmenu
>GUIDANCE
Describe a menu group.
Two purposes:
 (i)  Organize the help text in menu groups (not that the help
      items are not necessarily sorted alphabetically);
 (ii) Make sequences +SEQ consisting of all members of a menu.
Menus are not at all related to the hierarchy of tables
(command Dsub_to) which controls the I/O behaviour of a table.
.
Menus are established already by the parameter
-menu in Dtable etc. commands.
The Dmenu command supplies only a description of the menu
and, if desired, a superior menu (up to 4 levels of the menu
hierarchy are allowed).
>ACTION KADMEN
>PARAMETER
+
MNAME 'menu name' C D=' '
TEXT 'menu description' C D=' '
OPTION 'superior menu' C D=' '

>COMMAND Dattrib
>GUIDANCE
Definition of an attribute of a table.
>ACTION KADATT
>PARAMETER
NAME 'attribute name' C
FORM 'attribute format (I, F, ...)' C D=I
DIM 'attribute dimension' I D=0
TEXT 'attribute description' C D=' '

>COMMAND Drelone
>GUIDANCE
1st part of a one/one or one/many relation.
The 2nd part is given by a Dinvone or Dinvmany command.
Relations are symmetric; the difference between DRELxyz and
DINVxyz is that DRELxyz bears the information on Zebra division and
menu whereas DINVxyz does not.
.
Presently available Zebra divisions are:
 C  Constant division: dropping of this table is under user control
 E  Event division: automatic fast dropping ('MQWIPE') after every
    event processing.
>ACTION KADRE1
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
DIVISION 'Zebra division' C
+
TEXT 'description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Drelmany
>GUIDANCE
1st part of a many/many relation.
The 2nd part is given by a Dinvmany command.
Relations are symmetric; the difference between DRELxyz and
DINVxyz is that DRELxyz bears the information on Zebra division and
menu whereas DINVxyz does not.
.
Presently available Zebra divisions are:
 C  Constant division: dropping of this table is under user control
 E  Event division: automatic fast dropping ('MQWIPE') after every
    event processing.
>ACTION KADREM
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
DIVISION 'Zebra division' C
+
TEXT 'description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Dinvone
>GUIDANCE
2nd part of a one/one relation.
The 1st part is given by a Drelone command.
Relations are symmetric; the difference between DRELxyz and
DINVxyz is that DRELxyz bears the information on Zebra division and
menu whereas DINVxyz does not.
>ACTION KADIN1
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
+
TEXT 'description' C D=' '

>COMMAND Dinvmany
>GUIDANCE
2nd part of a one/many or many/many relation.
The 1st part is given by a Drelone command.
Relations are symmetric; the difference between DRELxyz and
DINVxyz is that DRELxyz bears the information on Zebra division and
menu whereas DINVxyz does not.
>ACTION KADINM
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
+
TEXT 'description' C D=' '

>COMMAND Dfile
>GUIDANCE
Declare default IO files for tables and relations.
The defaults can be modified by the IOTABLE command in every job.
Syntax: see IOTABLE.
>ACTION KADFIL
>PARAMETER
FILE 'symbolic file names' C D=' '

>COMMAND Dtext
>GUIDANCE
Give any text to be printed by the DD help mechanism.
This text is considered as
the logical continuation of a description in the previous
DD command. Thus, DTEXT is not allowed as the very first command.
>ACTION KADTEX
>PARAMETER
+
TEXT 'comment' C D=' '

>COMMAND Dsub_of
>GUIDANCE
Declare a table to be subordinate of another (superior) table.
>ACTION KADSUB
>PARAMETER
SUPER 'name of the superior table' C D=' '
+
TEXT 'comment' C D=' '

>COMMAND Dpar_to
>GUIDANCE
Declare a table to be parallel to another (superior) table.
>ACTION KADPAR
>PARAMETER
SUPER 'name of the superior table' C D=' '
+
TEXT 'comment' C D=' '

>MENU Dauto
>GUIDANCE
Automatically generated DD commands.

>COMMAND Drelati
>GUIDANCE
Automatically generated command. Keep you fingers away.
>ACTION KADREL
>PARAMETER
NAME 'relation name' C
DIVISION 'Zebra division' C
+
TEXT 'relation description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Dnamseq
>GUIDANCE
Keep names in proper order. Automatically generated command !!
>ACTION KADNAM
>PARAMETER
NAME 'attribute name' C
+
TEXT 'attribute description' C D=' '

#include "arte/ArteUtil.help"
#include "arte/ArteFlag.help"


>Menu /STAGE
>Guidance 
STAGE control cards 

>Command STAGEDIRECTORY 
>Guidance 
Declare the mark of the tape-file to be staged. 
on hera-b.desy.de with OSM it is '/acs/' (default) 
>Action KASTAG
>Parameters 
+ 
DIRECTORY  ' stage directory (from) ' C D='/acs/' 

>Command STAGETMP 
>Guidance 
Declare the output scratch directory for stageing
Default is /tmp/$USER 
>Action KASTAG 
>Parameters 
+
SCRATCH  ' name of directory where the stagedfile should be put' C D=' ' 
  
>Command STAGECOMMAND 
>Guidance 
Declare the command with which stageing should be performed.
On hera-b.desy.de machine it is 'osmcp' 
>Action KASTAG 
>Parameters 
+
COMMAND  'Command name ' C D=' osmcp ' 


************************************************************************
* End of ATKUIP
************************************************************************

