*CMZ :          22/03/96  15.34.30  by  Hartwig Albrecht
*CMZ :  2.01/03 29/02/96  19.31.29  by  Hartwig Albrecht
*CMZ :  2.01/02 28/01/96  17.51.57  by  Hartwig Albrecht
*CMZ :  2.01/01 15/12/95  10.28.27  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATCP

************************************************************************
*
* Description: make include files *.hh from the DATT command
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, K4, K5, IFF, IFH, IFB, LENOCC
      CHARACTER C4*4, C27*27

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)
      CALL CHCTOH ('H', IFH, 1)
      CALL CHCTOH ('B', IFB, 1)

C loop over tables

      DO 90 K1 = 1, NDDUSR
        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 90

C new deck *.hh

        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C4)
        CALL DDOPEN (C4, 'hh')
        CALL DDNDEF (C4, 'HH')

C structure declarations for relations

        C78 = 'struct     _'
        DO 10 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 20
          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 10

          CALL DDIREL (K2, K3)
          CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C78(8:11))
          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), C78(13:16))
          CALL DDCSTS (C78)

 10     CONTINUE

C declarations for attributes

 20     C78 = 'struct'
        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C78(8:11))
        C78(13:13) = '{'
        CALL DDCSTO (C78)

        DO 30 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 40

          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), C4)
          CALL CUTOL (C4)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
            K5 = IDDEF_DIM(K2)
            C78 = 'int'
            IF (HDDEF_NAM2(K2) .EQ. IFF)  THEN
              C78 = 'float'
            ELSE IF (HDDEF_NAM2(K2) .EQ. IFH)  THEN
              C78 = 'char'
              K5 = 4 * MAX (K5, 1)
            ELSE IF (HDDEF_NAM2(K2) .EQ. IFB)  THEN
              C78 = 'unsigned'
            END IF

            CALL CH78BC (C4)

            IF (K5 .NE. 0)  THEN
              CALL CH78AC ('[')
              CALL CH78AI (K5)
              CALL CH78AC (']')
            END IF

            CALL DDCSTS (C78)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            C78 = 'ArtePointer<'
            CALL DDIREL (K2, K3)
            CALL CHHTOC (IQ(HQDDEF_NAME(K3)), C78(13:16))
            C78(17:17) = '>'
            CALL CH78BC (C4)
            CALL DDCSTS (C78)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            C78 = 'ArteRelationPointer<'
            CALL DDIREL (K2, K3)
            CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C78(21:24))
            C78(25:25) = '_'
            CALL CH78AC (C4)
            CALL CLTOU (C78(21:29))
            CALL CH78AC ('>')
            CALL CH78BC (C4)
            CALL DDCSTS (C78)

          END IF

 30       CONTINUE

 40     CONTINUE
        CALL DDCSTS ('}')

C include

        C78 = '#include "auto/'
        C78(20:23) = '.hh"'

        DO 70 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 80
          IF (IDDEF_FLAG(K2) .LT. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 70

          CALL DDIREL (K2, K5)
          IF (K5 .EQ. K1)  GO TO 60

          DO 50 K3 = K1 + 1, K2 - 1
            IF (IDDEF_FLAG(K3) .NE. LDDEF_RE1 .AND.
     +          IDDEF_FLAG(K3) .NE. LDDEF_INM)  GO TO 50
            CALL DDIREL (K3, K4)
            IF (K5 .EQ. K4)  GO TO 60
 50       CONTINUE

C #include table.hh

          CALL CHHTOC (IQ(HQDDEF_NAME(K5)), C78(16:19))
          CALL DDCSTO (C78)

C include relation.hh

 60       CALL CHHTOC (IQ(HQDDEF_NAM3(K2)), C78(16:19))
          CALL DDCSTO (C78)

 70     CONTINUE

C #include *.icc

 80     C78(21:24) = 'icc"'
        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C78(16:19))
        CALL DDCSTO (C78)
        CALL DDCSTO ('#endif')

C deck *.icc

        C78 = 'inline ArteLink & ArtePointer<    >::getLink()'
        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C78(31:34))
        CALL DDOPEN (C78(31:34), 'icc')
        CALL DDCSTO (C78)
        C27 = '{ return artelink_.j    ; }'
        C27(21:24) = C78(31:34)
        CALL CUTOL (C27)
        CALL DDCSTO (C27)

 90   CONTINUE

C loop over relations

      DO 130 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_REL)  GO TO 130
        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C4)

C deck *.hh

        CALL DDOPEN (C4, 'hh')
        CALL DDNDEF (C4, 'HH')
        C78 = 'struct     _    : public      {}'

        DO 110 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
          IF (HDDEF_NAM3(K2) .NE. HDDEF_NAME(K1))  GO TO 110
          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 110

          CALL DDIREL (K2, K4)
          CALL CHHTOC (IQ(HQDDEF_NAME(K3)), C78(8:11))
          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), C78(13:16))
          CALL CHHTOC (IQ(HQDDEF_NAME(K4)), C78(26:29))
          CALL DDCSTS (C78)
 110    CONTINUE

        C78 = '#include "auto/' // C4 // '.icc"'
        CALL DDCSTO (C78)
        CALL DDCSTO ('#endif')

C deck *.icc

        CALL DDOPEN (C4, 'icc')

        DO 120 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
          IF (HDDEF_NAM3(K2) .NE. HDDEF_NAME(K1))  GO TO 120

          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 120

          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 120

          C78 = 'inline ArteLink &  ArtePointer<         >::getLink()'
          CALL CHHTOC (IQ(HQDDEF_NAME(K3)), C78(32:35))
          C78(36:36) = '_'
          CALL CHHTOC (IQ(HQDDEF_NAME(K2)), C78(37:40))
          CALL DDCSTO (C78)
          C27 = '{ return artelink_.j    ; }'
          CALL CUTOL (C4)
          C27(21:24) = C4
          CALL CUTOL (C27)
          CALL DDCSTO (C27)

          C78(8:23) = 'int ArteRelationPointer'
          C78(44:50) = 'relType'
          CALL DDCSTO (C78)
          K5 = 2
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM)  K5 = 4
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN
            CALL DDIREL (K2, K4)
            CALL DDRTYP (K2, K4)
            IF (K4 .EQ. 4)  K5 = 3
          END IF
          C27 = '{ return'
          CALL CHAPBI (C27, K5)
          CALL CHAPPC (C27, '; }')
          CALL DDCSTO (C27)

 120    CONTINUE

 130  CONTINUE

      END

************************************************************************
* End of DDATCP
************************************************************************
