/* F.Ratnikov: disable everywhere except of SGI (hera-b) */
#ifdef sgi

/* **************************************************************
 *                                                              *
 *     FFFFFFFFFFFF  rrrrrrrrrrr   eeeeeeeeee  eeeeeeeeee       *
 *     FFFFFFFFFFFF  rrrrrrrrrrrr  eeeeeeeeee  eeeeeeeeee       *
 *     FF            rr        rr  ee          ee               *
 *     FF            rr        rr  ee          ee               *
 *     FF            rr        rr  ee          ee               *
 *     FFFFFFFF      rrrrrrrrrrrr  eeeeeeee    eeeeeeee         *
 *     FFFFFFFF      rrrrrrrrrrr   eeeeeeee    eeeeeeee         *
 *     FF            rr    rr      ee          ee               *
 *     FF            rr     rr     ee          ee               *
 *     FF            rr      rr    ee          ee               *
 *     FF            rr       rr   eeeeeeeeee  eeeeeeeeee       *
 *     FF            rr        rr  eeeeeeeeee  eeeeeeeeee       * 
 *                                                              *
 *  SSSSSSSSS   pppppppppp    aaaaaaaa    cccccccc   eeeeeeeeee * 
 * SSSSSSSSSSS  ppppppppppp  aaaaaaaaaa  cccccccccc  eeeeeeeeee *
 * SS       SS  pp       pp  aa      aa  cc      cc  ee         *
 * SS           pp       pp  aa      aa  cc          ee         *
 * SSS          pp       pp  aa      aa  cc          ee         *
 *  SSSSSSSS    ppppppppppp  aaaaaaaaaa  cc          eeeeeeee   *
 *   SSSSSSSS   pppppppppp   aaaaaaaaaa  cc          eeeeeeee   *
 *         SSS  pp           aa      aa  cc          ee         *
 *          SS  pp           aa      aa  cc          ee         *
 * SS       SS  pp           aa      aa  cc      cc  ee         *
 * SSSSSSSSSSS  pp           aa      aa  cccccccccc  eeeeeeeeee *
 *  SSSSSSSSS   pp           aa      aa   cccccccc   eeeeeeeeee *
 *                                                              *
 ****************************************************************
 *                                                              *
 * int freespace_( char  *FileName);                            *
 * int FreeSpace ( char  *FileName);                            *
 *                                                              *
 * Arte call from FORTRAN-77:                                   *
 *  SPACE = FREESPACE(NAME(1:LENOCC(NAME)))                     *
 * do not forget INTEGER FREESPACE,EXTERNAL FREESPACE!          *
 *                                                              *
 ****************************************************************
 * Written by I.Belyaev                                         *
 *                                                              *
 * Descriotion:                                                 *
 *  Function returns the space available of file system         *
 *  where a file "FileName" is situated.                        *
 * Errors rsults in zero return value.                          *
 *                                                              *
 * Uses  statvfs structure and statvfs function.                *
 *                                                              *
 ****************************************************************
 */


/* the statvfs feature is system dependent! */
/* last correction for HPUX: F.Ratnikov, 24/12/97 */

#include<string.h> 

#include <iostream.h>


#if Linux_intel
#include <sys/vfs.h>
#elif HPUX  
#include <sys/types.h>
#include <sys/vfs.h>
#else
#include <sys/types.h>
#include <sys/statvfs.h>
#endif 

int FreeSpace( const char *FileName);
extern "C"
{
  int freespace_( const char *Name , const int NameLen )
  { 
    int Len = NameLen ; 
      if( Len <= 0   || Len >= 256 )
	{
	  int n1 = strlen(Name); 
	  if( n1 <= 0 || n1 >= 256 )
	    {
	      return 0;
	    }
	  Len = n1; 
	}

    char* FileName = new char[ Len + 1 ];
    strncpy( FileName , Name , Len ); 
    FileName[ Len ] = 0; 

    if( FileName[strlen(FileName)-1] != '/' )
      {
	strcat( FileName , "/");
      } 

    strcat( FileName , ".");
    
    return FreeSpace( FileName ) ;
  }  
}

int FreeSpace( const char *FileName)
{
  struct statvfs  FileInfo;
  struct statvfs *fileInfo= &FileInfo;
  if( statvfs( FileName , fileInfo ) ) return 0;

  if( fileInfo == NULL )               return 0;
  // return (FileInfo.f_bsize)*(FileInfo.f_bfree)/1024;
   return (FileInfo.f_bsize)*(FileInfo.f_bavail)/1024;
}

#else

/*   everewhere except of SGI  */
extern "C"
{
  int freespace_( const char *Name )
  { 
    return 0;
  }  
}
#endif



