//
// This file is part of the C++ interface for Arte
// the HERA-B reconstruction and analysis tool
//
// This is the definition of the ArtePointerBase class.
//
// ArtePointerBase is the base class of the ArtePointer
// template class.
//
//
// .SS Usage // A Pointer to an GESL is declared as
//
// .ft B
//      ArtePointer<GESL> geslPoint;
//
//
// .SS See Also
//
// ArtePointer.hh ArteStructures.hh
//
// Author: Christoph Borgmeier, Hartwig Albrecht
//

#ifndef _ARTE_POINTER_BASE_HH_
#define _ARTE_POINTER_BASE_HH_

//#ifdef __GNUC__
//#pragma interface
//#endif

#include <iostream.h>

class ArtePointerBase
{
public:
  inline ArtePointerBase( unsigned int i );
  inline unsigned int index() const;

  //inline operator int () const;

  int operator==( const ArtePointerBase & arg ) const;
  int operator!=( const ArtePointerBase & arg ) const;

  //protected:
  inline unsigned int & indexReference();
  // Returns the private data.

private:
  unsigned int idx;
};


inline ostream & operator<<( ostream & os, const ArtePointerBase & ap );
// Output to a stream.


#include "arte/PointerBase.icc"

#endif
