*CMZ :  2.01/01 23/10/95  11.36.13  by  HERA-B
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE IODECL (LUN, CSYM, CNAM)

************************************************************************
*
* Description: Declare the logical unit number to be reserved.
*              The file is NOT opened!
*
* Called from: anywhere
*
* External references: MEERRO
*
* Argument in/out description
*   LUN    in     logical unit number
*   CSYM   in     symbolic file name
*   CNAM   in     data set name
*
************************************************************************

      IMPLICIT NONE

#include "arte/ZIOCOM.fi"
#include "arte/Arte.fi"

      INTEGER LUN, I
      CHARACTER CSYM*(*), CNAM*(*), CUPP*(NIOSMX)

#include "arte/Arte.ff"

      CUPP = CSYM
      CALL CLTOU (CUPP)

      IF (LUN .LE. 0 .OR .LUN .GE. 100) THEN
        C78 = 'DECLARE: Logical unit'
        CALL CH78BI (LUN)
        CALL CH78BC ('is not in the range 1 ... 99')
        CALL ME78EC (35)
        GO TO 90
      END IF

      IF (CUPP .EQ. ' ')  GO TO 20

      IF (CUPP .EQ. 'INPUT' .OR. CUPP .EQ. 'OUTPUT')  THEN
        CALL MEERRC (93,
     +  'DECLARE: the names INPUT and OUTPUT refer to all I/O units!')
        GO TO 90
      END IF

      IF (CIOSYM(LUN) .NE. ' ' .AND. CIOSYM(LUN) .NE. CUPP)  THEN
        C78 = 'DECLARE: unit'
        CALL CH78BI (LUN)
        CALL CH78BC ('has already the symbolic name')
        CALL CH78BC (CIOSYM(LUN))
        CALL ME78ER
        GO TO 90
      END IF

      DO 10 I = 1, 99
        IF (I .NE. LUN .AND. CUPP .EQ. CIOSYM(I))  THEN
          C78 = 'DECLARE: symbolic name'
          CALL CH78BC (CUPP)
          CALL CH78BC ('is already declared for unit')
          CALL CH78BI (I)
          CALL ME78ER
          GO TO 90
        END IF
 10   CONTINUE
      CIOSYM(LUN) = CUPP

 20   IF (CNAM .NE. ' ')  THEN
        IF (IIOFLG(LUN) .LE. 0)  THEN
          CIONAM(LUN) = CNAM
        ELSE IF (CNAM(1:1) .NE. '(' .AND. CIONAM(LUN) .NE. CNAM)  THEN
          C78 = 'DECLARE: file name'
          CALL CH78BC (CNAM)
          CALL CH78BC ('ignored')
          CALL ME78WC (17634493)
        END IF
      END IF

 80   IF (IIOFLG(LUN) .LE. 0 .AND. CIONAM(LUN) .EQ. ' ')
     +    CIONAM(LUN) = '(unspecified)'

      IIOFLG(LUN) = MAX (IIOFLG(LUN), 0)

 90   RETURN

      END

************************************************************************
* End of IODECL
************************************************************************
