*-- Author :    Hartwig Albrecht   05/03/95

      SUBROUTINE IOOPEN (LUN, COPT, LREC, IOS)

************************************************************************
*
* Description: open data set for LUN or one of the concat. data sets
*
* Called from: anywhere
*
* External references: IOCLOS, IFOPEN
*
* Argument in/out description
*   LUN    in     logical unit number
*   COPT   in     options; for Zebra files: see Zebra manual
*                          for non-Zebra files: see routine IFOPEN
*   LREC   in     record length for direct access
*                 0 for sequential access
*   IOS    out    io status
*                 0:  ok
*                 -1: no more data sets
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"

      INTEGER IOS, L, LREC, LUN, CHIND1
      CHARACTER COPT*(*), CNEW*8, CMESS*78

#include "arte/Arte.ff"

      L = LUN

 10   IF (IIOFLG(L) .GT. 0)  GO TO 20

      CMESS = 'OPEN: no file given for'
      CALL CHAPBC (CMESS, CIOSYM(LUN))
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL MEERRC (27123946, CMESS)
      IOS = -1
      GO TO 90

 20   IF (IIOFLG(L) .NE. 1)  GO TO 30

      CMESS = 'OPEN'
      CALL CHAPBC (CMESS, CIOSYM(LUN))
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL CHAPPC (CMESS,':')
      CALL CHAPBC (CMESS, CIONAM(L))
      CALL MEWARN (CMESS)

      IF (CIOZEB(L) .EQ. 'Z')  THEN
        IF (CHIND1 (CIOZFL(L), 'A') .NE. 0)  THEN
          CNEW = 'F'
        ELSE
          CNEW = 'B'
          IF (CHIND1 (CIOZFL(L), 'N') .EQ. 0 .AND.
     +        CHIND1 (CIOZFL(L), 'X') .EQ. 0 .AND.
     +        CHIND1 (CIOZFL(L), 'L') .EQ. 0)  THEN
            CALL MEWARN (
     +   'OPEN: neither Native nor eXchange specified: default is L')
            CALL CHAPPC (CIOZFL(L), 'L')
          END IF
        END IF

        IF( CHIND1(CIOZFL(L),'L').NE.0)THEN
         CALL CHAPPC( CNEW , 'L' )
         IF( CHIND1(CIOZFL(L),'I').NE.0 .AND.
     &       CHIND1(CIOZFL(L),'O').EQ.0 )THEN
          CALL CHAPPC( CNEW , 'r' )
         ENDIF 
         IF( CHIND1(CIOZFL(L),'I').NE.0 .AND.
     &       CHIND1(CIOZFL(L),'O').NE.0 )THEN
          CALL CHAPPC( CNEW , 'r+' )
         ENDIF 
         IF( CHIND1(CIOZFL(L),'I').EQ.0 .AND.
     &       CHIND1(CIOZFL(L),'O').NE.0 )THEN
          CALL CHAPPC( CNEW , 'w+' )
         ENDIF 
        ELSE
         IF( CHIND1(CIOZFL(L),'I').NE.0)THEN
          CALL CHAPPC( CNEW , 'O' )
         ENDIF 
         IF( CHIND1(CIOZFL(L),'O').NE.0)THEN
          CALL CHAPPC( CNEW , 'N' )
         ENDIF 
        ENDIF 

      ELSE
        CNEW = COPT
      END IF

      CALL IFOPEN (LUN, CIONAM(L), CNEW, LREC, IOS, IIOPNT(L))

      IIOCUR(LUN) = L
      NIOLEN(L) = LREC
      IIOSTA(L) = IOS
      IIOFLG(L) = 3
      IF (CHIND1(COPT,'F') .NE. 0)  IIOFMT(L) = 1
      IF (CHIND1(COPT,'B') .NE. 0)  IIOFMT(L) = 0
      IF (CHIND1(COPT,'A') .EQ. 0)  NIOREC(L) = 0
      IF (IOS .NE. 0)  GO TO 30
      GO TO 90

 30   IF (IIOFLG(L) .GT. 3)  GO TO 40

      CMESS = 'OPEN: file'
      CALL CHAPBC (CMESS, CIOSYM(LUN))
      CALL CHAPBC (CMESS, 'already open')
      CALL MEWARN (CMESS)
      IF (IIONXT(L) .EQ. 0)  GO TO 90
      CALL IOCLOS (LUN)
      GO TO 10

 40   L = IIONXT(L)
      IF (L .NE. 0)  GO TO 10

      CMESS = 'OPEN: no more files for'
      CALL CHAPBC (CMESS, CIOSYM(LUN))
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL MEWARN (CMESS)
      IOS = -1

 90   END

************************************************************************
* End of IOOPEN
************************************************************************
