*CMZ :          21/03/96  15.26.34  by  Hartwig Albrecht
*CMZ :  2.01/02 28/01/96  14.33.50  by  Hartwig Albrecht
*CMZ :  2.01/01 14/11/95  20.37.50  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   04/04/95

      SUBROUTINE MMBOOK (JL, NNR)

************************************************************************
*
* Description: NR > 0: Book / extend table for NR new rows.
*              NR < 0: delete the |NR| last rows
*              NR = 0: make sure that relations and all depending parallel
*                      tables are booked
*
* Called from: anywhere
*
* External references: MZLIFT, MZPUSH
*
* Argument in/out description
*  JL      in     link
*  NR      in     see above
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/SUBT.fi"

      INTEGER JL(*), NNR(*), NR, NT, NU, LOCF, I, IL, IP, IS
      CHARACTER CNAME*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/SUBT.ff"

      NR = NNR(1)
      IL = LOCF (JL) - LARLN1

C check if JL is a correct Zebra link

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 270

C check that JL is not a parallel table

      IF (IMEMO_FLAG(IL) .LT. 0)  GO TO 250

C relations can be booked only with NR = 0

      IF (IMEMO_FLAG(IL) .GT. 0 .AND. NR .NE. 0)  GO TO 240

      IS = IMEMO_SUB1(IL) - 1

      IF (JL(1) .NE. 0)  GO TO 40

C book a new bank

      IF (NR)  280, 10, 20

 10   IQ(IQMEMO_NWRD(IL)) = 2
      GO TO 30

 20   IQ(IQMEMO_NWRD(IL)) = IMEMO_COL(IL) * (IMEMO_EXT(IL) + NR) + 2

 30   CALL MZLIFT (IMEMO_DIV(IL), JL(1), 0, 2, IQ(HQMEMO_NAME(IL)), 0)
      IQ(JL(1)+1) = IMEMO_COL(IL)
      IQ(JL(1)+2) = NR
      GO TO 100

C bank exists already:

C check positivity of number of columns

 40   IF (IQ(JL(1)+1) .LE. 0)  GO TO 260
      IF (NR .EQ. 0)  GO TO 100

C check positivity of number of rows:

      IF (IQ(JL(1)+2) + NR .LT. 0)  GO TO 280

C enough free space ?

      IF (N_F(JL(1)) .LT. NR)  GO TO 60
      IQ(JL(1)+2) = IQ(JL(1)+2) + NR

C set content of free rows to 0

      DO 50 I = 1, - NR * IQ(JL(1)+1)
        IQ(JL(1)+IQ(JL(1)+1)*IQ(JL(1)+2)+2+I) = 0
 50   CONTINUE
      GO TO 100

C extend table

 60   CALL MZPUSH (IMEMO_DIV(IL), JL(1), 0,
     +  IQ(JL(1)+1) * (NR + IMEMO_EXT(IL)), ' ')
      IQ(JL(1)+2) = IQ(JL(1)+2) + NR

C parallel tables and relations

 100  IF (IS .EQ. IMEMO_SUB2(IL))  GO TO 290
      IS = IS + 1
      IP = ISUBT_SUB(IS)
      IF (IMEMO_FLAG(IP))  110, 100, 140

C parallel table

 110  IF (JLINK(IMEMO_SUP(1,IP)) .EQ. 0)  THEN
        NU = 0
        NT = 0
      ELSE
        NU = IQ(JLINK(IMEMO_SUP(1,IP))+2)
        NT = (IQ(JLINK(IMEMO_SUP(1,IP))-1) - 2) /
     +        IQ(JLINK(IMEMO_SUP(1,IP))+1)
      END IF

      IF (JLINK(IP) .NE. 0)  GO TO 120

C book a new table

      IQ(IQMEMO_NWRD(IP)) = IMEMO_COL(IP) * NT + 2
      CALL MZLIFT (IMEMO_DIV(IP), JLINK(IP), 0, 2,
     +  IQ(HQMEMO_NAME(IP)), 0)
      IQ(JLINK(IP)+1) = IMEMO_COL(IP)
      IQ(JLINK(IP)+2) = NU
      GO TO 100

C bank exists already

 120  IF (IQ(JLINK(IP)+1) .LE. 0)  GO TO 260

C set content of free rows to 0

      DO 130 I = 1, (IQ(JLINK(IP)+2) - NU) * IQ(JLINK(IP)+1)
        IQ(JLINK(IP)+IQ(JLINK(IP)+1)*IQ(JLINK(IP)+2)+2+I) = 0
 130  CONTINUE

      IF (NT * IQ(JLINK(IP)+1) + 2 - IQ(JLINK(IP)-1) .NE. 0)
     +  CALL MZPUSH (IMEMO_DIV(IP), JLINK(IP), 0,
     +    NT * IQ(JLINK(IP)+1) + 2 - IQ(JLINK(IP)-1), ' ')
      IQ(JLINK(IP)+2) = NU
      GO TO 100

C book relation table with length = 0

 140  IF (JLINK(IP) .NE. 0 .OR. IMEMO_FLAG(IP) .EQ. 1)  GO TO 100
      IQ(IQMEMO_NWRD(IP)) = 2
      CALL MZLIFT (IMEMO_DIV(IP), JLINK(IP), 0, 2,
     +  IQ(HQMEMO_NAME(IP)), 0)
      IQ(JLINK(IP)+1) = IMEMO_COL(IP)
      IQ(JLINK(IP)+2) = 0
      GO TO 100

 240  C78 = 'MMBOOK:'
      CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL CH78BC (CNAME)
      CALL CH78BC ('is a relation (can be booked only with NR = 0)')
      CALL ME78ER
      GO TO 290

 250  C78 = 'MMBOOK:'
      CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL CH78BC (CNAME)
      CALL CH78BC ('is a parallel table (cannot be booked)')
      CALL ME78ER
      GO TO 290

 260  C78 = 'MMBOOK: table'
      CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL CH78BC (CNAME)
      CALL CH78BC ('has non-positive number of columns')
      CALL ME78ER
      GO TO 290

 270  CALL MEERRO ('MMBOOK: link JL not inside link area')
      GO TO 290

 280  C78 = 'MMBOOK: table'
      CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
      CALL CH78BC (CNAME)
      CALL CH78AC (': number of rows gets negative')
      CALL ME78ER

 290  END

************************************************************************
* End of MMBOOK
************************************************************************
