
*-- Author :    Siegmund Nowak   04/04/95

      SUBROUTINE MMCHTM (JL, NNC)

************************************************************************
*
* Description: Changes IQ(JL+1) and IQ(JL+2) for an existing bank.
*              Checks whether the existing table is compatible  
*              with new numbers for rows and columns
*
* Called from: anywhere
*
* External references: MZLIFT, MZPUSH
*
* Argument in/out description
*  JL      in/out link
*  NNC     new number of columns per row
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/SUBT.fi"

      INTEGER JL(*), NC, NNC(*), LOCF, I, IL, NEWROW, LENGTH
      CHARACTER CNAME*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/SUBT.ff"

      NC = NNC(1)

      IL = LOCF (JL) - LARLN1

C check if JL is a correct Zebra link

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  THEN
         CALL MEERRO ('MMBWRK: link JL not inside link area')
         GO TO 290 
      ENDIF

      IF (NC .LE. 0)  THEN     ! check positivity
         CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
         CALL MEERRO ('MMBWRK: table '//CNAME// 
     +                   'has number of columns or rows le 0')
         GO TO 290
      ENDIF

      IF (JL(1) .EQ. 0)  THEN                 ! table doesn't exist
         CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
         CALL MEERRO ('MMCHTM: table '//CNAME//' does not exist') 
         GO TO 290
      ENDIF

      IF (IQ(JL(1)+1) .NE. 1)  THEN                 ! not suitable
         CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
         CALL MEERRO ('MMCHTM: table '//CNAME//' Nwords/entry ne 1') 
         GO TO 290
      ENDIF

      IF (IQ(JL(1)+2) .LE. 0)  THEN                 ! no entries
         CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
         CALL MEERRO ('MMCHTM: table '//CNAME//' no entries') 
         GO TO 290
      ENDIF
      
      LENGTH = IQ(JL(1)+2) 
      NEWROW = LENGTH/NC
      IF (NEWROW*NC.NE.LENGTH) THEN
         CALL CHHTOC (IQ(HQMEMO_NAME(IL)), CNAME)
         CALL MEERRO ('MMCHTM: table '//CNAME//' new rows not complete') 
         GO TO 290
      ENDIF
C bank exists already:

      IQ(IQMEMO_COL(IL)) = NC
      IQ(JL(1)+1) = NC
      IQ(JL(1)+2) = NEWROW
      GO TO 290






 290  END

************************************************************************
* End of MMBWRK
************************************************************************
