*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMOPEN (LUN, IOS)

************************************************************************
*
* Description: open a file for Zebra I/O
*
* Called from: MMRTAB etc.
*
* External references:
*
* Argument in/out description
*   LUN    in     >0: logical output unit; <0: negative logical input unit
*   IOS    out    -1: no more data; 0: ok; never > 0
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"
#include "arte/ZQUEST.fi"

      INTEGER L, LUN, LCUR, IOS, CHIND1
      CHARACTER C1*2

#include "arte/Arte.ff"

      IOS = 0
      L = ABS (LUN)
      LCUR = IIOCUR(L)

C Already open ?

  10  IF (IIOFLG(LCUR) .EQ. 3 .OR.
     +    IIOFLG(LCUR) .EQ. 2)  GO TO 90

C file foreseen for Zebra input/output ?

      IF (IIOBIT(L) .EQ. 0)  THEN
        C78 = 'MMWRIT: no Arte table flagged for i/o '
        CALL CH78BC (CIOSYM(ABS(LUN)))
        CALL CH78BC ('on')
        CALL CH78BI (ABS(LUN))
        CALL ME78EC (672346)
      END IF

C Zebra io

 20   CIOZEB(LCUR) = 'Z'
      LCUR = IIONXT(LCUR)
      IF (LCUR .NE. 0)  GO TO 20
      C1 = ' '
      IF (LUN .LT. 0)  C1 = 'O'


C Fortran OPEN (IOS < 0: no more files; never positive):

      CALL IOOPEN (L, C1, 0, IOS)

      IF (IOS .LT. 0)  GO TO 90

      LCUR = IIOCUR(L)
      IF (LUN .LT. 0)  THEN
        IF (CHIND1 (CIOZFL(LCUR), 'I') .EQ. 0)
     +    CALL CHAPPC (CIOZFL(LCUR), 'I')
      ELSE
        IF (CHIND1 (CIOZFL(LCUR), 'O') .EQ. 0)
     +    CALL CHAPPC (CIOZFL(LCUR), 'O')
      END IF

C Zebra file initialization:

      IF( CHIND1(CIOZFL(LCUR),'L').EQ.0)  THEN
       CALL FZFILE ( L ,   0 , CIOZFL( LCUR ) )
      ELSE
       IQUEST(1) = IIOPNT(LCUR)
C*     for C library INPUT/OUTPUT.
C*     here IQUEST(1) is a "c"-pointer "file" 
C*     should not be equal to zero!!! 
       IF( IQUEST(1) .LE. 0 )THEN
        C78='MMOPEN: error FZFILE for C-input/output'
        CALL CH78CC('IQUEST(1)=')
        CALL CH78AI( IQUEST(1)  )
        CALL CH78CC( 'LUN='     ) 
        CALL CH78AI(  LUN       )
        CALL CH78AC( '/'        )         
        CALL CH78AI(  L         )
        CALL IOCLOS(  L         ) 
        GO TO 10          
       ENDIF 
C*     is there any reason to specify a record length and not to use
C*     the default value ?
       CALL FZFILE ( L , 0 , CIOZFL( LCUR ) ) 
      ENDIF 

C error from FZFILE?

      IF (IQUEST(1) .EQ. 0)  GO TO 30
      C78 = 'MMOPEN: FZFILE returns IQUEST(1) ='
      CALL CH78BI (IQUEST(1))
      CALL ME78EC (92)
      CALL IOCLOS (L)
      GO TO 10

 30   IF (FIOUTM(LCUR) .NE. 0)  CALL FZLIMI (L, FIOUTM(LCUR) / 4.)

 90   END

************************************************************************
* End of MMOPEN
************************************************************************
