
*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMRDAT (LUN, JLN)

************************************************************************
*
* Description: Read data of next Zebra record
*
* Called from: MMREAD, MMRMIX
*
* External references: FZIN
*
* Argument in/out description
*   LUN    in     logical unit
*   JLN    out    link to the actual bank
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, JLN, DUMMY, FARDAT, I, J
      CHARACTER CNAME*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      IF (JLINK(JLN) .EQ. 0)  GO TO 10
      IF (BITTEST(IQ(JLINK(JLN)), 25) .NE. 0)  GO TO 10

C bank exists: drop before reading new data

      IF (IQ(JLINK(JLN)+2) .GT. 0)  THEN
        C78 = 'MMRDAT: existing bank'
        CALL CHHTOC (IQ(HQMEMO_NAME(JLN)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('overwritten')
        CALL ME78PC (7534, 30)
      END IF
      CALL MMDROP (JLINK(JLN))

C read data

 10   IF (BITTEST (INOUTFARM, 1) .EQ. 0 .OR. LUN .NE. LEVI1)  THEN
        CALL FZIN (LUN, IMEMO_DIV(JLN), JLINK(JLN), 1, 'A',
     +    DUMMY, DUMMY)

C read error ?

        IF (IQUEST(1) .LT. 0)  THEN
          C78 = 'MMRDAT: read error. IQUEST(1) ='
          CALL CH78BI (IQUEST(1))
          CALL ME78WC (46586)
          CALL USRERR (LUN)
        END IF

        IF (N_C(JLINK(JLN)) .NE. IMEMO_COL(JLN))  THEN

          C78 = 'MMRDAT: table'
          CALL CHHTOC (IQ(HQMEMO_NAME(JLN)), CNAME)
          CALL CH78BC (CNAME)
          CALL CH78BC ('changed from')
          IF (N_C(JLINK(JLN)) .GT. IMEMO_COL(JLN))  THEN
            CALL CH78BI (IMEMO_COL(JLN))
            CALL CH78BC ('to')
            CALL CH78BI (N_C(JLINK(JLN)))
            CALL CH78BC ('columns')
            IQ(IQMEMO_COL(JLN)) = N_C(JLINK(JLN))
          ELSE
            CALL CH78BI (N_C(JLINK(JLN)))
            CALL CH78BC ('to')
            CALL CH78BI (IMEMO_COL(JLN))
            CALL CH78BC ('columns')
            CALL MZPUSH (IMEMO_DIV(JLN), JLINK(JLN), 0,
     +        (IMEMO_COL(JLN) - N_C(JLINK(JLN))) *
     +        N_U(JLINK(JLN)), ' ')

            DO I = N_U(JLINK(JLN)), 1, -1
              DO J = N_C(JLINK(JLN)), 1, -1
                IQ(JLINK(JLN)+(I-1)*IMEMO_COL(JLN)+J+2) =
     +          IQ(JLINK(JLN)+(I-1)*N_C(JLINK(JLN))+J+2)
              END DO
              DO J = N_C(JLINK(JLN)) + 1, IMEMO_COL(JLN)
                IQ(JLINK(JLN)+(I-1)*IMEMO_COL(JLN)+J+2) = 0
              END DO
            END DO
            IQ(JLINK(JLN)+1) = IQ(IQMEMO_COL(JLN))
          END IF
          CALL ME78PC (3646768, 30)
        END IF
      ELSE
        IF (INNCFARM .NE. IMEMO_COL(JLN))  THEN
          C78 = 'MMRDAT: table'
          CALL CHHTOC (IQ(HQMEMO_NAME(JLN)), CNAME)
          CALL CH78BC (CNAME)
          CALL CH78BC ('changed from')
          CALL CH78BI (IMEMO_COL(JLN))
          CALL CH78BC ('to')
          CALL CH78BI (INNCFARM)
          CALL CH78BC ('columns')
          CALL ME78PC (3646768, 30)
          IQ(IQMEMO_COL(JLN)) = INNCFARM
        END IF
        CALL MMBOOK (JLINK(JLN), INNRFARM)
        DUMMY = FARDAT (JLN)
      END IF

      IQ(IQMEMO_NIN(JLN)) = IQ(IQMEMO_NIN(JLN)) + 1

      END

************************************************************************
* End of MMRDAT
************************************************************************
