*CMZ :          16/03/96  15.52.09  by  Hartwig Albrecht
*CMZ :  2.01/03 07/02/96  18.50.38  by  Hartwig Albrecht
*CMZ :  2.01/02 29/01/96  16.26.27  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  11.53.08  by  Hartwig Albrecht
*CMZ :          29/03/95  17.50.44  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/03/95

      SUBROUTINE MMREVT (IOS)

************************************************************************
*
* Description: read next event record
*
* Called from: USEXEC
*
* External references: MMREAD
*
* Arguments: in/out description
*   IOS      out    flag: -1: end of data
*                          0: no event input file given
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MCIN.fi"
#include "auto/GEHD.fi"

      INTEGER IOS
      CHARACTER CNAME*4

#include "arte/Arte.ff"
#include "auto/MCIN.ff"
#include "auto/GEHD.ff"

C event input unit given ?

      IF (IIOFLG(LEVI1) .LE. 0 .AND. BITTEST (INOUTFARM, 1) .EQ. 0)
     +  GO TO 280

C to mix or not to mix

      IF (FIOMIX(5) .NE. 0.)  GO TO 30

C check that event input file 2, 3, and 4 are not given

      DO 10 IOS = 2, 4
        IF (IIOFLG(LEVIN(IOS)) .GT. 0)  THEN
          CALL MEMESC (653434, 3, ILARGEST,
     +      'MREVT: file EVI2..4 given but no IOMIX command')
        END IF
 10   CONTINUE

C sequential read from one unit.

 20   CALL MMREAD (LEVI1, CNAME)

C end of data ?

      IF (CNAME .EQ. 'EOD ')  THEN
        IOS = -1
        GO TO 290
      END IF

C event record ?

      IF (CNAME .EQ. 'EVHD')  GO TO 100

C special record

      CALL USRSPC (LEVI1, CNAME)
      GO TO 20

C mix events

 30   CALL MMRMIX (IOS)

C end of data ?

      IF (IOS .LT. 0)  GO TO 290

 100  CONTINUE

C get the correct geometrical constants

      IF (JGEHD .EQ. 0)  CALL ATCONS

      IF (JMCIN .EQ. 0)  THEN

C real data

      ELSE

C Monte Carlo

        IF (GEANINIT .NE. 0 .OR.
     +    FMCIN_VGEO(1) .EQ. 0. .OR.
     +    FMCIN_VGEO(1) .EQ. FGEHD_GEOM(1))  GO TO 290


C read geometry. TOPP and MFHD have to be stored after the geometry
C in order not to be overwritten.

 110    CALL MMREAD (LGEOI, CNAME)
        CALL MMREAD (LGEOI, CNAME)
        IF (CNAME .EQ. 'GEHD' .AND.
     +    FMCIN_VGEO(1) .EQ. FGEHD_GEOM(1))  GO TO 190
        IF (CNAME .NE. 'EOD')  GO TO 110
C not found:
        CALL MEMESC (35134, 10, ilargest,
     +    'MMREVT: detector geometry not found')
 190    CALL IOREWI (LGEOI)

      END IF

      GO TO 290

 280  CALL MEERRC (912346, 'MMREVT: no event input file given')
      IOS = 0

 290  END

************************************************************************
* End of MMREVT
************************************************************************
