*CMZ :          01/04/96  17.01.12  by  Siegmund Nowak
*CMZ :  2.01/03 02/02/96  10.37.17  by  Hartwig Albrecht
*CMZ :  2.01/02 29/01/96  16.30.44  by  Hartwig Albrecht
*CMZ :  2.01/01 18/12/95  18.19.55  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMRTAB (LUN, JLN)

************************************************************************
*
* Description: Read next Zebra table header with FZIN option 'S'
*
* Called from: MMREAD
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit
*   JLN    out    >0: link number of the table
*                  0: end of event
*                 -1: end of data
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MEMO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, JLN, NUH, IUH(2), HEVHD, DUMMY, FARTAB
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      CALL CHCTOH ('EVHD', HEVHD, 1)

 10   IF (JIOBNK(LUN) .EQ. 0)  GO TO 20

C process information from previous record

      JLN = JIOBNK(LUN)
      IF (JLN .GT. 0)  THEN
        JIOBNK(LUN) = 0
        GO TO 200
      END IF

      IF (BITTEST (INOUTFARM, 1) .NE. 0 .AND. LUN .EQ. LEVI1)  THEN
        CALL MEWARC (231455, 'MMRTAB: end-of-file on IOFARM')
        GO TO 990
      END IF

      JIOBNK(LUN) = 0
      CALL IOCLOS (LUN)

C read table identification

 20   NUH = 2
      IF (BITTEST (INOUTFARM, 1) .EQ. 0 .OR. LUN .NE. LEVI1)  THEN
        CALL MMOPEN (-LUN, JLN)
        IF (JLN .LT. 0)  GO TO 990
        CALL FZIN (LUN, DUMMY, DUMMY, DUMMY, 'S', NUH, IUH)
      ELSE
        IQUEST(1) = FARTAB (IUH(1), INNCFARM, INNRFARM)

        IF (IQUEST(1) .EQ. 4)  THEN
          JLN = 0
          GO TO 900
        END IF
      END IF

      IF (IQUEST(1) .EQ. 0)  GO TO 40

C read error ?

      IF (IQUEST(1) .LT. 0)  THEN

        C78 = 'MMRTAB: read error. IQUEST(1) ='
        CALL CH78BI (IQUEST(1))
        CALL ME78PC (111, 30)
        CALL USRERR (LUN)
        GO TO 20

C Zebra start/end-of-run record (I dont what to do with it)

      ELSE IF (IQUEST(1) .LE. 2)  THEN
        GO TO 20

C End of data (file ?)

      ELSE IF (IQUEST(1) .GE. 4)  THEN

        IF (BITTEST (INOUTFARM, 1) .EQ. 0 .OR. LUN .NE. LEVI1)
     +    CALL IOCLOS (LUN)

      END IF

 30   JIOBNK(LUN) = -1
      JLN = 0
      GO TO 900

C record header: 2 words requested

 40   IF (NUH .NE. 2 .OR. IUH(1) .EQ. 0)  THEN
        CALL MEERRC (333,
     +    'MMRTAB: bank identification incorrect. Dont use MMREAD')
        GO TO 20
      END IF

C which link ? (space for future program improvement !)

      DO 50 JLN = 1, NARLNK
 50   IF (HMEMO_NAME(JLN) .EQ. IUH(1))  GO TO 100

C unknown bank: (space for future program improvement !)

      CALL CHHTOC (IUH(1), C4)
      C78 = 'MMRTAB: unknown bank name. Bank skipped:'
      CALL CH78BC (C4)
      CALL ME78EC (444)
      GO TO 20

C new event ?

 100  IF (IQUEST(11) .EQ. 0 .OR. IMEMO_SUP(1,JLN) .EQ. 0)  GO TO 110
      C78 = 'MMRTAB: table'
      CALL CHHTOC (IUH(1), C4)
      CALL CH78BC (C4)
      CALL CH78BC ('is a record header on input but not in ARTE')
      CALL ME78PC (666, 30)

C record header table ?

 110  IF (IMEMO_SUP(1,JLN) .NE. 0)  GO TO 200
      IIOFLG(IIOCUR(LUN)) = 3
      IF (NIOSKP(LUN) .EQ. 0)  GO TO 130

C Skip records.
C On event files: skip event records, accept all other records

      IF (IUH(1) .EQ. HEVHD)  GO TO 120
      IF (LUN .NE. LEVI1 .AND. LUN .NE. LEVI2 .AND.
     +    LUN .NE. LEVI3 .AND. LUN .NE. LEVI4)  GO TO 120
      IIOSKP(LUN) = 0
      GO TO 130

 120  NIOSKP(LUN) = NIOSKP(LUN) - 1
      IIOSKP(LUN) = 1

C end of event: extra return with JLN = 0

 130  JIOBNK(LUN) = JLN
      JLN = 0
      GO TO 900

C test if bank is selected for input

 200  IF (BITTEST (BMEMO_IOA(JLN), 1) .EQ. 0)  GO TO 20
      IF (BITTEST (BMEMO_IOA(JLN), IIOBIT(LUN)) .EQ. 0)  THEN
        IF (BITTEST (BMEMO_IOD(JLN), IIOBIT(LUN)) .EQ. 0)  THEN
          C78 = 'MMRTAB: bank'
          CALL CHHTOC (IQ(HQMEMO_NAME(JLN)), C4)
          CALL CH78BC (C4)
          CALL CH78BC ('not expected on file')
          CALL CH78BC (CIOSYM(LUN))
          CALL CH78AC (' - skipped')
          CALL ME78PC (888, 30)
        END IF
        GO TO 20
      END IF

C test if header table exists

c      IF (IMEMO_SUP(1,JLN) .NE. 0)  THEN
c        IF (JLINK(IMEMO_SUP(1,JLN)) .EQ. 0)  THEN
c          C78 = 'MMRTAB: header table'
c          CALL CHHTOC (IQ(HQMEMO_NAME(IMEMO_SUP(1,JLN))), C4)
c          CALL CH78BC (C4)
c          CALL CH78BC ('missing on input file')
c          CALL ME78EC (1823764)
c        END IF
c      END IF

 900  IF (NIOSKP(LUN) * IIOSKP(LUN) .NE. 0)  GO TO 10
      IF (JLN .EQ. 0)  NIOREC(IIOCUR(LUN)) = NIOREC(IIOCUR(LUN)) + 1

 990  END

************************************************************************
* End of MMRTAB
************************************************************************
