*CMZ :          16/03/96  12.55.12  by  Hartwig Albrecht
*CMZ :  2.01/01 01/12/95  16.56.36  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   11/07/95

      SUBROUTINE MMRUPD (IL)

************************************************************************
*
* Description: invert relations and update specific tables
*
* Called from: MMREAD, MMRMIX
*
* External references: MMIREL
*
* Argument in/out description
*   IL     in     link number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "arte/ZMMCOM.fi"
#include "auto/SUBT.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/MVEX.fi"
#include "auto/TOPP.fi"

      INTEGER IL, I, J

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/SUBT.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/MVEX.ff"
#include "auto/TOPP.ff"

C fill tables MTRX and MVEX

      IF (JMTRA .EQ. 0)  GO TO 50
      DO 40 I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
        IF (JLINK(ISUBT_SUB(I)) .NE. JMTRA)  GO TO 40

        DO 30 J = 1, NMTRA()
          IF (IMTRA_FLAG(J) .EQ. 2)  THEN
C resonance
            Q(QMTRX_MASS(J)) = FMTRA_ML(J)
            Q(QMTRX_LENG(J)) = 0.
          ELSE
C stable particle
            Q(QMTRX_MASS(J)) = FTOPP_MASS(OMTRA_TOPP(J))
            Q(QMTRX_LENG(J)) = FMTRA_ML(J)
          END IF

C relations to MVEX

          IF (IMTRA_ORIG(J))  10, 30, 20
 10       IQ(L_A(JMTRX_BTRA,J,JMTRX)) = -IMTRA_ORIG(J)
          IQ(L_A(JMTRX_BVER,J,JMTRX)) = OMTRX_BVER(-IMTRA_ORIG(J))
          GO TO 30
 20       IQ(L_A(JMTRX_BTRA,J,JMTRX)) = OMVER_BTRA(IMTRA_ORIG(J))
          IQ(L_A(JMTRX_BVER,J,JMTRX)) = IMTRA_ORIG(J)

 30     CONTINUE
        GO TO 50

 40   CONTINUE

C invert relations

 50   DO 60 I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)

        IF (IMEMO_FLAG(ISUBT_SUB(I)) .GT. 0)
     +    CALL MMIREL (JLINK(ISUBT_SUB(I)))

 60   CONTINUE


C relation between TOPP and TDEC

      IF (JLINK(IL) .EQ. JTOPP .AND. JTOPP .NE. 0)  CALL TPRELA

 90   END

************************************************************************
* End of MMRUPD
************************************************************************
