*CMZ :  2.01/02 30/01/96  10.56.45  by  Hartwig Albrecht
*CMZ :  2.01/01 29/11/95  18.38.33  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/07/95

      SUBROUTINE MMWEVT

************************************************************************
*
* Description: write one event
*              output files are: LRAWO, LDSTO, LMINO
*
* Called from: ATEVNT
*
* External references: MMWRIT, MZWIPE
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MEMO.fi"
#include "auto/EVFN.fi"

      INTEGER NUN, LUN(3), I, IL, IOS, LOCF

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/EVFN.ff"

      IF (EVENTOUT .LE. 0)  THEN
        CALL MEMESC (6451355, 1, ILARGEST,
     +        'MMWEVT: event output flag EVENTOUT <= 0: no output')
        GO TO 90
      END IF

      NUN = 0

      IF (IIOFLG(LRAWO) .GT. 0)  THEN
        CALL MEMESC (9236634, 1, ILARGEST,
     +        'MMWEVT: event output on RAW data set')
        NUN = 1
        LUN(1) = LRAWO
      END IF

      IF (IIOFLG(LDSTO) .GT. 0)  THEN
        CALL MEMESC (9236634, 1, ILARGEST,
     +        'MMWEVT: event output on DST')
        NUN = NUN + 1
        LUN(NUN) = LDSTO
      END IF

      IF (IIOFLG(LMINO) .GT. 0)  THEN
        CALL MEMESC (1346354, 1, ILARGEST,
     +        'MMWEVT: event output on MINI')
        NUN = NUN + 11
        LUN(NUN) = LMINO
      END IF

      IF (BITTEST (INOUTFARM, 2) .EQ. 0)  THEN
        IF (NUN .EQ. 0)  THEN
          CALL MEMESC (512344, 1, ILARGEST,
     +        'MMWEVT: no event output file declared')
          GO TO 90
        ENDIF
      ELSE
        IF (NUN .NE. 0)  THEN
          CALL MEMESC (634514, 1, ILARGEST,
     + 'MMWEVT: only one of IOFARM OUT or IOFILE DST can be declared')
        ENDIF
        NUN = 1
        LUN(1) = LDSTO
      END IF

      IL = LOCF (JEVHD) - LARLN1

      IF (BITTEST(BMEMO_IOA(IL),2) .EQ. 0)  THEN
        CALL MEMESC (8345345, 1, ILARGEST,
     +        ' MMWEVT: event header EVHD is flagged for non-output')
        GO TO 90
      END IF

C file name
      CALL MMBOOK (JEVFN, 1)

      DO 20 I = 1, NUN

        CALL CHCTOH (CIONAM(IIOCUR(LUN(I))),
     +    IQ(HQEVFN_NAME_L(1)), NEVFN_NAME)

        CALL MMWRIT (LUN(I), JEVHD, IOS)
        IF (IOS .GE. 0)  GO TO 20

        C78 = 'MMWEVT: no more output files for unit'
        CALL CH78BI (LUN(I))
        CALL ME78EC (5134563)

 20   CONTINUE

C drop event

 90   CALL MZWIPE (IXEVNT)

C relation TOPP -> MTRA

      CALL MMDREL (LOCF(JMTTO) - LARLN1)

      END

************************************************************************
* End of MMWEVT
************************************************************************
