*CMZ :  2.01/01 29/11/95  18.18.45  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   17/05/95

      SUBROUTINE MMWRIT (LUN, JH, IOS)

************************************************************************
*
* Description: Zebra output
*
* Called from: anywhere
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit
*   JH     in     link to a header bank
*   IOS    out    iostatus: 0 = ok; -1 = output file(s) full; never >0.
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "arte/ZIOCOM.fi"
#include "auto/SUBT.fi"

      INTEGER LOCF, LUN, JH(1), I, IS, IH, IOS, ICLOSE
      CHARACTER CNAME*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/SUBT.ff"

      ICLOSE = 0
      IH = LOCF(JH) - LARLN1

      IF (IH .LE. 0 .OR. IH .GT. NARLNK)  THEN
        CALL MEERRC (97655, 'MMWRIT: link JH not inside ARTE link area')
        GO TO 90
      END IF

      IF (IMEMO_SUP(1,IH) .NE. 0)  THEN
        C78 = 'MMWRIT: table'
        CALL CHHTOC (IQ(HQMEMO_NAME(IH)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('is not a header bank')
        CALL ME78EC (45614)
        GO TO 90
      END IF

      IF (BITTEST (BMEMO_IOD(IH), 2) .EQ. 0 .OR.
     +    BITTEST (BMEMO_IOD(IH), IIOBIT(LUN)) .EQ. 0)  THEN
        C78 = 'MMWRIT: header bank'
        CALL CHHTOC (IQ(HQMEMO_NAME(IH)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('not marked for output on')
        CALL CH78BC (CIOSYM(LUN))
        CALL CH78BC ('- record skipped')
        CALL ME78PC (534888, 30)
        GO TO 90
      END IF

      IF (BITTEST (BMEMO_IOA(IH), 2) .EQ. 0)  GO TO 90
      IF (BITTEST (BMEMO_IOA(IH), IIOBIT(LUN)) .EQ. 0)  GO TO 90

      IF (JH(1) .EQ. 0 .OR. IQ(JH(1)+2) .EQ. 0)  THEN
        C78 = 'MMWRIT: header bank'
        CALL CHHTOC (IQ(HQMEMO_NAME(IH)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('is empty for output on')
        CALL CH78BC (CIOSYM(LUN))
        CALL CH78BC ('- record skipped')
        CALL ME78PC (7634561, 30)
        GO TO 90
      END IF

      IOS = 0
      IF (BITTEST (INOUTFARM, 2) .EQ. 0)  CALL MMOPEN (LUN, IOS)
      IF (IOS .LT. 0)  GO TO 90

      CALL MMWTAB (LUN, IH, IOS)
      ICLOSE = MIN (ICLOSE, IOS)

      DO 20 I = IMEMO_SUB1(IH), IMEMO_SUB2(IH)

        IS = ISUBT_SUB(I)
        IF (IS .EQ. IH)  GO TO 20

        IF (JLINK(IS) .EQ. 0 .OR. IQ(JLINK(IS)+2) .EQ. 0)  GO TO 20
        IF (BITTEST (BMEMO_IOA(IS), 2) .EQ. 0)  GO TO 20
        IF (BITTEST (BMEMO_IOD(IS), IIOBIT(LUN)) .EQ. 0)  THEN
          C78 = 'MMWRIT: bank'
          CALL CHHTOC (IQ(HQMEMO_NAME(IS)), CNAME)
          CALL CH78BC (CNAME)
          CALL CH78BC ('not marked for output on')
          CALL CH78BC (CIOSYM(LUN))
          CALL CH78AC (' - table skipped')
          CALL ME78PC (5386488, 30)
          GO TO 20
        END IF

        IF (BITTEST (BMEMO_IOA(IS), IIOBIT(LUN)) .EQ. 0)  GO TO 20
        CALL MMWTAB (LUN, IS, IOS)
        ICLOSE = MIN (ICLOSE, IOS)

 20   CONTINUE

      IF (ICLOSE .NE. 0)  CALL IOCLOS (LUN)
      IOS = 0

 90   END

************************************************************************
* End of MMWRIT
************************************************************************
