 
// *****************************************************************************
//
// source:    utcarg.C
//
// symbol:    void utcarg();
//
// externals: void utfarg_();
//            int  faLine();
//
// created:   27 Oct 95
// updated:   21 Aug 98
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// purpose:   prepare and pass shell arguments to Fortran routine utfarg_
//
// hints:     Fortran expects spaces as filling of character variables
//
// *****************************************************************************
 
// standard includes
#include <iostream.h>
#include <stdio.h>
#include <string.h>

// includes
#include "arte/ArteFlag.h"

// C prototypes
extern "C" {
void utcarg_();
void utfarg_( int *i, char *strg );
}

// C++ prototype
int faLine();

// externals
extern int  nArg;
extern char **vArg;

//
// program code
// 
void
utcarg_()
{
  // FARM flag
  arteflag_.inoutfarm = faLine();
  
  // locals
  char *strg = new char[78];
  
  // prepare argument string
  for( int i=0; i<nArg; i++ ){
    strg  = strncpy( strg, vArg[i], 78 );
    int n = strlen( vArg[i] );
    for( int j=n; j<78; j++ ){
      strg[j] = 32;
    }
    utfarg_( &i, strg  );
  }
}
