//                              -*- Mode: C++ -*-
//: CmdCareDump.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/CmdCareDump.hh"
#include "arte/ArteMessage.hh"

/////////////// The function seen by kuip

extern "C" {
  void caredump_(){
    CmdCareDump dumpCmd;
    dumpCmd.readAndExe();
  }
}

/////////////// Static data definition

bool CmdCareDump::dumpdata[END] = { 0, 0, 0, 0};

/////////////// CmdCareDump class member function definition

CmdCareDump::CmdCareDump(){}
CmdCareDump::~CmdCareDump(){}

void CmdCareDump::defValues(){
  for(int i=0; i<END; i++){  
    dumpdata[i] =0;
  }
}


//--
//   Execute stored command
void CmdCareDump::execute(){}

#ifdef USEKUIP
//--
//   Read acommand from external
void CmdCareDump::read(){
  int Hflag,Cflag,CTflag,LABflag;
  Hflag = readInt();
  Cflag = readInt();
  CTflag = readInt();
  LABflag = readInt();
  if( Hflag==1 || Hflag==0)
    dumpdata[HFLAG] = Hflag;
  if( Cflag==1 || Cflag==0)
    dumpdata[CFLAG] = Cflag;
  if( CTflag==1 || CTflag==0)
    dumpdata[CTFLAG] = CTflag;
  if( LABflag==1 || LABflag==0)
    dumpdata[LABFLAG] = LABflag;
}
#endif

bool CmdCareDump::get(int i){
  int j=0;
  if(i>=0 && i<END){
    j = dumpdata[i];
  } else {
    j = 0;
  }
  return j;
}

void CmdCareDump::dump(){
 
  arteMsg<<" Hit     dump:"<<dumpdata[0]
	 <<" Shower  dump:"<<dumpdata[1]
	 <<" Cluster dump:"<<dumpdata[2]
	 <<" Track   dump:"<<dumpdata[3];
  arteMsg.allp();
}
