//                              -*- Mode: C++ -*-
//: CmdCareECBoards.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/CmdCareECBoards.hh"
#include "arte/ArteMessage.hh"

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <math.h>


/////////////// The function seen by kuip
#ifdef USEKUIP
extern "C" {

  void kugetc_(char* name, int & len);

  void ecboard_(){
    CmdCareECBoards boardfile;
    boardfile.readAndExe();
    boardfile.dump();
  }
}

#endif

/////////////// Static data definition

char CmdCareECBoards::filename[256] = "\0";

/////////////// CmdCareECBoards class member function definition

CmdCareECBoards::CmdCareECBoards(){}
CmdCareECBoards::~CmdCareECBoards(){}

void CmdCareECBoards::defValues(){
  strcpy(filename,"ECAL/ecalboard.dat");
}


//--
//   Execute stored command
void CmdCareECBoards::execute(){}

#ifdef USEKUIP
//--
//   Read acommand from external
void CmdCareECBoards::read(){
  char name[256];
  name[0] = '\0';
  strcpy(name,"                       \0");
  int len = 250;
  cout<<" Reading board file name  "<<name<<endl;
  kugetc_(name, len);
  //cout<<" Read from kuip ("<<len<<" chars) :"<<name<<endl;
  if( len>0) {
    int i=0;
    for(; i<256 && name[i]!=' ' && name[i]!='\0'; i++)
      filename[i] = tolower(name[i]);
    //    filename[len] = '\0';
    filename[i] = '\0';
    //cout<<"I="<<i<<endl;
  } else {
    defValues();
  }
}
#endif

char* CmdCareECBoards::boardfile(){
  if( filename[0]==0) 
    defValues();
  return filename;
}

void CmdCareECBoards::dump(){
  arteMsg<<" Board file name :"<<filename;
  arteMsg.allp();
}
