//                              -*- Mode: C++ -*-
//:CmdCareMerger.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 26/5/97
// Last Update ........
//

#include "care/CmdCareMerger.hh"
#include "care/ECALtypes.hh"
#include"care/EDClusHypotModifier.hh"
#include "care/ESCTCValley.hh"

extern "C"  { void kugetr_(float *); }

extern "C" {
void caremerger_(){
  CmdCareMerger careMerg;
  careMerg.readAndExe();

}
}; // end of extern

CmdCareMerger::CmdCareMerger() : minimum(1.0), valley(0.2) {}
CmdCareMerger::~CmdCareMerger(){}

void CmdCareMerger::defValues(){
  minimum = 1.0;
  valley = 0.2;
}

//--
//   Execute stored command
void CmdCareMerger::execute(){
  ESCTCValley::setMergingCutOff(valley);
  EDClusHypotModifier::setMergingCutOffs(minimum,valley);
}

#ifdef USEKUIP
//--
//   Read a command from external
void CmdCareMerger::read(){

  minimum = readFloat();
  valley  = readFloat();
  if(minimum<0.001 || valley>minimum)
    defValues();
}
#endif
                          
//--
//   Printout Information for the current lambda info stored
void CmdCareMerger::dump(){
   EDClusHypotModifier::dumpMergingCutOffs();
}


