//                              -*- Mode: C++ -*-
//:ECDcalIO.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 9/4/97
// Last Update ........
//

#include "care/ECDcalIO.hh"


/*
CLASS
  ECDcalIO


*/

// -------------------------------
ECDcalIO::ECDcalIO() :  dcal(1), hfwd(0), nrows(0) , current(0){}

void ECDcalIO::start(EcalEvent_t * ){
  dcal = 1;
  hfwd = 0;
  nrows = ArtePointer<DCAL>::nrow()*2;
  current = 0;
}

void ECDcalIO::start(){
  dcal = 1;
  hfwd = 0;
  nrows = ArtePointer<DCAL>::nrow()*2;
  current = 0;
}
//
//-- 
//  Write to DCAL
ECDcalIO & ECDcalIO::operator << (unsigned short value){
  
  if( hfwd==0 ){  // write the first short
    DCAL Edcal;
    /*
    entry.hfw[0] = value;
    entry.hfw[1] = 0;
    (unsigned int *) *Edcal.bits =  entry.bits; */
    entry.bits[0] = (unsigned) (value>>8) & 255;
    entry.bits[1] = (unsigned) (value & 255);
    entry.bits[2] = 0;
    entry.bits[3] = 0;
    Edcal.bits = entry.bits;
    ArtePointer<DCAL>::append(Edcal);
    dcal = ArtePointer<DCAL>::nrow();
    hfwd = 1;
  } else {
    /*    entry.bits = *((unsigned int *) dcal->bits);
    entry.hfw[1] = value;
    (unsigned int *) *dcal->bits = entry.bits; */
    entry.bits = dcal->bits;
    entry.bits[2] = (unsigned) (value>>8) & 255;
    entry.bits[3] = (unsigned) (value & 255);
    dcal->bits = entry.bits;
    hfwd = 0;
  }
  return *this;
}
/*
//
//-- 
//  Read from DCAL
ECDcalIO & ECDcalIO::operator >> (unsigned short & value){
  if( dcal.index()!=0 && dcal.index()<=nrows) {
    entry.bits = dcal->bits;  // get the bits
    if( hfwd==0){
      value = (((unsigned)entry.bits[0])<<8)
              +(((unsigned)entry.bits[1])&255);
      // get the value
    } else if( hfwd==1 ){  // point to the next DCAL entry
      value = (((unsigned)entry.bits[2])<<8)+
              +(((unsigned)entry.bits[3])&255);
      dcal = dcal.index()+1;
    }
    hfwd = 1-hfwd;   // flip between 1 and 0
  } 
  return *this;
}

 //--
  //  Test if pointers are still valid
int ECDcalIO::valid() const{  
  int entr = (nrows+1-dcal.index())*2- hfwd;
  if(dcal.index()==0 && (hfwd & 0xFFFE) != 0)
    entr = 0;
  return entr;
}
*/
