//                              -*- Mode: C++ -*-
//:ECcalch.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//


#include "care/ECCellID.hh"
#include "auto/ECA.hh"

// routine to transform a gcal number into a 
// echc and ecbo index

extern "C" {
  int ecalch_(int *gcal, int * ecbo){
    // test if banks are present
    if(ArtePointer<ECHS>::getLink()()==0 ||
       ArtePointer<ECHF>::getLink()()==0 ||
       ArtePointer<ECBO>::getLink()()==0){
      // calibration banks are not booked!!
      *ecbo = 0;
      return 0;
    }

    ECCellID cellID( *gcal); // get the gcal value into the object descriptor
    CellIdx_t cell = cellID.cellIdx();
    if( cell.index()!=0 ){
      ArtePointer<ECHS> echs(cell.index());
      *ecbo = echs->ecbo;   // assign the linked board descriptor
      return  cell.index();  // return the ECHC entry
    } else {
      *ecbo = 0;
      return 0;
    }
  }
}
