//                              -*- Mode: C++ -*-
//:ECALtypes.hh
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 14/4/97
// Last Update ........
//
//
#ifndef ECALTYPES_HH_
#define ECALTYPES_HH_


#ifdef __xlC__
#  include <stl_config.h>
#  define _OLD_NAMES_
#endif
#ifdef __CC__
#  include <stl_config.h>
#endif



#include "arte/Arte.hh"
#include "auto/GCCE.hh"


//typedef int CellIdx_t;
typedef ArtePointer<GCCE> CellIdx_t;
typedef float Energy_t; // Use Energy_t type for energy data
typedef float Coord_t;  // Use Coord_t type for x,y,z data (cm)
enum  Level_t {TOPLEVEL= 0, FIRSTLEVEL = 1,MAXDEPTH=10000};

enum  SubCal {Inner=1, Middle = 2, Outer = 3};

typedef float ChiSquare_t; // use this type for ChiSquare information
//typedef unsigned char Hyp_t; // use this type for hypotheses
typedef int Hyp_t; // use this type for hypotheses

typedef unsigned short EcalEvent_t; // use this for the RAW ecal event

#endif // ECALTYPES_HH_
