//                              -*- Mode: C++ -*-
//:ECLastHit.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 6/5/97
// Last Update ........
//
#ifndef ECLASTHIT_HH_
#define ECLASTHIT_HH_


#include "care/care.hh"
#include "arte/Arte.hh"
#include "auto/MC.hh"
#include "auto/REC.hh"

#ifdef CMATCH
#  ifdef RTRALINK
#    include "marple/RcTraPoint.hh"
     typedef RcTraPoint TrackInfo;
#  else
#    include "marple/RcSegPoint.hh"
     typedef RcSegPoint TrackInfo;
#  endif
#else

struct TrackInfo {
  // default constructor
  TrackInfo();
  // full constructor
  TrackInfo(ArtePointer<RTRA> tr, float z, float x, float y, float tx, 
	    float ty, float p, ArtePointer<MTRA> mc);
  //
  //  Data start here
  //
  ArtePointer<RTRA>  track;
  float zf;
  float xf;
  float yf;
  float txf;
  float tyf;
  float pf;
  ArtePointer<MTRA>  mctrack;
};

#endif

extern "C" {  
  void eclasthit_(int * it,float * z,double * x,double * c,int *imc);
}


#endif // ECLASTHIT_HH_ 
