//                              -*- Mode: C++ -*-
//:MMBanks.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 9/4/97
// Last Update ........
//
#ifndef MMBanks_HH_
#define MMBanks_HH_

/**
  Interfaces with the MM package
  */
extern "C" {
  void mmbook_( int& link, const int &number );
  void mmbrel_( int& relBank, unsigned int &hitC, unsigned int &nrccl);
  void mmdrop_( int& link );
}

template <class T> 
class MMBank {
public:
  /// empty constructor
  MMBank(){};
  /// empty destructor
  ~MMBank(){};

  /// Book a bank with number entries
  static void Book( int number ){
    mmbook_(ArtePointer<T>::getLink().getRef(), number);
  };

  /// Make a relation between entries
  static void Brel( unsigned int first, unsigned int second){
    mmbrel_(ArtePointer<T>::getLink().getRef(), first, second);
  };
  
  /// Drop the bank
  static void Drop(){
    mmdrop_(ArtePointer<T>::getLink().getRef());
  };
};

#endif // MMBanks_HH_
