//**********************************************************************/
//
// MARPLE function for matching Care and Reconstructed SEGments~
//
//**********************************************************************/

#include "marple/marple.hh"
#include "care/ECALDetector.hh"
#include "arte/ArteMessage.hh"
#undef WRITE

#ifdef WRITE
#  include <iostream.h>
#endif

vector<RcSegPoint* > RangSegList;

void matchRsegCare()
{
  arteMsg<<" Matching";
  arteMsg.allp();
  if(RangSegList.size()>0){
    for(vector<RcSegPoint* >::iterator iter = RangSegList.begin();
      iter!=RangSegList.end(); iter++){
      delete *iter;
    }
    RangSegList.erase(RangSegList.begin(), RangSegList.end());		
  }

  // RANGER - Care matching
  // create list of tracks from Ranger
  if(ArtePointer<RSEG>::getLink()()==0) return;
 
  for( ArteTableIterator <RSEG> irseg; irseg.valid(); irseg.next() ){
    if( irseg->fit > 0 && irseg->cmp == 6  ){
	RangSegList.push_back(
			      new RcSegPoint( RcPoint( Hep3Vector(irseg->xe,
								  irseg->ye,
								  irseg->ze),
						       irseg->txe,
						       irseg->tye,
						       irseg->cve ),
					      irseg.index()) );
      }
  }

  for(vector<RcSegPoint* >::iterator iter = RangSegList.begin();
      iter!=RangSegList.end(); iter++){
    // store the pointer to the track segment
    ECALDetector::storeTrack(**iter);

#   ifdef WRITE
    cout<<" Cached the last hit of track "<<(*iter)->link()
	<<" Z="<<(*iter)->z()
	<<"  X= "<<(*iter)->x()<<"  Y= "<<(*iter)->y()<<endl;
#   endif
  }

  arteMsg<<" Found "<<RangSegList.size()<<" segments";
  arteMsg.allp();

}


