#define __I_N_I_T__
#include "database/Lists.h"
#include "database/DbLists.h"
#include "database/DbInit.h"

int dbinit_(void) {

  /*************************************************************************
   *
   * Author: HERA-B Bologna.
   *
   * Description: Initialize Db package.
   *
   * Called from: ATINIT
   *
   * External references:
   *
   * Return value: 1 success, 0 error.
   *
   ************************************************************************/

  char *mess;

  if( !DbMemoInit() ) {
    mess = "DbMemoInit: lists initialization failed";
    meerro_( mess, strlen(mess) );
    return 0;
  }

  dbkuip_();

  ku_exec( "EXEC db.kumac" );

  return 1;

}

int DbMemoInit(void) {

  /*************************************************************************
   *
   * Author: HERA-B Bologna.
   *
   * Description: Db lists inizialization.
   *
   * Called from: DBINIT
   *
   * External references: ListInit
   *
   * Return value: 1 success, 0 error.
   *
   ************************************************************************/

  int n=1;

  n &= ListInit( DbFiles, 'U' );
  n &= ListInit( DbTables, 'U' );

  return n;

}


















































