#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <varargs.h>
#include <string.h>
#include "database/Lists.h"

int ListInit(void *h, char t) {

  __Base *p = h;
  void *m;

  List(Mother_list) M;
  if( p->__mother == 0 ) {
    M.pointer = p;
    M.type = t;
    if( ( m = ListAdd( Mother_list, &M ) ) == 0 ) return 0;
    p ->__mother = m;
    return 1;
  }
  return 0;
}

void *ListAdd(void *h, void *l) {

  __Base *p = h;
  __Links *r;

  if( l == 0 ) return 0;
  if( ( r = (void *)malloc(p->__size) ) == 0 ) return 0;
  if( p->__first == 0 ) {
    p->__first = p->__last=r;
    r->__prev  = 0;
    r->__next  = 0;
  }
  else {
    r->__prev = p->__last;
    r->__next = 0;
    ((__Links *)(p->__last))->__next=r;
    p->__last = r;
  }
  p->__entries++;
  memcpy( (char *)r + sizeof(__Links), (char *)l + sizeof(__Links),
	 p->__size - sizeof(__Links) );
  return r;
}

int ListRemove(void *h, void *f) {

  __Base *p = h;
  __Links *s = f;

  if( p->__first == 0 || f == 0 ) return 0;
  if( p->__first == p->__last ) p->__first = p->__last = 0;
  else if( p->__first == f ) {
    p->__first = s->__next;
    ((__Links *)(p->__first))->__prev = 0;
  }
  else if( p->__last == f ) {
    p->__last = s->__prev;
    ((__Links *)(p->__last))->__next = 0;
  }
  else {
    ((__Links *)(s->__prev))->__next = s->__next;
    ((__Links *)(s->__next))->__prev = s->__prev;
  }
  free (f);
  p->__entries--;
  return 1;
}

ListIterator ListReset(void *h) {

  __Base *p = h;
  ListIterator r;

  r.__first = r.__iter = p->__first;
  return r;
}

int ListDrop(void *h) {

  __Base *p=h;
  void *t;
  int n=1;
  ListIterator i;

  if( p->__first == 0 ) return 0;
  for(i = ListReset( p ) ; ListMore( i ) ; ) {
    t = ListCurrent( i );
    ListNext( i );
    n &= ListRemove( p, t );
  }
  return n;
}

int ListWipe(char t) {

  ListIterator i;
  List(Mother_list) *M;
  int n=1;

  if( ((__Base *)Mother_list)->__first == 0 ) return 0;
  for( i = ListReset(Mother_list) ; ListMore( i ) ; ) {
    M = ListCurrent( i );
    ListNext( i );
    if( M->type == t ) n &= ListDrop( M->pointer );
  }
  return n;
}

int ListClear(void) {

  ListIterator i;
  List(Mother_list) *M;
  int n=1;

  if( ((__Base *)Mother_list)->__first == 0 ) return 0;
  for( i = ListReset( Mother_list ) ; ListMore( i ) ; ) {
    M = ListCurrent( i );
    ListNext( i );
    n &= ListDrop( M->pointer );
  }
  return n;
}

void *ListSearchF(lst, fmt, va_alist) void *lst; char *fmt; va_dcl
{

  va_list ap;
  ListIterator t;
  char *c;
  void *curnt,*as,*af;
  int i,at,st;
  __Base *p=lst;

  if( p->__first == 0 ) return 0;
  for( t = ListReset( p ) ; ListMore( t ) ; ListNext( t ) ) {
    va_start( ap );
    curnt = ListCurrent( t );
    for(c = fmt ; *c != '\0' ; c++ ) {
      if( *c != 'i' &&
	  *c != 'f' &&
	  *c != 'c' &&
	  *c != 's' &&
	  *c != 'S' ) continue;
      as = va_arg( ap, void * );
      at = (int)( (char *)as - ((char *)lst + sizeof(__Base)) );
      af = (char *)curnt + at + sizeof(__Links);
      switch(*c) {
      case 'i':
	if( c[-1] == 'l' && c[-2] == 'l' )
	  st = ((*(long long int *)af) != (*(long long int *)as)) ? 1 : 0;
	else if( c[-1]=='l' ) 
	  st = ((*(long int *)af) != (*(long int *)as)) ? 1 : 0;
	else
	  st = ((*(int *)af) != (*(int *)as)) ? 1 : 0;
	break;
      case 'f':
       	if( c[-1] == 'l' && c[-2] == 'l')
	  st = ((*(long double *)af) != (*(long double *)as)) ? 1 : 0;
	else if( c[-1] == 'l' )
	  st = ((*(double *)af) != (*(double *)as)) ? 1 : 0;
	else
	  st = ((*(float *)af) != (*(float *)as)) ? 1 : 0; 
	break;
      case 'c':
	st = ((*(char *)af) != (*(char *)as)) ? 1 : 0;
	break;
      case 's':
	st = (strcmp( (char *)af, (char *)as) ) ? 1 : 0;
	break;
      case 'S':
	st=( strcmp( *(char **)af, *(char **)as) ) ? 1 : 0;
	break;
      default:
	break;
      }
    }
    if( !st ) { 
      va_end( ap );
      return curnt;
    }
  }
  va_end( ap );
  return 0;
}

void *ListSearchS(lst, num, va_alist) void *lst; int num; va_dcl
{

  va_list ap;
  ListIterator t;
  size_t sz;
  char *c;
  void *curnt,*as,*af;
  int i,at,st;
  __Base *p=lst;

  if(p->__first == 0) return 0;
  for( t = ListReset( p ) ; ListMore( t ); ListNext( t ) ) {
    st = 0;
    for(i = 1; i <= num ; i++ ) {
      va_start( ap );
      curnt = ListCurrent( t );
      sz = va_arg( ap, size_t );
      as = va_arg( ap, void * );
      at = (int)( (char *)as - ((char *)lst + sizeof(__Base)) );
      af = (char *)curnt + at + sizeof(__Links);
      st += (memcmp(as, af, sz) !=0 ) ? 1 : 0;
    }
    if( !st ) {
      va_end( ap );
      return curnt;
    }
  }
  va_end( ap );
  return 0;
}

int ListPrint(lst, fmt, va_alist) void *lst; char *fmt; va_dcl
{

  va_list ap;
  ListIterator t;
  char *c,*count,o[256];
  void *curnt,*argp,*argdeb;
  int i;
  __Base *p=lst;

  if(p->__first == 0) {
    printf( "ListPrint: list %s empty\n", p->__name );
    return 0;
  }
  else printf( "List: listing %s\n", p->__name );
  for( t = ListReset( p ) , i = 1 ; ListMore( t ) ; ListNext( t ) ) {
    va_start( ap );
    curnt = ListCurrent( t );
    printf( "==>Entry n. %i\n", i++ );
    for( c = count = fmt ; *c != '\0' ; c++ ) {
      if( *c != '%' ) continue;
      if( c[1] == '%' ) { c++; continue; }
      argdeb = va_arg( ap, void * );
      argp = (char *)curnt + 
	((char *)argdeb -((char *)lst + sizeof(__Base))) + 
	sizeof(__Links);
      while( *++c != 'd' &&
	     *c != 'i' &&
	     *c != 'o' &&
	     *c != 'u' &&
	     *c != 'x' &&
	     *c != 'X' &&
	     *c != 'f' &&
	     *c != 'e' &&
	     *c != 'E' &&
	     *c != 'g' &&
	     *c != 'G' &&
	     *c != 'c' &&
	     *c != 's' &&
	     *c != 'S' &&
	     *c != 'p' &&
	     *c != 'n' );
      strncpy( o, count, (size_t)(c-count+1) );
      o[(int)( c-count+1 )] = '\0';
      switch ( *c ) {
      case 'i':
      case 'd':
      case 'o':
      case 'u':
      case 'x':
      case 'X':
	if( c[-1] == 'l' && c[-2] == 'l' )
	  printf( o, *(long long int *)argp );
	else if( c[-1] == 'l' )
	  printf( o, *(long int *)argp );
	else if( c[-1] == 'h' )
	  printf( o, *(short int *)argp );
	else
	  printf( o, *(int *)argp );
	break;
      case 'f':
      case 'e':
      case 'E':
      case 'g':
      case 'G':
	if( c[-1] == 'L' )
	  printf( o, *(long double *)argp );
	else if( c[-1] == 'l' )
	  printf( o, *(double *)argp );
	else
	  printf( o, *(float *)argp );
	break;
      case 'c':
	printf( o, *(char *)argp );
	break;
      case 's':
	printf( o, (char *)argp );
	break;
      case 'S':
	printf( o, *(char **)argp );
	break;
      case 'p':
	printf( o, *(void **)argp );
	break;
      default:
	break;
      }
      count = c+1;
    }
    printf( count );
  }
  va_end( ap );
  return 1;
}














