//                              -*- Mode: C++ -*-
//:dgcalche.C
// 
//:description - ADC CHANNEL -> ENERGY CONVERSION
//
// Author: Benedetto Giacobbe   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: giacobbe@bo.infn.it
//
// Created 26/7/97
// Last Update ........
//

//#include <stdlib.h>
#include <math.h>
#include "arte/Arte.hh"
#include "care/dgcal.hh"
#include "auto/ECA.hh"

float dgcalche(int idcell, int ich, float & fadc, float & enerr){
    
  ArtePointer<ECHF> echf(idcell);      
  ArtePointer<ECHS> echs(idcell);      
  float ch = (float)(ich)-echf->pedf;  /* ADC count -pedestal */
  fadc = ch;
  float q_rec =  echs->pcal[0];
  float ch_red = ch/4095.;
  float ch_redpow = ch_red;
    
  for(int i=1;i<6;i++){
    q_rec += echs->pcal[i]*ch_redpow;
    ch_redpow *= ch_red;
  }
  
  float en_rec = q_rec*echf->q;   
  //cout<<"Channel: "<<ich<<" Q: "<<echs->chmi<<"  Energy: "<<en_rec<<endl;

  // evaluate the energy error
  enerr =  echs->ecal[0];
  float en_redpow = en_rec;
  for(int j=1; j<3; j++){
    enerr += echs->ecal[j]*en_redpow;
    en_redpow *= en_rec;
  }
  return en_rec;
}

