/*************************************************************************
*
* CR_ARTE_USER
* written by Siegmund Nowak
*
* This routines gives the user the possibility to change data in the 
* last GEDE bank produced by cr_arte.C
*
*       called from G..MAIN
*
*************************************************************************/

#include "arte/Arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/ZGMOTH.h"
#include "auto/GEO.hh"
#include "gean/ZGESL.h"

  extern "C" {
    void cr_arte_user_(int,int,char*,int*,int);
    void itr_arte_(int,int,char*,int*,int);
    void sil_arte_(int,int,char*,int*,int);
    void ric_arte_(int,int,char*,int*,int);}

void cr_arte_user_(int ngede,int ngwal,char *lvols,int lcopy[],int nlev) {

    ArtePointer<GESL> gesl(zgmoth_.CURRSL);

    if(gesl->cmp == LGESL_SIL) 
       sil_arte_(ngede,ngwal,lvols,lcopy,nlev);

    else if(gesl->cmp == LGESL_MSG) 
       itr_arte_(ngede,ngwal,lvols,lcopy,nlev);

    else if(gesl->cmp == LGESL_RIC) 
       ric_arte_(ngede,ngwal,lvols,lcopy,nlev);


  }
      
/* cr_arte_user */








