
      SUBROUTINE CRGEDE(NAME,ILAY,ISEC)

************************************************************************
* CRGEDE
* written by Siegmund Nowak
*
* This routine books and fills the detector bank GEDE
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* var1        in           this variable will only be read
************************************************************************
      IMPLICIT NONE

      INTEGER ILAY,ISEC,IUCOMP,I,IVOS,JVOS,LVOLS(15),LCOPY(15),NLEV,
     +        INDAUT,NN
      INTEGER MATNUM,NUMED,NMAT,NMM,LENOCC
      REAL POS(11),ROTM(9),XMS
      CHARACTER NAME*4,MATNAM*20

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcvolu.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGMOTH.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

C     Book GEDE bank and connect it to GESL bank 
      IF(CURRSL.LE.0.OR.CURRSL.GT.NGESL()) 
     +                   CALL MEERRO('CRGEDE: current GESL entry = 0 ')
      CALL MMBOOK(JGEDE,1)
      NN = NGEDE()
      CALL MMBREL(JGSGD,CURRSL,NN)
      IF(IGESL_FPL(CURRSL).EQ.0) IQ(IQGESL_FPL(CURRSL)) = NN   
      IQ(IQGESL_NPL(CURRSL)) = IQ(IQGESL_NPL(CURRSL)) + 1

C     get detector volume nr IVOL 
      IVOS = IUCOMP (NAME, IQ(JVOLUM+1), IQ(JVOLUM-1))
      IF(IVOS.EQ.0) CALL MEERRO('CRGEDE >> NONVALID VOLUME')
      JVOS = LQ(JVOLUM-IVOS)

c     define the volume tree into LVOLS,LCOPY
      CALL CRLVBK(IQ(JVOLUM+IVOS),NN,INDAUT,NLEV,LVOLS,LCOPY)
      IF(NLEV.LE.0) CALL MEERRO('CRGEDE: NLEV < 0 ')

c     call the transformation routine and fill the geometric data in
      CALL CRVTRM(NLEV,LVOLS,LCOPY,POS,ROTM)
      CALL UCOPY(POS    ,Q(QGEDE_XMIN_L()),6)
      CALL UCOPY(POS(7) ,Q(QGEDE_XMAD_L()),3)
      CALL UCOPY(POS(10),Q(QGEDE_COS_L()) ,2)
      CALL UCOPY(ROTM,Q(QGEDE_ROT_L(1)),9) 

c     fill the remaining data 
      IQ(IQGEDE_CMP_L()) = IGESL_CMP(CURRSL)
      IQ(IQGEDE_SHP_L()) =  Q(JVOS+2)
      NUMED = Q(JVOS+4)
      NMAT = Q(LQ(JTMED-NUMED)+6)
      CALL UHTOC(Q(LQ(JMATE-NMAT)+1),4,MATNAM,20)
      NMM = MATNUM(MATNAM(1:LENOCC(MATNAM)))
      CALL MMBREL(JGMGD,NMM,NN)
      CALL GRADLN(IVOS,XMS)
      XMS = (POS(6)-POS(5))/XMS
      Q(QGEDE_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2
      IQ(HQGEDE_GVOL_L()) = IQ(JVOLUM+IVOS)

      IQ(IQGEDE_LAY_L()) = ILAY
      IQ(IQGEDE_SEC_L()) = ISEC

      IF(IDEBUG.NE.0) THEN
         IF(IGESL_CMP(CURRSL).EQ.LGESL_SIL) THEN
            WRITE(LPRNT,101) NN,(Q(QGEDE_XMIN_L()+I),I=0,5),
     +                   FGEDE_SIN(NN),GRMAT(10,NLEV),IGEDE_CMP(NN)
         ELSE
            WRITE(LPRNT,102) NN,(Q(QGEDE_XMIN_L()+I),I=0,5),
     +                   FGEDE_SIN(NN),GRMAT(10,NLEV),IGEDE_CMP(NN)
         ENDIF
      ENDIF
      RETURN
 101  FORMAT(1X,'DET ',I4,6(1X,F7.3),1X,F6.3,F2.0,I4)
 102  FORMAT(   'DET' ,I4,6(1X,F8.2),1X,F6.2,F2.0,I4)
      END




