      SUBROUTINE CRGWAL(NAME,NCOPY)

************************************************************************
*
* written by Siegmund Nowak 14/02/95
* extended by A.Lanyov for ISHAP=2 (trapezoid x varying)
*
* This routine books and fills the ZEBRA bank GWAL for walls
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* NAME        in          name of the wall
* NCOPY       in          copy number
************************************************************************

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcvolu.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGMOTH.fi"
      INTEGER IUCOMP,I,NCOPY,NN
      INTEGER IVOS,JVOS,LVOLS(15),LCOPY(15),NLEV,INDAUT,
     +        MATNUM,NUMED,NMAT,NMM,LENOCC
      REAL POS(11),ROTM(9),XMS
      CHARACTER NAME*4,MATNAM*20
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C     Book GWAL bank and connect it to GESL bank, 
      IF(CURRSL.LT.0.OR.CURRSL.GT.NGESL()) 
     +               CALL MEERRO('CRWAL: current GESL entry < 0')
      CALL MMBOOK(JGWAL,1)
      NN = NGWAL()
      IF(CURRSL.NE.0) THEN       
         CALL MMBREL(JGSGW,CURRSL,NN)
         IF(IGESL_FWL(CURRSL).EQ.0) IQ(IQGESL_FWL(CURRSL)) = NN   
         IQ(IQGESL_NWL(CURRSL)) = IQ(IQGESL_NWL(CURRSL)) + 1
      ENDIF

C     get wall volume nr IVOL 
      IVOS = IUCOMP (NAME, IQ(JVOLUM+1), IQ(JVOLUM-1))
      IF(IVOS.EQ.0) CALL MEERRO('CRGWAL >> NONVALID VOLUME')
      JVOS = LQ(JVOLUM-IVOS)

c     define the volume tree into LVOLS,LCOPY
      CALL CRLVBK(IQ(JVOLUM+IVOS),NCOPY,INDAUT,NLEV,LVOLS,LCOPY)
      IF(NLEV.LE.0) CALL MEERRO('CRGWAL : NLEV .LE.0 ')

c     call the transformation routine and fill the geometric data in
      CALL CRVTRM(NLEV,LVOLS,LCOPY,POS,ROTM)
      CALL UCOPY(POS    ,Q(QGWAL_XMIN_L()),6)
      CALL UCOPY(POS(7) ,Q(QGWAL_XMAD_L()),3)
      CALL UCOPY(ROTM,Q(QGWAL_ROT_L(1)),9)

c     fill the remaining data 
      IQ(IQGWAL_SHP_L()) = Q(JVOS+2)
      NUMED = Q(JVOS+4)
      NMAT = Q(LQ(JTMED-NUMED)+6)
      CALL UHTOC(Q(LQ(JMATE-NMAT)+1),4,MATNAM,20)
      NMM = MATNUM(MATNAM(1:LENOCC(MATNAM)))
      CALL MMBREL(JGMGW,NMM,NN)
      CALL GRADLN(IVOS,XMS)
      XMS = (POS(6)-POS(5))/XMS
      Q(QGWAL_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2
      IQ(HQGWAL_GVOL_L()) = IQ(JVOLUM+IVOS)

      IF(IDEBUG.NE.0)WRITE(LPRNT,102)NGWAL(),(Q(QGWAL_XMIN_L()+I),I=0,5)
     +                             ,FGWAL_YMAD(NGWAL()),GRMAT(10,NLEV)

      NLEVEL = 0
      RETURN
 102  FORMAT('WALL',I4,6(1X,F8.2),1X,F6.3,F2.0)
      END
