
      SUBROUTINE  EBMGEO(REGION)

************************************************************************
* EBMGEO
* written by Siegmund Nowak 03/93
*
* Description:  define geometry of the electron beam pipe
*
* called from GEOMAIN
*
* External references:
*
* Changes since last version: new geometry version (Eckmann 03/95)
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* REGION      in          either 'MAGN', 'CALO' or 'MUON'
************************************************************************

      IMPLICIT NONE

      INTEGER I,IFIRST,IVOL,JBAP,MEDNUM
      REAL PAR(5),XP,YP,ZP,ZP1,RI
      CHARACTER REGION*4

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA IFIRST /0/
#include "arte/Arte.ff"
#include "auto/GEO.ff"


      IF(IFIRST.EQ.0) THEN
 
         CALL EBMDAT('ebm.dat')
         
         CALL GSVOLU('ETFM','TUBE',MEDNUM(2,'IRON'),     PAR ,0 ,IVOL)
         CALL GSATT('ETFM','COLO',20)
         CALL GSVOLU('ETAM','TUBE',MEDNUM(2,'ALUMINIUM'),PAR ,0 ,IVOL)
         CALL GSATT('ETAM','COLO',50)
         CALL GSVOLU('ETCM','TUBE',MEDNUM(2,'COPPER' ),PAR ,0 ,IVOL)
         CALL GSATT('ETCM','COLO',20)
         CALL GSVOLU('ETVM','TUBE',MEDNUM(2,'VACUUM'),PAR ,0 ,IVOL)
         CALL GSATT('ETVM','SEEN',0)
         CALL GSVOLU('ETFP','TUBE',MEDNUM(1,'IRON' ),PAR ,0 ,IVOL)
         CALL GSATT('ETFP','COLO',20)
         CALL GSVOLU('ETVP','TUBE',MEDNUM(1,'VACUUM'),PAR ,0 ,IVOL)
         CALL GSATT('ETVP','SEEN',0)
         CALL GSVOLU('ECFM','CONE',MEDNUM(2,'IRON' ),PAR ,0 ,IVOL)
         CALL GSATT('ECFM','COLO',20)
         CALL GSVOLU('ECAM','CONE',MEDNUM(2,'ALUMINIUM' ),PAR ,0 ,IVOL)
         CALL GSATT('ECAM','COLO',50)
         CALL GSVOLU('ECCP','CONE',MEDNUM(1,'COPPER' ),PAR ,0 ,IVOL)
         CALL GSATT('ECCP','COLO',20)
         CALL GSVOLU('ECCM','CONE',MEDNUM(2,'COPPER' ),PAR ,0 ,IVOL)
         CALL GSATT('ECCM','COLO',20)

         CALL GSVOLU('EBAP','TUBE',MEDNUM(1,'ALUMINIUM'),PAR,0,IVOL)
         CALL GSATT('EBAP','COLO',50)
         CALL GSVOLU('EBAM','TUBE',MEDNUM(2,'ALUMINIUM'),PAR,0,IVOL)
         CALL GSATT('EBAM','COLO',50)
         CALL GSVOLU('EBVP','TUBE',MEDNUM(1,'VACUUM'),PAR ,0 ,IVOL)
         CALL GSATT('EBVP','SEEN',0)
         CALL GSVOLU('EBVM','TUBE',MEDNUM(2,'VACUUM'),PAR ,0 ,IVOL)
         CALL GSATT('EBVM','SEEN',0)

         JBAP = 0
         
         IFIRST = 1
      ENDIF

      RI = RNTUB - WDNTUB

      IF(REGION.NE.'MAGN') GO TO 200

C ***          POSITION VOLUMES BEFORE MAGNET

C     normal beam tube
 100  PAR(1) = RI
      PAR(2) = RNTUB
      PAR(3) = 0.5 * (FGESL_Z1(MAGNSL)-FGESL_Z1(MOTHSL))
      ZP = ZZERO + FGESL_Z1(MOTHSL) + PAR(3)
      JBAP = JBAP + 1
      CALL CRPOS('EBAP','MOTH',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     VACUUM IN THE BEAM TUBE
      PAR(1) = 0.
      PAR(2) = RI
      CALL GSPOSP('EBVP',JBAP,'MOTH',XETUB,YETUB,ZP,0,'ONLY',PAR,3)
      ZP = ZP + PAR(3)

C ***          POSITION VOLUMES IN MAGNET

C--   normal beam tube

      ZP = 0.5*(FGESL_Z1(MAGNSL)-FGESL_Z2(MAGNSL))
      IF(ZCCOIL(1).LE.FGESL_Z1(MAGNSL)) GO TO 10

      PAR(1) = RI
      PAR(2) = RNTUB
      PAR(3) = 0.5 * (ZCCOIL(1)-FGESL_Z1(MAGNSL))
      ZP =  ZP + PAR(3)
      JBAP = JBAP + 1
      CALL CRPOS('EBAM','MAGN',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     VACUUM
      PAR(1) = 0.
      PAR(2) = RI
      CALL GSPOSP('EBVM',JBAP,'MAGN',XETUB,YETUB,ZP,0,'ONLY',PAR,3)
      ZP = ZP + PAR(3)

C--    Start tube without coil

C     OUTER TUBE
 10   PAR(1) = RMETUB(1)
      PAR(2) = ROUTUB(1)
      PAR(3) = 0.5 * (ZCCOIL(2) - ZCCOIL(1))
      ZP = ZP + PAR(3)
      JBAP = JBAP + 1
      CALL CRPOS('ETFM','MAGN',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     Medium tube
      PAR(1) = RINTUB(1)
      PAR(2) = RMETUB(1)
      CALL CRPOS('ETAM','MAGN',1,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     Inner tube
      PAR(1) = RVATUB
      PAR(2) = RINTUB(1)
      CALL CRPOS('ETFM','MAGN',2,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     vacuum
      PAR(1) = 0.
      PAR(2) = RVATUB
      CALL GSPOSP('ETVM',JBAP,'MAGN',XETUB,YETUB,ZP,0,'ONLY',PAR,3)

      ZP = ZP + PAR(3)

C--    Start tube with coil

C     OUTER TUBE
      PAR(1) = RMETUB(1)
      PAR(2) = ROUTUB(1)
      PAR(3) = 0.5 * (ZCCOIL(3) - ZCCOIL(2))
      ZP = ZP + PAR(3)
      JBAP = JBAP + 1
      CALL CRPOS('ETFM','MAGN',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     Medium tube (coil)
      PAR(1) = RINTUB(1)
      PAR(2) = RMETUB(1)
      CALL CRPOS('ETCM','MAGN',1,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     Inner tube
      PAR(1) = RVATUB
      PAR(2) = RINTUB(1)
      CALL CRPOS('ETFM','MAGN',2,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C     vacuum
      PAR(1) = 0.
      PAR(2) = RVATUB
      CALL GSPOSP('ETVM',JBAP,'MAGN',XETUB,YETUB,ZP,0,'ONLY',PAR,3)
      ZP = ZP + PAR(3)

C     Conical part

C     OUTER tube first part
      PAR(1) = 0.5 * (ZCCOIL(5)-ZCCOIL(3))
      PAR(2) = RMETUB(1)
      PAR(3) = ROUTUB(1)
      PAR(4) = RMETUB(2)
      PAR(5) = ROUTUB(1) - (ZCCOIL(5)-ZCCOIL(3))/(ZCCOIL(6)-ZCCOIL(3)) *
     +                                   (ROUTUB(1) - ROUTUB(2))
      ZP1 = ZP + PAR(1)
      JBAP = JBAP+1
      CALL CRPOS('ECFM','MAGN',0,JBAP,XETUB,YETUB,ZP1,0,'ONLY',PAR)
      ZP1 = ZP1 + PAR(1)

C     OUTER tube second part
      PAR(1) = 0.5 * (ZCCOIL(6)-ZCCOIL(5))
      PAR(2) = RMETUB(2)
      PAR(3) = PAR(5)
      PAR(4) = RMETUB(2)
      PAR(5) = ROUTUB(2)
      ZP1 = ZP1 + PAR(1)
      CALL CRPOS('ECFM','MAGN',0,JBAP+1,XETUB,YETUB,ZP1,0,'ONLY',PAR)

C     medium tube first part

      PAR(1) = 0.5 * (ZCCOIL(4)-ZCCOIL(3))
      PAR(2) = RINTUB(1)
      PAR(3) = RMETUB(1)
      PAR(4) = RINTUB(1)
      PAR(5) = RMETUB(1) - (ZCCOIL(4)-ZCCOIL(3))/(ZCCOIL(5)-ZCCOIL(3))*
     +                                   (RMETUB(1) - RMETUB(2))
      ZP1 = ZP + PAR(1)
      CALL CRPOS('ECAM','MAGN',1,JBAP,XETUB,YETUB,ZP1,0,'ONLY',PAR)
      ZP1 = ZP1 + PAR(1)

C     medium tube second part
      PAR(1) = 0.5 * (ZCCOIL(5)-ZCCOIL(4))
      PAR(2) = RINTUB(1)
      PAR(3) = PAR(5)
      PAR(4) = RINTUB(2)
      PAR(5) = RMETUB(2)
      ZP1 = ZP1 + PAR(1)
      CALL CRPOS('ECFM','MAGN',1,JBAP+1,XETUB,YETUB,ZP1,0,'ONLY',PAR)
      ZP1 = ZP1 + PAR(1)

C     medium tube third part

      PAR(1) = RINTUB(2)
      PAR(2) = RMETUB(2)
      PAR(3) = 0.5 * (ZCCOIL(6) - ZCCOIL(5))
      ZP1 = ZP1 + PAR(3)
      CALL CRPOS('ETAM','MAGN',1,JBAP+2,XETUB,YETUB,ZP1,0,'ONLY',PAR)

C--   inner tube first part
      PAR(1) = RVATUB
      PAR(2) = RINTUB(1)
      PAR(3) = 0.5 * (ZCCOIL(4) - ZCCOIL(3))
      ZP = ZP + PAR(3)
      CALL CRPOS('ETFM','MAGN',2,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)
      ZP = ZP + PAR(3)

C--   inner tube second part
      PAR(1) = 0.5 * (ZCCOIL(5)-ZCCOIL(4))
      PAR(2) = RVATUB
      PAR(3) = RINTUB(1)
      PAR(4) = RVATUB
      PAR(5) = RINTUB(2)
      ZP = ZP + PAR(1)
      CALL CRPOS('ECFM','MAGN',2,JBAP+1,XETUB,YETUB,ZP,0,'ONLY',PAR)
      ZP = ZP + PAR(1)

C--   inner tube third part
      PAR(1) = RVATUB
      PAR(2) = RINTUB(2)
      PAR(3) = 0.5 * (ZCCOIL(6) - ZCCOIL(5))
      ZP = ZP + PAR(3)
      CALL CRPOS('ETFM','MAGN',2,JBAP+2,XETUB,YETUB,ZP,0,'ONLY',PAR)
      ZP = ZP + PAR(3)

C     straight part
C--   outer tube
      PAR(1) = RMETUB(2)
      PAR(2) = ROUTUB(2)
      PAR(3) = 0.5 * (ZCCOIL(7) - ZCCOIL(6))
      ZP = ZP + PAR(3)
      JBAP = JBAP + 3 
      CALL CRPOS('ETFM','MAGN',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C--   medium tube
      PAR(1) = RINTUB(2)
      PAR(2) = RMETUB(2)
      CALL CRPOS('ETAM','MAGN',1,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C--   inner tube
      PAR(1) = RVATUB
      PAR(2) = RINTUB(2)
      CALL CRPOS('ETFM','MAGN',2,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)
      ZP = ZP + PAR(3)

C--   last part

C--   outer coil inside magnet
      PAR(1) = 0.5 * (FGESL_Z2(MAGNSL) -ZCCOIL(7))
      PAR(2) = RINTUB(2)
      PAR(3) = ROUTUB(2)
      PAR(4) = RINTUB(2)
      PAR(5) = ROUTUB(2) - 2.*PAR(1)/(ZCCOIL(8)-ZCCOIL(7)) *
     +                      (ROUTUB(2) - RINTUB(2))
      ZP = ZP + PAR(1)
      JBAP = JBAP + 1
      CALL CRPOS('ECCM','MAGN',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C--   outer coil outside magnet
      PAR(1) = 0.5 * (ZCCOIL(8) - FGESL_Z2(MAGNSL))
      PAR(2) = RINTUB(2)
      PAR(3) = PAR(5)
      PAR(4) = RINTUB(2)
      PAR(5) = RINTUB(2) + 1.E-2
      ZP1 = ZZERO + FGESL_Z2(MAGNSL)  + PAR(1)
      CALL CRPOS('ECCP','MOTH',0,JBAP+1,XETUB,YETUB,ZP1,0,'ONLY',PAR)

C--   inner tube inside magnet
      PAR(1) = RVATUB
      PAR(2) = RINTUB(2)
      PAR(3) = 0.5 * (FGESL_Z2(MAGNSL) - ZCCOIL(7))
      CALL CRPOS('ETFM','MAGN',1,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C--   inner tube outside magnet
      PAR(1) = RVATUB
      PAR(2) = RINTUB(2)
      PAR(3) = 0.5 * (ZCCOIL(8) - FGESL_Z2(MAGNSL))
      CALL CRPOS('ETFP','MOTH',1,JBAP+1,XETUB,YETUB,ZP1,0,'ONLY',PAR)

C--   vacuum inside magnet
      PAR(1) = 0.
      PAR(2) = RVATUB
      PAR(3) = 0.5 * (FGESL_Z2(MAGNSL) - ZCCOIL(7))
      CALL GSPOSP('ETVM',JBAP,'MAGN',XETUB,YETUB,ZP,0,'ONLY',PAR,3)

C--   vacuum outside magnet
      PAR(1) = 0.
      PAR(2) = RVATUB
      PAR(3) = 0.5 * (ZCCOIL(8) - FGESL_Z2(MAGNSL))
      CALL GSPOSP('ETVP',JBAP+1,'MOTH',XETUB,YETUB,ZP1,0,'ONLY',PAR,3)
      ZP = ZP1 + PAR(3)

C ***          POSITION VOLUMES BEHIND MAGNET

C--   up to calorimeter

C--   normal tube
      PAR(1) = RI
      PAR(2) = RNTUB
      PAR(3) = 0.5 * (ZZERO + FGESL_Z1(CALOSL) - ZP)
      ZP = ZP + PAR(3)
      JBAP = JBAP + 2
      CALL CRPOS('EBAP','MOTH',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)

C--   VACUUM IN THE BEAM TUBE
      PAR(1) = 0.
      PAR(2) = RI
      CALL GSPOSP('EBVP',JBAP,'MOTH',XETUB,YETUB,ZP,0,'ONLY',PAR,3)
      ZP = ZP + PAR(3)
      GO TO 999

C--   inside calorimeter

 200  IF(REGION.NE.'CALO') GO TO 300

c     tube
      PAR(1) = RI
      PAR(2) = RNTUB
      PAR(3) = 0.5 * (FGESL_Z2(CALOSL)-FGESL_Z1(CALOSL))
      XP = XETUB - .5*(FGESL_X1(CALOSL)+FGESL_X2(CALOSL))
      YP = YETUB - .5*(FGESL_Y1(CALOSL)+FGESL_Y2(CALOSL))
      JBAP = JBAP + 1
      CALL CRPOS('EBAP','CALW',0,JBAP,XP,YP,0.,0,'ONLY',PAR)
      PAR(1) = 0.
      PAR(2) = RI
      CALL GSPOSP('EBVP',JBAP,'CALW',XP,YP,0,0,'ONLY',PAR,3)

C--   between  calorimeter and muon system
c     beam tube
      PAR(1) = RI
      PAR(2) = RNTUB
      PAR(3) = 0.5 * (FGESL_Z1(MUONSL)-FGESL_Z2(CALOSL))
      ZP = ZZERO + FGESL_Z1(MUONSL) - PAR(3)
      JBAP = JBAP + 1
      CALL CRPOS('EBAP','MOTH',0,JBAP,XETUB,YETUB,ZP,0,'ONLY',PAR)
C     VACUUM IN THE BEAM TUBE
      PAR(1) = 0.
      PAR(2) = RI
      CALL GSPOSP('EBVP',JBAP,'MOTH',XETUB,YETUB,ZP,0,'ONLY',PAR,3)
      GO to 999

C--   inside muon system

 300  IF(REGION.NE.'MUON')
     +    CALL MEERRO('Region= '//REGION//' must be MAGN, CALO or MUON')

C--   normal tube
      PAR(1) = RI
      PAR(2) = RNTUB
      PAR(3) = 0.5 * (FGESL_Z2(MUONSL)-FGESL_Z1(MUONSL))
      XP = XETUB - .5*(FGESL_X1(MUONSL)+FGESL_X2(MUONSL))
      YP = YETUB - .5*(FGESL_Y1(MUONSL)+FGESL_Y2(MUONSL))
      JBAP = JBAP + 1
      CALL CRPOS('EBAP','MUON',0,JBAP,XP,YP,0.,0,'ONLY',PAR)
C     vacuum
      PAR(1) = 0.
      PAR(2) = RI
      CALL GSPOSP('EBVP',JBAP,'MUON',XP,YP,0.,0,'ONLY',PAR,3)

 999  RETURN
      END
************************   END   EBMGEO    *****************************


