
      SUBROUTINE GEOACT

************************************************************************
*
* GEOACT
* written by Siegmund Nowak, 30/08/95 09.18.12
*
* Description: Reads data card DETV from ASCII kumac file and selects
*              the short, long or user variant of a detector version
*
* called from  KUIP
*
* External references:
*
* Changes since last version: addition of more selection choices
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"

      INTEGER IWKSTY,IGIWTY,NPAR,IFIRST,J,LENGTH,IUCOMP
      CHARACTER CHPATL*32,INPUT1*4,INPUT2*4,MGEO(NDETV)*4
      DATA IFIRST /0/
#include "arte/Arte.ff"

      IF(IFIRST.EQ.0) THEN
         CALL VFILL(MGEO,NDETV,'    ')
         CALL VFILL(DETV,NDETV,'    ')
         MGEO(LGESL_SIL) = 'SID '
         DETV(LGESL_SIL) = 'SIDL'
         MGEO(LGESL_WCH) = 'WTD '
         DETV(LGESL_WCH) = 'WTDL'
         MGEO(LGESL_MSG) = 'MTD '
         DETV(LGESL_MSG) = 'MTDL'
         MGEO(LGESL_PTC) = 'PTL '
         DETV(LGESL_PTC) = 'PTLL'
         MGEO(LGESL_RIC) = 'RIC '
         DETV(LGESL_RIC) = 'RICL'
         MGEO(LGESL_ECA) = 'CAL '
         DETV(LGESL_ECA) = 'CALL'
         MGEO(LGESL_TAR) = 'TAR '
         DETV(LGESL_TAR) = 'TARL'
         MGEO(LGESL_FLD) = 'FLD '
         DETV(LGESL_FLD) = 'FLDL'
         MGEO(LGESL_HOD1) = 'SZ0 '
         DETV(LGESL_HOD1) = 'SZ0L'
         MGEO(LGESL_HOD2) = 'SZ1'
         DETV(LGESL_HOD2) = 'SZ1L'
         MGEO(LGESL_HOD3) = 'SZ2'
         DETV(LGESL_HOD3) = 'SZ2L'

         MGEO(LGESL_TRSL) = 'TRD '
         DETV(LGESL_TRSL) = 'TRDS'      
         MGEO(LGESL_RPOT) = 'RPO'
         DETV(LGESL_RPOT) = 'RPOL'
         MGEO(LGESL_MAG)  = 'MAG'
         DETV(LGESL_MAG)  = 'MAGL'
         MGEO(LGESL_PPIP) = 'PPI'
         DETV(LGESL_PPIP) = 'PPIS'
         MGEO(LGESL_EPIP) = 'EPI'
         DETV(LGESL_EPIP) = 'EPIL'
         MGEO(LGESL_MUON) = 'MUD'
         DETV(LGESL_MUON) = 'MUDL'
         IFIRST = 1
      ENDIF

 10   IWKSTY = IGIWTY(1)
      CALL KUPATL(CHPATL,NPAR)
*
      IF(NPAR.EQ.0) GO TO 999
      IF(CHPATL.EQ.'DETV') THEN
         CALL KUGETC(INPUT1,LENGTH)
         INPUT2 = INPUT1(1:3)
         INPUT2(4:4) = ' '
         J = IUCOMP(INPUT2,MGEO,NDETV)
         IF(J.EQ.0.OR.J.GT.NDETV) THEN
            CALL MEERRO('IN THE DATA CARD DETV IS UNDEFINED:'//INPUT1)
         ELSE
            DETV(J) = INPUT1
         ENDIF
      ENDIF
 999  RETURN
      END

************************   END    GEOACT    *****************************




