/***********************************************************************
*
* GVERS
* written by Siegmund Nowak
*
* This routine stores the subdet version numbers and datefiles during
* geometry installation
*
* called from geomain
*
***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "arte/Arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteFlag.h"
#include "gean/hgdat.h"
#include "gean/zgvers.hh"

extern "C" { void gvers_(char *); }
FILE *utfilp(char*,char*);

void gvers_(char *status)  {
  if(!strncmp(status,"ini",3)) {
     int nitem;
     char  buffer[256], tag[80], taga[16], filnam[16]; 
     char *card;
     zgvers::ini(32);
     zgvers ZGVERS;

     //select file name and  open the file    
     int geovers = int(10000.*arteflag_.geomvers + .001);
     sprintf(taga, "%6d", geovers);
     for(int m=0;m<6;m++) {if(taga[m] == ' ') taga[m] = '0'; else break; }    
     strcpy(filnam,"gvers\0"); strncat(filnam,taga,6); strcat(filnam,".dat\0");
     FILE *vers_inp = utfilp(filnam,"\n");

     for(;;) {
        memset(buffer,' ',254);
        buffer[255] = '\0'; 
        if(fgets(buffer,256,vers_inp) == NULL) {
           if(feof(vers_inp)) {
             fclose(vers_inp);
             arteMsg << "=== close "<< filnam;     arteMsg.warn();
             break;  }
           else continue; }
        card=&buffer[0];
        nitem=sscanf(card,"%s",tag);
        if (nitem==-1) continue;   
        card+=itemlength(card,nitem);
        ToLower(tag);
      
        if (!strncmp(tag,"geovers",7) || !strncmp(tag,"vers",4) ) {
           float nr = ZGVERS.Read_geovers(card);  
        
           if(!strncmp(tag,"geovers",7) && nr != arteflag_.geomvers) {  
              arteMsg << "geomvers" << arteflag_.geomvers << 
               "and geomvers in file" << nr << "differ" ; arteMsg.warn();}}}}

  else if(!strncmp(status,"fin",3)) zgvers::fin();  
}


        









