#ifndef _ZGDET_HH_
#define _ZGDET_HH_

  typedef struct {
    int   sides; 
    int   index_hgvol;
    float sensdx,sensdy,sensdz; 
    float sens_offset_x,sens_offset_y,sens_offset_z;
    float wire_orient[4];
    float x_wire[4];
    float z_wire[4];
    int   n_wire[4];
    float y1_wire[4];
    float y2_wire[4];
    float polarity[4];
    float pitch[4];
    float effectivity;
    float accuracy;
    float double_hit_res;
  } hgdet;

class zgdet{
public:

  friend class zgmed;
  friend class zgpos;
  friend class zgrot;  
  friend class zgvol;
  friend class zguser;
 
  zgdet::zgdet() {}
  zgdet::~zgdet() {} 
  
  static void zgdet::ini(int n);
  static void zgdet::fin();
  static void zgdet::increase();
  static void zgdet::Set_ind_pt(int); 
  hgdet      *zgdet::get_ptdet(int); 
  
  void  zgdet::Read_sens_dim(char*);
  void  zgdet::Read_sens_offset(char*);
  void  zgdet::Read_sides(char*);
  void  zgdet::Read_x_wire(char*);
  void  zgdet::Read_z_wire(char*);
  void  zgdet::Read_n_wire(char*);
  void  zgdet::Read_y1_wire(char*);
  void  zgdet::Read_y2_wire(char*);
  void  zgdet::Read_wire_orientation(char*);
  void  zgdet::Read_polarity(char*);
  void  zgdet::Read_pitch(char*);
  void  zgdet::Read_effectivity(char*);
  void  zgdet::Read_accuracy(char*);
  void  zgdet::Read_double_hit_res(char*);

  void  zgdet::Set_vol_det_Rel();

  void  zgdet::Set_default();
  void  zgdet::Copy_previous();

  void  zgdet::Get_sens_dim(int &, float &, float &) ;
  void  zgdet::Get_sens_offset(int &, float &, float &) ;
  int   zgdet::Get_sides(int &) ;
  void  zgdet::Get_x_wire(int &,float *, int ) ;
  void  zgdet::Get_z_wire(int &,float *, int ) ;
  void  zgdet::Get_n_wire(int &,int   *, int ) ;
  void  zgdet::Get_y1_wire(int &,float *, int ) ;
  void  zgdet::Get_y2_wire(int &,float *, int ) ;
  void  zgdet::Get_wire_orientation(int &,float* ,int);
  void  zgdet::Get_polarity(int&, float*, int); 
  void  zgdet::Get_pitch(int &, float *,int) ;
  float zgdet::Get_effectivity(int &) ;
  float zgdet::Get_accuracy(int &) ;
  float zgdet::Get_double_hit_res(int &) ;

private:
  static  hgdet        *ptdet[33];
  static  int           nrdet[33];
  static  int           maxdet[33];
  static  int           ind_pt;
};

#endif
