#ifndef _ZGPOS_HH_
#define _ZGPOS_HH_

  typedef struct {
    int   index_hgvol;
    int   ctyp;
    int   sector;
    int   layer;
    int   rotm;
    float xpos, ypos, zpos;
    float rot_px, rot_py, rot_pz;
    char  comp   [4];
    char  only   [4];
    } hgpos;

class zgpos{
public:

  friend class zgdet;
  friend class zgrot;  
  friend class zgvol;
  friend class zguser;

  zgpos::zgpos() {}
  zgpos::~zgpos() {} 
  
  static void zgpos::ini(int n);
  static void zgpos::fin();
  static void zgpos::increase();
  static void zgpos::Set_ind_pt(int);
  hgpos      *zgpos::get_ptpos(int); 

  void  zgpos::Read_comp(char*);
  void  zgpos::Read_resolve(char*);
  void  zgpos::Read_Mirror_x();
  void  zgpos::Read_Mirror_y();  
  void  zgpos::Read_Mirror_z();

  void  zgpos::Set_default();
  void  zgpos::Set_vol_pos_Rel();
  void  zgpos::Copy_previous();

  char* zgpos::Get_posname(int& );
  int   zgpos::Get_RotPos(const int,float &,float &,float &,int &);
  int   zgpos::Get_layer(int,int);
  int   zgpos::Get_sector(int,int);  
   
  int   zgpos::Select_pos(char *,int);

  void  zgpos::Gposit_all(int &,int &); 
  void  zgpos::Gposit_superlayer(char *,int &);
 
  int   zgpos::Check_Gpos(char*);  

private:
  static  hgpos        *ptpos[33];
  static  int           nrpos[33];
  static  int           maxpos[33];
  static  int           ind_pt; 
};

#endif






