#ifndef _ZGVOL_HH_
#define _ZGVOL_HH_

  typedef struct {
    int   type;
    int   sens_flag;
    int   color;
    int   seen;
    int   npar; 
    int   ncomp, index_hgpos;
    int   index_hgdet;
    float dimension[11];
    float rel_px,rel_py,rel_pz;
    char  name  [40];
    char  object  [4];
    char  shape [4];
    char  material[12];
    char  user[80];           
  } hgvol;

class zgvol{
public:

  friend class zgdet;
  friend class zgpos;
  friend class zgrot;
  friend class zguser;
 
  zgvol::zgvol() {}
  zgvol::~zgvol() {} 
  
  static void zgvol::ini(int n);
  static void zgvol::fin();
  static void zgvol::increase();
  static void zgvol::Set_ind_pt(int); 
  hgvol *zgvol::get_ptvol(int); 
  
  void  zgvol::Read_vol(char*,int&);
  void  zgvol::Read_shape(char*);
  void  zgvol::Read_dimension(char*);
  void  zgvol::Read_type(char*);  
  void  zgvol::Read_sens_fl(char*);
  void  zgvol::Read_material(char*);
  void  zgvol::Read_rel_point(char*);
  void  zgvol::Read_color(char*);

  void  zgvol::Set_default();
  void  zgvol::Copy_previous();
  int   zgvol::RotateBox(int &);

  char* zgvol::Get_volname(int &);
  int   zgvol::Get_volnr(char *, int);
  char* zgvol::Get_shape(int &) ;
  int   zgvol::Get_dimension(int &,float *) ;
  int   zgvol::Get_par(int &,float *) ;
  int   zgvol::Get_type(int &) ;  
  int   zgvol::Get_sens_flag(int &) ;
  char* zgvol::Get_material(int &, int &) ;
  void  zgvol::Get_rel_point(int &, float*, float*, float*) ;
  int   zgvol::Get_color(int &) ;
  int   zgvol::Get_ncomp(int &);

  void  zgvol::Create_Gvol(int); 
  int   zgvol::Check_Gvol(char*);  

private:
  static  hgvol        *ptvol[33];
  static  int           nrvol[33];
  static  int           maxvol[33];
  static  int           ind_pt;
};


#endif
