
      SUBROUTINE  ITRGEO(ISL)

************************************************************************
* ITRGEO
* written by Siegmund Nowak 11/93
*
* This routines defines microstrip gas chamber geometry
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* ISL         in          MT superlayer number
************************************************************************

      IMPLICIT NONE

      INTEGER IFIRST,ISL,NSL,ILAY,ISEC,IVOL,IVOLS(2),IMF,IROT(9),JSG
      INTEGER IMTR,IR,MEDNUM,NSEC,IPOS,IUCOMP
      REAL PAR(3),ZP,Z00,PARSV(3),PAREL(3)
      REAL XMIN,XMAX,YMIN,YMAX,COSX,SINX,COS1,SIN1,A0,B0,XUPWIR,XLOWIR
      REAL XPEL,YPEL,ZPEL,XELMN,XELMX,XPSV,YPSV,ZPSV,XMS,ANG
      REAL XPHV,YPHV,ZPHV,ANGHV,ANGHVA,ANGHVB
      REAL PARG1(3),PARG2(3),PARG3(3),
     +                     XPG1,YPG1,XPG2U,YPG2U,XPG2L,YPG2L,XPG3,YPG3
      CHARACTER*4  MUTT,SLNAM,MTST(2),CLLN(2),CLEM(2),CLGN(2),CLKN(2),
     +     MTWAND(2)
      SAVE IFIRST
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMAGN.fi"
#include "gean/ZGITR.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA CLLN /'MTLY','MTLM'/, CLEM /'MTEL','MTEM'/
      DATA CLGN /'MTG1','MTG2'/, CLKN /'MTKC','MTKM'/
      DATA MTWAND /'MTWA','MTWM'/, MTST/'MTHV','MTHM'/
      DATA IFIRST/0/,JSG/0/
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--          DEFINE VOLUMINA FOR CHAMBERS AT FIRST ENTRY

      IF(IFIRST.EQ.0) THEN

         CALL ITRDAT('itr.dat')
         CALL MTLMED

         CALL VZERO(IROT,9)
         CALL CRROTM(IROT(2),90.,-ANGMT,90.,90.-ANGMT,0.,0.)
         CALL CRROTM(IROT(3),90., ANGMT,90.,90.+ANGMT,0.,0.)

         ANG = ANGMT/180.*PI
         COS1 = COS(ANG)
         SIN1 = SIN(ANG)

         ANGHV = 15.
         ANGHVA = 38.
         ANGHVB = 51.
         CALL CRROTM(IROT(4),90.,-ANGHV,90., 90.-ANGHV, 0.,0.)
         CALL CRROTM(IROT(5),90., ANGHV,90., 90.+ANGHV, 0.,0.)
         CALL CRROTM(IROT(6),90.,-ANGHVA,90.,90.-ANGHVA,0.,0.)
         CALL CRROTM(IROT(7),90., ANGHVA,90.,90.+ANGHVA,0.,0.)
         CALL CRROTM(IROT(8),90.,-ANGHVB,90.,90.-ANGHVB,0.,0.)
         CALL CRROTM(IROT(9),90.,+ANGHVB,90.,90.+ANGHVB,0.,0.)
         IF(IDEBUG.NE.0)WRITE(LPRNT,'(''ITRGEO: ROTMAT = '',3(1X,I2))')
     +                                  IROT

         CALL GSVOLU('MTWA','BOX ',MEDNUM(1,'ROHACELL'),PAR,0,IVOL)
         CALL GSVOLU('MTWM','BOX ',MEDNUM(2,'ROHACELL'),PAR,0,IVOL)
         CALL GSVOLU('MTLY','BOX ',MEDNUM(3,'ITR_LAYER'),PAR,0,IVOLS(1))
         CALL GSVOLU('MTLM','BOX ',MEDNUM(4,'ITR_LAYER'),PAR,0,IVOLS(2))
         CALL GSVOLU('MTEL','BOX ',MEDNUM(1,'AL2O3'),PAR,0,IVOL)
         CALL GSVOLU('MTEM','BOX ',MEDNUM(2,'AL2O3'),PAR,0,IVOL)
         CALL GSVOLU('MTG1','BOX ',MEDNUM(1,'GLASS'),PAR,0,IVOL)
         CALL GSVOLU('MTG2','BOX ',MEDNUM(2,'GLASS'),PAR,0,IVOL)
         CALL GSVOLU('MTKC','BOX ',MEDNUM(1,'MYLAR'),PAR,0,IVOL)
         CALL GSVOLU('MTKM','BOX ',MEDNUM(2,'MYLAR'),PAR,0,IVOL)
         CALL GSVOLU('MTHV','BOX ',MEDNUM(1,'ROHACELL'),PAR,0,IVOL)
         CALL GSVOLU('MTHM','BOX ',MEDNUM(2,'ROHACELL'),PAR,0,IVOL)
         IFIRST = 1
      ENDIF

C--          DEFINE THE SUPERLAYER VOLUMINA AND POSITION

      CALL UHTOC(HGESL_NAME(ISL),4,SLNAM,4)

      IF(IGESL_LAY(ISL).EQ.0) THEN
         C78 = 'MSGC-SUPERLAYER '//SLNAM//' NOT ACTIVATED'
         CALL ME78WA
         GO TO 90
      ENDIF
   
C     install superlayer
      CURRSL = ISL
      NSL = IUCOMP(SLNAM,DEMT,NSLMT)
      IF(NSL.EQ.0) CALL MEERRO('ITRGEO: '//SLNAM//' not found in DEMT')
      IMF = IGESL_MFL(ISL) +1 
      IF(IMF.EQ.1 ) THEN
         CALL CGGESL(SLNAM,'MOTH',0) 
         Z00 = ZZERO + .5*(FGESL_Z1(ISL)+FGESL_Z2(ISL)) 
         MUTT = 'MOTH'
      ELSE
         CALL CGGESL(SLNAM,'MAGN',0)
         MUTT = 'MAGN'
         Z00 = -ZMAGM + .5*(FGESL_Z1(ISL)+FGESL_Z2(ISL)) 
      ENDIF
      CALL GSATT(SLNAM,'COLO',-7)

      IF(IDEBUG.NE.0) WRITE(LPRNT,*) 'START ',SLNAM,' ',
     +        FGESL_Z1(ISL),FGESL_Z2(ISL),par(1),par(2),' ',MUTT

      ZP = -.5*(FLOAT(IGESL_LAY(ISL)-1))*DLOVMT
      IMTR = IROMT(NSL)

      DO ILAY=1,IGESL_LAY(ISL)
      IR =  IMTR / 10**(IGESL_LAY(ISL)-ILAY)
      IF(IR.EQ.0) THEN
         COSX = 1.
         SINX = 0.
      ELSE IF(IR.EQ.1) THEN
         COSX = COS1
         SINX = -SIN1
      ELSE IF(IR.EQ.2) THEN
         COSX = COS1
         SINX = SIN1
      ENDIF

      IMTR = IMTR - IR*10**(IGESL_LAY(ISL)-ILAY)

      PAR(1) =  XMMT(NSL)
      PAR(2) =  YMMT(NSL)
      PAR(3) = .5 * DWALMT
      CALL GSPOSP(MTWAND(IMF),NGEDE()+1,SLNAM,0.,2.5,ZP,0,'MANY',PAR,3)

      DO 85 ISEC=1,8,2
      IF(ISEC.EQ.1) THEN
         ZPSV = ZP - .5*(DWALMT+DCELMT)
         ZPEL = ZP - .5*(DWALMT+DECHMT)
         A0 =  XIMT(NSL) * (1. - 0.5*SINX - COSX)
         B0 =  XIMT(NSL) * (1. + 0.5*SINX - COSX)
      ELSE IF(ISEC.EQ.3) THEN
         ZPSV = ZP + .5*(DWALMT+DCELMT)
         ZPEL = ZP + .5*(DWALMT+DECHMT)
         A0 =  XIMT(NSL) * (1. + 0.5*SINX - COSX)
         B0 = -XIMT(NSL) * (1. - 0.5*SINX - COSX)
      ELSE IF(ISEC.EQ.5) THEN
         ZPSV = ZP - .5*(DWALMT+DCELMT)
         ZPEL = ZP - .5*(DWALMT+DECHMT)
         A0 = -XIMT(NSL) * (1. - 0.5*SINX - COSX)
         B0 = -XIMT(NSL) * (1. + 0.5*SINX - COSX)
      ELSE IF(ISEC.EQ.7) THEN
         ZPSV = ZP + .5*(DWALMT+DCELMT)
         ZPEL = ZP + .5*(DWALMT+DECHMT)
         A0 = -XIMT(NSL) * (1. + 0.5*SINX - COSX)
         B0 =  XIMT(NSL) * (1. - 0.5*SINX - COSX)
      ENDIF

c     each real sector is divided into two GEAN sectors, nsec = 0
c     stands for the leftmost of these two sectors
      NSEC = 0
      XMS=0.

 70   XMIN = XLMT(NSL,ISEC+NSEC)
      XMAX = XRMT(NSL,ISEC+NSEC)
      YMIN = YLMT(NSL,ISEC+NSEC)
      YMAX = YRMT(NSL,ISEC+NSEC)

c     first the chambers itself will be generated
      PARSV(1) = .5 * (XMAX-XMIN)
      PARSV(2) = .5 * (YMAX-YMIN)
      PARSV(3) = .5 * DCELMT

      XMIN = XMIN - A0
      XMAX = XMAX - A0
      YMIN = YMIN - B0
      YMAX = YMAX - B0
      XPSV   = .5*(XMIN+XMAX)*COSX-.5*(YMIN+YMAX)*SINX
      YPSV   = .5*(XMIN+XMAX)*SINX+.5*(YMIN+YMAX)*COSX


      CALL CRPOS(CLLN(IMF),SLNAM,ILAY,ISEC+NSEC,XPSV,YPSV,ZPSV,
     +                                        IROT(IR+1),'ONLY',PARSV)
      Q(QGEDE_ACC_L()) = SIGMT
      Q(QGEDE_EFF_L()) = EFFMT
      Q(QGEDE_PIT_L()) = PITMT
      Q(QGEDE_DOD_L()) = DIMXMT
      IQ(IQGEDE_NSL_L())  = 1

      IF(NSEC.EQ.0) THEN
         Q(QGEDE_SXMN_L()) = XMIN + RANDMT
         Q(QGEDE_SXMX_L()) = XMAX
         XLOWIR            = XMIN + RANDMT + .5*PITMT
         XUPWIR            = XMAX          - .5*PITMT
      ELSE
         Q(QGEDE_SXMN_L()) = XMIN
         Q(QGEDE_SXMX_L()) = XMAX - RANDMT
         XLOWIR            = XMIN          + .5*PITMT
         XUPWIR            = XMAX - RANDMT + .5*PITMT
      ENDIF
      Q(QGEDE_SYMN_L()) = YMIN + RANDMT
      Q(QGEDE_SYMX_L()) = YMAX - RANDMT

      Q(QGEDE_XFW_L(1))  = XLOWIR
      Q(QGEDE_ZFW_L(1))  = FGEDE_ZMIN(NGEDE()) + DGL1MT + DAUXMT
      Q(QGEDE_ZFW_L(2))  = FGEDE_ZFW(1,NGEDE()) + DGASMT
      IQ(IQGEDE_NWI_L(1)) = (XUPWIR-XLOWIR)/PITMT + 1.001

      IF(NSEC.EQ.0) THEN
         CALL GRADLN(IVOLS(IMF),XMS)
         XMS = DCELMT/XMS
      ENDIF
      Q(QGEDE_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2

c     next create the electronics. Here only one board is created for
c     both sectors, associated to the second sector
      IF(NSEC.EQ.0) THEN
         XELMN = XMIN
         XELMX = XMAX
      ELSE
         XELMN = AMIN1(XELMN,XMIN)
         XELMX = AMAX1(XELMX,XMAX)
         PAREL(1) = .5 * (XELMX-XELMN)
         PAREL(2) = .5 * BRELMT
         PAREL(3) = .5 * DECHMT
         XPEL = .5 * (XELMN+XELMX)
         IF(ISEC.EQ.1.OR.ISEC.EQ.7) THEN
            YPEL = YRMT(NSL,ISEC+NSEC) + YEOVMT + 0.5* BRELMT
            CALL GSPOSP(CLEM(IMF),NGEDE(),SLNAM,
     +                   XPEL,YPEL,ZPEL,0,'ONLY',PAREL,3)
         ELSE
            YPEL = YLMT(NSL,ISEC+NSEC) - YEOVMT - 0.5* BRELMT
            CALL GSPOSP(CLEM(IMF),NGEDE(),SLNAM,
     +                   XPEL,YPEL,ZPEL,0,'ONLY',PAREL,3)
         ENDIF
      ENDIF

c     glas border on the left and right hand side of the MSGC
      PARG1(1) = .165
      PARG1(2) = PARSV(2) + .33
      PARG1(3) = .043
      IF(NSEC.EQ.1) THEN
         XPG1 = (XMAX+PARG1(1))*COSX-.5*(YMIN+YMAX)*SINX
         YPG1 = (XMAX+PARG1(1))*SINX+.5*(YMIN+YMAX)*COSX
      ELSEIF(NSEC.EQ.0) THEN
         XPG1 = (XMIN-PARG1(1))*COSX-.5*(YMIN+YMAX)*SINX
         YPG1 = (XMIN-PARG1(1))*SINX+.5*(YMIN+YMAX)*COSX
         ENDIF
      CALL GSPOSP(CLGN(IMF),4*NGEDE()-3,SLNAM,XPG1,YPG1,ZPSV,
     +                                  IROT(IR+1),'ONLY',PARG1,3)

c     glas border on top and bottom of the MSGC
      PARG2(1) = PARSV(1)
      PARG2(2) = .165
      PARG2(3) = .043
      XPG2U   = (.5*(XMIN+XMAX))*COSX-(YMAX+PARG2(2))*SINX
      YPG2U   = (.5*(XMIN+XMAX))*SINX+(YMAX+PARG2(2))*COSX
      XPG2L   = (.5*(XMIN+XMAX))*COSX-(YMIN-PARG2(2))*SINX
      YPG2L   = (.5*(XMIN+XMAX))*SINX+(YMIN-PARG2(2))*COSX

      CALL GSPOSP(CLGN(IMF),4*NGEDE()-2,SLNAM,XPG2U,YPG2U,ZPSV,
     +                                    IROT(IR+1),'ONLY',PARG2,3)
      CALL GSPOSP(CLGN(IMF),4*NGEDE()-1,SLNAM,XPG2L,YPG2L,ZPSV,
     +                                    IROT(IR+1),'ONLY',PARG2,3)

c     glas border on left/right side for inner part
      IPOS = 0
      PARG3(1) = .165
      PARG3(3) = .043

      IF(ISEC.EQ.1.AND.NSEC.EQ.1) THEN
         PARG3(2) = .5 *(YLMT(NSL,ISEC)-YMIN)
         XPG3 = (XMIN-PARG3(1))*COSX - (YMIN+PARG3(2))*SINX
         YPG3 = (XMIN-PARG3(1))*SINX + (YMIN+PARG3(2))*COSX
         IPOS = 1
      ELSEIF(ISEC.EQ.3.AND.NSEC.EQ.1) THEN
         PARG3(2) = .5 * (YMAX-YRMT(NSL,ISEC))
         XPG3 = (XMIN-PARG3(1))*COSX - (YMAX-PARG3(2))*SINX
         YPG3 = (XMIN-PARG3(1))*SINX + (YMAX-PARG3(2))*COSX
         IPOS = 1
      ELSEIF(ISEC.EQ.5.AND.NSEC.EQ.0) THEN
         PARG3(2) = .5 * (YMAX-YRMT(NSL,ISEC+1))
         XPG3 = (XMAX+PARG3(1))*COSX - (YMAX-PARG3(2))*SINX
         YPG3 = (XMAX+PARG3(1))*SINX + (YMAX-PARG3(2))*COSX
         IPOS = 1
      ELSEIF(ISEC.EQ.7.AND.NSEC.EQ.0) THEN
         PARG3(2) = .5 * (YLMT(NSL,ISEC+1)-YMIN)
         XPG3 = (XMAX+PARG3(1))*COSX - (YMIN+PARG3(2))*SINX
         YPG3 = (XMAX+PARG3(1))*SINX + (YMIN+PARG3(2))*COSX
         IPOS = 1
      ENDIF

      IF(IPOS.EQ.1) THEN
         CALL GSPOSP(CLGN(IMF),4*NGEDE(),SLNAM,XPG3,YPG3,ZPSV,
     +                                   IROT(IR+1),'ONLY',PARG3,3)
      ENDIF
      NSEC = NSEC + 1
      IF(NSEC.EQ.1) GO TO 70

 85   CONTINUE

      ZP = ZP + DLOVMT
      ENDDO
       
      IF(NSL.LT.6) GO TO 90
      IF(NSL.GT.13) GO TO 80

      ZPHV = Z00
      PAR(3) = .2

c     Strebe 1
      XPHV = 0.
      YPHV = 49.
      PAR(1) = 69.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     Strebe 2
      XPHV = 0.
      YPHV = 55.
      PAR(1) = 140.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     Strebe 3
      XPHV = -60.5
      YPHV = 10.5
      PAR(1) = 3.0
      PAR(2) = 36.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(5),'ONLY',PAR,3)

c     Strebe 4
      XPHV = -40.
      YPHV = 6.0
      PAR(1) = 3.
      PAR(2) = 40.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(4),'ONLY',PAR,3)

c     Strebe 5
      XPHV = 40.
      YPHV = 6.0
      PAR(1) = 3.
      PAR(2) = 40.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(5),'ONLY',PAR,3)

c     Strebe 6
      XPHV = 60.5
      YPHV = 10.5
      PAR(1) = 3.
      PAR(2) = 36.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(4),'ONLY',PAR,3)

c     strebe 9
      XPHV = -27.
      YPHV = -40.
      PAR(1) = 22.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     strebe 10
      XPHV = 27.
      YPHV = -40.
      PAR(1) = 22.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     streben 11 - 18
      PAR(1) = 3.
      YPHV = 130.

c     strebe 11
      XPHV = -232.
      PAR(2) = 115.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(9),'ONLY',PAR,3)

c     strebe 12
      XPHV = -162.
      PAR(2) = 91.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(7),'ONLY',PAR,3)

c     strebe 13
      XPHV = -79.
      PAR(2) = 74.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(5),'ONLY',PAR,3)

c     strebe 14
      XPHV = -43.
      PAR(2) = 70.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     strebe 15
      XPHV = 43.
      PAR(2) = 70.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     strebe 16
      XPHV = 79.
      PAR(2) = 74.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(4),'ONLY',PAR,3)

c     strebe 17
      XPHV = 162.
      PAR(2) = 91.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(6),'ONLY',PAR,3)

c     strebe 18
      XPHV = 232.
      PAR(2) = 115.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(8),'ONLY',PAR,3)
      GO TO 90

 80   CONTINUE

      Z00 = Z00
      PAR(3) = .2

c     Strebe 1
      XPHV = 0.
      YPHV = 51.
      PAR(1) = 75.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     Strebe 2
      XPHV = 0.
      YPHV = 57.
      PAR(1) = 140.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     Strebe 3
      XPHV = -64
      YPHV = 3.5
      PAR(1) = 3.0
      PAR(2) = 44.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(5),'ONLY',PAR,3)

c     Strebe 4
      XPHV = -42.
      YPHV = 6.5
      PAR(1) = 3.
      PAR(2) = 45.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(4),'ONLY',PAR,3)

c     Strebe 5
      XPHV = 42.
      YPHV = 3.0
      PAR(1) = 3.
      PAR(2) = 45.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(5),'ONLY',PAR,3)

c     Strebe 6
      XPHV = 64
      YPHV = 3.5
      PAR(1) = 3.
      PAR(2) = 44.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(4),'ONLY',PAR,3)

c     strebe 9
      XPHV = -27.
      YPHV = -45.
      PAR(1) = 22.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     strebe 10
      XPHV = 27.
      YPHV = -45.
      PAR(1) = 22.
      PAR(2) = 3.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     streben 11 - 18
      PAR(1) = 3.
      YPHV = 131.

c     strebe 11
      XPHV = -232.
      PAR(2) = 113.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(9),'ONLY',PAR,3)

c     strebe 12
      XPHV = -162.
      PAR(2) = 90.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(7),'ONLY',PAR,3)

c     strebe 13
      XPHV = -79.
      PAR(2) = 73.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(5),'ONLY',PAR,3)

c     strebe 14
      XPHV = -43.
      PAR(2) = 69.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     strebe 15
      XPHV = 43.
      PAR(2) = 69.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,0,'ONLY',PAR,3)

c     strebe 16
      XPHV = 79.
      PAR(2) = 73.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(4),'ONLY',PAR,3)

c     strebe 17
      XPHV = 162.
      PAR(2) = 90.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(6),'ONLY',PAR,3)

c     strebe 18
      XPHV = 232.
      PAR(2) = 113.
      JSG = JSG+1
      CALL GSPOSP(MTST(IMF),JSG,MUTT,XPHV,YPHV,Z00,IROT(8),'ONLY',PAR,3)

 90   RETURN
      END
