
      SUBROUTINE MTLSTR (ISL,ILAY,IR,IMF,ZP,IVOL)

************************************************************************
*
* MTLSTR
* written by Siegmund Nowak 11/93
*
* This routines posit the layers/section of MSGC inside the superlayer
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* ISL        in           MT superlayer number
* ILAY       in           layer number
* ISEC       in           section number
* IMF        in           magnet field flag
* ZP         in/out       z start position
* IVOL       in           volumen number
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGITR.fi"
#include "auto/GEO.fi"

      INTEGER ISL,ILAY,ISC,IVOL(2),IMF,IR,IFIRST,IROTM(3),NSEC,IPOS
      REAL PAR(3),PARSV(3),PAREL(3),ZP,XPSV,YPSV,ZPSV,XMS,ANG
      REAL XMIN,XMAX,YMIN,YMAX,COSX,SINX,COS1,SIN1,A0,B0,XUPWIR,XLOWIR
      REAL XPEL,YPEL,ZPEL,XELMN,XELMX
      REAL PARG1(3),PARG2(3),PARG3(3),
     +     XPG1,YPG1,XPG2U,YPG2U,XPG2L,YPG2L,XPG3,YPG3
      CHARACTER*4 CLLN(2),CLEM(2),CLGN(2),CLKN(2),MTWAND(2)
      DATA CLLN /'MTLY','MTLM'/, CLEM /'MTEL','MTEM'/
      DATA CLGN /'MTG1','MTG2'/, CLKN /'MTKC','MTKM'/
      DATA MTWAND /'MTWA','MTWM'/
      DATA IFIRST /0/
      SAVE IFIRST

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      IF(IFIRST.EQ.0) THEN
         IROTM(1) = 0
         CALL CRROTM(IROTM(2),90.,-ANGMT,90.,90.-ANGMT,0.,0.)
         CALL CRROTM(IROTM(3),90., ANGMT,90.,90.+ANGMT,0.,0.)
         IF(IDEBUG.NE.0)WRITE(LPRNT,'(''MTLSTR: ROTMAT = '',3(1X,I2))')
     +                                  IROTM
         ANG = ANGMT/180.*PI
         COS1 = COS(ANG)
         SIN1 = SIN(ANG)
         IFIRST = 1
      ENDIF

      IF(IR.EQ.0) THEN
         COSX = 1.
         SINX = 0.
      ELSE IF(IR.EQ.1) THEN
         COSX = COS1
         SINX = -SIN1
      ELSE IF(IR.EQ.2) THEN
         COSX = COS1
         SINX = SIN1
      ENDIF

      PAR(1) =  XMMT(ISL)
      PAR(2) =  YMMT(ISL)
      PAR(3) = .5 * DWALMT
      CALL GSPOSP(MTWAND(IMF+1),NGEDE()+1,DEMT(ISL),0.,2.5,ZP,
     +                                         0,'MANY',PAR,3)

      DO 85 ISC=1,8,2
      IF(ISC.EQ.1.OR.ISC.EQ.5)THEN
         ZPSV = ZP - .5*(DWALMT+DCELMT)
         ZPEL = ZP - .5*(DWALMT+DECHMT)
      ELSEIF(ISC.EQ.3.OR.ISC.EQ.7) THEN
         ZPSV = ZP + .5*(DWALMT+DCELMT)
         ZPEL = ZP + .5*(DWALMT+DECHMT)
      ENDIF

      IF(ISC.EQ.1) THEN
         A0 =  XIMT(ISL) * (1. - 0.5*SINX - COSX)
         B0 =  XIMT(ISL) * (1. + 0.5*SINX - COSX)
      ELSE IF(ISC.EQ.3) THEN
         A0 =  XIMT(ISL) * (1. + 0.5*SINX - COSX)
         B0 = -XIMT(ISL) * (1. - 0.5*SINX - COSX)
      ELSE IF(ISC.EQ.5) THEN
         A0 = -XIMT(ISL) * (1. - 0.5*SINX - COSX)
         B0 = -XIMT(ISL) * (1. + 0.5*SINX - COSX)
      ELSE IF(ISC.EQ.7) THEN
         A0 = -XIMT(ISL) * (1. + 0.5*SINX - COSX)
         B0 =  XIMT(ISL) * (1. - 0.5*SINX - COSX)
      ENDIF

c     each real sector is divided into two GEAN sectors, nsec = 0
c     stands for the leftmost of these two sectors
      NSEC = 0
      XMS=0.

 70   XMIN = XLMT(ISL,ISC+NSEC)
      XMAX = XRMT(ISL,ISC+NSEC)
      YMIN = YLMT(ISL,ISC+NSEC)
      YMAX = YRMT(ISL,ISC+NSEC)

c     first the chambers itself will be generated
      PARSV(1) = .5 * (XMAX-XMIN)
      PARSV(2) = .5 * (YMAX-YMIN)
      PARSV(3) = .5 * DCELMT

      IF(IR.EQ.0) THEN
         XPSV = .5*(XMIN+XMAX)
         YPSV = .5*(YMIN+YMAX)
      ELSE
         XPSV   = (.5*(XMIN+XMAX)-A0)*COSX-(.5*(YMIN+YMAX)-B0)*SINX
         YPSV   = (.5*(XMIN+XMAX)-A0)*SINX+(.5*(YMIN+YMAX)-B0)*COSX
         XMIN = XMIN - A0
         XMAX = XMAX - A0
         YMIN = YMIN - B0
         YMAX = YMAX - B0
      ENDIF

      CALL CRPOS(CLLN(IMF+1),DEMT(ISL),ILAY,ISC+NSEC,XPSV,YPSV,ZPSV,
     +                                  IROTM(IR+1),'ONLY',PARSV,3)

      Q(QGEDE_ACC_L()) = SIGMT
      Q(QGEDE_EFF_L()) = EFFMT
      Q(QGEDE_PIT_L()) = PITMT
      Q(QGEDE_DOD_L()) = DIMXMT
      IQ(IQGEDE_NSL_L())  = 1

      IF(NSEC.EQ.0) THEN
         Q(QGEDE_SXMN_L()) = XMIN + RANDMT
         Q(QGEDE_SXMX_L()) = XMAX
         XLOWIR            = XMIN + RANDMT + .5*PITMT
         XUPWIR            = XMAX          - .5*PITMT
      ELSE
         Q(QGEDE_SXMN_L()) = XMIN
         Q(QGEDE_SXMX_L()) = XMAX - RANDMT
         XLOWIR            = XMIN          + .5*PITMT
         XUPWIR            = XMAX - RANDMT + .5*PITMT
      ENDIF
      Q(QGEDE_SYMN_L()) = YMIN + RANDMT
      Q(QGEDE_SYMX_L()) = YMAX - RANDMT

      Q(QGEDE_XFW_L(1))  = XLOWIR
      Q(QGEDE_ZFW_L(1))  = FGEDE_ZMIN(NGEDE()) + DGL1MT + DAUXMT
      Q(QGEDE_ZFW_L(2))  = FGEDE_ZFW(1,NGEDE()) + DGASMT
      IQ(IQGEDE_NWI_L(1)) = (XUPWIR-XLOWIR)/PITMT + 1.001

      IF(NSEC.EQ.0) THEN
         CALL GRADLN(IVOL(IMF+1),XMS)
         XMS = DCELMT/XMS
      ENDIF
      Q(QGEDE_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2

c     next create the electronics. Here only one board is created for
c     both sectors, associated to the second sector
      IF(NSEC.EQ.0) THEN
         XELMN = XMIN
         XELMX = XMAX
      ELSE
         XELMN = AMIN1(XELMN,XMIN)
         XELMX = AMAX1(XELMX,XMAX)
         PAREL(1) = .5 * (XELMX-XELMN)
         PAREL(2) = .5 * BRELMT
         PAREL(3) = .5 * DECHMT
         XPEL = .5 * (XELMN+XELMX)
         IF(ISC.EQ.1.OR.ISC.EQ.7) THEN
            YPEL = YRMT(ISL,ISC+NSEC) + YEOVMT + 0.5* BRELMT
            CALL GSPOSP(CLEM(IMF+1),NGEDE(),DEMT(ISL),
     +                   XPEL,YPEL,ZPEL,0,'ONLY',PAREL,3)
         ELSE
            YPEL = YLMT(ISL,ISC+NSEC) - YEOVMT - 0.5* BRELMT
            CALL GSPOSP(CLEM(IMF+1),NGEDE(),DEMT(ISL),
     +                   XPEL,YPEL,ZPEL,0,'ONLY',PAREL,3)
         ENDIF
      ENDIF

c     glas border on the left and right hand side of the MSGC
      PARG1(1) = .165
      PARG1(2) = PARSV(2) + .33
      PARG1(3) = .043
      IF(IR.EQ.0) THEN
         IF(NSEC.EQ.1) THEN
            XPG1 = XMAX + PARG1(1)
            YPG1 = YPSV
         ELSEIF(NSEC.EQ.0) THEN
            XPG1 = XMIN - PARG1(1)
            YPG1 = YPSV
         ENDIF
      ELSE
         IF(NSEC.EQ.1) THEN
            XPG1 = (XMAX+PARG1(1))*COSX-.5*(YMIN+YMAX)*SINX
            YPG1 = (XMAX+PARG1(1))*SINX+.5*(YMIN+YMAX)*COSX
         ELSEIF(NSEC.EQ.0) THEN
            XPG1 = (XMIN-PARG1(1))*COSX-.5*(YMIN+YMAX)*SINX
            YPG1 = (XMIN-PARG1(1))*SINX+.5*(YMIN+YMAX)*COSX
         ENDIF
      ENDIF
      CALL GSPOSP(CLGN(IMF+1),4*NGEDE()-3,DEMT(ISL),XPG1,YPG1,ZPSV,
     +                                  IROTM(IR+1),'ONLY',PARG1,3)

c     glas border on top and bottom of the MSGC
      PARG2(1) = PARSV(1)
      PARG2(2) = .165
      PARG2(3) = .043
      IF(IR.EQ.0) THEN
         XPG2U = XPSV
         YPG2U = YMAX + PARG2(2)
         XPG2L = XPSV
         YPG2L = YMIN - PARG2(2)
      ELSE
         XPG2U   = (.5*(XMIN+XMAX))*COSX-(YMAX+PARG2(2))*SINX
         YPG2U   = (.5*(XMIN+XMAX))*SINX+(YMAX+PARG2(2))*COSX
         XPG2L   = (.5*(XMIN+XMAX))*COSX-(YMIN-PARG2(2))*SINX
         YPG2L   = (.5*(XMIN+XMAX))*SINX+(YMIN-PARG2(2))*COSX
      ENDIF
      CALL GSPOSP(CLGN(IMF+1),4*NGEDE()-2,DEMT(ISL),XPG2U,YPG2U,ZPSV,
     +                                    IROTM(IR+1),'ONLY',PARG2,3)
      CALL GSPOSP(CLGN(IMF+1),4*NGEDE()-1,DEMT(ISL),XPG2L,YPG2L,ZPSV,
     +                                    IROTM(IR+1),'ONLY',PARG2,3)

c     glas border on left/right side for inner part
      IPOS = 0
      PARG3(1) = .165
      PARG3(3) = .043
      IF(IR.EQ.0) THEN
         IF(ISC.EQ.1.AND.NSEC.EQ.1) THEN
            PARG3(2) = .5 *(YLMT(ISL,ISC)-YMIN)
            XPG3 = XMIN - PARG3(1)
            YPG3 = YMIN + PARG3(2)
            IPOS = 1
         ELSEIF(ISC.EQ.3.AND.NSEC.EQ.1) THEN
            PARG3(2) = .5 * (YMAX-YRMT(ISL,ISC))
            XPG3 = XMIN - PARG3(1)
            YPG3 = YMAX - PARG3(2)
            IPOS = 1
         ELSEIF(ISC.EQ.5.AND.NSEC.EQ.0) THEN
            PARG3(2) = .5 * (YMAX-YRMT(ISL,ISC+1))
            XPG3 = XMAX + PARG3(1)
            YPG3 = YMAX - PARG3(2)
            IPOS = 1
         ELSEIF(ISC.EQ.7.AND.NSEC.EQ.0) THEN
            PARG3(2) = .5 * (YLMT(ISL,ISC+1)-YMIN)
            XPG3 = XMAX + PARG3(1)
            YPG3 = YMIN + PARG3(2)
            IPOS = 1
         ENDIF
      ELSE
         IF(ISC.EQ.1.AND.NSEC.EQ.1) THEN
            PARG3(2) = .5 *(YLMT(ISL,ISC)-YMIN)
            XPG3 = (XMIN-PARG3(1))*COSX - (YMIN+PARG3(2))*SINX
            YPG3 = (XMIN-PARG3(1))*SINX + (YMIN+PARG3(2))*COSX
            IPOS = 1
         ELSEIF(ISC.EQ.3.AND.NSEC.EQ.1) THEN
            PARG3(2) = .5 * (YMAX-YRMT(ISL,ISC))
            XPG3 = (XMIN-PARG3(1))*COSX - (YMAX-PARG3(2))*SINX
            YPG3 = (XMIN-PARG3(1))*SINX + (YMAX-PARG3(2))*COSX
            IPOS = 1
         ELSEIF(ISC.EQ.5.AND.NSEC.EQ.0) THEN
            PARG3(2) = .5 * (YMAX-YRMT(ISL,ISC+1))
            XPG3 = (XMAX+PARG3(1))*COSX - (YMAX-PARG3(2))*SINX
            YPG3 = (XMAX+PARG3(1))*SINX + (YMAX-PARG3(2))*COSX
            IPOS = 1
         ELSEIF(ISC.EQ.7.AND.NSEC.EQ.0) THEN
            PARG3(2) = .5 * (YLMT(ISL,ISC+1)-YMIN)
            XPG3 = (XMAX+PARG3(1))*COSX - (YMIN+PARG3(2))*SINX
            YPG3 = (XMAX+PARG3(1))*SINX + (YMIN+PARG3(2))*COSX
            IPOS = 1
         ENDIF
      ENDIF
      IF(IPOS.EQ.1) THEN
         CALL GSPOSP(CLGN(IMF+1),4*NGEDE(),DEMT(ISL),XPG3,YPG3,ZPSV,
     +                                   IROTM(IR+1),'ONLY',PARG3,3)
      ENDIF
      NSEC = NSEC + 1
      IF(NSEC.EQ.1) GO TO 70

 85   CONTINUE
 90   RETURN

      END



