
      SUBROUTINE MUODAT(FILNAM)

************************************************************************
* MUODAT
* written by Siegmund Nowak, 16/03/95 09.18.12
*
* Description: Reads ASCII geometry file and stores the data  
*
* called from  MUOGEO
*
* External references: IO..., FF..., ...KEY,
************************************************************************

      IMPLICIT NONE
      INTEGER LENOCC
      CHARACTER*(*) FILNAM 

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"
#include "gean/ZGMUON.fi"
#include "arte/Arte.ff"

C---             Initialize geo dat input

      CALL GEOPEN(FILNAM(1:LENOCC(FILNAM)))
      IF(IIOFLG(LREAD).LE.0) 
     +    CALL MEERRO('no muon input file is given, bad for YOU !')

      CALL FFINIT(0)

C     SET KEYS FOR READING DETECTOR DATA CARDS BY FFREAD

      CALL FFKEY('DEMU' ,DEMU  , 4,'MIXED')
      CALL FFKEY('MUCC' ,MUCC  , 4,'MIXED')

      CALL FFKEY('NMPT' ,NMUPTB, 1,'INTE')
      CALL FFKEY('RMPT' ,RMUPTB, NMPTMX*5,'REAL')

      CALL FFKEY('ZAMU' ,ZAMU  , 4,'REAL')
      CALL FFKEY('NMUF' ,NLMUF,  6,'INTE')
      CALL FFKEY('ZMUF' ,ZAMUF,  6,'REAL')
      CALL FFKEY('NAMF' ,NAMUF, 24,'INTE')
      CALL FFKEY('DZMF' ,DZMUF, 24,'REAL')
      CALL FFKEY('XMUF' ,XAMUF,NSHIMX*24,'REAL')           	
      CALL FFKEY('DXMF' ,DXMUF,NSHIMX*24,'REAL')           	
      CALL FFKEY('YMUF' ,YAMUF,NSHIMX*24,'REAL')
      CALL FFKEY('DYMF' ,DYMUF,NSHIMX*24,'REAL')
      CALL FFKEY('NMMF' ,NMMUF,NSHIMX*24,'INTE')

      CALL FFKEY('ANMU',ANG_MU,1,'REAL')
      CALL FFKEY('MUIN',R_MU_IN,4,'REAL')
      CALL FFKEY('XMUO',X_MU_OU,4,'REAL')
      CALL FFKEY('YMUO',Y_MU_OU,4,'REAL')
      CALL FFKEY('ZMUO',ZMUPOS,4,'REAL')
      CALL FFKEY('DZMU',DZMUSL,4,'REAL')
      CALL FFKEY('MUDI',DMU_ECUP,5,'REAL')
      CALL FFKEY('MU00' ,MU00  , 4,'MIXED')
      CALL FFKEY('MUPL' ,MUPL  , 4,'MIXED')
      CALL FFKEY('MUMI' ,MUMI  , 4,'MIXED')
      CALL FFKEY('MUPX' ,MUPX  , 4,'MIXED')

      CALL FFKEY('PIMU' ,PIMU  , 1,'REAL')
      CALL FFKEY('EFMU' ,EFMU  , 3,'REAL')
      CALL FFKEY('DMMU' ,DMMU  , 1,'REAL')
      CALL FFKEY('ACMU' ,ACMU  , 1,'REAL')

      CALL FFKEY('NMU0' ,NMU0,  8,'INTE')
      CALL FFKEY('NMUP' ,NMUP,  4,'INTE')
      CALL FFKEY('NMUM' ,NMUM,  4,'INTE')

      CALL FFKEY('XMU0' ,XMU0,  8,'REAL')
      CALL FFKEY('XMUP' ,XMUP,  4,'REAL')
      CALL FFKEY('XMUM' ,XMUM,  4,'REAL')

      CALL FFKEY('YMU0' ,YMU0,  8,'REAL')
      CALL FFKEY('YMUP' ,YMUP,  4,'REAL')
      CALL FFKEY('YMUM' ,YMUM,  4,'REAL')

      CALL FFKEY('ZMU0' ,ZMU0,  8,'REAL')
      CALL FFKEY('ZMUP' ,ZMUP,  4,'REAL')
      CALL FFKEY('ZMUM' ,ZMUM,  4,'REAL')

      CALL FFKEY('DZU0' ,DZMU0,  8,'REAL')
      CALL FFKEY('DZUP' ,DZMUP,  4,'REAL')
      CALL FFKEY('DZUM' ,DZMUM,  4,'REAL')

      CALL FFKEY('DXMU' ,DXMUO(1),4,'REAL')


      CALL FFKEY('OVMU' ,OVMUO,  1,'REAL')

      CALL FFKEY('FWMU' ,DXFWMU,  1,'REAL')

      CALL FFKEY('NWMU' ,NUMWMU,  1,'INTE')


      CALL FFKEY('DY01' ,DYMU0(1,1),MUMAXC,'REAL')
      CALL FFKEY('DYP1' ,DYMUP(1,1),MUMAXC,'REAL')
      CALL FFKEY('DYM1' ,DYMUM(1,1),MUMAXC,'REAL')

      CALL FFKEY('FY01' ,DDYU0(1),MUMAXC,'REAL')
      CALL FFKEY('FYP1' ,DDYUP(1),MUMAXC,'REAL')
      CALL FFKEY('FYM1' ,DDYUM(1),MUMAXC,'REAL')

      CALL FFKEY('FX01' ,DDXU0(1),MUMAXC,'REAL')
      CALL FFKEY('FXP1' ,DDXUP(1),MUMAXC,'REAL')
      CALL FFKEY('FXM1' ,DDXUM(1),MUMAXC,'REAL')

      CALL FFKEY('DY02' ,DYMU0(MUMAXC+1,1),MUMAXC,'REAL')
      CALL FFKEY('DYP2' ,DYMUP(MUMAXC+1,1),MUMAXC,'REAL')
      CALL FFKEY('DYM2' ,DYMUM(MUMAXC+1,1),MUMAXC,'REAL')

      CALL FFKEY('FY02' ,DDYU0(MUMAXC+1),MUMAXC,'REAL')
      CALL FFKEY('FYP2' ,DDYUP(MUMAXC+1),MUMAXC,'REAL')
      CALL FFKEY('FYM2' ,DDYUM(MUMAXC+1),MUMAXC,'REAL')

      CALL FFKEY('FX02' ,DDXU0(MUMAXC+1),MUMAXC,'REAL')
      CALL FFKEY('FXP2' ,DDXUP(MUMAXC+1),MUMAXC,'REAL')
      CALL FFKEY('FXM2' ,DDXUM(MUMAXC+1),MUMAXC,'REAL')

      CALL FFKEY('DY03' ,DYMU0(2*MUMAXC+1,1),MUMAXC,'REAL')
      CALL FFKEY('FY03' ,DDYU0(2*MUMAXC+1),MUMAXC,'REAL')
      CALL FFKEY('FX03' ,DDXU0(2*MUMAXC+1),MUMAXC,'REAL')

      CALL FFKEY('DY04' ,DYMU0(3*MUMAXC+1,1),MUMAXC,'REAL')
      CALL FFKEY('FY04' ,DDYU0(3*MUMAXC+1),MUMAXC,'REAL')
      CALL FFKEY('FX04' ,DDXU0(3*MUMAXC+1),MUMAXC,'REAL')

      CALL FFKEY('DY05' ,DYMU0(1,2),MUMAXC,'REAL')
      CALL FFKEY('DY06' ,DYMU0(MUMAXC+1,2),MUMAXC,'REAL')
      CALL FFKEY('DY07' ,DYMU0(2*MUMAXC+1,2),MUMAXC,'REAL')
      CALL FFKEY('DY08' ,DYMU0(3*MUMAXC+1,2),MUMAXC,'REAL')
      CALL FFKEY('DYP3' ,DYMUP(1,2),MUMAXC,'REAL')
      CALL FFKEY('DYP4' ,DYMUP(MUMAXC+1,2),MUMAXC,'REAL')
      CALL FFKEY('DYM3' ,DYMUM(1,2),MUMAXC,'REAL')
      CALL FFKEY('DYM4' ,DYMUM(MUMAXC+1,2),MUMAXC,'REAL')

      CALL FFKEY('XLX1' ,XLMUX(1),4,'REAL')
      CALL FFKEY('XRX1' ,XRMUX(1),4,'REAL')
      CALL FFKEY('YLX1' ,YLMUX(1),4,'REAL')
      CALL FFKEY('YUX1' ,YUMUX(1),4,'REAL')

      CALL FFKEY('ZPX1' ,ZMUX(1),4,'REAL')
      CALL FFKEY('DZX1' ,DZMUX(1),4,'REAL')

      CALL FFKEY('XLX2' ,XLMUX(5),4,'REAL')
      CALL FFKEY('XRX2' ,XRMUX(5),4,'REAL')
      CALL FFKEY('YLX2' ,YLMUX(5),4,'REAL')
      CALL FFKEY('YUX2' ,YUMUX(5),4,'REAL')

      CALL FFKEY('ZPX2' ,ZMUX(5),4,'REAL')
      CALL FFKEY('DZX2' ,DZMUX(5),4,'REAL')

      CALL FFKEY('XLX3' ,XLMUX(9),4,'REAL')
      CALL FFKEY('XRX3' ,XRMUX(9),4,'REAL')
      CALL FFKEY('YLX3' ,YLMUX(9),4,'REAL')
      CALL FFKEY('YUX3' ,YUMUX(9),4,'REAL')

      CALL FFKEY('ZPX3' ,ZMUX(9),4,'REAL')
      CALL FFKEY('DZX3' ,DZMUX(9),4,'REAL')

      CALL FFKEY('XLX4' ,XLMUX(13),4,'REAL')
      CALL FFKEY('XRX4' ,XRMUX(13),4,'REAL')
      CALL FFKEY('YLX4' ,YLMUX(13),4,'REAL')
      CALL FFKEY('YUX4' ,YUMUX(13),4,'REAL')

      CALL FFKEY('ZPX4' ,ZMUX(13),4,'REAL')
      CALL FFKEY('DZX4' ,DZMUX(13),4,'REAL')

      CALL FFKEY('OVMX' ,OVMUX,2,'REAL')
      CALL FFKEY('RMUX' ,RMUX,1,'REAL')
      CALL FFKEY('RSMX' ,RSENMX(1),4,'REAL')

      CALL FFKEY('MUSX' ,DXMUPD(1),12,'REAL')
      CALL FFKEY('MUSY' ,DYMUPD(1),12,'REAL')

      CALL FFKEY('NXPX' ,NXMUPX(1),4,'INTE')
      CALL FFKEY('NXPY' ,NYMUPX(1),4,'INTE')

      CALL FFKEY('NTPX' ,NXMUTO(1),4,'INTE')
      CALL FFKEY('NTPY' ,NYMUTO(1),4,'INTE')

      CALL FFKEY('DXPX' ,DXMUPX(1),4,'REAL')
      CALL FFKEY('DXPY' ,DYMUPX(1),4,'REAL')

C     Read in of data cards
      
      CALL FFSET('LINP',LREAD)
      CALL FFSET('LOUT',LLOGF)
      CALL FFGO
      CALL IOCLOS(LREAD)

 999  RETURN
      END

************************   END    MUODAT    *****************************




