*
* written by Boris Fominykh  28.06.96
*     geometry of the proton beam pipe, Lopez monitor and kicker
*     in the region of muon detector
* updated by B.Fominykh      19.02.97
*     cone beam pipe implemented
*
*       called from MUOG96 and MUOGEO
*
      SUBROUTINE  MUPIPE
C*    ==================
      IMPLICIT NONE
      INTEGER NCOP,NCPW,NCFK,NCCK,NCCV,NCCI
      INTEGER IV,IPM,IVC,IVOL,MEDNUM,NSB,IPMA
      REAL ZPOSM,ZPOSW,ZST,ZFIN,PAR(5),XP,YP,ZP
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMUON.fi"
#include "auto/GEO.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
*     ------------------
* check the number of volumes
      IF(NMUPTB.LE.0) GOTO 999
* define the volumes for proton beam pipe
      CALL GSVOLU('MPIA','TUBE',MEDNUM(1,'ALUMIN_MU'),PAR,0,IVOL)
      CALL GSATT('MPIA','COLO',4)

      CALL GSVOLU('MPIF','TUBE',MEDNUM(1,'IRON_MU'),PAR,0,IVOL)
      CALL GSATT('MPIF','COLO',3)

      CALL GSVOLU('MPIR','TUBE',MEDNUM(1,'FERRITE'),PAR,0,IVOL)
      CALL GSATT('MPIR','COLO',6)

      CALL GSVOLU('MPIV','TUBE',MEDNUM(1,'VACUUM_MU'),PAR,0,IVOL)
      CALL GSATT('MPIV','COLO',0)

      CALL GSVOLU('MPIW','TUBE',MEDNUM(1,'VACUUM_MU'),PAR,0,IVOL)
      CALL GSATT('MPIW','SEEN',0)

      CALL GSVOLU('MPII','TUBE',MEDNUM(1,'AIR_MU'),PAR,0,IVOL)
      CALL GSATT('MPII','COLO',0)

      CALL GSVOLU('MPFK','BOX ',MEDNUM(1,'FERRITE'),PAR,0,IVOL)
      CALL GSATT('MPFK','COLO',6)

      CALL GSVOLU('MPCK','TUBS',MEDNUM(1,'IRON_MU'),PAR,0,IVOL)
      CALL GSATT('MPCK','COLO',3)

      CALL GSVOLU('MPCN','CONE',MEDNUM(1,'IRON_MU'),PAR,0,IVOL)
      CALL GSATT('MPCN','COLO',3)

      CALL GSVOLU('MPCV','CONE',MEDNUM(1,'VACUUM_MU'),PAR,0,IVOL)
      CALL GSATT('MPCV','COLO',0)

      CALL GSVOLU('MPCI','CONE',MEDNUM(1,'AIR_MU'),PAR,0,IVOL)
      CALL GSATT('MPCI','COLO',0)

* Z-position of volume MUON
      ZPOSM = .5*(FGESL_Z1(MUONSL)+FGESL_Z2(MUONSL))

* start Z
      ZST=ZAMUF(1)
* final Z
      ZFIN = FGESL_Z2(MUONSL)

      NCOP=0
      NCPW=0
      NCFK=0
      NCCK=0
      NCCV=0
      NCCI=0
      NSB=0
* loops over volumes
      DO 100 IV=1,NMUPTB
        IF(IV.GT.NMUPTB-NSB) GOTO 999
        IPM=INT(RMUPTB(5*(IV+NSB-1)+5))
        IVC=IPM/10
        IF(IPM.GT.90) GOTO 50
* cylinders
        IF(RMUPTB(5*(IV+NSB-1)+3).EQ.0.) RMUPTB(5*(IV+NSB-1)+3)=ZST
        IF(RMUPTB(5*(IV+NSB-1)+4).EQ.0.) THEN
          IF(IV.LT.NMUPTB.AND.
     +       RMUPTB(5*(IV+NSB)+3).GT.RMUPTB(5*(IV+NSB-1)+3)) THEN
      RMUPTB(5*(IV+NSB-1)+4)=RMUPTB(5*(IV+NSB)+3)-RMUPTB(5*(IV+NSB-1)+3)
          ELSE
      RMUPTB(5*(IV+NSB-1)+4)=ZFIN-RMUPTB(5*(IV+NSB-1)+3)
          ENDIF
        ENDIF
        PAR(1)=RMUPTB(5*(IV+NSB-1)+1)
        PAR(2)=RMUPTB(5*(IV+NSB-1)+2)
        PAR(3)=0.5*RMUPTB(5*(IV+NSB-1)+4)
        ZP = RMUPTB(5*(IV+NSB-1)+3)+PAR(3)-ZPOSM
        IPM=INT(RMUPTB(5*(IV+NSB-1)+5))-10*IVC
        IF(IPM.EQ.1) CALL CRPOS('MPIA','MUON',0,0,0.,0.,ZP,0,'ONLY',PAR)    
        IF(IPM.EQ.2) CALL CRPOS('MPIF','MUON',0,0,0.,0.,ZP,0,'ONLY',PAR)
        IF(IPM.EQ.3) CALL CRPOS('MPIR','MUON',0,0,0.,0.,ZP,0,'ONLY',PAR)
        IF(IPM.EQ.4) CALL CRPOS('MPII','MUON',0,0,0.,0.,ZP,0,'ONLY',PAR)
* vacuum inside tube
        IF(IVC.EQ.1.OR.IVC.EQ.2) THEN
          PAR(2) = PAR(1)
          PAR(1) = 0.
          IF(IVC.EQ.1) THEN
            NCOP=NCOP+1
            CALL GSPOSP('MPIV',NCOP,'MUON',0.,0.,ZP,0,'ONLY',PAR,3)
          ELSE
            NCPW=NCPW+1
            CALL GSPOSP('MPIW',NCPW,'MUON',0.,0.,ZP,0,'ONLY',PAR,3)
* Z-position of volume MPIW
            ZPOSW=ZP+ZPOSM
          ENDIF
        ENDIF
        ZST = RMUPTB(5*(IV+NSB-1)+3)+2.*PAR(3)
        GOTO 100
  50    CONTINUE
* segments and boxes - are placed after tubes, 2 lines with parameters
        IF(IPM.NE.99) GOTO 60      
* segments
        NSB=NSB+1
        PAR(1)=RMUPTB(5*(IV+NSB-2)+1)
        PAR(2)=RMUPTB(5*(IV+NSB-2)+2)
        PAR(3)=0.5*RMUPTB(5*(IV+NSB-2)+4)
        PAR(4)=RMUPTB(5*(IV+NSB-2)+6)
        PAR(5)=RMUPTB(5*(IV+NSB-2)+7)
        XP    =RMUPTB(5*(IV+NSB-2)+8)
        YP    =RMUPTB(5*(IV+NSB-2)+9)
        ZP    =RMUPTB(5*(IV+NSB-2)+3)+PAR(3)-ZPOSW
        NCCK=NCCK+1
        CALL GSPOSP('MPCK',NCCK,'MPIW',XP,YP,ZP,0,'ONLY',PAR,5)
***        CALL CRGWAL('MPCK',NCCK)
        GOTO 100
  60    CONTINUE
        IF(IPM.NE.98) GOTO 70      
* boxes
        NSB=NSB+1
        PAR(1)=0.5*RMUPTB(5*(IV+NSB-2)+6)
        PAR(2)=0.5*RMUPTB(5*(IV+NSB-2)+7)
        PAR(3)=0.5*RMUPTB(5*(IV+NSB-2)+4)
        XP    =RMUPTB(5*(IV+NSB-2)+1)+PAR(1)
        YP    =RMUPTB(5*(IV+NSB-2)+2)+PAR(2)
        ZP    =RMUPTB(5*(IV+NSB-2)+3)+PAR(3)-ZPOSW
        NCFK=NCFK+1
        CALL GSPOSP('MPFK',NCFK,'MPIW',XP,YP,ZP,0,'ONLY',PAR,3)
***        CALL CRGWAL('MPFK',NCFK)
        GOTO 100
  70    CONTINUE
        IF(IPM.NE.97) GOTO 100
* cones
        NSB=NSB+1
        PAR(1)=0.5*RMUPTB(5*(IV+NSB-2)+4)
        PAR(2)=RMUPTB(5*(IV+NSB-2)+1)
        PAR(3)=RMUPTB(5*(IV+NSB-2)+2)
        PAR(4)=RMUPTB(5*(IV+NSB-2)+6)
        PAR(5)=RMUPTB(5*(IV+NSB-2)+7)
        XP    =RMUPTB(5*(IV+NSB-2)+8)
        YP    =RMUPTB(5*(IV+NSB-2)+9)
        ZP    =RMUPTB(5*(IV+NSB-2)+3)+PAR(1)-ZPOSM
        IPMA=INT(RMUPTB(5*(IV+NSB-2)+10))
        IVC=IPMA/10
        IPMA=IPMA-IVC*10
        IF(IPMA.EQ.2) THEN
          CALL CRPOS('MPCN','MUON',0,0,XP,YP,ZP,0,'ONLY',PAR)
* vacuum inside cone
          IF(IVC.EQ.1) THEN
            PAR(3) = PAR(2)
            PAR(2) = 0.
            PAR(5) = PAR(4)
            PAR(4) = 0.
            NCCV=NCCV+1
            CALL GSPOSP('MPCV',NCCV,'MUON',XP,YP,ZP,0,'ONLY',PAR,5)
          ENDIF
        ENDIF
        IF(IPMA.EQ.4) THEN
          NCCI=NCCI+1
          CALL GSPOSP('MPCI',NCCI,'MUON',XP,YP,ZP,0,'ONLY',PAR,5)
        ENDIF
        ZST=ZP+ZPOSM+PAR(1)
 100  CONTINUE


 999  CONTINUE
      RETURN
      END
