      SUBROUTINE OTRMED
******************************************************************
* Defines material constants and media for OTR chambers.
*
* Called from: otrgeo
*
* Alexander Lanyov     Jul 1997 (abridged from S.Nowak version)
************************************************************************

      implicit none
#include "gean/ZGOTR.fi"

      real vol_mix(3)
      character*12 nam_mix(3)

      nam_mix(1) = 'MYLAR'
      nam_mix(2) = 'OTR_GAS'
      nam_mix(3) = 'COPPER'

c from GMAT.dd
c flag meaning:
c '1 = nonsensitive nonmagnetic medium'
c '2 = nonsensitive magnetic medium'
c '4 = sensitive nonmagnetic medium'
c '8 = sensitive magnetic medium'

c honeycomb tubes 10 mm single
      vol_mix(1) = 4.*dls1wt + 2.*dlwewt
      vol_mix(2) = 1.5*dlclwt(1) - 4.*(dls1wt+dls2wt)
      vol_mix(3) = 4.*dls2wt
      call crmixt('OTR_WS10',12,3,nam_mix,vol_mix)      ! medflg=12=8+4

c honeycomb tubes 5 mm single
      vol_mix(2) = 1.5*dlclwt(2) - 4.*(dls1wt+dls2wt)
      call crmixt('OTR_WS5',15,3,nam_mix,vol_mix)       ! medflg=15=8+4+2+1

c honeycomb tubes 10 mm double
      vol_mix(1) = 6.666667*dls1wt + 2.*dlwewt
      vol_mix(2) = 2.5*dlclwt(3) - 6.666667*(dls1wt+dls2wt)
      vol_mix(3) = 6.666667*dls2wt
      call crmixt('OTR_WD10',12,3,nam_mix,vol_mix)      ! medflg=12=8+4

c honeycomb tubes wt 5 mm double
      vol_mix(2) = 2.5*dlclwt(4) - 6.666667*(dls1wt+dls2wt)
      call crmixt('OTR_WD5',15,3,nam_mix,vol_mix)       ! medflg=15=8+4+2+1

c====================================== tests
      nam_mix(1) = 'GLASS'
      nam_mix(2) = 'EPOXY_RESIN'
      vol_mix(1) = 0.4
      vol_mix(2) = 0.6
      call crmixt('GLASSFIBER',3,2,nam_mix,vol_mix)

      return
      end
