
      SUBROUTINE PICSIL

************************************************************************
* written by Siegmund Nowak
*
* This routines draws a view of one Si superlayer
*
* called from KUIP
************************************************************************

      IMPLICIT NONE

      INTEGER NUME(2),IFPL,K,J,LAY,ISEC,SEC
      CHARACTER*4 NAME(2),PERS,NAM,MTDA(4),CSL

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/MVOLUM.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL KUGETC(PERS,J)
      CALL KUGETC(NAM,J)

      DO J=1,NGESL()
      IF(IGESL_CMP(J).EQ.LGESL_SIL) THEN
         CALL UHTOC(HGESL_NAME(J),4,CSL,4)
         IF(CSL.EQ.NAM) GO TO 1 
      ENDIF
      ENDDO
      CALL MEWARN('Superlayer '//NAM//' not found as silicon detector')
      GO TO 999
      
 1    NAME(1) = NAM
      NUME(1) = J

      IF(IGESL_MFL(J).NE.0) THEN
         MTDA(1) = 'SILM'
         MTDA(2) = 'SICM'
         MTDA(3) = 'SIMM'
      ELSE
         MTDA(1) = 'SILZ'
         MTDA(2) = 'SICA'
         MTDA(3) = 'SIMX'
      ENDIF

      CALL GSATT(CSL,'SEEN',0)
      CALL GSATT('BAGF','SEEN',0)

c      CALL GSATT('BAGF','COLO',2)
c      CALL GSATT('BAGF','LWID',1)
c      CALL GSATT('BAGF','FILL',2)
      CALL GSATT(MTDA(2),'COLO',3)
      CALL GSATT(MTDA(2),'FILL',4)
      CALL GSATT(MTDA(2),'LWID',3)
      CALL GSATT(MTDA(1),'COLO',5)
      CALL GSATT(MTDA(1),'LWID',3)
      CALL GSATT(MTDA(1),'FILL',4)
      CALL GSATT(MTDA(3),'COLO',7)
      CALL GSATT(MTDA(3),'LWID',3)
      CALL GSATT(MTDA(3),'FILL',4)

      CALL GDOPT('HIDE','OFF ')
      CALL GDOPT('SHAD','ON  ')

      CALL KUGETI(LAY)
      CALL KUGETI(SEC)

      IFPL = IGESL_FPL(J) - 1

      DO 20 K =1,IGESL_NPL(J),4

      IF(IGEDE_LAY(IFPL+K).NE.LAY) GO TO 20
      ISEC = IGEDE_SEC(IFPL+K)
      IF(SEC.NE.0 .AND. ISEC.NE.SEC) GO TO 20
      print *,'picsil',K
c     carrier
      NAME(2) = MTDA(2)
      NUME(2) = IFPL + K
c      CALL GDRVOL(2,NAME,NUME,0,150.,150.,0.,15.,14.,.12,.12)
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)

c     silicon
      NAME(2) = MTDA(1)
      NUME(2) = IFPL + K
c      CALL GDRVOL(2,NAME,NUME,0,150.,150.,0.,10.,10.5,.12,.12)
c      CALL GDRVOL(2,NAME,NUME,0,180.,180.,0.,12., 3.,.08,.08)
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)

c      NUME(2) = NUME(2) + 2
c      CALL GDRVOL(2,NAME,NUME,0,180.,180.,0.,17., 6.,.08,.08)

      NAME(2) = MTDA(3)
      NUME(2) = IFPL +K
c      CALL GDRVOL(2,NAME,NUME,0,150.,150.,0.,10.,10.5,.12,.12)
c      CALL GDRVOL(2,NAME,NUME,0,180.,180.,0.,12., 3.,.08,.08)
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)
c      NUME(2) = NUME(2) + 2
c      CALL GDRVOL(2,NAME,NUME,0,180.,180.,0.,17., 6.,.08,.08)


      IF(K.EQ.13) CALL GDSCAL(16.,2.)
 20   CONTINUE

 999  RETURN
      END

