
      SUBROUTINE  PIPG96

************************************************************************
*
* PIPG96
* written by Siegmund Nowak
*
* This routines adds the food at the beginning of the steel beam pipe 
* and the blind flange to the geometry of the beam pipe 
*
*       called from G97MAIN
*
************************************************************************

      IMPLICIT NONE
      INTEGER IVOL,MEDNUM,IROT
      REAL PAR(5),XP,YP,ZP
#include "gean/ZGMOTH.fi"

c     defines rotation matrix for blind flange       
      CALL CRROTM(IROT,90.,90., 180.,0.,90.,180.)

c          defines beam pipe volumina
      CALL GSVOLU('CPBF','TUBE',MEDNUM(1,'IRON'),PAR,0,IVOL)
      CALL GSATT('CPBF','COLO',20)
      CALL GSVOLU('FLAS','TUBS',MEDNUM(1,'IRON'),PAR,0,IVOL) 
      CALL GSATT('FLAS','COLO',20)
      CALL GSVOLU('BPFO','BOX ',MEDNUM(1,'IRON'),PAR,0,IVOL)
      CALL GSATT('BPFO','COLO',20)

c     'foot' at the beginning of the steel beam pipe (crude estimate)
  85  PAR(1) = 3.
      PAR(2) = 2.5
      PAR(3) = 25.
      YP = -12.2 - PAR(2)
      ZP = ZZERO + 903. + 10.
      CALL CRPOS('BPFO','MOTH',1,1,0.,YP,ZP,0,'ONLY',PAR)  
      YP = YP - PAR(2)

      PAR(1) = 8.8
      PAR(2) = 10.
      PAR(3) = 2.
      PAR(4) = 180.
      PAR(5) = 360.
      CALL CRPOS('FLAS','MOTH',1,1,0.,0.,ZP-21.,0,'ONLY',PAR)  
      CALL CRPOS('FLAS','MOTH',1,1,0.,0.,ZP+21.,0,'ONLY',PAR)  

      PAR(1) = 4.
      PAR(2) = 50.
      PAR(3) = .2
      YP = YP - PAR(2)
      ZP = ZZERO + 903.
      CALL CRPOS('BPFO','MOTH',1,1,0.,YP,ZP-3.8,0,'ONLY',PAR)  
      CALL CRPOS('BPFO','MOTH',1,1,0.,YP,ZP+3.8,0,'ONLY',PAR)  
      PAR(1) = .2
      PAR(3) = 4.6
      CALL CRPOS('BPFO','MOTH',1,1,-3.8,YP,ZP,0,'ONLY',PAR)  
      CALL CRPOS('BPFO','MOTH',1,1, 3.8,YP,ZP,0,'ONLY',PAR)  

C      'blind flange'
      PAR(1) = 5. 
      PAR(2) = 5.2
      PAR(3) = 7.65     ! .5*(25. - 7.7 - 2.)
      XP = 7.7 + PAR(3)
      ZP = ZZERO + 877.6 + 23.5 + 16.4 
      CALL CRPOS('CPBF','MOTH',1,1,XP,0.,ZP,IROT,'ONLY',PAR)
      XP = XP + PAR(3)

      PAR(1) = 5.0
      PAR(2) = 7.75
      PAR(3) = 1. 
      XP = XP + PAR(3)
      CALL CRPOS('CPBF','MOTH',1,1,XP,0.,ZP,IROT,'ONLY',PAR)
      XP = XP + PAR(3)      

      PAR(1) = 0. 
      PAR(2) = 5.2
      PAR(3) = .075
      XP = XP - PAR(3)
      CALL CRPOS('CPBF','MOTH',1,1,XP,0.,ZP,IROT,'ONLY',PAR)


 99   RETURN
      END

