
      SUBROUTINE PTLDAT
**************************************************************************
*                                                                        *
* PPPPPPPPP   TTTTTTTTTT  LL        DDDDDDDD      AAAAAAAAA   TTTTTTTTTT *
* PPPPPPPPPP  TTTTTTTTTT  LL        DDDDDDDDD    AAAAAAAAAAA  TTTTTTTTTT *
* PP      PP      TT      LL        DD      DD   AA       AA      TT     *
* PP      PP      TT      LL        DD       DD  AA       AA      TT     *
* PP      PP      TT      LL        DD       DD  AA       AA      TT     *
* PPPPPPPPPP      TT      LL        DD       DD  AAAAAAAAAAA      TT     *
* PPPPPPPPP       TT      LL        DD       DD  AAAAAAAAAAA      TT     *
* PP              TT      LL        DD       DD  AA       AA      TT     *
* PP              TT      LL        DD       DD  AA       AA      TT     *
* PP              TT      LL        DD      DD   AA       AA      TT     *
* PP              TT      LLLLLLLL  DDDDDDDDD    AA       AA      TT     *
* PP              TT      LLLLLLLL  DDDDDDDD     AA       AA      TT     *
*                                                                        *
**************************************************************************
*                                                                        *
* Revision: 1.1.1.1 $                                                    *
* Author: I.Belyaev                                                      *
* Date: 1997/11/06 09:52:46 $                                            * 
*                                                                        *
* Created: Apr 10, 1997 by I.Belyaev                                     *
*                                                                        *
* Description:                                                           *
* This routine reads file CFILE and fill the PTGE table.                 *
* Also it performs some primitive checks.                                *
*                                                                        *
* Called from: PTLGEO                                                    *
*                                                                        *
* Arguments:                                                             *
* name       in/out/update Argument description                          *
*                                                                        *
**************************************************************************
      IMPLICIT NONE
 
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/ZGESL.fi"
#include "auto/GEO.fi"
#include "auto/PT.fi"
#include "gean/PTGEA.fi"
      INTEGER         NFILE  , NMAXFILE 
      PARAMETER      (NMAXFILE=20)
      CHARACTER*78    CFILERUN(NMAXFILE)
      CHARACTER*78    CF
      CHARACTER*78    CWORD,CTOKEN,CAUX,CTMP
      INTEGER         NWORD,IWORD,NITEM,IITEM,NANGL
      PARAMETER      (NWORD=256,NITEM=20,NANGL=9)    
      CHARACTER*128   WORD(NWORD) 
      CHARACTER*128   UWORD(NWORD) 
      CHARACTER*78    CITEM(NITEM)
      CHARACTER*78    UITEM(NITEM)
      CHARACTER*78    UTOKEN
      CHARACTER*256   BUFFER,C256
      CHARACTER*4     CNAME,CSUPL,CMOTH,CSHAP,CROTA,CMAON
      CHARACTER*78    CANGLES,COMMENT
      CHARACTER*12    CMATE  
      CHARACTER*12    C12
      REAL            ANGL(NANGL),ANG,ROTM(9),ROWM(3),COST,SINT
      REAL            COSP,SINP,T1,P1,T2,P2,T3,P3
      REAL             XMIN, YMIN, XMAX, YMAX, ZMIN, ZMAX, DX, DY
      REAL             ORAD, THIK, ZLEN, XL  , YL  , ZL  
      REAL             XPOS, YPOS, ZPOS 
      LOGICAL         LXMIN,LYMIN,LXMAX,LYMAX,LZMIN,LZMAX,LDX,LDY
      LOGICAL         LNAME,LSUPL,LMOTH,LROTA,LANGU,LCOMM,LNX,LNY
      LOGICAL         LSHAP,LMATE,LMAON,LCOLO,LSEEN,LFILL
      LOGICAL         LORAD,LTHIK,LZLEN,LXL  ,LYL  ,LZL 
      LOGICAL         LXPOS,LYPOS,LZPOS 
      LOGICAL         FIRST,LL
      LOGICAL         LCHAMBER , LWALL 
      INTEGER         STATUS ,I,IB,IL,LENGTH,ITEM,ICOLOR,IFILL,ISEEN
      INTEGER         I1,I1L,I1B,NX,NY,I2,I2L,I2B,IANGL
      INTEGER         LENOCC,BUFLEN,IROTA,JROTA,JR,IFILE 
      INTEGER         IRND , IGESL , NCH , NUN , NWA 

      REAL            RNDM 
      LOGICAL         PTLRRE
      LOGICAL         PTLRIN
      INTEGER         PTLBUF


      EXTERNAL        PTLRRE
      EXTERNAL        PTLRIN
      EXTERNAL        PTLBUF
      EXTERNAL        LENOCC
      EXTERNAL        RNDM
       
      COMMON          /PTBUFF/ BUFLEN,BUFFER
 
      SAVE            FIRST 
      SAVE            CFILERUN 
      SAVE            NFILE 



      DATA            FIRST / .TRUE. / 
     
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/PT.ff"
#include "gean/PTGEA.ff" 

      IF( FIRST )THEN
       IF( JPTGE .GT. 0 )THEN
        C78='PTLDAT warning!PTGE table is not empty!Remove it!'
        CALL ME78WC( 9127491 ) 
        CALL MMDROP( JPTGE ) 
       ENDIF  
C********************************************************************C
C*     Construct the names of the ASCII files from which the        *C
C*     geometry information must be extracted                       *C
C* File NAME=SUPL.i.runNN.geo for (i)nner gas pixel chambers  and     *C
C*           SUPL.o.runNN.geo for (o)uter pad chambers,               *C
C*   where   SUPL - name of the SUPERLAYER (from table GESL)        *C 
C*           NN   = INT( GEOMVERS )                                 *C
C********************************************************************C
       IF( JGESL .LE. 0 )THEN
        C78='PTLDAT error! GESL table does not exist!'
        CALL ME78EC( 932874 ) ! in BATCH mode STOP         
        RETURN 
       ENDIF 
       IF( NGESL() .LE. 0 )THEN 
        C78='PTLDAT error! GESL table is empty!'
        CALL ME78EC( 934587 ) ! in BATCH mode STOP         
        RETURN
       ENDIF 
       NFILE = 0 
       DO iGESL = 1, NGESL()
        IF( IGESL_CMP( iGESL ) .EQ. LGESL_PTC )THEN
C*       PTC syperlayer is found! 
         CALL CHHTOC(IQ(HQGESL_NAME(iGESL)),CNAME)
         DO i=1,2
          IF( NFILE .LT. NMAXFILE )THEN
           NFILE=NFILE+1
          ELSE 
           C78='PTLDAT error!No space left for files!'
           CALL ME78EC( 9812437 ) ! in BATCH mode STOP 
          ENDIF 
          C78=CNAME
          IF( i .EQ. 1 ) CALL CH78AC( '.i.run' )  
          IF( i .EQ. 2 ) CALL CH78AC( '.o.run' )
          CALL CH78AI( INT(GEOMVERS)         ) 
          CALL CH78AC( '.dat'                )   
          CFILERUN( NFILE ) = C78( 1 : LENOCC( C78 ) )
         ENDDO 
        ENDIF 
       ENDDO  
       IF( NFILE .LE. 0 .OR. NFILE .GT. NMAXFILE )THEN
        C78='PTLDAT error! NFILE='
        CALL CH78AI( NFILE                          ) 
        CALL CH78BC( '(must be 1<=NFILE<=NMAXFILE=' ) 
        CALL CH78AI( NMAXFILE                       ) 
        CALL CH78AC( ')'                            )
        CALL ME78EC( 9143507 ) ! in BATCH mode STOP 
       ENDIF 
       FIRST = .FALSE. 
      ENDIF 
          

      IF( NFILE .LE. 0 .OR. NFILE .GT. NMAXFILE )THEN
       C78='PTLDAT error! NFILE='
       CALL CH78AI( NFILE                          ) 
       CALL CH78BC( '(must be 1<=NFILE<=NMAXFILE=' ) 
       CALL CH78AI( NMAXFILE                       ) 
       CALL CH78AC( ')'                            )
       CALL ME78EC( 9213847 ) ! in BATCH mode STOP 
      ENDIF 

      IF( JPTGE .NE. 0 )THEN
       C78='PTLDAT warning!PTGE table is not empty!'
       CALL ME78WC(9729875)
      ENDIF 

      IF( LENOCC(CNAME) .LE. 0 )THEN
       C78='PTLDAT error! wrong FILE NAME!' 
       CALL ME78EC( 938045 ) ! in BATCH mode STOP!
       RETURN
      ENDIF 

      LCHAMBER = .FALSE. 
      LWALL    = .FALSE. 
      IWORD    = 0       

C*    READ lines from file CNAME into BUFFER
      IFILE = 1 
 10   CONTINUE 
      BUFFER = '  '
      BUFLEN = 0 
      CF=CFILERUN(IFILE)(1:LENOCC(CFILERUN((IFILE))))
      STATUS = PTLBUF( CF(1:LENOCC(CF))//CHNULL ) 
      IF( STATUS .EQ. -1 )THEN
       IFILE = IFILE + 1 
       IF( IFILE .LE. NFILE ) GO TO 10 
       GO TO 100 
      ENDIF 
      IF( STATUS .EQ. -2 )THEN 
       C78='PTLDAT ==> Can''t open file: '
       CALL CH78BC(CF(1:LENOCC(CF)))
       IRND = 1000 + 2000* RNDM( IRND ) 
       CALL ME78WC( IQ( IRND ) ) 
       IFILE = IFILE + 1          
       IF( IFILE .LE. NFILE ) GO TO 10 
       GO TO 100 
      ENDIF 
      IF( STATUS .EQ.  0 ) GO TO 10  
      IF( STATUS .NE.  1 ) THEN 
       C78='PTLDAT error! Unknown status='
       CALL CH78AI( STATUS               ) 
       CALL CH78BC( 'from PTLBUF'         ) 
       CALL ME78EC( 3294721  )    ! in BATCH mode STOP!
       GO TO 10 
      ENDIF 
C*    Split line into tokens:
      I = 0 
      IF( BUFLEN .LE. 2 ) GO TO 10 
      C256   = ' ' 
      C256   = BUFFER(1:MIN(BUFLEN,LENOCC(BUFFER)))
      LENGTH = LENOCC( C256)
      IF( LENGTH .LE. 1 ) GO TO 10                    ! Empty   Lines ! 
C*    Check for comment line:                           
      IF(  C256(1:2) .EQ. 'C*' .OR.                   ! Comment Lines ! 
     &     C256(1:2) .EQ. 'c*' .OR.                   ! Comment Lines ! 
     &     C256(1:2) .EQ. 'C ' .OR.                   ! Comment Lines ! 
     &     C256(1:2) .EQ. 'c ' .OR.                   ! Comment Lines ! 
     &     C256(1:2) .EQ. '* ')GO TO 10               ! Comment Lines ! 
 20   CONTINUE 
      CALL CHWORD( C256(1:LENGTH),',',I,IB,IL)  ! separators are Comma or Blank!
      IF( IL .NE. 0 )THEN 
C*     Token is found!
       CWORD = ' ' 
       CWORD = C256(IB:IL) 
       CALL CLTOU( CWORD ) 
       IF(CWORD(1:LENOCC(CWORD)).EQ.'BEGIN_OF_PTCHAMBER'.OR.
     &    CWORD(1:LENOCC(CWORD)).EQ.'BEGIN_OF_PTWALL')THEN
        IF( LWALL .OR. LCHAMBER )THEN
         C78='PTLDAT error! Command='
         CALL CH78AC( CWORD(1:LENOCC(CWORD)) )
         CALL CH78BC( 'while another chamber/wall is active!')  
         CALL ME78EC( 20981478 ) !          In BATCH mode STOP !
         C78='PTLDAT ==> last line is:'
         CALL ME78AP 
         C78=' ' 
         CALL CH78AC(C256(1:LENOCC(C256)))
         CALL ME78AP 
        ENDIF 
        IF(CWORD(1:LENOCC(CWORD)).EQ.'BEGIN_OF_PTCHAMBER')THEN 
         LCHAMBER = .TRUE. 
         LWALL    = .FALSE.
        ENDIF
        IF(CWORD(1:LENOCC(CWORD)).EQ.'BEGIN_OF_PTWALL')THEN 
         LCHAMBER = .FALSE. 
         LWALL    = .TRUE.
        ENDIF 
        IWORD    = 1 
        WORD(IWORD) = C256(IB:IL)
        I = IL 
        GO TO 20 
       ENDIF 
       IF(CWORD(1:LENOCC(CWORD)) .EQ.'END_OF_PTCHAMBER' .OR. 
     &    CWORD(1:LENOCC(CWORD)) .EQ.'END_OF_PTWALL'   )THEN
        IF(CWORD(1:LENOCC(CWORD)).EQ.'END_OF_PTCHAMBER')THEN 
         IF( .NOT. LCHAMBER )THEN
          C78='PTLDAT error! Command='
          CALL CH78AC( CWORD(1:LENOCC(CWORD)) )
          CALL CH78BC( 'whicle chamber is not active!'  ) 
          CALL ME78EC( 202355 ) !          In BATCH mode STOP !
          C78='PTLDAT ==> last line is:'
          CALL ME78AP 
          C78=' ' 
          CALL CH78AC(C256(1:LENOCC(C256)))
          CALL ME78AP 
         ENDIF 
         IF(  LWALL )THEN
          C78='PTLDAT error! Command='
          CALL CH78AC( CWORD(1:LENOCC(CWORD)) )
          CALL CH78BC( 'while wall is  active!'  ) 
          CALL ME78EC( 572365 ) !          In BATCH mode STOP !
          C78='PTLDAT ==> last line is:'
          CALL ME78AP 
          C78=' ' 
          CALL CH78AC(C256(1:LENOCC(C256)))
          CALL ME78AP 
         ENDIF 
        ENDIF
        IF(CWORD(1:LENOCC(CWORD)).EQ.'END_OF_PTWALL')THEN 
         IF( .NOT. LWALL )THEN
          C78='PTLDAT error! Command='
          CALL CH78AC( CWORD(1:LENOCC(CWORD)) )
          CALL CH78BC( 'while wall  is not active!'  ) 
          CALL ME78EC( 242355 ) !          In BATCH mode STOP !
          C78='PTLDAT ==> last line is:'
          CALL ME78AP 
          C78=' ' 
          CALL CH78AC(C256(1:LENOCC(C256)))
          CALL ME78AP 
         ENDIF 
         IF(  LCHAMBER )THEN
          C78='PTLDAT error! Command='
          CALL CH78AC( CWORD(1:LENOCC(CWORD)) )
          CALL CH78BC( 'while chamber  is  active!'  ) 
          CALL ME78EC( 545365 ) !          In BATCH mode STOP !
          C78='PTLDAT ==> last line is:'
          CALL ME78AP 
          C78=' ' 
          CALL CH78AC(C256(1:LENOCC(C256)))
          CALL ME78AP 
         ENDIF 
        ENDIF
        IF( IWORD .LT. NWORD )THEN
         IWORD = IWORD + 1 
         WORD( IWORD ) = C256(IB:IL)
        ENDIF 
C*      perform action! 

        LNAME = .FALSE. 
        LSUPL = .FALSE. 
        LMOTH = .FALSE.     
        LSHAP = .FALSE. 
        LMATE = .FALSE. 
        LANGU = .FALSE. 
        LROTA = .FALSE. 
        LCOMM = .FALSE. 
        LNX   = .FALSE. 
        LNY   = .FALSE. 

        LXPOS = .FALSE.
        LYPOS = .FALSE.
        LZPOS = .FALSE.

C*      Box 
        LXMIN = .FALSE. 
        LXMAX = .FALSE. 
        LYMIN = .FALSE. 
        LYMAX = .FALSE. 
        LZMIN = .FALSE. 
        LZMAX = .FALSE. 

C*      Tube 
        LORAD = .FALSE. 
        LTHIK = .FALSE. 
        LZLEN = .FALSE. 

C*      TRD2 
        LXL   = .FALSE. 
        LYL   = .FALSE. 
        LZL   = .FALSE.  
        LDX   = .FALSE. 
        LDY   = .FALSE. 

        DO I = 2 , IWORD-1 
         UWORD(i)   = WORD(i)(1:LENOCC(WORD(i)))
         CALL CLTOU( UWORD(i)(1:LENOCC(UWORD(i))))
         CTMP  =  WORD(i)(1:LENOCC( WORD(i)))
         CAUX  =  CTMP 
         CALL CLTOU( CAUX )
         I1 = 0
         IITEM = 0 
 30      CONTINUE 
         CALL CHWORD(CAUX,'=',I1,I1B,I1L)    ! Separator is '=' sign!
         IF( I1L .NE. 0 )THEN
          UTOKEN = CAUX(I1B:I1L)
          CTOKEN = CTMP(I1B:I1L)
          IF( LENOCC(CTOKEN) .NE. 0 .AND. 
     &        CTOKEN(1:LENOCC(CTOKEN)).NE.'=')THEN
           IF( IITEM .LT. NITEM )THEN
            IITEM = IITEM + 1
            CITEM(IITEM)=CTOKEN(1:LENOCC(CTOKEN))
           ENDIF 
          ENDIF    
          I1 = I1L 
          GO TO 30 
         ENDIF 
         DO item=1,IITEM
          UITEM(item)=CITEM(item)(1:LENOCC(CITEM(item)))
          CALL CLTOU(UITEM(item)(1:LENOCC(UITEM(item))))
         ENDDO 
         IF( IITEM .GE. 2 )THEN
          CTMP=UITEM(1)(1:LENOCC(UITEM(1)))
          IF(     CTMP(1:LENOCC(CTMP)) .EQ. 'NAME'          )THEN ! NAME
           CNAME = CITEM(2)(1:MIN(4,LENOCC(CITEM(2))))
           LNAME = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'SUPERLAYER'    )THEN ! SUPL
           CSUPL = CITEM(2)(1:MIN(4,LENOCC(CITEM(2))))
           LSUPL = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'SHAPE'         )THEN ! SHAP 
           CSHAP = CITEM(2)(1:MIN(4,LENOCC(CITEM(2))))
           LSHAP = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'MANY/ONLY'     )THEN ! MAON
           CMAON = CITEM(2)(1:MIN(4,LENOCC(CITEM(2))))
           LMAON = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'MOTHER'        )THEN ! MOTH
           CMOTH = CITEM(2)(1:MIN(4,LENOCC(CITEM(2))))
           LMOTH = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'MATHERIAL'    )THEN  ! MATH
           CMATE = CITEM(2)(1:MIN(12,LENOCC(CITEM(2))))
           LMATE = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'ROTATE'       )THEN  ! ROTA 
           CROTA = CITEM(2)(1:MIN(12,LENOCC(CITEM(2))))
           LROTA = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'XMIN'         )THEN  ! XMIN 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LXMIN = PTLRRE( CAUX(1:LENOCC(CAUX))  , 
     &                     CTMP(1:LENOCC(CTMP))  , XMIN ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'XMAX'         )THEN  ! XMAX 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LXMAX = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , XMAX ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'YMIN'         )THEN  ! YMIN
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LYMIN = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , YMIN ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'YMAX'         )THEN  ! YMAX 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LYMAX = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , YMAX ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'ZMIN'         )THEN  ! ZMIN 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LZMIN = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ZMIN ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'ZMAX'         )THEN  ! ZMAX 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LZMAX = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ZMAX ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'DX'           )THEN  ! DX 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LDX   = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , DX   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'DY'           )THEN  ! DY 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LDY   = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , DY   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'OUTERRADIUS'  )THEN  ! OuterRadius 
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LORAD = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ORAD ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'THICKNESS'    )THEN  ! Thickness 
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LTHIK = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , THIK ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'LENGTH'       )THEN  ! Length 
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LZLEN = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ZLEN ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'XPOSITION'    )THEN  ! Xposition 
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LXPOS = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , XPOS ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'YPOSITION'    )THEN  ! Yposition 
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LYPOS = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , YPOS ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'ZPOSITION'    )THEN  ! Zposition 
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LZPOS = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ZPOS ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'XLENGTH'      )THEN  ! Xlen
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LXL   = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , XL   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'YLENGTH'      )THEN  ! Ylen
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LYL   = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , YL   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'ZLENGTH'      )THEN  ! Zlen
           CAUX  = CITEM(2)(1:LENOCC(CITEM(2)))
           LZL   = PTLRRE( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ZL   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'NX'           )THEN  ! NX 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LNX   = PTLRIN( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , NX   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'NY'           )THEN  ! NY 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LNY   = PTLRIN( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , NY   ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'COLOR'        )THEN  ! COLOR 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LCOLO = PTLRIN( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ICOLOR ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'FILL'         )THEN  ! FILL 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LFILL = PTLRIN( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , IFILL ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'SEEN'         )THEN  ! SEEN 
           CAUX  =  CITEM(2)(1:LENOCC(CITEM(2)))
           LSEEN = PTLRIN( CAUX(1:LENOCC(CAUX)) , 
     &                     CTMP(1:LENOCC(CTMP)) , ISEEN ) 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'ANGLES'       )THEN  ! ANGLES 
           CANGLES=CITEM(2)(2:LENOCC(CITEM(2))-1)
           LANGU = .TRUE. 
          ELSEIF( CTMP(1:LENOCC(CTMP)) .EQ. 'COMMENT'      )THEN  ! Comment 
           COMMENT=CITEM(2)(2:LENOCC(CITEM(2))-1)           
           LCOMM = .TRUE. 
          ELSE
           C78='PTLDAT warning! Unknown ITEM='
           CALL CH78AC( CTMP(1:LENOCC(CTMP)) )
           CALL ME78EC( 8754745 )  ! in BATCH mode STOP! 
           C78='PTLDAT ==> last line is:'
           CALL ME78AP 
           C78=' ' 
           CALL CH78AC(C256(1:LENOCC(C256)))
           CALL ME78AP 
          ENDIF  
         ELSE 
          C78='PTLDAT error!Number of ITEMs='
          CALL CH78AI( IITEM ) 
          CALL ME78EC(930989423)            ! in BATCH mode STOP!
          C78='PTLDAT ==> last line is:'
          CALL ME78AP 
          C78=' ' 
          CALL CH78AC(C256(1:LENOCC(C256)))
          CALL ME78AP 
         ENDIF 
        ENDDO 
C*  
c        C78='after loop over items! '
c        CALL ME78AP 

        IF( LROTA )THEN 
         CALL CLTOU(CROTA(1:LENOCC(CROTA)))
         IF( CROTA(1:LENOCC(CROTA)) .EQ. 'YES' .OR.
     &       CROTA(1:LENOCC(CROTA)) .EQ. 'ON' )THEN
          IF( LANGU )THEN
C*         Extract angles
           I2    = 0 
           IANGL = 0           
 170        CONTINUE 
           CALL CHWORD(CANGLES(1:LENOCC(CANGLES)),';',I2,I2B,I2L)
           IF( I2L .NE. 0 )THEN
            CTMP=CANGLES(I2B:I2L)
            IF( LENOCC(CTMP) .NE. 0 .AND. 
     &          CTMP(1:LENOCC(CTMP)) .NE. ';' )THEN
             READ(CTMP(1:LENOCC(CTMP)),*,ERR=171)ANG
             IF( IANGL .LT. NANGL ) THEN
              IANGL = IANGL + 1  
              ANGL( IANGL ) = ANG 
             ENDIF 
             GO TO 172 
 171          CONTINUE 
             C78='PTLDAT error! Unknown format for ANGLE='
             CALL CH78AC( CTMP(1:LENOCC(CTMP)))
             CALL ME78EC( 918437  )        !in BATCH mode STOP!
 172          CONTINUE 
            ENDIF
            I2 = I2L  
            GO TO 170 
           ENDIF  
           IF( IANGL .NE. 6 .AND. IANGL .NE. 9 )THEN
C*          6 - number of angles 
C*          9 - rotation matrix itself! 
            C78='PTLDAT Error! Number of ANGLES='
            CALL CH78AI( IANGL ) 
            CALL ME78EC( 98372498 ) ! in BATCH mode STOP 
           ENDIF 
          ELSE
           C78='PTLDAT error! Rotation is'
           CALL CH78BC( CROTA(1:LENOCC(CROTA)))
           CALL CH78CC( 'but no ANGLEs are defined!') 
           CALL ME78EC(9872598 )             ! in BATCH mode STOP!
          ENDIF 
         ELSEIF( CROTA(1:LENOCC(CROTA)) .EQ. 'OFF' .OR.
     &           CROTA(1:LENOCC(CROTA)) .EQ. 'NO' )THEN
         ELSE
          C78='PTLDAT error! Wrong format for Rotate='
          CALL CH78AC( CROTA(1:LENOCC(CROTA)))
          CALL ME78EC( 384435 )           ! in BATCH mode STOP 
         ENDIF
        ELSE 
         C78='PTLDAT error! Nothing is known about Rotation!'
         CALL ME78EC( 023974  )           ! in BATCH mode STOP! 
        ENDIF 


        IF( .NOT. LNAME  .OR. 
     &      .NOT. LSUPL  .OR. 
     &      .NOT. LSHAP  .OR. 
     &      .NOT. LMATE  .OR. 
     &      .NOT. LMAON  .OR. 
     &      .NOT. LROTA  )THEN 
C*       Obligatory Parameters! 
         C78='PTLDAT error!Not all Obligatory parameters are given!'
         CALL ME78EC( 921834798 )              ! In BATCH mode STOP! 
         C78='LIST='
         CALL CH78AI( LNAME ) 
         CALL CH78CI( LSUPL ) 
         CALL CH78CI( LSHAP ) 
         CALL CH78CI( LMATE ) 
         CALL CH78CI( LMAON ) 
         CALL CH78CI( LROTA ) 
         CALL ME78AP 
        ENDIF 

        IF( LCHAMBER )THEN
         IF( .NOT. LNX .OR. 
     &       .NOT. LNY  )THEN
          C78='PTLGEO Error! For CHAMBER NX or NY is not given!'
          CALL ME78EC( 928347 )  ! in BATCH moed STOP!
         ENDIF 
        ENDIF 
         
        CALL CLTOU(CMAON)
        IF( CMAON(1:LENOCC(CMAON)) .NE. 'MANY' .AND. 
     &      CMAON(1:LENOCC(CMAON)) .NE. 'ONLY' )THEN
         C78='PTLDAT Error! Many/Only='
         CALL CH78AC( CMAON(1:LENOCC(CMAON))) 
         CALL CH78BC( 'is not allowed!' )
         CALL ME78EC( 2191247 )          ! in BATCH mode STOP!
        ENDIF 

        CALL CLTOU(CROTA)
        IROTA = 0 
        IF(     CROTA(1:LENOCC(CROTA)) .EQ. 'YES' .OR. 
     &          CROTA(1:LENOCC(CROTA)) .EQ. 'ON' )THEN
         IF(     IANGL .EQ. 6 )THEN 
C*        Fill the rotation matrix from given angles. 
          CALL CRROTM( IROTA , ANGL( 1 ) , ANGL( 2 )
     &                       , ANGL( 3 ) , ANGL( 4 )
     &                       , ANGL( 5 ) , ANGL( 6 ) )
          JROTA = LQ( JROTM - IROTA ) 
          IF( IROTA .EQ. 0 .OR. JROTA .EQ. 0 )THEN
           C78='PTLDAT error! Wrong Rotation MATRIX!' 
           CALL ME78EC( 394772 ) ! In BATCH mode STOP!
          ENDIF  
          JR = LQ( JROTM - IROTA )          
          ROTM(1) = Q( JR + 1 ) 
          ROTM(4) = Q( JR + 2 )  
          ROTM(7) = Q( JR + 3 )  
          ROTM(2) = Q( JR + 4 )  
          ROTM(5) = Q( JR + 5 )  
          ROTM(8) = Q( JR + 6 )  
          ROTM(3) = Q( JR + 7 )  
          ROTM(6) = Q( JR + 8 )  
          ROTM(9) = Q( JR + 9 )   
         ELSEIF( IANGL .EQ. 9 )THEN
C*        Find angles for given rotation matrix
C*        Be careful using this option!                        ! NB!
          ROWM( 1 ) = ANGL( 1 ) 
          ROWM( 2 ) = ANGL( 2 ) 
          ROWM( 3 ) = ANGL( 3 ) 
          CALL GFANG(ROWM,COST,SINT,COSP,SINP,LL)
          T1 = ATAN2(SINT,COST)*RADDEG
          P1 = ATAN2(SINT,COST)*RADDEG 
          ROWM( 1 ) = ANGL( 4 ) 
          ROWM( 2 ) = ANGL( 5 ) 
          ROWM( 3 ) = ANGL( 6 )  
          CALL GFANG(ROWM,COST,SINT,COSP,SINP,LL)
          T2 = ATAN2(SINT,COST)*RADDEG
          P2 = ATAN2(SINT,COST)*RADDEG 
          ROWM( 1 ) = ANGL( 7 ) 
          ROWM( 2 ) = ANGL( 8 ) 
          ROWM( 3 ) = ANGL( 9 ) 
          CALL GFANG(ROWM,COST,SINT,COSP,SINP,LL)
          T3 = ATAN2(SINT,COST)*RADDEG
          P3 = ATAN2(SINT,COST)*RADDEG 
          CALL CRROTM(IROTA,T1,P1,T2,P2,T3,P3)
          JROTM = LQ( JROTM - IROTA ) 
          IF( IROTA .EQ. 0 .OR. JROTA .EQ. 0 )THEN
           C78='PTLDAT error! Wrong Rotation MTRX!' 
           CALL ME78EC( 3943572 ) ! In BATCH mode STOP!
          ENDIF           
          ROTM(1) = Q( JR + 1 ) 
          ROTM(4) = Q( JR + 2 )  
          ROTM(7) = Q( JR + 3 )  
          ROTM(2) = Q( JR + 4 )  
          ROTM(5) = Q( JR + 5 )  
          ROTM(8) = Q( JR + 6 )  
          ROTM(3) = Q( JR + 7 )  
          ROTM(6) = Q( JR + 8 )  
          ROTM(9) = Q( JR + 9 )   
         ENDIF 
        ELSEIF( CROTA(1:LENOCC(CROTA)) .EQ. 'OFF' .OR. 
     &          CROTA(1:LENOCC(CROTA)) .EQ. 'NO' )THEN
         IROTA = 0 
         DO i = 1 , 9 
          ROTM( i ) = 0.0
         ENDDO 
         ROTM( 1 ) = 1.0
         ROTM( 5 ) = 1.0
         ROTM( 9 ) = 1.0
        ELSE
         C78='PTLDAT error! Rotate='
         CALL CH78AC( CROTA(1:LENOCC(CROTA)) ) 
         CALL CH78BC( 'is not allowed!'      ) 
         CALL ME78EC( 8742134                ) ! In BATCH mode STOP!
        ENDIF        

        IF(    CSHAP(1:LENOCC(CSHAP)) .EQ. 'TRD2' )THEN
         IF( .NOT. LXL    .OR. 
     &       .NOT. LYL    .OR. 
     &       .NOT. LZL    .OR. 
     &       .NOT. LDX    .OR. 
     &       .NOT. LDY    .OR. 
     &       .NOT. LXPOS  .OR. 
     &       .NOT. LYPOS  .OR. 
     &       .NOT. LZPOS       ) THEN
          C78='PTLDAT error! for TRD2 SHAPE not all information!!!'
          CALL ME78EC( 148345 )
         ENDIF 
         IF(   LXMIN      .OR. 
     &         LYMIN      .OR. 
     &         LZMIN      .OR. 
     &         LORAD      .OR. 
     &         LTHIK      .OR. 
     &         LZLEN           )THEN
          C78='PTLDAT error! for TRD2 SHAPE extra wrong parameters!!!'
          CALL ME78EC( 983274 ) ! in BATCH mode STOP 
         ENDIF 
        ELSEIF(CSHAP(1:LENOCC(CSHAP)) .EQ. 'BOX'  )THEN
         IF( .NOT. LXMIN  .OR. 
     &       .NOT. LXMAX  .OR. 
     &       .NOT. LYMIN  .OR. 
     &       .NOT. LYMAX  .OR. 
     &       .NOT. LZMIN  .OR. 
     &       .NOT. LZMAX       )THEN
          C78='PTLDAT error! for BOX  SHAPE not all information!!!'
          CALL ME78EC( 134545 )
         ENDIF 
         IF(   LXPOS      .OR. 
     &         LYPOS      .OR. 
     &         LZPOS      .OR. 
     &         LORAD      .OR. 
     &         LTHIK      .OR. 
     &         LZLEN      .OR.
     &         LDX        .OR. 
     &         LDY        .OR.
     &         LXL        .OR.
     &         LYL        .OR.
     &         LZL            )THEN 
          C78='PTLDAT error! for BOX SHAPE extra wrong parameters!!!'
          CALL ME78EC( 234274 ) ! in BATCH mode STOP 
         ENDIF 
        ELSEIF(CSHAP(1:LENOCC(CSHAP)) .EQ. 'TUBE' )THEN
         IF( .NOT. LORAD  .OR. 
     &       .NOT. LTHIK  .OR. 
     &       .NOT. LZLEN  .OR. 
     &       .NOT. LXPOS  .OR. 
     &       .NOT. LXPOS  .OR. 
     &       .NOT. LXPOS       ) THEN
          C78='PTLDAT error! for TUBE SHAPE not all information!!!'
          CALL ME78EC( 143245 )
         ENDIF 
         IF(   LXMIN      .OR. 
     &         LYMIN      .OR. 
     &         LZMIN      .OR. 
     &         LXMAX      .OR. 
     &         LYMAX      .OR. 
     &         LZMAX      .OR.
     &         LDX        .OR. 
     &         LDY        .OR. 
     &         LXL        .OR. 
     &         LYL        .OR. 
     &         LZL             )THEN 
          C78='PTLDAT error! for TUBE SHAPE extra wrong parameters!!!'
          CALL ME78EC( 453374 ) ! in BATCH mode STOP 
         ENDIF 
        ELSE 
         C78='PTLDAT Error! SHAPE='
         CALL CH78AC( CSHAP(1:LENOCC(CSHAP))) 
         CALL CH78BC( 'is not allowed!' )
         CALL ME78EC( 219847 )              ! in BATCH mode STOP!
        ENDIF 

        IF( .NOT. LCOLO )THEN
         ICOLOR = 0 
        ENDIF 
        IF( .NOT. LSEEN )THEN
         ISEEN  = 0 
        ENDIF 
        IF( .NOT. LFILL )THEN
         IFILL  = 0 
        ENDIF 

        IF( CSHAP(1:LENOCC(CSHAP)).EQ.'BOX' )THEN
         IF( XMIN .GE. XMAX ) THEN 
          C78='PTLDAT Error! XMIN='
          CALL CH78AF( XMIN , -3 ) 
          CALL CH78AC( '>XMAX='  )
          CALL CH78AF( XMAX , -3 ) 
          CALL ME78EC( 9128741 ) ! in BATCH mode STOP!
         ENDIF 
         IF( YMIN .GE. YMAX ) THEN 
          C78='PTLDAT Error! YMIN='
          CALL CH78AF( YMIN , -3 ) 
          CALL CH78AC( '>YMAX='  )
          CALL CH78AF( YMAX , -3 ) 
          CALL ME78EC( 8749841 ) ! in BATCH mode STOP!
         ENDIF 
         IF( ZMIN .GE. ZMAX ) THEN 
          C78='PTLDAT Error! ZMIN='
          CALL CH78AF( ZMIN , -3 ) 
          CALL CH78AC( '>ZMAX='  ) 
          CALL CH78AF( ZMAX , -3 ) 
          CALL ME78EC( 912874 ) ! in BATCH mode STOP!
         ENDIF 
        ENDIF 

        IF( CSHAP(1:LENOCC(CSHAP)).EQ.'TUBE' )THEN
         IF( THIK .GT. ORAD ) THEN 
          C78='PTLDAT Error! THICKNESS='
          CALL CH78AF( THIK , -3 ) 
          CALL CH78AC( '>OuterRadius='  )
          CALL CH78AF( ORAD , -3 ) 
          CALL ME78EC( 12343 ) ! in BATCH mode STOP!
         ENDIF 
         IF( THIK .LE. 0 ) THEN 
          C78='PTLDAT Error! THICKNESS='
          CALL CH78AF( THIK , -3 ) 
          CALL CH78AC( '<0 !'  )
          CALL ME78EC( 6875543 ) ! in BATCH mode STOP!
         ENDIF 
         IF( ORAD .LE. 0 ) THEN 
          C78='PTLDAT Error! OuterRadius='
          CALL CH78AF( ORAD , -3 ) 
          CALL CH78AC( '<0!'  )
          CALL ME78EC( 124323 ) ! in BATCH mode STOP!
         ENDIF 
         IF( ZLEN .LE. 0 ) THEN 
          C78='PTLDAT Error! Length='
          CALL CH78AF( ZLEN , -3 ) 
          CALL CH78AC( '<0!'  )
          CALL ME78EC( 67453 ) ! in BATCH mode STOP!
         ENDIF 
        ENDIF 

        IF( LCHAMBER ) THEN 
         IF( NX .LE. 0 .OR. NY .LE. 0 ) THEN 
          C78='PTLDAT error!For CHAMBER NX='
          CALL CH78AI( NX    ) 
          CALL CH78CC( 'NY=' ) 
          CALL CH78AI( NY    )
          CALL ME78EC( 3450943 )  ! in BATCH mode STOP  
         ENDIF 
         IF( NX * NY .GT. 256 )THEN
          C78='PTLDAT warning==>Nx*Ny='
          CALL CH78AI( NX  ) 
          CALL CH78AC( '*' ) 
          CALL CH78AI( NY  ) 
          CALL CH78AC( '=' )
          CALL CH78AI( NX * NY ) 
          CALL CH78BC( '> 256 ==> DAQ problems!' )
          CALL ME78WC( 9348217 ) 
         ENDIF 
        ELSE 
         NX = 1 
         NY = 1 
        ENDIF 


        GO TO 99 

c        IF( LCHAMBER )THEN 
c         C78='BEGIN_OF_PTCHAMBER' 
c        ELSE
c         C78='BEGIN_OF_PTWALL'  
c        ENDIF 
c        CALL ME78AP 
c        C78= '         Name='
c        CALL CH78AC( CNAME         )
c        CALL CH78CC( ' Superlayer=') 
c        CALL CH78AC( CSUPL         )
c        CALL CH78CC( ' Mother='    ) 
c        CALL CH78AC( CMOTH         )
c        CALL ME78AP
c        C78= '         Shape='      
c        CALL CH78AC( CSHAP         ) 
c        CALL CH78CC( ' Matherial=' ) 
c        CALL CH78AC( CMATE(1:LENOCC(CMATE)))
c        CALL CH78CC( ' Many/Only=' ) 
c        CALL CH78AC( CMAON         )
c        CALL ME78AP 
c        C78= '         Rotate='    
c        CALL CH78AC( CROTA         ) 
c        CALL CLTOU (CROTA(1:LENOCC(CROTA)))
c        IF( CROTA(1:LENOCC(CROTA)).EQ.'YES' .OR.
c     &      CROTA(1:LENOCC(CROTA)).EQ.'ON' )THEN
c         IF( LANGU )THEN
c          CALL CH78CC( ' Angles=('   ) 
c          DO i=1,IANGL
c            CALL CH78AF( ANGL(i) , -3 )
c           IF( I .NE. IANGL )CALL CH78AC( ';' ) 
c          ENDDO   
c          CALL CH78AC(')')
c         ENDIF
c        ENDIF  
c        CALL ME78AP 
c        IF( LCHAMBER ) THEN
c         C78='         NX='
c         CALL CH78AI( NX ) 
c         CALL CH78CC( ' NY=' ) 
c         CALL CH78AI( NY ) 
c         CALL ME78AP  
c        ENDIF  
c        IF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'BOX' )THEN 
c         C78= '         Xmin='
c         CALL CH78AF( XMIN , -3 ) 
c         CALL CH78CC( ' Xmax='  )         
c         CALL CH78AF( XMAX , -3 ) 
c         CALL ME78AP 
c         C78= '         Ymin='           
c         CALL CH78AF( YMIN , -3 ) 
c         CALL CH78CC( ' Ymax='  )         
c         CALL CH78AF( YMAX , -3 ) 
c         CALL ME78AP 
c         C78= '         Zmin='           
c         CALL CH78AF( ZMIN , -3 ) 
c         CALL CH78CC( ' Zmax='  )         
c         CALL CH78AF( ZMAX , -3 )
c         CALL ME78AP 
c        ENDIF 
c        IF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TRD2' )THEN 
c         C78= '         Xposition='
c         CALL CH78AF( XPOS , -3 ) 
c         CALL CH78CC( ' Yposition='  )         
c         CALL CH78AF(  Ypos , -3 ) 
c         CALL CH78CC( ' Zposition='  )         
c         CALL CH78AF(  Zpos , -3 ) 
c         CALL ME78AP 
c         C78= '         Xlength='           
c         CALL CH78AF( XL , -3 ) 
c         CALL CH78CC( ' Ylength='  )         
c         CALL CH78AF( YL , -3 ) 
c         CALL CH78CC( ' Zlength='  )         
c         CALL CH78AF( ZL , -3 ) 
c         CALL ME78AP 
c         C78= '         DX='           
c         CALL CH78AF( DX , -3 ) 
c         CALL CH78CC( ' DY='  )         
c         CALL CH78AF( DY , -3 ) 
c         CALL ME78AP 
c        ENDIF
c        IF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TUBE' )THEN 
c         C78= '         Xposition='
c         CALL CH78AF( XPOS , -3 ) 
c         CALL CH78CC( ' Yposition='  )         
c         CALL CH78AF(  Ypos , -3 ) 
c         CALL CH78CC( ' Zposition='  )         
c         CALL CH78AF(  Zpos , -3 ) 
c         CALL ME78AP 
c         C78= '         OuterRadius='           
c         CALL CH78AF( ORAD , -3 ) 
c         CALL CH78CC( ' Thickness='  )         
c         CALL CH78AF( THIK , -3 ) 
c         CALL CH78CC( ' Length='  )         
c         CALL CH78AF( ZLEN , -3 ) 
c         CALL ME78AP 
c        ENDIF
c        C78= ' '   
c        IF( LCOLO )THEN
c         CALL CH78BC( '        Color=' ) 
c         CALL CH78AI( ICOLOR    )   
c        ENDIF 
c        IF( LSEEN )THEN
c         CALL CH78BC( '        Seen=' ) 
c         CALL CH78AI( ISEEN    )   
c        ENDIF 
c        IF( LFILL )THEN
c         CALL CH78BC( '        Fill=' ) 
c         CALL CH78AI( IFILL    )   
c        ENDIF 
c        CALL ME78AP
c        IF( LCOMM )THEN
c         C78=' Comment="'
c         CALL CH78AC( COMMENT ) 
c         CALL CH78AC( '"'     ) 
c         CALL ME78AP 
c        ENDIF  
c        IF( LCHAMBER )THEN
c         C78='END_OF_PTCHAMBER'
c        ELSE
c         C78='END_OF_PTWALL' 
c        ENDIF 
c        CALL ME78AP 

 99     CONTINUE 

C*      Book and fill PTGE table!                           BOOK PTGE!
        CALL MMBOOK(JPTGE,1)
C*      Flag 
        IF(     LCHAMBER ) THEN 
         IQ(IQPTGE_FLAG_L()) = 1
        ELSEIF( LWALL    ) THEN
         IQ(IQPTGE_FLAG_L()) = -1 
        ELSE 
         IQ(IQPTGE_FLAG_L()) = 0 
        ENDIF  
C*      Name 
        CALL CLTOU ( CNAME ) 
        CALL CHCTOH( CNAME , IQ(HQPTGE_NAME_L()) , 1 )
C*      Superlayer
        CALL CLTOU ( CSUPL ) 
        CALL CHCTOH( CSUPL , IQ(HQPTGE_SUPL_L()) , 1 )
C*      Mother
        CALL CLTOU ( CMOTH ) 
        CALL CHCTOH( CMOTH , IQ(HQPTGE_MOTH_L()) , 1 )
C*      Shape
        CALL CLTOU ( CSHAP ) 
        CALL CHCTOH( '    ' , IQ(HQPTGE_SHAP_L()) , 1 )
        CALL CHCTOH( CSHAP  , IQ(HQPTGE_SHAP_L()) , 1 )
C*      Matherial
        CALL CHCTOH(CMATE,IQ(HQPTGE_MATE_L(1)),3)
        CMATE=' ' 
        CALL CHHTOC(IQ(HQPTGE_MATE(1,NPTGE())),C12) 
C*      Many/Only flag for GEANT
        CALL CLTOU ( CMAON ) 
        CALL CHCTOH( CMAON , IQ(HQPTGE_MAON_L()) , 1 )
C*      Rotation ang angles:
        IQ(IQPTGE_IROT_L()) = IROTA
        DO i = 1 , 9 
          Q( QPTGE_ROTM_L(i)) = ROTM( i )
        ENDDO          
C*      Geometry
        IF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'BOX' )THEN 
          Q( QPTGE_XMIN_L()) = XMIN 
          Q( QPTGE_XMAX_L()) = XMAX 
          Q( QPTGE_YMIN_L()) = YMIN 
          Q( QPTGE_YMAX_L()) = YMAX 
          Q( QPTGE_ZMIN_L()) = ZMIN 
          Q( QPTGE_ZMAX_L()) = ZMAX
          Q( QPTGE_DX_L  ()) = 0 
          Q( QPTGE_DY_L  ()) = 0 
        ELSEIF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TUBE')THEN  
          Q( QPTGE_ORAD_L()) = ORAD
          Q( QPTGE_THIK_L()) = THIK 
          Q( QPTGE_ZLEN_L()) = ZLEN 
          Q( QPTGE_XPOS_L()) = XPOS 
          Q( QPTGE_YPOS_L()) = YPOS 
          Q( QPTGE_ZPOS_L()) = ZPOS 
          Q( QPTGE_DX_L  ()) = 0 
          Q( QPTGE_DY_L  ()) = 0 
        ELSEIF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TRD2' )THEN 
          Q( QPTGE_XLEN_L()) = XL  
          Q( QPTGE_YLEN_L()) = YL  
          Q( QPTGE_ZLEN_L()) = ZL  
          Q( QPTGE_XPOS_L()) = XPOS  
          Q( QPTGE_YPOS_L()) = YPOS 
          Q( QPTGE_ZPOS_L()) = ZPOS
          Q( QPTGE_DX_L  ()) = DX
          Q( QPTGE_DY_L  ()) = DY          
        ENDIF 
        IQ(IQPTGE_NX_L  ()) = NX 
        IQ(IQPTGE_NY_L  ()) = NY 
C*      Attributes
        IQ(IQPTGE_COLO_L()) = ICOLOR 
        IQ(IQPTGE_FILL_L()) = IFILL
        IQ(IQPTGE_SEEN_L()) = ISEEN 
C*      Comment
        CALL CHCTOH(COMMENT,IQ(HQPTGE_COMM_L(1)), 20 )
C*      End of action!
        LCHAMBER = .FALSE. 
        LWALL    = .FALSE.
        I = IL 
        GO TO 20 
       ENDIF 
       IF(  LCHAMBER .OR. LWALL  )THEN     ! Something is active  
        IF( LENOCC(CWORD) .NE. 0 )THEN 
         IF( CWORD(1:LENOCC(CWORD)) .NE. ',' )THEN
          IF( IWORD .LT. NWORD ) THEN
           IWORD = IWORD + 1 
           WORD(IWORD)=C256(IB:IL)
          ELSE
           C78='PTLDAT Error! Number of tokens='
           CALL CH78AI( IWORD ) 
           CALL CH78BC( ' too large!' ) 
           CALL ME78EC( 723647286 )  
          ENDIF 
         ENDIF 
        ENDIF 
       ENDIF 
       I = IL 
       GO TO 20  
      ENDIF 

      GO TO 10 


 100  CONTINUE

      IF(     JPTGE .LE. 0 )THEN 
       C78='PTLDAT (END) warning: PTGE table was not booked!' 
       CALL ME78WC( 9213478 ) 
      ELSEIF( NPTGE() .EQ. 0 )THEN
       C78='PTLDAT (END) warning: PTGE table is empty!' 
       CALL ME78WC( 9212345 ) 
      ELSE 
       NCH = 0 
       NWA = 0 
       NUN = 0 
       DO i=1,NPTGE()
        IF(     IPTGE_FLAG( i ) .EQ. 1    )THEN  ! Chamber(Active Object)
          NCH = NCH + 1 
        ELSEIF( IPTGE_FLAG( i ) .EQ. -1   )THEN  ! Wall 
          NWA = NWA + 1 
        ELSE                                     ! Unknown(Comment?) 
          NUN = NUN + 1 
        ENDIF 
       ENDDO  
       IF( NUN .NE. 0 )THEN
        C78='PTLDAT (END) warning: Number of Unknown Objects:'
        CALL CH78AI( NUN ) 
        CALL ME78WC( 2184987 )     
       ENDIF 
       C78='PTLDAT (END)statistics==> Total Objects:' 
       CALL CH78AI( NCH + NWA + NUN ) 
       IF( NCH .NE. 0 )THEN
        CALL CH78CC( 'Chambers:'     ) 
        CALL CH78AI( NCH ) 
       ENDIF 
       IF( NWA .NE. 0 )THEN
        CALL CH78CC( 'Walls:'     ) 
        CALL CH78AI( NWA ) 
       ENDIF 
       IF( NUN .NE. 0 )THEN
        CALL CH78CC( 'Unknown:'     ) 
        CALL CH78AI( NUN ) 
       ENDIF
       CALL ME78AP 
      ENDIF 

      RETURN        
      END


