/*
************************************************************************
*
* RIC_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced GEDE/GWAL
* banks for the rich 
*
*       called from G..MAIN
*
* The transferred parameters are
* void ric_arte_(int ngede,int ngwal,char lvols[],int lcopy[],int nlev)  
************************************************************************
*/

#include <stdio.h>
#include "arte/Arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "auto/GEO.hh"
#include "gean/gclink.h"
#include "gean/zgeom.h"

extern "C" {
    void ric_arte_(int,int,char*,int*,int);
    void mmbrel_(int &,int *, int*);}

void ric_arte_(int ngede,int ,char lvols[],int *,int nlev) {

    zgvol ZGVOL;
    char  volname[4];
    union  { int ii; char cname[4];};
    union { int ji; float jx;};
    
    if(ngede) {  
      int ngede1 = ngede;
      ArtePointer<GESL> currgesl(zgmoth_.CURRSL);
      ArtePointer<GEDE> currgede(ngede);
      if(currgesl->fpl == ngede) {
         struct GEDE gede;
         ArtePointer<GEDE>::append(gede);
         ngede1++; 
         ArtePointer<GEDE> nextgede(ngede1);      
         *nextgede = *currgede; 
         nextgede->gesl =0; 
         mmbrel_(ArtePointer<GSLX_GEDE>::getLink().getRef(),
                 &zgmoth_.CURRSL,&ngede1);
         nextgede->gmat =0;      
         ArtePointer<GMAX> gm = currgede->gmat;
         int nrgm = gm.index();
         mmbrel_(ArtePointer<GMAX_GEDE>::getLink().getRef(),&nrgm,&ngede1);
         currgesl->npl = currgesl->npl +1 ;
         strncpy(currgede->gvol,"    ",4);
         strncpy(volname,nextgede->gvol,4);}
      else {
         ngede1=ngede;   strncpy(volname,currgede->gvol,4);}

      int Gvolnum = ZGVOL.Check_Gvol(&lvols[4*nlev-4]);
      int jvos = *(gcbank_.lq + gclink_.jvolum -1 - Gvolnum);
      ji =*(gcbank_.iq + jvos + 2);
      int nin = int(jx);
      for(int in = 1; in <= nin;in++) {
          int jin = *(gcbank_.lq + jvos -1 -in);
          ji = *(gcbank_.iq + jin +1);
          int ivot = int(jx);
          ii =  *(gcbank_.iq+gclink_.jvolum-1 + ivot);
          if(!strncmp(cname,volname,4)) { 
             jx = float(ngede1);  *(gcbank_.iq + jin +2) = ji;    return;}}  
      arteMsg << "ric_arte: volume " << volname << " not found";
      arteMsg.error();        
}}          

/* ric_arte_ */









