#include "rich/PhotonDetection.h"
#include "rich/vessel.h"

void RICHConfigDir(char *configdir) {
  
  char* RICHconfigdir=getenv("RICH_CONFIGDIR");
  if (RICHconfigdir) {
    strcpy(configdir,RICHconfigdir);
    if (configdir[strlen(configdir)-1]!='/') strcat(configdir,"/");
    }
  else {
    char *hb=getenv("HB");
    char *hbvers=getenv("HBVERS");
    if (!hb||!hbvers) {
      fprintf(stderr,"RICINI:  $HB/$HBVERS is not defined. Abort.\n");
      exit(1);
      }
    strcpy(configdir,hb);
    strcat(configdir,"/");
    strcat(configdir,hbvers);
    strcat(configdir,"/geo/rich/");
    }
  }

extern "C" {


void F77NAME(ricini)() {
  if (RICH_Detector) return;
  char configdir[256];
  RICHConfigDir(&configdir[0]);
  printf(" === RICH configuration directory: %s\n",configdir);

  RICH_Detector=new RICHDetector(configdir);
  if (!RICH_Vessel) RICH_Vessel=new RICHVessel(configdir);
  }

void F77NAME(rgnini)() {
  F77NAME(ricini)();

  Table eff;
  
//
// stepfunction
//
/*
  double lmin=280e-9;
  double lmax=650e-9;
  eff.append(lmin*(1-1E-10),0);
  eff.append(lmin          ,1);
  eff.append(lmax          ,1);
  eff.append(lmax*(1+1E-10),0);
  FILE* fp=fopen("MaxEfficiency.dat","w");
  eff0.print(fp);
*/

// fold detection efficiency into generation probability

  int n=1000;  // set accuracy of the linear interpolation
  Table deff,veff;
  RICH_Detector->MaxEfficiency(deff,n,2);
  RICH_Vessel->MaxEfficiency(veff,n,2);
 
  double lmin=1E37,lmax=0;
  int i;
  for (i=0;i<n;i++) {
    if (deff.y(i)!=0 && deff.x(i)<lmin ) lmin=deff.x(i);
    if (deff.y(i)!=0 && deff.x(i)>lmax ) lmax=deff.x(i);
    if (veff.y(i)!=0 && veff.x(i)<lmin ) lmin=veff.x(i);
    if (veff.y(i)!=0 && veff.x(i)>lmax ) lmax=veff.x(i);
    }
  double dl=(lmax-lmin)/n;
  for (i=0;i<n;i++) {
    double l=lmin+i*dl;
    eff.append(l,deff.f(l)*veff.f(l));
    }
  eff.append(lmax,0);

  RICH_Vessel->Radiator().gsckov(200,eff);
  }

  
void F77NAME(ricexi)() {
  if (RICH_Detector) { delete RICH_Detector; RICH_Detector=0;}
  if (RICH_Vessel) { delete RICH_Vessel;  RICH_Vessel=0; }
  }


} // extern "C"
