
/***********************************************************************
*
* SIL_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced GEDE/GWAL
* banks for the SVD 
*
*       called from G..MAIN
*
* The transferred parameters are
* void ric_arte_(int ngede,int ngwal,char lvols[],int lcopy[],int nlev)
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/Arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "auto/GEO.hh"
#include "gean/zgeom.h"

  extern "C" {
    void sil_arte_(int,int,char*,int*,int); 
    mmbrel_(int&, int*, int*);}

void sil_arte_(int ngede,int,char lvols[],int lcopy[],int nlev) {
    zgdet ZGDET;
    zgvol ZGVOL;
    char  volname[5];

      if(ngede!=0) { 
      struct GEDE gede;
      ArtePointer<GEDE>::append(gede);

      ArtePointer<GEDE> currgede(ngede);
      ArtePointer<GEDE> nextgede(ngede+1);      
      *nextgede = *currgede; 
      int ngede1 = ngede + 1;     
      ArtePointer<GESL> currgesl(zgmoth_.CURRSL);
      nextgede->gesl =0;      
      mmbrel_(ArtePointer<GSLX_GEDE>::getLink().getRef(),
              &zgmoth_.CURRSL,&ngede1);
      nextgede->gmat =0;
      ArtePointer<GMAX> gm = currgede->gmat;
      int nrgm = gm.index();
      mmbrel_(ArtePointer<GMAX_GEDE>::getLink().getRef(),&nrgm,&ngede1);
      currgesl->npl = currgesl->npl +1 ;
 
      nextgede->zfw[0] = currgede->zfw[1];
      currgede->zfw[1] =0.;
      nextgede->zfw[1] =0.;
      nextgede->xfw[0] = currgede->xfw[1];
      currgede->xfw[1] =0.;
      nextgede->xfw[1] =0.;
      nextgede->nwi[0] = currgede->nwi[1];
      currgede->nwi[1] =0;
      nextgede->nwi[1] =0;
      strncpy(volname,&lvols[4*nlev],4);
      int type = lcopy[nlev];
      int itype = type>>16;
      int nr_vol = ZGVOL.Get_volnr(volname,itype);
      
      float pitch[4], wire_or[4];
      ZGDET.Get_wire_orientation(nr_vol,wire_or,currgede->nsl);
      nextgede->cos =cos(AR_DEGRAD*wire_or[1]);
      nextgede->sin =sin(AR_DEGRAD*wire_or[1]);

      ZGDET.Get_pitch(nr_vol,pitch,currgede->nsl);      
      nextgede->pit = pitch[1];  
      currgede->nsl = 1;
      nextgede->nsl = 1;}}
/* sil_arte_ */


