
      SUBROUTINE SIPG96(ISL)

************************************************************************
* Author :    Siegmund Nowak   05/07/96
*
* Description:   Silicon Detector from Target group
*
* Called from:
*
* External references:
*
* Argument in/out description
*      ISL       Superlayer number ( goes as SI04 )
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMAGN.fi"
#include "gean/ZGSILD.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
      INTEGER I,ISL,IFIRST,IVOL(5),JSG,JPL,JPLF,JPLL,ISET,IDET,MEDNUM
      REAL PAR(3),PARBG(3),XPOS,YPOS,ZPOS,XPOSBG,ZPOSBG
      REAL XPOSSI,XMS(5),DZBG
      CHARACTER*4 SLNAM
      DATA DZBG/.01/
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--   initialisation (volume definition,rad-length,angles etc)
      IF(IFIRST.EQ.0) THEN
          
         IF(DETV(LGESL_SIL).EQ.'SIDS') CALL SILDAT('sil97.dat')
         CALL GSVOLU('BAGM','BOX ',MEDNUM(2,'ALUMINIUM' ),PAR,0,IVOL(2))
         CALL GSATT('BAGM','COLO',50)
         PAR(1) = 1.45
         PAR(2) = 1.625
         PAR(3) = .015
         CALL GSVOLU('SPLM','BOX ',MEDNUM(4,'SILICON' ),PAR,3,IVOL(3))
         CALL GSATT('SPLM','COLO',5)
         PAR(1) = 5.
         PAR(2) = 1.25
         PAR(3) = .075
         CALL GSVOLU('SPGM','BOX ',MEDNUM(2,'G10'),PAR,3,IVOL(4))
         CALL GSATT('SPGM','COLO',4)
         PAR(1) = 2.0
         PAR(2) = 1.0
         PAR(3) = .03
         CALL GSVOLU('SPHM','BOX ',MEDNUM(2,'AL2O3'),PAR,3,IVOL(5))
         CALL GSATT('SPHM','COLO',3)
         CALL GSVOLU('SPCM','BOX ',MEDNUM(2,'AL2O3'),PAR,0,IVOL(5))
         CALL GSATT('SPCM','COLO',2)
         DO I=2,5
         CALL GRADLN(IVOL(I),XMS(I))
         ENDDO
         JSG = 0
         IFIRST = 1
      ENDIF

c     Superlayer
      IF(IGESL_LAY(ISL).EQ.0) GO TO 90
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,SLNAM,4)
      CALL CGGESL(SLNAM,'MAGN',0)

C--    alu bags (front side)
      PARBG(1) = 5.5
      PARBG(2) = 5.
      PARBG(3) = .5*DZBG
      XPOSBG = 24.575
      ZPOS = -.5*(FGESL_Z2(ISL)-FGESL_Z1(ISL)) + PARBG(3)
      JSG = JSG + 1
      CALL GSPOSP('BAGM',JSG,SLNAM,-XPOSBG,0.,ZPOS,0,'ONLY',PARBG,3)
      JSG = JSG + 1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOSBG,0.,ZPOS,0,'ONLY',PARBG,3)

C--    alu bags (left and right sides)
      PAR(1) =  .5*DZBG
      PAR(2) = 5. - DZBG
      PAR(3) = .5*(FGESL_Z2(ISL)-FGESL_Z1(ISL)) - DZBG
      XPOS = XPOSBG + (PARBG(1) - .5*DZBG)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOS,0.,0.,0,'ONLY',PAR,3)
      XPOS = XPOSBG - (PARBG(1) - .5*DZBG)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOS,0.,0.,0,'ONLY',PAR,3)
      XPOS = -XPOSBG + (PARBG(1) - .5*DZBG)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOS,0.,0.,0,'ONLY',PAR,3)
      XPOS = -XPOSBG - (PARBG(1) - .5*DZBG)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOS,0.,0.,0,'ONLY',PAR,3)

C--    alu bags (lower and upper sides)

      PAR(1) = 5.5
      PAR(2) = .5*DZBG
      YPOS = -5. + .5*DZBG
      XPOS = XPOSBG
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOS,YPOS,0.,0,'ONLY',PAR,3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,XPOS,-YPOS,0.,0,'ONLY',PAR,3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,-XPOS,YPOS,0.,0,'ONLY',PAR,3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,-XPOS,-YPOS,0.,0,'ONLY',PAR,3)

C--   silicon chips

      YPOS = -2.425
      XPOSSI = 1.525
      CALL GSPOS('SPLM',NGEDE()+1,SLNAM,
     +                              XPOSBG+XPOSSI,YPOS,-.015,0,'ONLY')
      CALL CRGEDE('SPLM',1,1)
      JPLF = 2 + (NGEDE()-1) * NCGEDE()
      CALL GSPOS('SPLM',NGEDE()+1,SLNAM,
     +                              XPOSBG-XPOSSI,YPOS,-.015,0,'ONLY')
      CALL CRGEDE('SPLM',1,2)

      CALL GSPOS('SPLM',NGEDE()+1,SLNAM,
     +                             -XPOSBG+XPOSSI,YPOS,-.015,0,'ONLY')
      CALL CRGEDE('SPLM',1,3)

      CALL GSPOS('SPLM',NGEDE()+1,SLNAM,
     +                             -XPOSBG-XPOSSI,YPOS,-.015,0,'ONLY')
      CALL CRGEDE('SPLM',1,4)
      JPLL = 2 + (NGEDE()-1) * NCGEDE()

C--   fill remaing detector data common for all detectors
      DO JPL=JPLF+JGEDE,JPLL+JGEDE,NCGEDE()
       Q (JPL+JGEDE_COS) = 1.
       Q (JPL+JGEDE_SIN) = 0.
       Q (JPL+JGEDE_XFW) = Q(JPL+JGEDE_XMIN) + 0.5*PITSI
       Q (JPL+JGEDE_ZFW) = Q(JPL+JGEDE_ZMIN)
       IQ(JPL+JGEDE_NWI) = 2.*14.5 / PITSI
       Q(JPL+JGEDE_ACC) = SIGSI
       Q(JPL+JGEDE_EFF) = EFFSI
       Q(JPL+JGEDE_PIT) = PITSI
       Q(JPL+JGEDE_DOD) = DMSI
       IQ(JPL+JGEDE_NSL)  = 1
       Q(JPL+JGEDE_MS)= XMS(3)*(.0136*(1.+.038*ALOG(XMS(3))))**2
       Q(JPL+JGEDE_SXMN) = Q(JPL+JGEDE_XMIN)
       Q(JPL+JGEDE_SXMX) = Q(JPL+JGEDE_XMAX)
       Q(JPL+JGEDE_SYMN) = Q(JPL+JGEDE_YMIN)
       Q(JPL+JGEDE_SYMX) = Q(JPL+JGEDE_YMAX)
      ENDDO

c      Preamplifiers

      YPOS = .2
      CALL GSPOS('SPHM',1,SLNAM, XPOSBG,YPOS,-.03,0,'ONLY')
      CALL GSPOS('SPHM',2,SLNAM,-XPOSBG,YPOS,-.03,0,'ONLY')

C      Carrier1 = ceramic-plates
      PAR(1) = 3.05
      PAR(2) = 2.45
      PAR(3) = .025
      YPOS = -1.75
      CALL GSPOSP('SPCM',1,SLNAM, XPOSBG,YPOS,PAR(3),0,'ONLY',PAR,3)
      CALL GSPOSP('SPCM',3,SLNAM,-XPOSBG,YPOS,PAR(3),0,'ONLY',PAR,3)

      YPOS = YPOS + PAR(2)
      PAR(1) = 2.2
      PAR(2) = .5
      YPOS = YPOS + PAR(2)
      CALL GSPOSP('SPCM',2,SLNAM, XPOSBG,YPOS,PAR(3),0,'ONLY',PAR,3)
      CALL GSPOSP('SPCM',4,SLNAM,-XPOSBG,YPOS,PAR(3),0,'ONLY',PAR,3)


c      G10 plate

      YPOS = 2.5
      ZPOS = 207.9 - .5*(FGESL_Z1(ISL)+FGESL_Z2(ISL))
      CALL GSPOS('SPGM',1,SLNAM, XPOSBG,YPOS,ZPOS,0,'ONLY')
      CALL GSPOS('SPGM',2,SLNAM,-XPOSBG,YPOS,ZPOS,0,'ONLY')

C--    alu bag (back side)
      ZPOSBG = .5*(FGESL_Z2(ISL)-FGESL_Z1(ISL)) - PARBG(3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM, XPOSBG,0.,ZPOSBG,0,'ONLY',PARBG,3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,-XPOSBG,0.,ZPOSBG,0,'ONLY',PARBG,3)

c     CORNERS
      PAR(1) = PARBG(1)
      PAR(2) = .1
      PAR(3) = 1.
      YPOS = 5. - DZBG - PAR(3)
      ZPOS = .5*(FGESL_Z2(ISL)-FGESL_Z1(ISL))-DZBG-PAR(3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM, XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,-XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)
      PAR(2) = 1. - .1
      PAR(3) = .1
      YPOS = 5. - DZBG - .2 - PAR(2)
      ZPOS = .5*(FGESL_Z2(ISL)-FGESL_Z1(ISL))-DZBG-PAR(3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM, XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)
      JSG = JSG+1
      CALL GSPOSP('BAGM',JSG,SLNAM,-XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)

      CALL GSDET ('SILD','SPLM',1,'SPLM',16,LGESL_SIL,50,20,ISET,IDET)

 90   RETURN
      END

************************************************************************
* End of SIPG96
************************************************************************



