
      SUBROUTINE SOTR96(ISL)

************************************************************************
* Author :    Siegmund Nowak   05/07/96
*
* Description:   Silicon Detector from OTR group
*
* Called from:   g96main, g97main
*
* External references:
*
* Argument in/out description
*      ISL       Superlayer number ( goes as SI04 )
************************************************************************

      IMPLICIT NONE

      INTEGER I,ISL,IFIRST,IVOL(5),JSG,JPL,JPLF,JPLL,ISET,IDET
      INTEGER NLAY(4),IFLAY,MEDNUM 
      REAL PAR(3),XPOS,YPOS,ZPOS,XPOSBG,ZPOSBG,XMS(5),ZMOD,DZMOD,ZSH
      REAL DSL(3),XBG(4),XSH,DSIC(3),DG10(3),DGPA(3),DGCA(3),DBAG(3)
      CHARACTER*4 SLNAM
#include "arte/Arte.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGSILD.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA NLAY /2,1,2,2/
      DATA DSL /100., 10., 0./,           XBG /-38.5,-50.5,-74.5,-98.5/
      DATA XSH /-20./,   DSIC/2.9, 3.25, .053 /,   DG10/10., 2.5, .2 /
      DATA DGPA /4.0, 2.0 , .05/, DGCA/ 0., 0. , .05/
      DATA DBAG /11.0, 10.0, .01 /
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--   initialisation (volume definition,rad-length,angles etc)
      IF(IFIRST.EQ.0) THEN
c        bag
         CALL GSVOLU('BAOT','BOX ',MEDNUM(1,'ALUMINIUM' ),PAR,0,IVOL(2))
         CALL GSATT('BAOT','COLO',50)
c        Silicon
         PAR(1) = .5*DSIC(1)
         PAR(2) = .5*DSIC(2)
         PAR(3) = .5*DSIC(3)
         CALL GSVOLU('SOTT','BOX ',MEDNUM(3,'SILICON' ),PAR,3,IVOL(3))
         CALL GSATT('SOTT','COLO',5)
c        G10 plate
         PAR(1) = .5*DG10(1)
         PAR(2) = .5*DG10(2)
         PAR(3) = .5*DG10(3)
         CALL GSVOLU('SOGT','BOX ',MEDNUM(1,'G10'),PAR,3,IVOL(4))
         CALL GSATT('SOGT','COLO',4)
c        preamplifier
         PAR(1) = .5*DGPA(1)
         PAR(2) = .5*DGPA(2)
         PAR(3) = .5*DGPA(3)
         CALL GSVOLU('SOHT','BOX ',MEDNUM(1,'AL2O3'),PAR,3,IVOL(5))
         CALL GSATT('SOHT','COLO',3)
c        carrier
         CALL GSVOLU('SOCT','BOX ',MEDNUM(1,'AL2O3'),PAR,0,IVOL(5))
         CALL GSATT('SOCT','COLO',2)

         DO I=2,5
         CALL GRADLN(IVOL(I),XMS(I))
         ENDDO

         JSG = 0
         IFIRST = 1
      ENDIF

c     Superlayer
      IF(IGESL_LAY(ISL).EQ.0) GO TO 90
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,SLNAM,4)
      CALL CGGESL(SLNAM,'MOTH',0)

      DZMOD = FGESL_Z2(ISL)-FGESL_Z1(ISL) 

      JPLF = 2 + NGEDE() * NCGEDE()
      DO I=1,4      
      ZMOD = -.25*DZMOD
      IFLAY = 0
C--    alu bags (front side)
20    PAR(1) = .5*DBAG(1)
      PAR(2) = .5*DBAG(2)
      PAR(3) = .5*DBAG(3)
      XPOSBG = XBG(I) - XSH +.5*DSL(1)
      ZPOS = ZMOD -.25*DZMOD + PAR(3)
      JSG = JSG + 1
      CALL GSPOSP('BAOT',JSG,SLNAM,XPOSBG,0.,ZPOS,0,'ONLY',PAR,3)

C--    alu bags (left and right sides)
      PAR(1) =  .5*DBAG(3)
      PAR(2) = .5*DBAG(2) - DBAG(3)
      PAR(3) = .25*DZMOD - DBAG(3)
      XPOS = XPOSBG + .5*(DBAG(1) - DBAG(3))
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM,XPOS,0.,ZMOD,0,'ONLY',PAR,3)
      XPOS = XPOSBG - .5*(DBAG(1) - DBAG(3))
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM,XPOS,0.,ZMOD,0,'ONLY',PAR,3)

C--    alu bags (lower and upper sides)

      PAR(1) = .5*DBAG(1)
      PAR(2) = .5*DBAG(3)
      YPOS = .5*DBAG(2) - .5*DBAG(3)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM,XPOSBG,YPOS,ZMOD,0,'ONLY',PAR,3)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM,XPOSBG,-YPOS,ZMOD,0,'ONLY',PAR,3)

C--   silicon chips

      ZSH = ZMOD + .2
      XPOS = 1.525
      YPOS = -2.425
      ZPOS = ZSH - .5*DSIC(3)
      CALL GSPOS('SOTT',NGEDE()+1,SLNAM,
     +                          XPOSBG+XPOS,YPOS,ZPOS,0,'ONLY')
      CALL CRGEDE('SOTT',1,1)

      CALL GSPOS('SOTT',NGEDE()+1,SLNAM,
     +                          XPOSBG-XPOS,YPOS,ZPOS,0,'ONLY')
      CALL CRGEDE('SOTT',1,2)


c      Preamplifiers

      YPOS = .2
      ZPOS = ZSH - .5*DGPA(3)
      CALL GSPOS('SOHT',NGEDE()-1,SLNAM, XPOSBG,YPOS,ZPOS,0,'ONLY')

C      Carrier1 = ceramic-plates
      PAR(1) = 3.05
      PAR(2) = 2.45
      PAR(3) = .5*DGCA(3)
      YPOS = -1.75
      ZPOS = ZSH + PAR(3)
      CALL GSPOSP('SOCT',NGEDE()-1,SLNAM,
     +                            XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)

      YPOS = YPOS + PAR(2)
      PAR(1) = 2.2
      PAR(2) = .5
      YPOS = YPOS + PAR(2)
      CALL GSPOSP('SOCT',NGEDE(),SLNAM,XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)
      
c      G10 plate

      YPOS = 2.5
      ZPOS = ZPOS + DGCA(3) + .5*DG10(3) 
      CALL GSPOS('SOGT',NGEDE()-1,SLNAM, XPOSBG,YPOS,ZPOS,0,'ONLY')

C--    alu bag (back side)
      PAR(1) = .5*DBAG(1)
      PAR(2) = .5*DBAG(2)
      PAR(3) = .5*DBAG(3)
      ZPOSBG = ZMOD +.25*DZMOD - .5*DBAG(3)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM, XPOSBG,0.,ZPOSBG,0,'ONLY',PAR,3)

c     CORNERS
      PAR(1) = .5*DBAG(1)
      PAR(2) = .1
      PAR(3) = 1.
      YPOS = .5*DBAG(2) - DBAG(3) - PAR(2)
      ZPOS = ZMOD + .25*DZMOD - DBAG(3) - PAR(3)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM, XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)
      PAR(2) = 1. - .1
      PAR(3) = .1
      YPOS = .5*DBAG(2) - DBAG(3) - .2 - PAR(2)
      ZPOS = ZMOD + .25*DZMOD - DBAG(3) - PAR(3)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,SLNAM,XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)
      IF(IFLAY.EQ.0.AND.NLAY(I).EQ.2) THEN
         IFLAY = 1
         ZMOD = ZMOD+.5*DZMOD
         GO TO 20
      ENDIF 
      ENDDO

      JPLL = 2 + (NGEDE()-1) * NCGEDE()
C--   fill remaing detector data common for all detectors
      DO JPL=JPLF+JGEDE,JPLL+JGEDE,NCGEDE()
       Q (JPL+JGEDE_COS) = 1.
       Q (JPL+JGEDE_SIN) = 0.
       Q (JPL+JGEDE_XFW) = Q(JPL+JGEDE_XMIN) + 0.5*PITSI
       Q (JPL+JGEDE_ZFW) = Q(JPL+JGEDE_ZMIN)
       IQ(JPL+JGEDE_NWI) = 2.*14.5 / PITSI
       Q(JPL+JGEDE_ACC) = SIGSI
       Q(JPL+JGEDE_EFF) = EFFSI
       Q(JPL+JGEDE_PIT) = PITSI
       Q(JPL+JGEDE_DOD) = DMSI
       IQ(JPL+JGEDE_NSL)  = 1
       Q(JPL+JGEDE_MS)= XMS(3)*(.0136*(1.+.038*ALOG(XMS(3))))**2
       Q(JPL+JGEDE_SXMN) = Q(JPL+JGEDE_XMIN)
       Q(JPL+JGEDE_SXMX) = Q(JPL+JGEDE_XMAX)
       Q(JPL+JGEDE_SYMN) = Q(JPL+JGEDE_YMIN)
       Q(JPL+JGEDE_SYMX) = Q(JPL+JGEDE_YMAX)
      ENDDO

      CALL GSDET ('SILD','SOTT',1,'SOTT',16,LGESL_SIL,50,20,ISET,IDET)

c     Overall support corner
      PAR(1) = .5*DSL(1)
      PAR(2) = .1
      PAR(3) = 1.
      XPOS = XSH - PAR(1)
      YPOS = 2.425 + .5*DSL(2) - PAR(2)
      ZPOS = .5*(FGESL_Z1(ISL)+FGESL_Z2(ISL)) + ZZERO + PAR(3)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,'MOTH',XPOS ,YPOS,ZPOS,0,'ONLY',PAR,3)
      YPOS = YPOS - PAR(2)
      PAR(2) = 1. - .1
      PAR(3) = .1
      YPOS = YPOS - PAR(2)
      JSG = JSG+1
      CALL GSPOSP('BAOT',JSG,'MOTH',XPOSBG,YPOS,ZPOS,0,'ONLY',PAR,3)


 90   RETURN
      END

************************************************************************
* End of SOTR96
************************************************************************



