
      SUBROUTINE SZ1G96

************************************************************************
* written by Siegmund Nowak, 06/03/96 12.10.18
*
* This routines generates the geometry for the 'new triggerhodoscope'
* called from GEOMAIN
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*    ISL      in          superlayer number in GESL table 
************************************************************************

      IMPLICIT NONE

      INTEGER IVOLC,IVOLG,ISET,IDET,MEDNUM,ISL
      REAL PAR(5),PARA(8),XMSC,XMSG,XPOS,YPOS,ZSZH1
      REAL DXS2C, DYS2C, DZS2C, DXS2G, DYS2G, DZS2G
      REAL PXS2C, PYS2C, PZS2C, PXS2G, PYS2G
      CHARACTER*4 CSL 

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMAGN.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA DXS2C /50./, DYS2C /10.8/, DZS2C /.4/
      DATA PXS2C / 0./, PYS2C /25.4/, PZS2C /.95/
      DATA DXS2G /60./, DYS2G /10.8/, DZS2G /.4/
      DATA PXS2G / 0./, PYS2G /25.4/
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL GSVOLU('SZ1C', 'BOX ', MEDNUM(4,'LUCITE'),PAR,0,IVOLC)
      CALL GSATT('SZ1C','COLO',4)
      CALL GSVOLU('SZ1G', 'BOX ', MEDNUM(2,'LUCITE'),PAR,0,IVOLG)
      CALL GSATT('SZ1G','COLO',110)
      CALL GRADLN(IVOLC,XMSC)
      XMSC = DZS2C/XMSC
      CALL GRADLN(IVOLG,XMSG)
      XMSG = DZS2G/XMSG

c     install superlayer volume for the new triggercounter
      DO ISL = 1,NGESL()
       IF(IGESL_CMP(ISL).EQ.LGESL_HOD2.AND.IGESL_NSL(ISL).EQ.1) GO TO 1
      ENDDO
 1    CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,CSL,4)
      IF(IGESL_MFL(ISL).EQ.0) THEN      
         CALL CGGESL(CSL,'MOTH',0)
      ELSE
         CALL CGGESL(CSL,'MAGN',0)
      ENDIF
      ZSZH1 = 0.5*(FGESL_Z1(ISL)+FGESL_Z2(ISL))

c     horizontal counter upper/lower part
      PAR(1) = .5* DXS2C
      PAR(2) = .5* DYS2C
      PAR(3) = .5* DZS2C

      XPOS =  PXS2C
      YPOS =  PYS2C
c     first counter
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                        XPOS, YPOS,-PZS2C-PAR(3),0,'ONLY',PAR,3)
      PARA(1) = XPOS - PAR(1)
      PARA(2) = XPOS + PAR(1)
      PARA(3) = YPOS - PAR(2)
      PARA(4) = YPOS + PAR(2)
      PARA(5) = ZSZH1 - PZS2C - DZS2C
      PARA(6) = ZSZH1 - PZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 1
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     second counter
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                        XPOS, YPOS,-PZS2C+PAR(3),0,'ONLY',PAR,3)
      PARA(5) = ZSZH1 - PZS2C
      PARA(6) = ZSZH1 - PZS2C + DZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 1
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     third counter = second sector
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                        XPOS,-YPOS,-PZS2C-PAR(3),0,'ONLY',PAR,3)
      PARA(3) = -YPOS - PAR(2)
      PARA(4) = -YPOS + PAR(2)
      PARA(5) = ZSZH1 - PZS2C - DZS2C
      PARA(6) = ZSZH1 - PZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 2
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     fourth counter
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                        XPOS,-YPOS,-PZS2C+PAR(3),0,'ONLY',PAR,3)
      PARA(5) = ZSZH1 - PZS2C
      PARA(6) = ZSZH1 - PZS2C + DZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 2
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     light guide straigt part

      XPOS = XPOS + PAR(1)

      PAR(1) = .5*DXS2G
      XPOS = XPOS + PAR(1)

      CALL GSPOSP('SZ1G',1,CSL,
     +                        XPOS, YPOS,-PZS2C-PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',1)
      CALL GSPOSP('SZ1G',2,CSL,
     +                        XPOS, YPOS,-PZS2C+PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',2)
      CALL GSPOSP('SZ1G',3,CSL,
     +                        XPOS,-YPOS,-PZS2C-PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',3)
      CALL GSPOSP('SZ1G',4,CSL,
     +                        XPOS,-YPOS,-PZS2C+PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',4)

c     vertical counter left/right part
      PAR(1) = .5* DYS2C
      PAR(2) = .5* DXS2C
      PAR(3) = .5* DZS2C

      XPOS =  PYS2C
      YPOS =  PXS2C
c     first counter = third sector
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                        -XPOS,YPOS,PZS2C-PAR(3),0,'ONLY',PAR,3)
      PARA(1) = -XPOS - PAR(1)
      PARA(2) = -XPOS + PAR(1)
      PARA(3) =  YPOS - PAR(2)
      PARA(4) =  YPOS + PAR(2)
      PARA(5) = ZSZH1 + PZS2C - DZS2C
      PARA(6) = ZSZH1 + PZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 3
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     second counter
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                        -XPOS,YPOS,PZS2C+PAR(3),0,'ONLY',PAR,3)
      PARA(5) = ZSZH1 + PZS2C
      PARA(6) = ZSZH1 + PZS2C + DZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 3
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     third counter = fourth sector
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                         XPOS,YPOS,PZS2C-PAR(3),0,'ONLY',PAR,3)
      PARA(1) = XPOS - PAR(1)
      PARA(2) = XPOS + PAR(1)
      PARA(5) = ZSZH1 + PZS2C - DZS2C
      PARA(6) = ZSZH1 + PZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 4
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     fourth counter
      CALL GSPOSP('SZ1C',NGCAL()+1,CSL,
     +                         XPOS,YPOS,PZS2C+PAR(3),0,'ONLY',PAR,3)
      PARA(5) = ZSZH1 + PZS2C
      PARA(6) = ZSZH1 + PZS2C + DZS2C
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQGCAL_NCL_L()) = 1
      IQ(IQGCAL_SEC_L()) = 4
      Q(QGCAL_EFF_L()) = 1.
      Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

c     light guide straigt part

      YPOS = YPOS + PAR(2)

      PAR(2) = .5*DXS2G
      YPOS = YPOS + PAR(2)

      CALL GSPOSP('SZ1G',5,CSL,
     +                        -XPOS,YPOS,PZS2C-PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',5)
      CALL GSPOSP('SZ1G',6,CSL,
     +                        -XPOS,YPOS,PZS2C+PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',6)
      CALL GSPOSP('SZ1G',7,CSL,
     +                         XPOS,YPOS,PZS2C-PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',7)
      CALL GSPOSP('SZ1G',8,CSL,
     +                         XPOS,YPOS,PZS2C+PAR(3),0,'ONLY',PAR,3)
      CALL CRGWAL('SZ1G',8)

      CALL GSDET(CSL,'SZ1C',1,'SZ1C',5,LGESL_HOD2,50,20,ISET,IDET)

      RETURN
      END




