
      SUBROUTINE SZ3G96(ISL)

************************************************************************
*
* SZ3G96
* written by Siegmund Nowak, 05/09/96 17.54.07
*
* This routine implements the Szintillator hodoscope 3 behind magnet
*
*       called from G97MAIN
*
************************************************************************

      IMPLICIT NONE

      INTEGER IVOL,IVOLC,IROTM(5),I,J,ISET,IDET,MEDNUM,IC,ISL
      INTEGER RSTANG(11)
      REAL PAR(5),PARA(8),WM,COSW,SINW,XP,YP,ZP,XMS
      REAL ZSZH3,ZHOD3(4),ZBL(4)
      REAL XHOD3(4),YHOD3(4),XSTANG(11),YSTANG(11),ZSTANG(11),LSTANG(11)
      CHARACTER*4 CSL

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMAGN.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

      DATA XHOD3 /58.7 ,-10.5 ,-58.5 , 0. /
      DATA YHOD3 / 0.  , -58.6 , 0.  ,58.9/
      DATA ZHOD3 /984.,978.,984.,978./
      DATA ZBL /980.,974.,980.,974./
      DATA XSTANG /       0.,       0.,      42.,    -42.,      0., 
     +          0.,     84.5,    -84.5,     36.7,    36.7,    -90.    /
      DATA YSTANG /      43.,    -43.0,       0.,      0.,    84.5,
     +       -84.5,      -5.,      -5.,   -100.7,    20.3,   -72.     /
      DATA ZSTANG /     972.,     972.,     968.,    968.,    972.,
     +        972.,     978.,     978.,    945.5,    950.,    955.    /
      DATA RSTANG /       1 ,       1 ,       2 ,      2 ,      1 ,  
     +          1 ,       2 ,       2 ,       5 ,      5 ,      5     / 
      DATA LSTANG /      88.,      88.,      90.,     90.,     58., 
     +         58.,      88.,      88.,      30.,     30.,     30.    /


#include "arte/Arte.ff"
#include "auto/GEO.ff"

c     define rotation matrices
      DO I=1,4
      WM = FLOAT(4-I)*90. 
      CALL CRROTM( IROTM(I),90.,WM, 180.,0.,90.,AMOD(WM+90.,360.))
      ENDDO
      IROTM(5) = 0

c     overall volumen for the counter
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,CSL,4)
      CALL CGGESL(CSL,'MOTH',0) 
      ZSZH3 = .5*(FGESL_Z1(ISL)+FGESL_Z2(ISL))

      CALL GSVOLU('SZ3C', 'BOX ', MEDNUM(4,'LUCITE'),PAR,0,IVOLC)
      CALL GSATT('SZ3C','COLO',4)
      CALL GSVOLU('SZ3G', 'TRD2', MEDNUM(2,'LUCITE'),PAR,0,IVOL)
      CALL GSATT('SZ3G','COLO',110)
c     support block
      PAR(1) = 5.
      PAR(2) = 5.
      PAR(3) = 10.
      CALL GSVOLU('SZ3B', 'BOX ', MEDNUM(2,'ALUMINIUM'),PAR,3,IVOL)
      CALL GSATT('SZ3B','COLO',50)
      CALL GSVOLU('SZ3S', 'TUBE', MEDNUM(2,'ALUMINIUM'),PAR,0,IVOL)
      CALL GSATT('SZ3S','COLO',50)
      PAR(1) = 0.
      PAR(2) = 2.85
      PAR(3) = 12.5
      CALL GSVOLU('SZ3P', 'TUBE', MEDNUM(2,'IRON'),PAR,3,IVOL)
      CALL GSATT('SZ3P','COLO',20)
      PAR(1) = 0.
      PAR(2) = 4.
      PAR(3) = 1.  
      CALL GSVOLU('SZ3F', 'TUBE', MEDNUM(2,'IRON'),PAR,3,IVOL)
      CALL GSATT('SZ3F','COLO',20)

c     posit all elements
      DO  I = 1,4
       WM   = FLOAT(1-I)*PI/2. 
       COSW = COS(WM)
       SINW = SIN(WM)
c     counters 
       IC = 1
       J = I
       PAR(1) = 1.25
       PAR(2) = 1.25
       PAR(3) = 0.5
       ZP = ZHOD3(I) - ZSZH3 - 2.
 30    XP = XHOD3(I)
       YP = YHOD3(I)
       CALL GSPOSP('SZ3C',NGCAL()+1,CSL,XP,YP,ZP,0,'ONLY',PAR,3)
       PARA(1) = XP - PAR(1)
       PARA(2) = XP + PAR(1)
       PARA(3) = YP - PAR(2) 
       PARA(4) = YP + PAR(2)
       PARA(5) = ZSZH3 + ZP - PAR(3)
       PARA(6) = ZSZH3 + ZP + PAR(3)
       PARA(7) = 1.
       PARA(8) = 0.
       CALL CRGCAL(1,IVOLC,PARA)
       IQ(IQGCAL_NCL_L())  = 1
       IQ(IQGCAL_SEC_L()) = I
       CALL GRADLN(IVOLC,XMS)
       XMS = 2.*.5/XMS
       Q(QGCAL_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2
       XP = XP + PAR(1)*COSW
       YP = YP + PAR(2)*SINW  

c     light guide
       PAR(1) = PAR(1)
       PAR(3) = PAR(3)
       PAR(2) = SQRT(PAR(1)*PAR(3))
       PAR(4) = PAR(2)
       PAR(5) = 5.      
       XP = XP + PAR(5)*COSW
       YP = YP + PAR(5)*SINW
       CALL GSPOSP('SZ3G',J,CSL,XP,YP,ZP,IROTM(I),'ONLY',PAR,5)
       XP = XP + PAR(5)*COSW
       YP = YP + PAR(5)*SINW

c      photomultiplier
       XP = XP + 12.5*COSW
       YP = YP + 12.5*SINW
       CALL GSPOS('SZ3P',J,CSL,XP,YP,ZP,IROTM(I),'ONLY')
       IF(IC.EQ.1) THEN
c         big counters 
          PAR(1) = 2.5
          PAR(2) = 2.5
          PAR(3) = 0.5
          ZP = ZHOD3(I) - ZSZH3 + 2.
          IC = 2
          J=I+4
          GO TO 30
       ENDIF

c      support block
       XP = XHOD3(I) + 26.*COSW
       YP = YHOD3(I) + 26.*SINW
       CALL GSPOS('SZ3B',I,CSL,XP,YP,ZBL(I)-ZSZH3,0,'ONLY')

      ENDDO

c     Support tubes
      PAR(1) = 1.3
      PAR(2) = 1.7
      DO I = 1,11
         PAR(3) = LSTANG(I)
      IF(IROTM(RSTANG(I)).NE.5) THEN
        CALL GSPOSP('SZ3S',I,CSL,XSTANG(I),YSTANG(I),ZSTANG(I)-ZSZH3,
     +                                  IROTM(RSTANG(I)),'ONLY',PAR,3)
      ELSE
        CALL GSPOSP('SZ3S',I,'MOTH',XSTANG(I),YSTANG(I),ZSTANG(I)+ZZERO,       
     +                                  IROTM(RSTANG(I)),'ONLY',PAR,3)
      ENDIF 
      ENDDO
c     hits will be written out
      CALL GSDET('SZH0','SZ3C',1,'SZ3C',5,LGESL_HOD1,50,20,ISET,IDET)

      END
