
      SUBROUTINE SZ3G98(ISL)

************************************************************************
*
* SZ3G98
* written by Siegmund Nowak, 05/09/96 17.54.07
*
* This routine implements the Szintillator hodoscope 3 behind magnet
*
*       called from G97MAIN
*
************************************************************************

      IMPLICIT NONE

      INTEGER IVOL,IVOLC,IVOLD,IROTM(2),I,ISET,IDET,MEDNUM,IC,ISL
      REAL PAR(11),PARA(8),XP,YP,ZP,XMS,yp1,yp2
      REAL ZSZH3,ZHOD3(4),FACX(4), XHOD3(4),YHOD3(4)
      CHARACTER*4 CSL

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMAGN.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

c      DATA XHOD3 /280.45 ,280.45 ,-280.45 , -280.45 /
      DATA XHOD3 /277.2  ,277.2  ,-277.2  , -277.2  /
      DATA YHOD3 /94.775 , -94.775 ,94.775  ,-94.775/
      DATA ZHOD3 /1313.5,1313.5,1313.5,1313.5/
      DATA FACX  /1.,1.,-1., -1./

#include "arte/Arte.ff"
#include "auto/GEO.ff"

c     define rotation matrices

      CALL CRROTM( IROTM(1),90.,90., 180.,0.,90.,0.)
      CALL CRROTM( IROTM(2),90.,90., 180.,0.,90.,180.)

c     overall volumen for the counter
      CURRSL = ISL
      CALL UHTOC(HGESL_NAME(ISL),4,CSL,4)
      CALL CGGESL(CSL,'MOTH',0) 
      ZSZH3 = .5*(FGESL_Z1(ISL)+FGESL_Z2(ISL))

      CALL GSVOLU('SZ3C', 'BOX ', MEDNUM(4,'LUCITE'),PAR,0,IVOLC)
      CALL GSATT('SZ3C','COLO',4)
      CALL GSVOLU('SZ3D', 'TRD1', MEDNUM(4,'LUCITE'),PAR,0,IVOLD)
      CALL GSATT('SZ3D','COLO',4)
c      CALL GSVOLU('SZ3G', 'TRD2', MEDNUM(2,'LUCITE'),PAR,0,IVOL)
      CALL GSVOLU('SZ3G', 'TRAP', MEDNUM(2,'LUCITE'),PAR,0,IVOL)
      CALL GSATT('SZ3G','COLO',110)
c     support block
      PAR(1) = 5.
      PAR(2) = 5.
      PAR(3) = 10.
      CALL GSVOLU('SZ3B', 'BOX ', MEDNUM(2,'ALUMINIUM'),PAR,3,IVOL)
      CALL GSATT('SZ3B','COLO',50)
      CALL GSVOLU('SZ3S', 'TUBE', MEDNUM(2,'ALUMINIUM'),PAR,0,IVOL)
      CALL GSATT('SZ3S','COLO',50)

      CALL GSVOLU('SZ3P', 'TUBE', MEDNUM(2,'ALUMINIUM'),PAR,0,IVOL)
      CALL GSATT('SZ3P','COLO',20)
      PAR(1) = 0.
      PAR(2) = 4.
      PAR(3) = 1.  
      CALL GSVOLU('SZ3F', 'TUBE', MEDNUM(2,'IRON'),PAR,3,IVOL)
      CALL GSATT('SZ3F','COLO',20)

c     posit all elements
      DO  I = 1,4
       IC = 1
       PAR(1) = 3.8
       PAR(2) = 4.8
       PAR(3) = 0.3
       PAR(4) = 0.5 
       ZP = ZHOD3(I) - ZSZH3
       XP = XHOD3(I) - (4.5 - PAR(4))*FACX(I)
       YP = YHOD3(I)
       YP1 = YP + 1.5 - 4.8 
 30    CALL GSPOSP('SZ3D',NGCAL()+1,CSL,XP,YP1,ZP,IROTM((I-1)/2+1),
     +                                               'ONLY',PAR,4)
       PARA(1) = XP - PAR(4)
       PARA(2) = XP + PAR(4)
       PARA(3) = YP1 - 0.5*(PAR(1)+par(2))
       PARA(4) = YP1 + 0.5*(PAR(1)+par(2))
       PARA(5) = ZSZH3 + ZP - PAR(3) 
       PARA(6) = ZSZH3 + ZP + PAR(3) 
       CALL CRGCAL(1,IVOLD,PARA)
       IQ(IQGCAL_NCL_L())  = 1
       IQ(IQGCAL_SEC_L()) = I
       CALL GRADLN(IVOLD,XMS)
       XMS = 2.*PAR(4)/XMS
       Q(QGCAL_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2

       XP = XP + PAR(4)*FACX(i)

c      BOX counters 
       PAR(1) = 4.5 - PAR(4)
       PAR(2) = 4.8
       PAR(3) = 0.3
       XP = XP + PAR(1)*FACX(I)
       CALL GSPOSP('SZ3C',NGCAL()+1,CSL,XP,YP1,ZP,0,'ONLY',PAR,3)
       PARA(1) = XP - PAR(1)
       PARA(2) = XP + PAR(1)
       PARA(3) = YP - PAR(2) 
       PARA(4) = YP + PAR(2)
       PARA(5) = ZSZH3 + ZP - PAR(3)
       PARA(6) = ZSZH3 + ZP + PAR(3)
       PARA(7) = 1.
       PARA(8) = 0.
       CALL CRGCAL(1,IVOLC,PARA)
       IQ(IQGCAL_NCL_L())  = 1
       IQ(IQGCAL_SEC_L()) = I
       CALL GRADLN(IVOLC,XMS)
       XMS = 2.*.5/XMS
       Q(QGCAL_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2
       XP = XP + PAR(1)*FACX(i)

c     light guide
c      PAR(1) = PAR(1)
c      PAR(3) = PAR(3)
c      PAR(2) = SQRT(PAR(1)*PAR(3))
c      PAR(4) = PAR(2)
c      PAR(5) = 12.5      
c      XP = XP + PAR(5)*FACX(I)
c      CALL CRPOS('SZ3G',CSL,IC,I,XP,YP,ZP,IROTM((I-1)/2+1),'ONLY',PAR)
c      XP = XP + PAR(5)*FACX(I)

      PAR(1) = 12.5
      par(2) = 8.2
      par(3) = 0.
      par(4) = .3
      par(5) = 4.8
      PAR(6) = 4.8
      PAR(7) = 0.
      PAR(8) = 1.2
      par(9) = 1.2
      par(10)= 1.2
      par(11)= 0. 
      XP = XP + PAR(1)*FACX(I)
      YP2 = YP +1.5 - 3.
      CALL GSPOSP('SZ3G',2*(I-1)+IC,CSL,XP,YP2,ZP,
     +                       IROTM((I-1)/2+1),'ONLY',PAR,11)
      XP = XP + PAR(1)*FACX(I)      

c     photomultiplier

      PAR(1) = 0.
      PAR(2) = 1.5
      PAR(3) = 7.85
      XP = XP + PAR(3)*FACX(I)
      CALL CRPOS('SZ3P',CSL,IC,I,XP,YP,ZP,IROTM((I-1)/2+1),'ONLY',PAR)


       IF(IC.EQ.1) THEN
c         big counters 
          PAR(1) = 2.8
          PAR(2) = 4.8
          PAR(3) = 0.3
          PAR(4) = 1.0           
          XP = XHOD3(I) - (4.5 - PAR(4))*FACX(I)
          ZP = ZHOD3(I) - ZSZH3 + 3.5
          IC = 2
          GO TO 30
       ENDIF

c      support block
c       XP = XHOD3(I) + 26.*COSW
c       YP = YHOD3(I) + 26.*SINW
c       CALL GSPOS('SZ3B',I,CSL,XP,YP,ZBL(I)-ZSZH3,0,'ONLY')

      ENDDO


c     hits will be written out
      CALL GSDET('SZH0','SZ3C',1,'SZ3C',5,LGESL_HOD3,50,20,ISET,IDET)
      CALL GSDET('SZH0','SZ3D',1,'SZ3D',5,LGESL_HOD3,50,20,ISET,IDET)
      END
