#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "arte/Arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/zgeom.h"
#include "gean/gclink.h"

extern "C" {
   void gsposp_(char*,unsigned int*,char*,float*,float*,float*,
                int*,char*,float[],unsigned int*);}

int    zgpos::maxpos[33];
int    zgpos::nrpos[33] ;
int    zgpos::ind_pt;
hgpos *zgpos::ptpos[33];

void zgpos::ini(int n){ 
        ptpos[ind_pt] = new hgpos[n];
        if(ptpos[ind_pt]==NULL)
           {arteMsg << "no hgpos[n] allocated"; arteMsg.error();}
        maxpos[ind_pt] = n;
        nrpos[ind_pt] =0;  }

void zgpos::fin() {   
        delete [] ptpos[ind_pt];
        nrpos[ind_pt] = 0; }   

void zgpos::increase() {
        if(nrpos[ind_pt] < maxpos[ind_pt]-1) nrpos[ind_pt]++;
        else {
        hgpos *pos, *temp, *tmp; 
        int n =2*maxpos[ind_pt];
        temp = new hgpos[n];    
        if(temp == NULL) {
             arteMsg << "no hgpos[2*n] allocated";   arteMsg.error();} 
        for(int i=0; i <= nrpos[ind_pt]; i++) {
          pos = ptpos[ind_pt] + i ;    tmp = temp + i ;   *tmp = *pos; }
        delete [] ptpos[ind_pt];        
        ptpos[ind_pt] = temp;
        maxpos[ind_pt] = 2* maxpos[ind_pt]; 
        nrpos[ind_pt]++;}}

void zgpos::Set_ind_pt(int n) {
        if(n >= 0 && n < 34) {
           ind_pt = n;
           zgdet::ind_pt = n;           
           zgrot::ind_pt = n;           
           zgvol::ind_pt = n;}
        else{  arteMsg << "zgpos: ind_pt outside limits";  arteMsg.error();}}

hgpos *zgpos::get_ptpos(int n) {
        return ptpos[n];} 
  
  void zgpos::Set_default() {
        hgpos *pos = ptpos[ind_pt] + nrpos[ind_pt] ;
        memset(pos,0,sizeof(hgpos));
        pos->index_hgvol = -1;}

  void zgpos::Set_vol_pos_Rel() {
        hgvol *vol = zgvol::ptvol[zgvol::ind_pt] + zgvol::nrvol[zgvol::ind_pt] ;
        vol->index_hgpos = nrpos[ind_pt] - vol->ncomp;}


  void zgpos::Read_comp(char *card) {
        char taga[16],tagb[16];
        hgvol *vol = zgvol::ptvol[zgvol::ind_pt] + zgvol::nrvol[zgvol::ind_pt] ;
        hgpos *pos = ptpos[ind_pt] + nrpos[ind_pt] ;
        int nitem=sscanf(card,"%s %d %f %f %f %s", taga, &pos->ctyp, 
             &pos->xpos, &pos->ypos,&pos->zpos, tagb );
        if (nitem!=6) {
           arteMsg <<"check standard data on comp cards"; arteMsg.error();}
        fillstr(taga,4);
        fillstr(tagb,4);
        zgvol ZGVOL;
        int j = ZGVOL.Get_volnr(taga,pos->ctyp);
        if(j<0) { 
           arteMsg <<"comp card: volume " <<taga << "not defined before";
           arteMsg.error();} 
        else            {
        hgvol *dau = zgvol::ptvol[zgvol::ind_pt] + j ;
        strncpy(pos->comp,taga,4);
        strncpy(pos->only,tagb,4);
        pos->xpos = pos->xpos + vol->rel_px - dau->rel_px;
        pos->ypos = pos->ypos + vol->rel_py - dau->rel_py; 
        pos->zpos = pos->zpos + vol->rel_pz - dau->rel_pz; 
        // rotation matrix, sector and layer 
        card+=itemlength(card,nitem);
        nitem = sscanf(card," %s ",taga);
        if(nitem== -1 || !strncmp(taga,"!",1) || !strncmp(taga,"//",2)) {
           pos->rotm = pos->sector = pos->layer = 0;
           pos->rot_px = pos->rot_py = pos->rot_pz =0.;
           vol->ncomp++;
           pos->index_hgvol = zgvol::nrvol[zgvol::ind_pt];
           increase(); 
           return; }
        nitem=sscanf(card," %d %d %d ",&pos->rotm,&pos->sector,
                     &pos->layer);
        if (nitem!=3) {
           arteMsg <<"check rot/lay/sec on comp cards";  arteMsg.error();}
        if(pos->layer > 15) {
           arteMsg <<"zgpos: more than 15 layers - contact S.Nowak";
           arteMsg.error();} 
        if(pos->sector > 63) {
           arteMsg <<"zgpos: more than 63 sector - contact S.Nowak";
           arteMsg.error();}
        // rotation point
        card+=itemlength(card,nitem);
        nitem = sscanf(card," %s ",taga);
        if(nitem== -1 || !strncmp(taga,"!",1) || !strncmp(taga,"//",2)) {
           pos->rot_px = pos->rot_py = pos->rot_pz =0.;
           vol->ncomp++;
           pos->index_hgvol = zgvol::nrvol[zgvol::ind_pt];
           increase(); 
           return; }
        nitem=sscanf(card," %f %f %f ",&pos->rot_px,&pos->rot_py,
                     &pos->rot_pz);
        if (nitem!=3) {
           arteMsg <<"check rotation point data on comp cards";
           arteMsg.error();}
        pos->rot_px = pos->rot_px + vol->rel_px ;
        pos->rot_py = pos->rot_py + vol->rel_py ;
        pos->rot_pz = pos->rot_pz + vol->rel_pz ;
        vol->ncomp++; 
        pos->index_hgvol = zgvol::nrvol[zgvol::ind_pt];
        increase(); 
        return; }}

 
  void zgpos::Read_resolve(char *card) {
          char taga[16];
          hgvol *vol= zgvol::ptvol[zgvol::ind_pt] + zgvol::nrvol[zgvol::ind_pt];
          int nc = vol->ncomp;     int type;
          int nitem=sscanf(card,"%s %d",taga, &type);
          taga[5] = '\0';
          if (nitem!=2) { 
             arteMsg << "check card resolve for " << taga;  arteMsg.error();} 
          for (int m=0;m<3;m++) taga[m]=toupper(taga[m]);
          float xp=0, yp=0, zp =0 ; 
          card+=itemlength(card,nitem);
          nitem=sscanf(card,"%f %f %f",&xp, &yp, &zp ); 
          if (nitem!=3) {arteMsg << "check card resolve"; arteMsg.error();} 
          zgvol ZGVOL;  
          int n = ZGVOL.Get_volnr(taga,type);
          if(n<0) { 
             arteMsg <<"volume " <<taga << " to resolve does not exist";
             arteMsg.error();}
          else  {
             hgvol *dau = zgvol::ptvol[zgvol::ind_pt] + n;
	     if(dau->index_hgpos < 0) {
                  arteMsg <<"volume " <<taga << " nothing to resolve ";
                  arteMsg.warn();}
               else { 
                  hgpos *posdau = ptpos[ind_pt] + dau->index_hgpos;
                  for(int s=0; s< dau->ncomp;s++) { 
                     hgpos *pos    = ptpos[ind_pt] + nrpos[ind_pt] + nc;
                      *pos = *posdau;
                       pos->xpos += xp + vol->rel_px - dau->rel_px;   
                       pos->ypos += yp + vol->rel_py - dau->rel_py;
                       pos->zpos += zp + vol->rel_pz - dau->rel_pz;   
                     posdau++;
                    increase();}
                  vol->ncomp = vol->ncomp + dau->ncomp;}
             return ; }}

  void  zgpos::Read_Mirror_x() {
        if (nrpos[ind_pt] >0) {
           hgvol *vol=zgvol::ptvol[zgvol::ind_pt]+zgvol::nrvol[zgvol::ind_pt]; 
           hgvol *oldv = vol-1;
	   if(oldv->index_hgpos < 0) {
	     arteMsg <<"mirror_x nonexecutable - previous without components";
	     arteMsg.error();}
           hgpos *oldp =ptpos[ind_pt] + oldv->index_hgpos ;
           for(int s=0; s< oldv->ncomp;s++) {  
              hgpos *pos = ptpos[ind_pt] + nrpos[ind_pt] ;
              *pos = *oldp;
              pos->xpos = -pos->xpos;
              increase();
              oldp++;}
           vol->ncomp = oldv->ncomp;       
           vol->rel_px = -oldv->rel_px;}}
 
  void  zgpos::Read_Mirror_y() {
        if (nrpos[ind_pt] >0) {
           hgvol *vol=zgvol::ptvol[zgvol::ind_pt]+zgvol::nrvol[zgvol::ind_pt]; 
           hgvol *oldv = vol-1;
	   if(oldv->index_hgpos < 0) {
	     arteMsg <<"mirror_y noexecutable - previous without components";
	     arteMsg.error();}
           hgpos *oldp =ptpos[ind_pt] + oldv->index_hgpos ;
           for(int s=0; s< oldv->ncomp;s++) {  
              hgpos *pos = ptpos[ind_pt] + nrpos[ind_pt] ;
              *pos = *oldp;
              pos->ypos = -pos->ypos;
              increase();
              oldp++;}
           vol->ncomp = oldv->ncomp;       
           vol->rel_py = -oldv->rel_py;}}

  void  zgpos::Read_Mirror_z() {
        if (nrpos[ind_pt] >0) {
           hgvol *vol=zgvol::ptvol[zgvol::ind_pt]+zgvol::nrvol[zgvol::ind_pt]; 
           hgvol *oldv = vol-1;
	   if(oldv->index_hgpos < 0) {
	     arteMsg <<"mirror_z noexecutable - previous without components";
	     arteMsg.error();}
           hgpos *oldp =ptpos[ind_pt] + oldv->index_hgpos ;
           for(int s=0; s< oldv->ncomp;s++) {  
              hgpos *pos = ptpos[ind_pt] + nrpos[ind_pt] ;
              *pos = *oldp;
              pos->zpos = -pos->zpos;
              increase();
              oldp++;}
           vol->ncomp = oldv->ncomp;       
           vol->rel_pz = -oldv->rel_pz;}}

  void  zgpos::Gposit_all(int &nr_vol,int &icopy) {
        unsigned int npar; int gnr_rot;  float par[11],xp,yp,zp;  zgvol ZGVOL;
        char volume[5], mot[5];    volume[4] = mot[4] = '\0';

        hgvol *moth = zgvol::ptvol[zgvol::ind_pt] + nr_vol;
        strncpy(mot,moth->object,4);
        for(int i=0;i<moth->ncomp;i++) {
           int nr_pos = moth->index_hgpos +i;
           hgpos *pos = ptpos[ind_pt] + nr_pos;
           strncpy(volume,pos->comp,4);
           int j = ZGVOL.Get_volnr(volume,pos->ctyp);
           if(j>=0) { 
             npar = ZGVOL.Get_par(j,par);
             if(Get_RotPos(nr_pos,xp,yp,zp,gnr_rot)) {
                unsigned int inum = pos->ctyp<<16;
                icopy++; 
                if(icopy > 4095) {
                   arteMsg <<"zgpos: > 4095 copies - contact S.Nowak";
                   arteMsg.error();}
                inum = inum + icopy;
                gsposp_(volume,&inum,mot,&xp,&yp,&zp,&gnr_rot,
                        pos->only,par,&npar); }
             else {
                arteMsg <<"rotation matrix for comp " << volume <<" not found";
                arteMsg.error();} }
           else {arteMsg <<"volume "<< volume <<" not found";arteMsg.error();}}}

  int   zgpos::Get_RotPos
                (const int nr_pos,float &xp,float &yp,float &zp,int &nr_rot){ 
         hgpos *pos = ptpos[ind_pt] + nr_pos;
         int found = 0;
         for(int k=0; k<= zgrot::nrrot[zgrot::ind_pt];k++) { 
            hgrot *rot = zgrot::ptrot[zgrot::ind_pt] + k;
            if(abs(pos->rotm) == rot->rotnum) {
               xp = pos->xpos,yp = pos->ypos,zp = pos->zpos;
               if(pos->rotm !=0) {
                  float xp1=xp-pos->rot_px;       
                  float yp1=yp-pos->rot_py;       
                  float zp1=zp-pos->rot_pz;       
                  xp = rot->grot[0]*xp1 + rot->grot[3]*yp1 + 
                    rot->grot[6]*zp1 + pos->rot_px ; 
                  yp = rot->grot[1]*xp1 + rot->grot[4]*yp1 + 
                    rot->grot[7]*zp1 + pos->rot_py ; 
                  zp = rot->grot[2]*xp1 + rot->grot[5]*yp1 + 
                    rot->grot[8]*zp1 + pos->rot_pz ;}
               found = 1;    nr_rot = rot->irotm;   break; }}
        return found; }
 
  int   zgpos::Get_layer(int nr_vol,int index) {
        hgvol *vol = zgvol::ptvol[zgvol::ind_pt] + nr_vol;
        hgpos *pos = ptpos[ind_pt] + vol->index_hgpos + index - 1;
        return pos->layer;}

  int   zgpos::Get_sector(int nr_vol,int index) {
        hgvol *vol = zgvol::ptvol[zgvol::ind_pt] + nr_vol;
        hgpos *pos = ptpos[ind_pt] + vol->index_hgpos + index - 1;
        return pos->sector;}


