#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "arte/Arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/gclink.h"
#include "gean/zgeom.h"

extern "C" {void crrotm_(int*,float*,float*,float*,float*,float*,float*);  }

int zgrot::maxrot[33];
int zgrot::nrrot[33] ;
int zgrot::ind_pt;
hgrot *zgrot::ptrot[33];

void zgrot::ini(int n){ 
        ptrot[ind_pt] = new hgrot[n];
        if(ptrot[ind_pt]==NULL) {
          arteMsg << "no hgrot[n] allocated";
          arteMsg.error();      }
        maxrot[ind_pt] = n;
        nrrot[ind_pt] =0;  
        hgrot *rot = ptrot[ind_pt];
        rot->irotm = 0; 
        rot->rotnum = 0; 
        rot->grot[0] = rot->grot[4] = rot->grot[8] = 1.;
        rot->arot[0] = rot->arot[4] = rot->arot[8] = 1.;
        rot->grot[1] = rot->grot[2] = rot->grot[3] = rot->grot[5] = 
        rot->grot[6] = rot->grot[7] = rot->arot[1] = rot->arot[2] =
        rot->arot[3] = rot->arot[5] = rot->arot[6] = rot->arot[7] = 0.; }

void zgrot::fin() {   
        delete [] ptrot[ind_pt];
        nrrot[ind_pt] = 0; 
        maxrot[ind_pt]=0;            }   

void zgrot::increase() {
        if(nrrot[ind_pt] < maxrot[ind_pt]-1) nrrot[ind_pt]++; 
        else{
        hgrot *rot, *temp, *tmp; 
        int n =2*maxrot[ind_pt];
        temp = new hgrot[n];    
        if(temp == NULL) {
             arteMsg << "no hgrot[2*n] allocated";   arteMsg.error();} 
        for(int i=0; i <= nrrot[ind_pt]; i++) {
          rot = ptrot[ind_pt] + i ;    tmp = temp + i ;   *tmp = *rot; }
        delete [] ptrot[ind_pt];        
        ptrot[ind_pt] = temp;
        maxrot[ind_pt] = 2* maxrot[ind_pt]; 
        nrrot[ind_pt]++;}}

void zgrot::Set_ind_pt(int n) {
        if(n >= 0 && n < 34) {
           ind_pt = n;
           zgdet::ind_pt = n;           
           zgpos::ind_pt = n;           
           zgvol::ind_pt = n;}
        else{
          arteMsg << "zgrot: ind_pt outside limits";
          arteMsg.warn();      }}
 
hgrot *zgrot::get_ptrot(int n) {
        return ptrot[n];} 


int  zgrot::Readrot(char *card,int &nr) {
        increase(); 
        nr =nrrot[ind_pt];
        hgrot *rot = ptrot[ind_pt] + nr ;
        int nitem=sscanf(card,"%d %f %f %f %f %f %f",&rot->rotnum,&rot->theta1,
                 &rot->phi1,&rot->theta2,&rot->phi2,&rot->theta3,&rot->phi3); 
        if (nitem!=7)   {
            arteMsg <<"check data on rotation cards";    arteMsg.error();} 
        if (rot->rotnum ==0 )  {
            arteMsg <<"Rotnum 0 is reserved for no rotation"; arteMsg.error();} 
        return rot->rotnum; }
 

int  zgrot::Create_Grot(int &nr) {
           hgrot *rot = ptrot[ind_pt] + nr;
           crrotm_(&rot->irotm,&rot->theta1,&rot->phi1,&rot->theta2,
                                 &rot->phi2, &rot->theta3, &rot->phi3);
           int jrot= gclink_.jrotm;
           jrot = *(gcbank_.lq + gclink_.jrotm -1 -rot->irotm);

           union { int ji; float jx;};
           for(int i=0;i<9;i++) {
              ji = *(gcbank_.iq + jrot +i);
              rot->grot[i] =jx;}
           rot->arot[0] = rot->grot[0];
           rot->arot[1] = rot->grot[3];
           rot->arot[2] = rot->grot[6];
           rot->arot[3] = rot->grot[1];
           rot->arot[4] = rot->grot[4];
           rot->arot[5] = rot->grot[7];
           rot->arot[6] = rot->grot[2];
           rot->arot[7] = rot->grot[5];
           rot->arot[8] = rot->grot[8];
           return rot->irotm;}








