#ifndef DATA_FORMS_H
#define DATA_FORMS_H

typedef struct Item
{
  int   nums;           /* number of simple elements of the type "type"    */
  int   width;          /*                                                 */
  char  type;           /* type of element : I, F, B, H                    */
  char  reserved;
  short code;           /* codetype: 0,1,2,. - indicate compression method */
  float low;            /* range of floating points: low ...               */  
  float up;             /* ... & up boundaries(?)                          */
  float acc;            /* accuracy (tolerance?)   (0 means: not used)     */
} Item;
  
typedef struct Field
{
  char   *name;
  int    nitems;
  Item   *item;
} Field;

typedef struct Formats
{
  int   nfields;
  Field *field;
} Formats;
  
typedef struct Prefix
{
  int   length;           /* length & ...   */
  int   oid;              /* type of object */
} Prefix;

typedef struct TabDefPrefix 
{
  size_t        pos;
  int           length;
} TabDefPrefix;

typedef struct TableDef
{
  size_t           pos;      /* position in the file                */ 
  int              length;   /* length of name/description pair     */
  char*            name;     /* Table name                          */
  char*            desc;     /* description of the fields           */
  Formats         *form;     /* pointer to translated description   */
  struct TableDef *next;     /* next TableDef or NULL               */
} TableDef;

typedef struct Table
{
  size_t   pos;           /* position of TableDef on disk/buffer */
  int      ncols;         /* # of columns (fields)               */
  int      nrows;         /* # of rows (records) in the table    */
} Table;

#endif /* DATA_FORMS_H */
