*CMZ :          05/09/96  20.18.06  by  Fedor Ratnikov
*CMZ :  1.01/02 01/02/96  16.36.25  by  Fedor Ratnikov
*CMZ :  1.01/01 16/01/96  23.51.02  by  Fedor Ratnikov
*CMZ :  1.01/00 29/12/95  18.26.36  by  Fedor Ratnikov
*CMZ :  1.00/01 17/08/95  10.39.39  by   Ivan Belyaev
*-- Author :    Fedor Ratnikov   20/09/94
************************************************************************
*
* L1DETIN
* written by Fedor Ratnikov, 20/09/94 22.13.36
*
* This routines action:
* Initializes detector data structure
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* ierr       update       is set to nonzero on error (else preserved)
*
************************************************************************
c
      SUBROUTINE L1DETIN(ierr)
c
      IMPLICIT NONE
c
#include "arte/Arte.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1param.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mcuda.fi"
#include "l1si/l1detuse.fi"
#include "l1si/l1detmu.fi"
#include "l1si/hbmudefs.fi"
C
C Added for muons
C


c
c
      INTEGER idet,JSL,nlay,nsec,itype,icheck,ibuf,j,ipla,
     &        ifirst,nword,JDET,isl,ilay,iCaloType,
     &        isec,JPL,jDetGeo,jDetInf,jCellGeo,
     &        il1sec,nl1sec,
     &        idetnum,JBYT,i,iPlate,iPla2,ksec,kPlate,KPL,klay,
     &        iLU,iLL,iRU,iRL,iLeft,iRight,ierr,iSLlist,nSLlist
      REAL    stereo,xmin,xmax,ymin,ymax,pitchx,dodx,dxAdd,toly,tolx,
     &        BoundU,BoundL
      LOGICAL skip
      CHARACTER*4 CQ(100), cdetname
      EQUIVALENCE(Q(1),CQ(1))
      DIMENSION iSLlist(L1maxDetUsed)
      EXTERNAL JBYT

c
c VARIABLES USED BY MUON PART
c
      LOGICAL UPsection,MuX4
      CHARACTER*4 cMuPadNam
      INTEGER JPL_SECOND,ncell,iorder,iMuPresl,iMuAdd,
     &     nwtotal,iPlateUF,iPlateLF,iPlateUL,iPlateLL,
     &     npad3y(2),MuSnum,iMuPreLink,MuCount,
     &     JDETX,kDetGeo,kDetInf,kCellGeo,
     &     iMuImport1,iExtra
      REAL x0,sx,x0sl,sxsl,XYout(4),
     &     zMU3,zMU4,xsecmin,xsecmax,xMuShtCh,pad3y(2),y3secmin(2),
     &     RotCos,RotSin,RotTg,
     &     YpadMinU(2),YpadMaxU(2),YpadminL(2),YpadMaxL(2),pady
      INTEGER nExtra(3),NoExtra(3,2),iSecExtra(3,2),iimport,
     &     MUor,NpadL(2),NpadU(2)
      REAL    xExtra(3,2),dx
      LOGICAL LongSection
      REAL yMUtol ! tolerance to fix the long chamber in MU
      INTEGER NumLayInMu(4)

      INTEGER LOCF

      DATA yMUtol /22./
      DATA NumLayInMu / 3 , 3 , 1 , 1 /
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
#include "l1si/hbmudefs.ff"
c
c
      IF ( L1PARprnlev.ge.1 ) THEN
       WRITE(L1LUNprn,*) 'L1DETIN==> +++++++ BEGIN ++++++++++++'
c
       IF ( L1PARprnlev.eq.9 ) THEN
        WRITE(L1LUNprn,*)
     &       'CDET:PLAT SL LA SE  XMIN  XMAX  YMIN  YMAX'//
     &       'alpha:    X0    SX    Y0    SY'
       ELSE IF ( L1PARprnlev.eq.8 ) THEN
        WRITE(L1LUNprn,*)
     &       'CDET:PLAT SL LA SE alph'//
     &       '      Z  XMIN  XMAX  YMIN  YMAX'//
     &       ' SPAC OLAP LU RU LL RL MAX'
       END IF
      END IF
c
      CALL VZERO(npad3y,2)      ! MU3 not inited yet
c
c     What detectors will be used?
c
      nSLlist = 0
      l1nDetUsed = L1maxDetUsed
      DO idet=1,L1maxDetUsed
       IF (c1DetUsed(idet).EQ.C1MCUdummy) THEN ! last det have been found
        l1nDetUsed = idet-1
        GOTO 774
       ENDIF
      ENDDO
 774  CONTINUE





c
      iMuAdd=0                  ! preset of number of additional links for pretrigger
c
c     Check for muon pretrigger definition consistency
c
c
      do i=1,L1NUMpret
       icheck=0
       do j=1,l1nDetUsed
        if(C1NamePret(i).eq.c1DetUsed(j)) then
         icheck=1
        endif
       enddo
       if(icheck.ne.1)  WRITE(L1LUNprn,*)
     &      ' L1DETIN ==> detector ',C1NamePret(i)
     &      ,'for pretrigger requested, but not defined in USEDET card '
      enddo
c
c The end of check of superlayer names for muon pretrigger
c



c     First create the BANK for detector information
c
      CALL MZBOOK(IXCONS,L1JDET,L1JDET,1,'LJDE',l1nDetUsed+L1nPreMuAdd
     $     ,l1nDetUsed+L1nPreMuAdd,l1nDetUsed+L1nPreMuAdd,0,0)
      DO idet=1,l1nDetUsed      ! fill data structure
c       PRINT *,'L1DETIN==> Looking for detector: ',c1DetUsed(idet)
       DO isl = 1,NGESL()        ! look for SL used
        if (CQ(HQGESL_NAME(isl)).EQ.c1DetUsed(idet)) THEN !found
c
         nSLlist = nSLlist + 1
         IF ( nSLlist.gt.L1maxDetUsed ) THEN
          WRITE(L1LUNprn,*) 'L1DETIN==> too many detectors:',
     &         nSLlist
         ELSE
          iSLlist(nSLlist) = idet
         END IF
c
         nlay = IGESL_LAY(isl)
         nsec = IGESL_NPL(isl)/nlay
         nl1sec = nsec    ! internal L1SIMU section number
         itype = IGESL_CMP(isl)
         CQ(L1JDET+idet) = c1DetUsed(idet)
c         print *,'det/typ/isl,nlay/nsec:',
c     &       CQ(L1JDET+idet),itype,nlay,nsec
c
c        first detector of this SL in general numeration
c
         ifirst = IGESL_FPL(isl)
         nword = 2*L1GEOINFlen+L1DETINFlen
         if(itype.eq.L1DETtypeMS) then
          nl1sec = nsec/2                  ! MSGC: 2 GEDE per section
         elseif(itype.eq.L1DETtypeMU) then ! constants for MU
          nword = 2*L1GEOINFlen+L1DETINFlenMu
C
C         Determination of total number of layers in superlayer
C
          MuSNum=IGESL_NSL(ISL) ! number of muon superlayer
c
c         From data cards we have to get the number of sections per muon
c         superlayer
c
          IF(MuSNum.GT.2)   THEN
           nl1sec = L1DEFmuosec(MuSNum) ! number of sections
          ELSE
           nl1sec = L1DEFmuosec(MuSNum)*2 ! Up&down sections in MU1
          ENDIF
          nlay = NumLayInMu(MuSNum) ! the number of layers
         endif

         CALL MZBOOK(IXCONS,JDET,L1JDET,-idet,'LJDE',
     &        0,0,nlay*nl1sec*nword,0,0) !bank for det information
C
C        Muon tube chambers  should be processed in a different way
C
         if(itype.EQ.L1DETtypeMU) GOTO 111
C
C        For the rest of detectors:
C
         DO ipla = 1,IGESL_NPL(isl)   ! general numeration
          iPlate = ifirst+ipla-1
          IF(itype.EQ.L1DETtypeMS) THEN  ! MSGC: isec is fastest
           isec = MOD(ipla-1,nsec)+1
           il1sec = (isec+1)/2            ! 2 GEDE per L1SIMU det
           ilay = (ipla-1)/(nsec)+1
           IF(MOD(isec,2).EQ.0)       GOTO 200  ! skip second section
          ELSE                            ! ilay is fastest for the rest
           isec = (ipla-1)/nlay+1
           il1sec = isec
           ilay = MOD(ipla-1,nlay)+1
          ENDIF
c
           jDetGeo = JDET+nword*((il1sec-1)*nlay+ilay-1)
           jDetInf = jDetGeo+L1GEOINFlen
           jCellGeo = jDetInf+L1DETINFlen
c
c               --- Calorimeter :::::::
c
           IF(itype.EQ.L1DETtypeEC) THEN ! Calorimeter
c
            Q(jDetGeo+L1GEOINFx0) = FGCAL_XMIN(iPlate)
            Q(jDetGeo+L1GEOINFsx) = FGCAL_XMAX(iPlate)-
     &           FGCAL_XMIN(iPlate)
            Q(jDetGeo+L1GEOINFy0) = FGCAL_YMIN(iPlate)
            Q(jDetGeo+L1GEOINFsy) = FGCAL_YMAX(iPlate)-
     &           FGCAL_YMIN(iPlate)
            Q(jDetGeo+L1GEOINFz) = FGCAL_ZMIN(iPlate)+
     &                T1DEFzecal(MIN(IGCAL_NCL(iPlate),3))   ! z0 in the showermax position
            Q(jDetGeo+L1GEOINFsin_al) = 0.
            Q(jDetGeo+L1GEOINFcos_al) = 1.
c
c            IF ( L1PARprnlev.eq.9 ) THEN
c             WRITE(L1LUNprn,1001)
c     &            CQ(L1JDET+idet),iPlate,isl,ilay,isec,
c     &            FGCAL_XMIN(iPlate),FGCAL_XMAX(iPlate),
c     &            FGCAL_YMIN(iPlate),FGCAL_YMAX(iPlate),
c     &            0.,
c     &            Q(jDetGeo+L1GEOINFx0),Q(jDetGeo+L1GEOINFsx),
c     &            Q(jDetGeo+L1GEOINFy0),Q(jDetGeo+L1GEOINFsy)
c            END IF
c
            Q(jDetInf+L1DETINFxspace) = Q(jDetGeo+L1GEOINFsx)/
     &           IGCAL_NCL(iPlate)
            Q(jDetInf+L1DETINFyspace) = Q(jDetInf+L1DETINFxspace)
            IQ(jDetInf+L1DETINFlast)   = IGCAL_NCL(iPlate)**2
            IQ(jDetInf+L1DETINFnRow)   = IGCAL_NCL(iPlate)
            IQ(jDetInf+L1DETINFnCol)   = IGCAL_NCL(iPlate)
            IQ(jDetInf+L1DETINFfirst)  = 1
            IQ(jDetInf+L1DETINFnlay)   = nlay
            IQ(jDetInf+L1DETINFnsec)   = nl1sec
            IQ(jDetInf+L1DETINFhbtype) = itype
            IQ(jDetInf+L1DETINFplate)  = iPlate !for further references
            IQ(jDetInf+L1DETINFwirepad) = 2
           ELSE                 ! non calorimeter detectors
c
c           Fill DetGeoInf
c
c           XMIN/XMAX correspondes to Y=0 plane
c
c
            Q(jDetGeo+L1GEOINFx0)     = FGEDE_XMIN(iPlate)+
     &           FGEDE_YMIN(iPlate)*
     &           FGEDE_SIN(iPlate)/FGEDE_COS(iPlate)
            Q(jDetGeo+L1GEOINFsx)     = FGEDE_XMAX(iPlate)-
     &           FGEDE_XMIN(iPlate)
            Q(jDetGeo+L1GEOINFy0)     = FGEDE_YMIN(iPlate)
            Q(jDetGeo+L1GEOINFsy)     = FGEDE_YMAX(iPlate)-
     &           FGEDE_YMIN(iPlate)
            Q(jDetGeo+L1GEOINFz)      = 0.5*(FGEDE_ZMIN(iPlate)+
     &           FGEDE_ZMAX(iPlate)) ! z0 in the middle of detector
            Q(jDetGeo+L1GEOINFsin_al) = FGEDE_SIN(iPlate)
            Q(jDetGeo+L1GEOINFcos_al) = FGEDE_COS(iPlate)
c
            IF ( L1PARprnlev.eq.9 ) THEN
             WRITE(L1LUNprn,1001)
     &            CQ(L1JDET+idet),iPlate,isl,ilay,il1sec,
     &            FGEDE_XMIN(iPlate),FGEDE_XMAX(iPlate),
     &            FGEDE_YMIN(iPlate),FGEDE_YMAX(iPlate),
     &            FGEDE_SIN(iPlate)/FGEDE_COS(iPlate),
     &            Q(jDetGeo+L1GEOINFx0),Q(jDetGeo+L1GEOINFsx),
     &            Q(jDetGeo+L1GEOINFy0),Q(jDetGeo+L1GEOINFsy)
            END IF
c
            Q(jDetInf+L1DETINFxspace) = FGEDE_PIT(iPlate)/
     &           FGEDE_COS(iPlate)
            Q(jDetInf+L1DETINFyspace) = Q(jDetGeo+L1GEOINFsy)
            IQ(jDetInf+L1DETINFlast)   = IGEDE_NWI(1,iPlate)
            IQ(jDetInf+L1DETINFnRow)   = IQ(jDetInf+L1DETINFlast)
            IQ(jDetInf+L1DETINFnCol)   = 1
            IQ(jDetInf+L1DETINFfirst)  = 1
            IQ(jDetInf+L1DETINFnlay)   = nlay
            IQ(jDetInf+L1DETINFnsec)   = nl1sec
            IQ(jDetInf+L1DETINFhbtype) = itype !for further references
            IQ(jDetInf+L1DETINFplate)  = iPlate !for further references
            IQ(jDetInf+L1DETINFwirepad) = 1
c
c           --- Outer Tracker ::::::::::::
c
            IF (itype.EQ.L1DETtypeTT) THEN
c
c            Drift tubes overlaping configuration
c            consider only first two (overlaping) layers
c
             pitchx = FGEDE_PIT(iPlate)   ! pitch in local system
             xmin   = MIN(FGEDE_XFW(1,iPlate),FGEDE_XFW(2,iPlate))-
     &            pitchx/3.
             xmax   = pitchx/3. + MAX(
     &            FGEDE_XFW(1,iPlate)+pitchx*(IGEDE_NWI(1,iPlate)-1),
     &            FGEDE_XFW(2,iPlate)+pitchx*(IGEDE_NWI(2,iPlate)-1))
             RotCos = FGEDE_COS(iPlate)
             RotSin = FGEDE_SIN(iPlate)
             CALL MUROT(xmin,xmax,
     &            FGEDE_YMIN(iPlate),FGEDE_YMAX(iPlate), ! rotation
     &            RotSin,RotCos,XYout)                   ! of the chamber
             xmin = XYout(1)
             xmax = XYout(2)
             pitchx = FGEDE_PIT(iPlate)/FGEDE_COS(iPlate)
             dodx   = FGEDE_DOD(iPlate)/FGEDE_COS(iPlate)
             Q(jDetGeo+L1GEOINFx0) = xmin+
     &            FGEDE_YMIN(iPlate)*RotSin/RotCos
             Q(jDetGeo+L1GEOINFsx) =  xmax-xmin
             Q(jDetInf+L1DETINFxspace) = 0.5*pitchx
             Q(jDetInf+L1DETINFyspace) = Q(jDetGeo+L1GEOINFsy)
             IQ(jDetInf+L1DETINFlast) = IGEDE_NWI(1,iPlate)+
     &            IGEDE_NWI(2,iPlate)
             IQ(jDetInf+L1DETINFnRow) = IQ(jDetInf+L1DETINFlast)
             IQ(jDetInf+L1DETINFnCol) = 1
c
c            --- Inner Tracker (MSGCs) ::::::::::::
c
            ELSEIF (itype.EQ.L1DETtypeMS) THEN
c             print '(''MSGC:'',3i4,8f9.3)',iPlate,ilay,isec,
c     &            FGEDE_XMIN(iPlate), FGEDE_XMAX(iPlate),
c     &            FGEDE_YMIN(iPlate), FGEDE_YMAX(iPlate),
c     &            0.5*(FGEDE_ZMIN(iPlate)+
c     &            FGEDE_ZMAX(iPlate)),
c     &            FGEDE_SIN(iPlate),FGEDE_XFW(1,iPlate),
c     &            FGEDE_PIT(iPlate)
c
             RotCos=FGEDE_ROT(1,iPlate) ! we take angles from rotation matrix
             RotSin=FGEDE_ROT(2,iPlate) !
             Q(jDetGeo+L1GEOINFsin_al) = RotSin
             Q(jDetGeo+L1GEOINFcos_al) = RotCos
             Xmin = FGEDE_XFW(1,iPlate)-0.5*FGEDE_PIT(iPlate)  ! actual chamber start
             CALL MUROT(Xmin,FGEDE_XMAX(iPlate), ! the very
     &            FGEDE_YMIN(iPlate),FGEDE_YMAX(iPlate), ! rotation
     &            RotSin,RotCos,XYout) ! of the chamber
             pitchx = FGEDE_PIT(iPlate)/RotCos
             Xmin = XYout(1)
             Xmax = XYout(2)
             Ymin = XYout(3)
             Ymax = XYout(4)
c             print '(''First section:'',5f9.3)',XYout,RotSin
             CALL MUROT( FGEDE_XMIN(iPlate+1),FGEDE_XMAX(iPlate+1), ! the very
     &            FGEDE_YMIN(iPlate+1),FGEDE_YMAX(iPlate+1), ! rotation
     &            RotSin,RotCos,XYout) ! of the second part
c             print '(''Second section:'',4f9.3)',XYout
             IF(Xmin.GT.XYout(1).OR.Xmax.GT.XYout(2))  THEN
              WRITE (L1LUNprn,*)
     &             'L1DETIN ===> Error: MSGC incorrect ordering',
     &             Xmin,XYout(1),Xmax,XYout(2)
              GOTO 999
             ENDIF
             Xmax = XYout(2)      ! second section is rightmost
             Ymin = MIN(Ymin,XYout(3))
             Ymax = MAX(Ymax,XYout(4))
             x0 = Xmin+Ymin*RotSin/RotCos
             ncell = IGEDE_NWI(1,iPlate)+IGEDE_NWI(1,iPlate+1) ! wire number
             sx = pitchx*ncell  ! chamber width
             Q(jDetGeo+L1GEOINFx0) = x0
             Q(jDetGeo+L1GEOINFy0) = Ymin
             Q(jDetGeo+L1GEOINFsy) = Ymax-Ymin
             Q(jDetInf+L1DETINFxspace) = pitchx*FLOAT(L1DETmsgOR) ! OR strips
             IQ(jDetInf+L1DETINFlast)  = ncell/L1DETmsgOR
             IQ(jDetInf+L1DETINFnRow) = IQ(jDetInf+L1DETINFlast)
             Q(jDetGeo+L1GEOINFsx) =
     &            Q(jDetInf+L1DETINFxspace)*IQ(jDetInf+L1DETINFnRow)
             IQ(jDetInf+L1DETINFnw1) = IGEDE_NWI(1,iPlate)  ! wires in
                                                            ! first section
c
c            P.Pakhlovs Pad Chamber for B-->pi+pi- Trigger ! I.B.
c
            ELSEIF (itype.EQ.L1DETtypePT)	THEN

            Q(jDetGeo+L1GEOINFx0)     = FGEDE_SXMN(iPlate)
            Q(jDetGeo+L1GEOINFsx)     = FGEDE_SXMX(iPlate)-
     &           FGEDE_SXMN(iPlate)
            Q(jDetGeo+L1GEOINFy0)     = FGEDE_SYMN(iPlate)
            Q(jDetGeo+L1GEOINFsy)     = FGEDE_SYMX(iPlate)-
     &           FGEDE_SYMN(iPlate)
             IQ(jDetInf+L1DETINFnRow) = IGEDE_NWI(1,iPlate)
             IQ(jDetInf+L1DETINFnCol) = IGEDE_NWI(2,iPlate)
             Q(jDetInf+L1DETINFxspace) =
     &            Q(jDetGeo+L1GEOINFsx)/IQ(jDetInf+L1DETINFnRow)
             Q(jDetInf+L1DETINFyspace) =
     &            Q(jDetGeo+L1GEOINFsy)/IQ(jDetInf+L1DETINFnCol)
             IQ(jDetInf+L1DETINFlast) = IGEDE_NWI(1,iPlate)*
     &               IGEDE_NWI(2,iPlate)
             Q(jDetGeo+L1GEOINFz)      = 0.5*(FGEDE_ZMIN(iPlate)+
     &            FGEDE_ZMAX(iPlate)) ! z0 in the middle of detector
             IQ(jDetInf+L1DETINFwirepad) = 2
             Q(jDetGeo+L1GEOINFsin_al) = 0.
             Q(jDetGeo+L1GEOINFcos_al) = 1.

C
C            ------  Inner muon chamber (pixel type) -------
C

            ELSEIF (itype.EQ.L1DETtypeMX) THEN
c
             MuX4 = (c1DetUsed(idet)(4:4).eq.'4') ! pads in MU4 are shifted by
                                ! 1/2 in Y
c
             IQ(jDetInf+L1DETINFnRow) =
     &            FLOAT(IGEDE_PXNX(iPlate)-1)/IGEDE_NXPX(iPlate)+1
             IF(MuX4)  THEN
              IQ(jDetInf+L1DETINFnCol) =
     &             FLOAT(IGEDE_PXNY(iPlate)-1)/IGEDE_NYPX(iPlate)+1.5
             ELSE
              IQ(jDetInf+L1DETINFnCol) =
     &             FLOAT(IGEDE_PXNY(iPlate)-1)/IGEDE_NYPX(iPlate)+1
             ENDIF
             Q(jDetInf+L1DETINFxspace) =
     &            FGEDE_PXDX(iPlate)*IGEDE_NXPX(iPlate)
             Q(jDetInf+L1DETINFyspace) =
     &            FGEDE_PXDY(iPlate)*IGEDE_NYPX(iPlate)
             IQ(jDetInf+L1DETINFlast) =
     &            IQ(jDetInf+L1DETINFnRow)*IQ(jDetInf+L1DETINFnCol)
c
             Q(jDetGeo+L1GEOINFsx) =
     &            Q(jDetInf+L1DETINFxspace)*IQ(jDetInf+L1DETINFnRow)
c
             IF(ABS(FGEDE_XMIN(iPlate)).lt.ABS(FGEDE_XMAX(iPlate))) THEN
              Q(jDetGeo+L1GEOINFx0) =
     &             FGEDE_XMIN(iPlate)+FGEDE_XFW(1,iPlate)
             ELSE
              Q(jDetGeo+L1GEOINFx0) =
     &             FGEDE_XMAX(iPlate)-FGEDE_XFW(1,iPlate)-
     &             Q(jDetGeo+L1GEOINFsx)
             ENDIF
c
             Q(jDetGeo+L1GEOINFsy) =
     &            Q(jDetInf+L1DETINFyspace)*IQ(jDetInf+L1DETINFnCol)
c
             IF(ABS(FGEDE_YMIN(iPlate)).lt.ABS(FGEDE_YMAX(iPlate))) THEN
              IF(MuX4)   THEN   ! pads in MU4 are shifted by 1/2 in Y
               Q(jDetGeo+L1GEOINFy0) = FGEDE_YMIN(iPlate)+
     &              FGEDE_XFW(2,iPlate)-0.5*Q(jDetInf+L1DETINFyspace)
              ELSE
               Q(jDetGeo+L1GEOINFy0) =
     &              FGEDE_YMIN(iPlate)+FGEDE_XFW(2,iPlate)
              ENDIF
             ELSE
              IF(MuX4)   THEN   ! pads in MU4 are shifted by 1/2 in Y
               Q(jDetGeo+L1GEOINFy0) = FGEDE_YMAX(iPlate)-
     &              FGEDE_XFW(2,iPlate)-
     &              Q(jDetGeo+L1GEOINFsy)+0.5*Q(jDetInf+L1DETINFyspace)
              ELSE
               Q(jDetGeo+L1GEOINFy0) = FGEDE_YMAX(iPlate)-
     &              FGEDE_XFW(2,iPlate)-Q(jDetGeo+L1GEOINFsy)
              ENDIF
             ENDIF
c
             Q(jDetGeo+L1GEOINFsin_al) = 0.
             Q(jDetGeo+L1GEOINFcos_al) = 1.
c
             IQ(jDetInf+L1DETINFwirepad) = 2

c
c            This is part for muon pretrigger
c
             iMuPresl=0
             do i=1,L1NUMpret
              IF(c1DetUsed(idet).eq.C1NamePret(i)) THEN
               iMuPreSl=i
              ENDIF
             enddo
c
             IF(iMuPreSl.gt.0) THEN ! this detector is used in pretrigger
c
c             First call to this detector initializes creation of the
c             bank for
c             pretrigger geometry
c
              if(ilay.eq.1.and.isec.eq.1) then
               iMuAdd=iMuAdd+1  ! increase the number of additional links
               iMuPreLink=l1nDetUsed+iMuAdd ! link to pretrigger
               cMuPadNam = c1DetUsed(idet)
               cMuPadNam(3:3) = 'P'
               CQ(L1JDET+iMuPreLink) = cMuPadNam
               CALL MZBOOK(IXCONS,JDETX,L1JDET,-iMuPreLink !bank for det information
     $              ,'LJDE',0,0,nlay*nl1sec*nword,0,0)
c
c              end of pretrigger initialization part
c
              endif
c
              kDetGeo = JDETX+nword*((il1sec-1)*nlay+ilay-1)
              kDetInf = kDetGeo+L1GEOINFlen
              kCellGeo = kDetInf+L1DETINFlen
c
              Q(kDetInf+L1DETINFxspace) = ! ORing in X
     &             Q(jDetInf+L1DETINFxspace)*L1DETmupxor
              Q(kDetInf+L1DETINFyspace) = Q(jDetInf+L1DETINFyspace)
              IQ(kDetInf+L1DETINFnRow)   =
     &             (IQ(jDetInf+L1DETINFnRow)-1)/L1DETmupxor + 1
              IQ(kDetInf+L1DETINFnCol)   = IQ(jDetInf+L1DETINFnCol)
              Q(kDetGeo+L1GEOINFsx) = ! ORing in X
     &             Q(kDetInf+L1DETINFxspace)*IQ(kDetInf+L1DETINFnRow)
c
              IF(ABS(Q(jDetGeo+L1GEOINFx0)).lt.
     &             ABS(Q(jDetGeo+L1GEOINFx0)+Q(jDetGeo+L1GEOINFsx)))
     $             THEN
               IQ(kDetInf+L1DETINFfltFiEXa) = 1 ! common left end
              ELSE
c              we should fix possible shift of PADs from pixels
               IQ(kDetInf+L1DETINFfltFiEXa) = IQ(jDetInf+L1DETINFnRow)-
     &              L1DETmupxor*IQ(kDetInf+L1DETINFnRow)+1 ! common right end
              ENDIF
              Q(kDetGeo+L1GEOINFx0) = Q(jDetGeo+L1GEOINFx0)+
     &             (IQ(kDetInf+L1DETINFfltFiEXa)-1)*Q(jDetInf
     $             +L1DETINFxspace)
c
              Q(kDetGeo+L1GEOINFsy) = Q(jDetGeo+L1GEOINFsy) ! no changes in Y
              Q(kDetGeo+L1GEOINFy0) = Q(jDetGeo+L1GEOINFy0)
              Q(kDetGeo+L1GEOINFz) = Q(jDetGeo+L1GEOINFz)
              Q(kDetGeo+L1GEOINFsin_al) = 0.
              Q(kDetGeo+L1GEOINFcos_al) = 1.
c
              IQ(kDetInf+L1DETINFfirst)  = 1
              IQ(kDetInf+L1DETINFlast)   =  IQ(kDetInf+L1DETINFnRow)*
     &             IQ(kDetInf+L1DETINFnCol)
              IQ(kDetInf+L1DETINFnlay)   = nlay
              IQ(kDetInf+L1DETINFnsec)   = nl1sec
              IQ(kDetInf+L1DETINFhbtype) = itype !for further references
              IQ(kDetInf+L1DETINFplate)  = iPlate !for further references
c
              IQ(kDetInf+L1DETINFleftU)  = 0
              IQ(kDetInf+L1DETINFrightU) = 0
              IQ(kDetInf+L1DETINFleftL)  = 0
              IQ(kDetInf+L1DETINFrightL) = 0
              IQ(kDetInf+L1DETINFwirepad) = 2

              CALL UCOPY(Q(kDetGeo+1),Q(kCellGeo+1),L1GEOINFlen)
              Q(kCellGeo+L1GEOINFsx) = Q(kDetInf+L1DETINFxspace)
              Q(kCellGeo+L1GEOINFsy) = Q(kDetInf+L1DETINFyspace)
c
c             end of pretrigger part
c
             ENDIF              ! over detector types
            ENDIF               ! detector is used
           ENDIF
c
c
c          Fill cell data (mostly copy DET data)
c
           CALL UCOPY(Q(jDetGeo+1),Q(jCellGeo+1),L1GEOINFlen)
           Q(jCellGeo+L1GEOINFsx) = FGEDE_PIT(iPlate)/
     &          FGEDE_COS(iPlate)
           Q(jCellGeo+L1GEOINFsy) = Q(jDetInf+L1DETINFyspace)
c
           IF (itype.EQ.L1DETtypeTT) THEN ! Drift celles
            Q(jCellGeo+L1GEOINFsx) =  2.*FGEDE_DOD(iPlate)/
     &           FGEDE_COS(iPlate)
c
           ELSEIF (itype.EQ.L1DETtypeMS) THEN ! MSGC
c
            Q(jCellGeo+L1GEOINFsx) =
     &           Q(jCellGeo+L1GEOINFsx) * ! FLT uses ORed MSGCs
     &           FLOAT(L1DETmsgOR)
c
           ELSEIF (itype.EQ.L1DETtypeEC) THEN ! ECAL
c
            Q(jCellGeo+L1GEOINFsx) =
     &           Q(jDetGeo+L1GEOINFsx)/IQ(jDetInf+L1DETINFnRow)
            Q(jCellGeo+L1GEOINFsy) =
     &           Q(jDetGeo+L1GEOINFsy)/IQ(jDetInf+L1DETINFnCol)
c
           ELSEIF (itype.EQ.L1DETtypePT)	THEN ! P.Pakhlovs Pad Chamber  I.B.
            Q(jCellGeo+L1GEOINFsx) =
     &           Q(jDetGeo+L1GEOINFsx)/IQ(jDetInf+L1DETINFnRow)
            Q(jCellGeo+L1GEOINFsy) =
     &           Q(jDetGeo+L1GEOINFsy)/IQ(jDetInf+L1DETINFnCol)
           ELSEIF (itype.EQ.L1DETtypeMX)	THEN ! Muon pixel
                                ! chambers
            Q(jCellGeo+L1GEOINFsx) = Q(jDetInf+L1DETINFxspace)
            Q(jCellGeo+L1GEOINFsy) = Q(jDetInf+L1DETINFyspace)
           ENDIF
c
           Q(jDetInf+L1DETINFxlap) = Q(jCellGeo+L1GEOINFsx)-
     &          Q(jDetInf+L1DETINFxspace)
           IF (Q(jDetInf+L1DETINFxlap).LT.0.)
     &          Q(jDetInf+L1DETINFxlap)=0.
           Q(jDetInf+L1DETINFylap) = Q(jCellGeo+L1GEOINFsy)-
     &          Q(jDetInf+L1DETINFyspace)
           IF (Q(jDetInf+L1DETINFylap).LT.0.)
     &          Q(jDetInf+L1DETINFylap)=0.
           Q(jDetInf+L1DETINFx0Nomin) = Q(jDetGeo+L1GEOINFx0)
           Q(jDetInf+L1DETINFsxNomin) = Q(jDetGeo+L1GEOINFsx)
c
 200       CONTINUE
          ENDDO
c
         GOTO 778               ! we have found what we need
 111     CONTINUE               ! start of muon tube chamber part
C
C        We have to process muon tube chambers in a slightly different
c        way,
C        as we consider only one half of a chamber to be a detector
c        plane
C
c
c        --- Outer muon chambers -------- (looks slightly different)
c
c        The main difference is that we have to combine several chambers
c        together
c        to get one section accepted by L1SIMU
c

         IF (itype.EQ.L1DETtypeMU) THEN
          x0sl = FGESL_X1(isl) ! SL is simmetrical
          sxsl = FGESL_X2(isl) - FGESL_X1(isl)
          CALL VZERO(nExtra(1),3) ! No extra sections for this SL yet
          DO iPlate=ifirst,ifirst+IGESL_NPL(isl)-1,2
           iPla2 = iPlate+1     ! back section
           LongSection = .FALSE. ! this section is not long (yet)
c
c          We have to rotate chamber
c
c           print '(''first:'',i5,6f9.3)',
c     &         iPlate,
c     &          FGEDE_XMIN(iPlate),FGEDE_XMAX(iPlate),
c     &          FGEDE_YMIN(iPlate),FGEDE_YMAX(iPlate),
c     &          FGEDE_ROT(1,iPlate),FGEDE_ROT(2,iPlate)
c           print '(''secnd:'',i5,6f9.3)',
c     &         iPla2,
c     &          FGEDE_XMIN(iPla2),FGEDE_XMAX(iPla2),
c     &          FGEDE_YMIN(iPla2),FGEDE_YMAX(iPla2),
c     &          FGEDE_ROT(1,iPla2),FGEDE_ROT(2,iPla2)
c
           RotCos=FGEDE_ROT(1,iPlate) ! we take angles from rotation matrix
           RotSin=FGEDE_ROT(2,iPlate) !
           RotTg = RotSin/RotCos
           CALL MUROT( FGEDE_XMIN(iPlate),FGEDE_XMAX(iPlate), ! the very
     &          FGEDE_YMIN(iPlate),FGEDE_YMAX(iPlate), ! rotation
     &          RotSin,RotCos,XYout) ! of the chamber
           Xmin=XYout(1)        !                            ------
           Xmax=XYout(2)        ! coordinates of rotated    /     /
           Ymin=XYout(3)        ! chamber. New look ->     /     /  (not rectangular form)
           Ymax=XYout(4)        !                         -------
c          print '('' New chamber:'',i5,5f9.3)',iplate,XYout,RotSin
           CALL MUROT( FGEDE_XMIN(iPla2),
     &          FGEDE_XMAX(iPla2),
     &          FGEDE_YMIN(iPla2),
     &          FGEDE_YMAX(iPla2),
     &          RotSin,RotCos,XYout) !second chamber
c          print '('' 2nd chamber:'',i5,4f9.3)',iPla2,XYout
           Ymin = MIN(Ymin,XYout(3)) ! Min&Max of both
           Ymax = MAX(Ymax,XYout(4))
           IF(Xmin.GT.XYout(1))  THEN ! second plate shifted to lower x
            MuCount =  -1
           ELSE
            MuCount =  1
           ENDIF
c           print '(i4,i2,4f10.3)',
c     &          iplate,MuCount,Xmin,Xmax,XYout(1),XYout(2)
c          layer number according to angle
           IF(abs(RotSin).lt.0.1) THEN
            ilay=1
           ELSEIF(RotSin.gt.0.1) THEN
            ilay=2              ! in l1simu frame alpha > 0
           ELSEIF(RotSin.lt.-0.1) THEN
            ilay=3              ! in l1simu frame alpha < 0
           ELSE                 ! error printout
            WRITE (L1LUNprn,124)
     &           'L1DETIN ===> wrong muon angle!!!! ',RotSin
 124        FORMAT(2x,A50,F7.4)
            GOTO 999
           ENDIF
           IF(MuSNum.GT.2.AND.ilay.NE.1)   THEN ! error: only "0"
                                ! wires for MU3-4
            WRITE (L1LUNprn,*)
     &           'L1DETIN ===> Error: nonzerro angle for MU',MuSNum
            GOTO 999
           ENDIF
           IF(0.5*(Ymin+Ymax).LT.0.) THEN ! low section
            UPsection = .FALSE.
           ELSE
            UPsection = .TRUE.
           ENDIF
           MUor = L1DETmuOR(MuSNum)
           IF(MUor.NE.1.AND.MUor.NE.2)  THEN
            WRITE (L1LUNprn,*)
     &           'L1DETIN ===> Error: Incorrect ORing for MU',
     &           MuSNum,MUor
            GOTO 999
           ENDIF
c
           IF(MuSNum.GT.2)  THEN !MU3-4 - single section raw
            il1sec = (Xmin-x0sl)*nl1sec/sxsl+1
            IF(il1sec.LT.1)  il1sec = 1
            IF(il1sec.GT.nl1sec)  il1sec = nl1sec
           ELSE                 ! MU1 - two section raws          !  1 2 3
            il1sec = (Xmin-x0sl)*nl1sec/sxsl/2.+1 !  4 5 6
            IF(il1sec.LT.1)  il1sec = 1
            IF(il1sec.GT.nl1sec/2)  il1sec = nl1sec/2
            IF(.NOT.UPsection) il1sec = il1sec+nl1sec/2
c           PRINT *,iplate,xmin,xmax,ymin,ymax
            IF(UPsection.AND.Ymin.LT.-yMUtol.OR. ! long chamber in MU1
     &           .NOT.UPsection.AND.Ymax.GT.yMUtol)  THEN
             LongSection = .TRUE.
             IF(nExtra(ilay).LT.2)  THEN
              nExtra(ilay) = nExtra(ilay)+1
              NoExtra(ilay,nExtra(ilay)) = iPlate
              xExtra(ilay,nExtra(ilay)) = 0.5*(Xmin+Xmax)
              IF(UPsection) THEN ! refer to low section
               iSecExtra(ilay,nExtra(ilay)) = il1sec+nl1sec/2
              ELSE
               iSecExtra(ilay,nExtra(ilay)) = il1sec-nl1sec/2
              ENDIF
             ELSE
              WRITE (L1LUNprn,*)
     &             'L1DETIN ==> no space for long chamber',
     &             ilay,iPlate
             ENDIF
            ENDIF
           ENDIF
c
c          PRINT *, 'isec/UP/ilay:',il1sec,UPsection,ilay
           JDET = LQ(L1JDET-idet) ! detector information
           jDetGeo = JDET+nword*((il1sec-1)*nlay+ilay-1)
           jDetInf = jDetGeo+L1GEOINFlen
           jCellGeo = jDetInf+L1DETINFlenMu
           pitchx = FGEDE_PIT(iPlate)/RotCos
           x0 = Xmin+FGEDE_XFW(1,iPlate)/RotCos-0.5*pitchx
           x0 = x0+Ymin*RotTg   ! Low left corner
           ncell = IGEDE_NWI(1,iPlate) ! wire number
           sx = pitchx*(ncell+0.5) ! chamber width
           IF(MuCount.LT.0.) THEN ! second plate shifted to lower x
            x0 = x0-0.5*pitchx
           ENDIF
c
c          fill FLT database
c
           IF(Q(jDetGeo+L1GEOINFsx).EQ.0.)    THEN ! section not
            Q(jDetGeo+L1GEOINFx0) = x0 ! inited yet
            Q(jDetGeo+L1GEOINFsx) = sx
            Q(jDetGeo+L1GEOINFy0) = Ymin
            Q(jDetGeo+L1GEOINFsy) = Ymax-Ymin
            Q(jDetGeo+L1GEOINFz) =
     &           0.5*(FGEDE_ZMIN(iPlate)+FGEDE_ZMAX(iPlate))
            Q(jDetGeo+L1GEOINFsin_al) = RotSin
            Q(jDetGeo+L1GEOINFcos_al) = RotCos
            CALL UCOPY(Q(jDetGeo+1),Q(jCellGeo+1),L1GEOINFlen) !cell information
            Q(jCellGeo+L1GEOINFsx) = pitchx
            Q(jDetInf+L1DETINFxspace) = 0.5*pitchx
            Q(jDetInf+L1DETINFyspace) = Q(jDetGeo+L1GEOINFsy)
            IQ(jDetInf+L1DETINFnRow) = 0 ! to be filled further
            IQ(jDetInf+L1DETINFfirst) = 1
            IQ(jDetInf+L1DETINFFLTfi) = IQ(jDetInf+L1DETINFfirst)
            IQ(jDetInf+L1DETINFlast) = 0 ! to be filled further
            IQ(jDetInf+L1DETINFnCol) = 1
            Q(jDetInf+L1DETINFxlap) = Q(jCellGeo+L1GEOINFsx)-
     &           Q(jDetInf+L1DETINFxspace)
            Q(jDetInf+L1DETINFylap) = 0.
            IQ(jDetInf+L1DETINFnlay) = nlay
            IQ(jDetInf+L1DETINFnsec) = nl1sec
            IQ(jDetInf+L1DETINFhbtype) = IGEDE_CMP(iPlate)
            IQ(jDetInf+L1DETINFwirepad) = 1 ! wire chamber
            IF(MuSnum.GT.2)  THEN
c            MU3&MU4 are treated as PAD chambers
             IQ(jDetInf+L1DETINFwirepad) = 2
             IF(ilay.EQ.1.AND.il1sec.EQ.1)   THEN
              YpadMaxU(MuSnum-2) = -999. ! pad initialisation for MU3&4
              YpadMaxL(MuSnum-2) = -999. ! once per SL
              YpadMinU(MuSnum-2) = 999.
              YpadMinL(MuSnum-2) = 999.
             ENDIF
            ENDIF
            IQ(jDetInf+L1DETINFplate)  = iPlate !should not be
                                !used for muons
c           print *, 'ipla/pitchx:',iPlate,0.5*pitchx
c           muon specific
            IF(UPsection)  THEN
             IQ(jDetInf+L1DETINFMuPlateUF) = iPlate
             IQ(jDetInf+L1DETINFMuPlateUL) = iPlate
             IQ(jDetInf+L1DETINFMuPlateLF) = 99999
             IQ(jDetInf+L1DETINFMuPlateLL) = 0
             IF(MuSNum.EQ.3)  THEN
              zMU3 = Q(jDetGeo+L1GEOINFz) ! z for MU3
             ELSEIF(MuSNum.EQ.4)  THEN
              zMU4 = Q(jDetGeo+L1GEOINFz) ! z for MU4
             ENDIF
            ELSE
             IQ(jDetInf+L1DETINFMuPlateUF) = 99999
             IQ(jDetInf+L1DETINFMuPlateUL) = 0
             IQ(jDetInf+L1DETINFMuPlateLF) = iPlate
             IQ(jDetInf+L1DETINFMuPlateLL) = iPlate
            ENDIF
            IQ(jDetInf+L1DETINFMuImport1) = 0
            IQ(jDetInf+L1DETINFMuImport2) = 0
            IQ(jDetInf+L1DETINFMuNW1) =  ncell
            IQ(jDetInf+L1DETINFMuCount) =  MuCount
            IF(il1sec.EQ.1.OR.(MuSNum.LE.2.AND.il1sec.EQ.nl1sec/2+1))
     &           THEN           !leftmost section
             IQ(jDetInf+L1DETINFleftU) = 0
            ELSE
             IQ(jDetInf+L1DETINFleftU) = il1sec-1
            ENDIF
            IF(il1sec.EQ.nl1sec.OR.(MuSNum.LE.2.AND.il1sec.EQ.nl1sec/2))
     &           THEN           !rightmost section
             IQ(jDetInf+L1DETINFrightU) = 0
            ELSE
             IQ(jDetInf+L1DETINFrightU) = il1sec+1
            ENDIF
            IQ(jDetInf+L1DETINFleftL) = 0
            IQ(jDetInf+L1DETINFrightL) = 0
           ENDIF
c
c          follow section size in Y
c
           IF(MuSNum.GT.2)  THEN ! Y size for PAD sections
            IF(UPsection.AND.YpadMaxU(MuSNum-2).LT.0.)  THEN
c            Up PADS not inited yet
             pady = (FGEDE_SYMX(iPlate)-FGEDE_SYMN(iPlate)- ! height
     &            FGEDE_PADDY_SMALL(iPlate)) / ! first  unregular pad
     &            (IGEDE_PADNY(iPlate)-1)      ! pads exept first one
             YpadMinU(MuSNum-2) = Ymin+   ! low edge
     &            FGEDE_SYMN(iPlate)-FGEDE_YMIN(iPlate)+ ! Start of sencetive
     &            FGEDE_PADDY_SMALL(iPlate)-         ! unregular pad
     &            pady
             YpadMaxU(MuSNum-2) = YpadMinU(MuSNum-2)+
     &            pady*IGEDE_PADNY(iPlate)
             NpadU(MuSNum-2) = IGEDE_PADNY(iPlate)
             ELSEIF(.NOT.UPsection.AND.YpadMinL(MuSNum-2).GT.0.) THEN
c             Down PADS not inited yet
             pady = (FGEDE_SYMX(iPlate)-FGEDE_SYMN(iPlate)- ! height
     &            FGEDE_PADDY_SMALL(iPlate)) / ! first  unregular pad
     &            (IGEDE_PADNY(iPlate)-1)      ! pads exept first one
             YpadMaxL(MuSNum-2) = Ymax-   ! high edge
     &            FGEDE_YMAX(iPlate)-FGEDE_SYMX(iPlate)- ! Start of sencetive
     &            FGEDE_PADDY_SMALL(iPlate)+         ! unregular pad
     &            pady
             YpadMinL(MuSNum-2) = YpadMaxL(MuSNum-2)-
     &            pady*IGEDE_PADNY(iPlate)
             NpadL(MuSNum-2) = IGEDE_PADNY(iPlate)
            ENDIF
           ENDIF
           IF(.NOT.LongSection) THEN
            IF(Ymin.LT.Q(jDetGeo+L1GEOINFy0))  THEN
             Q(jDetGeo+L1GEOINFsy) = Q(jDetGeo+L1GEOINFy0)+
     &            Q(jDetGeo+L1GEOINFsy)-Ymin
             Q(jDetGeo+L1GEOINFx0) = Q(jDetGeo+L1GEOINFx0)-
     &            (Q(jDetGeo+L1GEOINFy0)-Ymin)*RotTg !enlage in X
             Q(jDetGeo+L1GEOINFy0) = Ymin ! the least Y
            ENDIF
            IF(Ymax.GT.Q(jDetGeo+L1GEOINFy0)+
     &           Q(jDetGeo+L1GEOINFsy))      THEN
             Q(jDetGeo+L1GEOINFsy) =
     &            Ymax-Q(jDetGeo+L1GEOINFy0) ! the largest Y
            ENDIF
           ENDIF
c          update section parameters
           x0 = x0+(Q(jDetGeo+L1GEOINFy0)-Ymin)*RotTg ! refer to
                                ! actual y0
           IF(MuCount.NE.IQ(jDetInf+L1DETINFMuCount)) THEN
            WRITE (L1LUNprn,*)
     &           'L1DETIN ===> Error: different MuCount in MU:',
     &           MuSNum,MuCount,IQ(jDetInf+L1DETINFMuCount)
            GOTO 999
           ENDIF
           IF((MuSNum.GT.2.AND..NOT.UPsection).OR.MuSNum.EQ.1)
     &          THEN            ! base on low half in MU3-4
            IF(ncell.NE.IQ(jDetInf+L1DETINFMuNW1))  THEN
             WRITE (L1LUNprn,*)
     &            'L1DETIN ===> Error: different chambers in MU:',
     &            MuSNum,ncell,IQ(jDetInf+L1DETINFMuNW1)
             GOTO 999
            ENDIF
c
            IQ(jDetInf+L1DETINFnRow) =
     &           IQ(jDetInf+L1DETINFnRow)+2*ncell ! add celles of
                                ! 2 sections
c
            IF(x0.LE.Q(jDetGeo+L1GEOINFx0)) THEN ! add left section
             Q(jDetGeo+L1GEOINFsx) = Q(jDetGeo+L1GEOINFx0)+
     &            Q(jDetGeo+L1GEOINFsx)-x0 ! FLT width
             Q(jDetGeo+L1GEOINFx0) = x0
             IQ(jDetInf+L1DETINFMuPlateLF) = iPlate ! first low
                                ! section
             iorder =  -1       ! decreasing order
            ELSEIF(x0+sx.GT.Q(jDetGeo+L1GEOINFx0)+
     &            Q(jDetGeo+L1GEOINFsx)) THEN ! add right section
             Q(jDetGeo+L1GEOINFsx) = x0+sx-
     &            Q(jDetGeo+L1GEOINFx0) ! FLT width
             IQ(jDetInf+L1DETINFMuPlateLL) = iPlate ! last low
                                ! section
             iorder =  1        ! increasing order
            ELSEIF(nExtra(ilay).LT.2)  THEN ! extra short chamber
             nExtra(ilay) = nExtra(ilay)+1
             NoExtra(ilay,nExtra(ilay)) = iPlate
             xExtra(ilay,nExtra(ilay)) = 0.5*(Xmin+Xmax)
             iSecExtra(ilay,nExtra(ilay)) = il1sec
             IQ(jDetInf+L1DETINFnRow) =
     &            IQ(jDetInf+L1DETINFnRow)-2*ncell ! skip this
                                ! wires
            ELSE
             WRITE (L1LUNprn,*)
     &            'L1DETIN ==> no space for short chamber',
     &            ilay,iPlate
            ENDIF
           ELSE                 ! upper half in MU3-4: fill plate numbers only
            IF(iPlate.LT.IQ(jDetInf+L1DETINFMuPlateUF))
     &           IQ(jDetInf+L1DETINFMuPlateUF) = iPlate
            IF(iPlate.GT.IQ(jDetInf+L1DETINFMuPlateUL))
     &           IQ(jDetInf+L1DETINFMuPlateUL) = iPlate
           ENDIF
          ENDDO                 ! iPlate
c
c         Muon wire chambers postprocessing
c
c         create pretrigger detector
c
          iMuPresl=0
          do i=1,L1NUMpret
           IF(c1DetUsed(idet).eq.C1NamePret(i)) THEN
            iMuPreSl=i
           ENDIF
          enddo
c
          IF(iMuPreSl.gt.0) THEN ! this detector is used in
                                ! pretrigger
c
c          Two sections to cover up and down half of PADs
c
           iMuAdd=iMuAdd+1      ! increase the number of additional links
           iMuPreLink=l1nDetUsed+iMuAdd ! link to pretrigger
           cMuPadNam = c1DetUsed(idet)
           cMuPadNam(3:3) = 'P'
           CQ(L1JDET+iMuPreLink) = cMuPadNam
           CALL MZBOOK(IXCONS,JDETX,L1JDET,-iMuPreLink !bank for det information
     $          ,'LJDE',0,0,2*nword,0,0) ! reserve space for two sections
c
          ENDIF
c
          iMuImport1 = 0
          DO ilay=1,nlay
           DO il1sec=1,nl1sec
            JDET = LQ(L1JDET-idet) ! detector information
            jDetGeo = JDET+nword*((il1sec-1)*nlay+ilay-1)
            jDetInf = jDetGeo+L1GEOINFlen
            jCellGeo = jDetInf+L1DETINFlenMu
c
c           check wire sections selfconsistency
c
            nwtotal = (ABS(IQ(jDetInf+L1DETINFMuPlateLL)-
     &           IQ(jDetInf+L1DETINFMuPlateLF))+2)*
     &           IQ(jDetInf+L1DETINFMuNW1)
            IF(nwtotal.EQ.IQ(jDetInf+L1DETINFnRow))
     &           THEN           ! full range
             IQ(jDetInf+L1DETINFnRow) =
     &            IQ(jDetInf+L1DETINFnRow)/MUor ! wire ORing
             Q(jDetInf+L1DETINFxspace) = Q(jDetGeo+L1GEOINFsx)/
     &            (IQ(jDetInf+L1DETINFnRow)+1)
             Q(jCellGeo+L1GEOINFsx) = Q(jDetInf+L1DETINFxspace)+
     &            Q(jDetInf+L1DETINFxlap)
             IQ(jDetInf+L1DETINFlast) = IQ(jDetInf+L1DETINFnRow)
             IQ(jDetInf+L1DETINFfltLa) = IQ(jDetInf+L1DETINFlast)
             IF(MuSNum.LE.2)  THEN !MU1: refer to upper sections
              IQ(jDetInf+L1DETINFMuPlateUF) =
     &             IQ(jDetInf+L1DETINFMuPlateLF)
              IQ(jDetInf+L1DETINFMuPlateUL) =
     &             IQ(jDetInf+L1DETINFMuPlateLL)
              IQ(jDetInf+L1DETINFMuPlateLF) = 0
              IQ(jDetInf+L1DETINFMuPlateLL) = 0
c             fill extra sections information
              DO iExtra=1,nExtra(ilay)
               IF(iSecExtra(ilay,iExtra).EQ.il1sec) THEN ! this
                                ! section
                dx = xExtra(ilay,iExtra)-(Q(jDetGeo+L1GEOINFx0)-
     &               Q(jDetGeo+L1GEOINFy0)*
     &               Q(jDetGeo+L1GEOINFsin_al)/
     &               Q(jDetGeo+L1GEOINFcos_al)) ! ref to Y=0
                IF(IQ(jDetInf+L1DETINFMuPlateUF).LT.
     &               IQ(jDetInf+L1DETINFMuPlateUL))  THEN ! normal ordering
                 iimport = IQ(jDetInf+L1DETINFMuPlateUF)+
     &                2*INT(dx/Q(jDetGeo+L1GEOINFsx)*
     &                0.5*(IQ(jDetInf+L1DETINFMuPlateUL)-
     &                IQ(jDetInf+L1DETINFMuPlateUF)+1))
                ELSE            ! opposite odering
                 iimport = IQ(jDetInf+L1DETINFMuPlateUF)-
     &                2*INT(dx/Q(jDetGeo+L1GEOINFsx)*
     &                0.5*(IQ(jDetInf+L1DETINFMuPlateUF)-
     &                IQ(jDetInf+L1DETINFMuPlateUL)+1))
                ENDIF
                iimport = iimport+NoExtra(ilay,iExtra)*10000
                IF(IQ(jDetInf+L1DETINFMuImport1).EQ.0) THEN
                 IQ(jDetInf+L1DETINFMuImport1) = iimport
                ELSEIF(IQ(jDetInf+L1DETINFMuImport2).EQ.0) THEN
                 IQ(jDetInf+L1DETINFMuImport2) = iimport
                ENDIF
c               PRINT *, 'DETIN=> extra chamber W id/x/idref:',
c               &                    NoExtra(ilay,iExtra),xExtra(ilay
c               ,iExtra),
c               &                    iimport
               ENDIF
              ENDDO
c
             ELSE               ! MU3-4: arrange upper sections
              IF(IQ(jDetInf+L1DETINFMuPlateLF).GT.
     &             IQ(jDetInf+L1DETINFMuPlateLL))  THEN
               ibuf = IQ(jDetInf+L1DETINFMuPlateUF)
               IQ(jDetInf+L1DETINFMuPlateUF) =
     &              IQ(jDetInf+L1DETINFMuPlateUL)
               IQ(jDetInf+L1DETINFMuPlateUL) = ibuf
              ENDIF
              IF(IQ(jDetInf+L1DETINFMuPlateUL)-
     &             IQ(jDetInf+L1DETINFMuPlateUF).NE.
     &             IQ(jDetInf+L1DETINFMuPlateLL)-
     &             IQ(jDetInf+L1DETINFMuPlateLF)) THEN
               WRITE (L1LUNprn,*)
     &              'L1DETIN ===> Different section number MU:',
     &              MuSNum,
     &              IQ(jDetInf+L1DETINFMuPlateUL)-
     &              IQ(jDetInf+L1DETINFMuPlateUF),
     &              IQ(jDetInf+L1DETINFMuPlateLL)-
     &              IQ(jDetInf+L1DETINFMuPlateLF)
               GOTO 999
              ENDIF
c             fill extra sections information
              IF(nExtra(ilay).EQ.1)  THEN
               iExtra = 1
               IF(iSecExtra(ilay,iExtra).EQ.il1sec) THEN ! this
                                ! section
                dx = xExtra(ilay,iExtra)-Q(jDetGeo+L1GEOINFx0)
c               short chamber refer to low part
                IF(IQ(jDetInf+L1DETINFMuPlateLF).LT.
     &               IQ(jDetInf+L1DETINFMuPlateLL))  THEN ! normal ordering
                 iimport = IQ(jDetInf+L1DETINFMuPlateLF)+
     &                2*INT(dx/Q(jDetGeo+L1GEOINFsx)*
     &                0.5*(IQ(jDetInf+L1DETINFMuPlateLL)-
     &                IQ(jDetInf+L1DETINFMuPlateLF)+1))
                ELSE            ! opposite ordering
                 iimport = IQ(jDetInf+L1DETINFMuPlateLF)-
     &                2*INT(dx/Q(jDetGeo+L1GEOINFsx)*
     &                0.5*(IQ(jDetInf+L1DETINFMuPlateLF)-
     &                IQ(jDetInf+L1DETINFMuPlateLL)+1))
                ENDIF
                iimport = iimport+NoExtra(ilay,iExtra)*10000
                IQ(jDetInf+L1DETINFMuImport1) = iimport
c               PRINT *, 'DETIN=> extra chamber P id/x/idref:',
c               &                    NoExtra(ilay,iExtra),xExtra(ilay
c               ,iExtra),
c               &                    iimport
               ENDIF
              ELSEIF(nExtra(ilay).GT.1)  THEN
               WRITE (L1LUNprn,*)
     &              'L1DETIN ==> Error: the only short chamber',
     &              ' for MU3&4:',  ilay,il1sec
              ENDIF
c
             ENDIF
            ELSE                ! some chambers skipped - error
             WRITE (L1LUNprn,*)
     &            'L1DETIN ===> Wires are lost MU:',
     &            MuSNum,nwtotal,IQ(jDetInf+L1DETINFnRow)
             GOTO 999
            ENDIF
            IF(MuSNum.GT.2)   THEN ! save some data for MU3-4
             IF(il1sec.EQ.1)  THEN ! leftmost section
              xsecmin = Q(jDetGeo+L1GEOINFx0)
              iPlateUF = IQ(jDetInf+L1DETINFMuPlateUF)
              iPlateLF = IQ(jDetInf+L1DETINFMuPlateLF)
             ELSEIF(il1sec.EQ.nl1sec) THEN ! rightmost section
              xsecmax = Q(jDetGeo+L1GEOINFx0)+
     &             Q(jDetGeo+L1GEOINFsx)
              iPlateUL = IQ(jDetInf+L1DETINFMuPlateUL)
              iPlateLL = IQ(jDetInf+L1DETINFMuPlateLL)
             ENDIF
c            short chamber information...
             IF(IQ(jDetInf+L1DETINFMuImport1).NE.0)
     &            iMuImport1 = IQ(jDetInf+L1DETINFMuImport1)
            ENDIF
            Q(jDetInf+L1DETINFx0Nomin) = Q(jDetGeo+L1GEOINFx0)
            Q(jDetInf+L1DETINFsxNomin) = Q(jDetGeo+L1GEOINFsx)
           ENDDO
          ENDDO
c
c         fill pretrigger detector info
c
          IF(iMuPreSl.gt.0) THEN ! this detector is used in
                                ! pretrigger
           DO il1sec=1,2        ! over up(2)&down(1) sections
            UPsection = (il1sec.EQ.2)
            kDetGeo = JDETX+nword*(il1sec-1)
            kDetInf = kDetGeo+L1GEOINFlen
            kCellGeo = kDetInf+L1DETINFlenMu
            CALL UCOPY(Q(jDetGeo+1),Q(kDetGeo+1),
     &           L1DETINFlenMu+2*L1GEOINFlen)
            IQ(kDetInf+L1DETINFwirepad) = 2 ! pad chamber
            IF(UPsection)   THEN
             ipla = IQ(kDetInf+L1DETINFMuPlateUF) ! refer to the first plate
             Q(kDetGeo+L1GEOINFy0) = YpadMinU(MuSNum-2)
             Q(kDetGeo+L1GEOINFsy) =
     &            YpadMaxU(MuSNum-2)-YpadMinU(MuSNum-2)
             IQ(kDetInf+L1DETINFnCol) = NpadU(MuSNum-2)
            ELSE
             Q(kDetGeo+L1GEOINFy0) = YpadMinL(MuSNum-2)
             Q(kDetGeo+L1GEOINFsy) =
     &            YpadMaxL(MuSNum-2)-YpadMinL(MuSNum-2)
             IQ(kDetInf+L1DETINFnCol) = NpadL(MuSNum-2)
            ENDIF
            Q(kDetInf+L1DETINFyspace) =
     &           Q(kDetGeo+L1GEOINFsy)/IQ(kDetInf+L1DETINFnCol)
            Q(kCellGeo+L1GEOINFy0) = Q(kDetGeo+L1GEOINFy0)
            Q(kCellGeo+L1GEOINFsy) = Q(kDetInf+L1DETINFyspace)
            IQ(kDetInf+L1DETINFnRow) = ! 2 pads per doublechamber
     &           (ABS((iPlateUF-iPlateUL))/2+1)*2
            IQ(kDetInf+L1DETINFlast) =
     &           IQ(kDetInf+L1DETINFnRow)*IQ(kDetInf+L1DETINFnCol)
            IQ(jDetInf+L1DETINFfltLa) = IQ(jDetInf+L1DETINFlast)
            Q(kDetGeo+L1GEOINFx0) = xsecmin
            Q(kDetGeo+L1GEOINFsx) = xsecmax-xsecmin
            Q(kDetInf+L1DETINFxspace) = (Q(kDetGeo+L1GEOINFsx)-
     &           Q(kDetInf+L1DETINFxlap))/
     &           IQ(kDetInf+L1DETINFnRow)
            Q(kCellGeo+L1GEOINFsx) = Q(kDetInf+L1DETINFxspace)+
     &           Q(kDetInf+L1DETINFxlap)
            Q(kCellGeo+L1GEOINFx0) = Q(kDetGeo+L1GEOINFx0)
c
            IQ(kDetInf+L1DETINFMuPlateLF) = 0
            IQ(kDetInf+L1DETINFMuPlateLL) = 0
            IF(UPsection)   THEN
             IQ(kDetInf+L1DETINFMuPlateUF) = iPlateUF ! first&last section
             IQ(kDetInf+L1DETINFMuPlateUL) = iPlateUL ! take UP
             IQ(kDetInf+L1DETINFMuImport1) = 0 ! short chamber
            ELSE
             IQ(kDetInf+L1DETINFMuPlateUF) = iPlateLF ! first&last section
             IQ(kDetInf+L1DETINFMuPlateUL) = iPlateLL ! take DOWN
            ENDIF
            IF(MOD(iMuImport1,10000).GE.MIN(
     &           IQ(kDetInf+L1DETINFMuPlateUF),
     &           IQ(kDetInf+L1DETINFMuPlateUL)).AND.
     &           MOD(iMuImport1,10000).LE.MAX(
     &           IQ(kDetInf+L1DETINFMuPlateUF),
     &           IQ(kDetInf+L1DETINFMuPlateUL))) THEN
             IQ(kDetInf+L1DETINFMuImport1) = iMuImport1
            ELSE
             IQ(kDetInf+L1DETINFMuImport1) = 0
            ENDIF
            IQ(kDetInf+L1DETINFMuImport2) = 0 ! no long chamber
                                ! for MU3&4
            IF ( L1PARprnlev.eq.8 ) THEN
             WRITE(L1LUNprn,1002)
     &            cMuPadNam,
     &            IQ(kDetInf+L1DETINFplate),
     &            isl,1,il1sec,
     &            Q(kDetGeo+L1GEOINFsin_al)/
     &            Q(kDetGeo+L1GEOINFcos_al),
     &            Q(kDetGeo+L1GEOINFz),
     &            Q(kDetGeo+L1GEOINFx0),
     &            Q(kDetGeo+L1GEOINFx0)+Q(kDetGeo+L1GEOINFsx),
     &            Q(kDetGeo+L1GEOINFy0),
     &            Q(kDetGeo+L1GEOINFy0)+Q(kDetGeo+L1GEOINFsy),
     &            Q(kDetInf+L1DETINFxspace),
     &            Q(kDetInf+L1DETINFxlap),
     &            IQ(kDetInf+L1DETINFleftU),
     &            IQ(kDetInf+L1DETINFrightU),
     &            IQ(kDetInf+L1DETINFleftL),
     &            IQ(kDetInf+L1DETINFrightL),
     &            IQ(kDetInf+L1DETINFlast)
             WRITE(L1LUNprn,1098)
     &            IQ(kDetInf+L1DETINFMuPlateUF),
     &            IQ(kDetInf+L1DETINFMuPlateUL),
     &            IQ(kDetInf+L1DETINFMuPlateLF),
     &            IQ(kDetInf+L1DETINFMuPlateLL)
 1098        FORMAT('   upper/low/first/last sections UF:',
     &            I4,' UL:',I4,' LF:',I4,' LL:',I4)
            END IF
           ENDDO                ! up&down
          ENDIF
c
          go  to 778
         ENDIF
        ENDIF
       ENDDO

       PRINT *, 'L1DETIN==> Detector ',c1DetUsed(idet),
     &      ' is not found. STOP!'
       GOTO 999
 778   CONTINUE

       IF(itype.NE.L1DETtypeEC) THEN ! skip ECAL
c
c       Loop to find neighbour sections
c
        DO ilay=1,nlay
         DO il1sec=1,nl1sec
          iLU = 0
          iLL = 0
          iRU = 0
          iRL = 0
          jDetGeo = JDET+nword*((il1sec-1)*nlay+ilay-1)
          jDetInf = jDetGeo+L1GEOINFlen
          Xmin = Q(jDetGeo+L1GEOINFx0)-   ! refer to Y=0
     &         Q(jDetGeo+L1GEOINFy0)*
     &         Q(jDetGeo+L1GEOINFsin_al)/Q(jDetGeo+L1GEOINFcos_al)
          Xmax = Xmin+Q(jDetGeo+L1GEOINFsx)
          Ymin = Q(jDetGeo+L1GEOINFy0)
          Ymax = Q(jDetGeo+L1GEOINFy0)+Q(jDetGeo+L1GEOINFsy)
          DO ksec = 1,nl1sec
           IF(ksec.NE.il1sec)     THEN ! do not compare with itself
            kDetGeo = JDET+nword*((ksec-1)*nlay+ilay-1)
            toly = MIN(Q(jDetGeo+L1GEOINFsy),
     &           Q(kDetGeo+L1GEOINFsy))*0.25
            tolx = MIN(Q(jDetGeo+L1GEOINFsx),
     &           Q(kDetGeo+L1GEOINFsx))*0.25
            IF(ABS(Ymax-Q(kDetGeo+L1GEOINFy0)-
     &           Q(kDetGeo+L1GEOINFsy)).LT.toly)  THEN ! same top
             IF(ABS(Xmax-(Q(kDetGeo+L1GEOINFx0)-
     &            Q(kDetGeo+L1GEOINFy0)*
     &            Q(kDetGeo+L1GEOINFsin_al)/Q(kDetGeo+L1GEOINFcos_al)))
     &            .LT.tolx)          iRU = ksec !right neighbour
             IF(ABS(Xmin-(Q(kDetGeo+L1GEOINFx0)+Q(kDetGeo+L1GEOINFsx)-
     &            Q(kDetGeo+L1GEOINFy0)*
     &            Q(kDetGeo+L1GEOINFsin_al)/Q(kDetGeo+L1GEOINFcos_al)))
     &            .LT.tolx)          iLU = ksec !left neighbour
            ENDIF
            IF(ABS(Ymin-Q(kDetGeo+L1GEOINFy0)).LT.toly)  THEN ! same bottom
             IF(ABS(Xmax-(Q(kDetGeo+L1GEOINFx0)-
     &            Q(kDetGeo+L1GEOINFy0)*
     &            Q(kDetGeo+L1GEOINFsin_al)/Q(kDetGeo+L1GEOINFcos_al)))
     &            .LT.tolx)          iRL = ksec !right neighbour
             IF(ABS(Xmin-(Q(kDetGeo+L1GEOINFx0)+Q(kDetGeo+L1GEOINFsx)-
     &            Q(kDetGeo+L1GEOINFy0)*
     &            Q(kDetGeo+L1GEOINFsin_al)/Q(kDetGeo+L1GEOINFcos_al)))
     &            .LT.tolx)          iLL = ksec !left neighbour
            ENDIF
           ENDIF
          ENDDO
c
c         Fill DetInf with overlap info
c
          IQ(jDetInf+L1DETINFleftU)  = iLU
          IQ(jDetInf+L1DETINFrightU) = iRU
          IQ(jDetInf+L1DETINFleftL)  = iLL
          IQ(jDetInf+L1DETINFrightL) = iRL
          Q(jDetInf+L1DETINFyBound) = 0. ! rudiment
c
          IF ( L1PARprnlev.eq.8)  THEN
           WRITE(L1LUNprn,1002)
     &          CQ(L1JDET+idet),
     &          IQ(jDetInf+L1DETINFplate),isl,ilay,il1sec,
     &          Q(jDetGeo+L1GEOINFsin_al)/Q(jDetGeo+L1GEOINFcos_al),
     &          Q(jDetGeo+L1GEOINFz),
     &          Q(jDetGeo+L1GEOINFx0),
     &          Q(jDetGeo+L1GEOINFx0)+Q(jDetGeo+L1GEOINFsx),
     &          Q(jDetGeo+L1GEOINFy0),
     &          Q(jDetGeo+L1GEOINFy0)+Q(jDetGeo+L1GEOINFsy),
     &          Q(jDetInf+L1DETINFxspace),
     &          Q(jDetInf+L1DETINFxlap),
     &          IQ(jDetInf+L1DETINFleftU),
     &          IQ(jDetInf+L1DETINFrightU),
     &          IQ(jDetInf+L1DETINFleftL),
     &          IQ(jDetInf+L1DETINFrightL),
     &          IQ(jDetInf+L1DETINFlast)
           IF(itype.EQ.L1DETtypeMU)  THEN ! additional muon information
            WRITE(L1LUNprn,1099)
     &           IQ(jDetInf+L1DETINFMuPlateUF),
     &           IQ(jDetInf+L1DETINFMuPlateUL),
     &           IQ(jDetInf+L1DETINFMuPlateLF),
     &           IQ(jDetInf+L1DETINFMuPlateLL)
 1099       FORMAT('   upper/low/first/last sections UF:',
     &           I4,' UL:',I4,' LF:',I4,' LL:',I4)
           END IF
          END IF
c
         ENDDO
        ENDDO
       ENDIF
c
      ENDDO

      l1nDetUsed=l1nDetUsed+iMuAdd

c
      CALL MZPUSH(IXCONS,L1JDET,iMuAdd-L1nPreMuAdd,iMuAdd-L1nPreMuAdd
     $     ,' ')
c
      CALL l1detov(nSLlist,iSLlist,ierr) ! calculate section
                                ! overlap cell numbers
c      CALL l1prnsl
      RETURN
 999  CONTINUE                  ! Stop processing
      STOP ' ****** Stop in L1DETIN ******'
c
 1001 FORMAT(1x,a4,':',i4,3i3,4f6.1,1x,f4.2,':',4f6.1)
 1002 FORMAT(1x,a4,':',i4,3i3,1x,f4.2,f7.1,4f6.1,2f5.2,4i3,i4)
c
      END
