*CMZ :          07/09/96  20.11.41  by  Fedor Ratnikov
*CMZ :  1.01/00 19/12/95  14.41.21  by  Fedor Ratnikov
*CMZ :  1.00/08 22/11/95  19.24.43  by  Fedor Ratnikov
*CMZ :  1.00/05 18/09/95  01.45.00  by  Fedor Ratnikov
*CMZ :  1.00/03 24/08/95  11.21.49  by   Ivan Belyaev
*CMZ :  1.00/00 21/02/95  19.01.04  by  Fedor Ratnikov
*CMZ :  0.01/02 11/09/94  23.39.12  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   12/08/94
************************************************************************
*
* L1MESUP
* written by Dominik Ressing, 12/08/94 19.42.31
*
* This routines action:
* updates message iP. The new ROI and destination processor is calculated.
* If there is foud more then one Connected Processor new messages and
* jobs are created accordingly.
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iPme       in           Pointer to Message
* iTime      in           current time (for new generated mesages)
* ierr       out          error flag set to non-zero if message is inconsistent
*
************************************************************************
c
      SUBROUTINE L1MESUP(iPme,iTime,ierr)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1detdf.fi"
c
      INTEGER iPme,ierr,iTime
c
      LOGICAL L1DETLP
      EXTERNAL L1DETLP
c
      INTEGER iP,iRoi,iPoi,iPcLa,next,nROI,iPoi2,iCon,nCon,job,
     &        New,iCoPo,kSec,nSecs,k,iTFU,nFou,nextsup,
     &        kROI,iPoLa,iCurSup,iPixelFlag,iAlgo,iPrevSup
      REAL    ROI(0:L1ROIlen-1,2),alpla,width,shift,Pnom,ymin,ymax,
     &        Po1(L1GEOINFlen),Pmin,Pmax,z,dz,ROIT(0:L1ROIlen-1)
      INTEGER iGeo,iInf,iCell
      INTEGER iDet(L1DETSPElen),IroiRe,iROIold,iPoiPTextrapolation
      REAL    Geo(L1GEOINFlen), PoPretrigger( L1GEOINFlen ) ,
     &        zNominal,zMIn,zMax,dx,dy,scale,scale1,scale2,x0cog
      INTEGER MaxSplitNumber
      PARAMETER (MaxSplitNumber=9)
      INTEGER iHardEta(MaxSplitNumber),ic,iPo,iPoi1,
     &     nRoisplit,iROIsplit,irowF,irowL,irow,isplit,Nsplit
      REAL ROIsplit(0:L1ROIlen-1,2),OvLap(L1GEOINFlen)
      INTEGER ibaseSL
#include "l1si/l1mesdf.ff"
c
      IF (L1PARprnlev.ge.1 ) THEN
         WRITE(L1LUNprn,998)
 998     FORMAT(1x,'L1MESUP==> BEGIN ',58('+'))
      END IF
c
      ierr = 0
      iP = iPme
c
      iPcLa = L1MEstor(iP+L1MEnextPC)                    ! active processor
      iPoi2 = iP + L1MEpoint(L1MEstor(iP+L1MElast))      ! pointer to new Point
      iRoiRe = L1MEroi(L1MEstor(iP+L1MElast))
      iRoi  = iP + iRoiRe                                ! pointer to next ROI

c
c After muon pretrigger software part contains 2 messages
c But we have to use the oldest one.
c
      IF ((L1MEstor(iP+L1MEprid).eq.L1PREmuon.or.L1MEstor(iP+L1MEprid)
     $     .eq.L1PREpxmuon).and.L1MEstor(iP+L1MElast).eq.1) THEN
            iPoi2 = iP + L1MEpoint(0)
      ENDIF
c
c Setting of pixel flag to process muon pixel pretrigger
c in a special way (see below)
c
      iPixelFlag=0
      IF(L1MEstor(iP+L1MEprid).eq.L1PREpxmuon.and.
     &   L1MEstor(iP+L1MElast).eq.1) THEN
         iPixelFlag=1
      ENDIF
c
      nCon = L1PCstor(iPcLa+L1PCncon) ! number of connected processors to current one
      IF ( nCon.le.0 ) THEN           ! anything connected ??
         WRITE(l1LUNprn,*)
     &     'L1MESUP==> no processor connected!'
         ierr = 2
         GO TO 997
      END IF
      iCurSup = L1MEstor(iPoi2+L1POsup)
c
c  Looking for the next SL
c
      next = L1PCstor(iPcLa+L1PCcons) ! first connected processor
      IF ( L1PCstor(next+L1PCtype).eq.L1PCttfu ) THEN ! is TFU
       iTFU = L1PCstor(next+L1PCnum) ! number of TFU
       NextSup = L1DEFtfudef(L1TFUsup,iTFU) ! super layer number of TFU
      ELSEIF( L1PCstor(next+L1PCtype).eq.L1PCttpm ) THEN ! is TPM
       NextSup = 0
      ELSE
       WRITE(l1LUNprn,*)
     &      'L1MESUP==> incorrect destination processor!'
       ierr = 2
       GO TO 997
      END IF
      IF(L1MEstor(iP+L1MElast).GT.0)   THEN  !not after pretrigger
       iPrevSup =
     &      L1MEstor(iP + L1MEpoint(L1MEstor(iP+L1MElast)-1)+L1POsup)
      ELSE
       iPrevSup = 0
      ENDIF
c
c Choice of kinematics prediction algorythm
c
      IF(iPrevSup.LE.L1DEFsupMU4.AND.iPrevSup.GE.L1DEFsupMU1) THEN  !
                                ! Muon shielders, etc.
       iAlgo = iCurSup*100+(iPrevSup-iCurSup)*10+(iCurSup-NextSup)
      ELSE
       iAlgo = 0  ! no multiple scattering: "standard" algorythm
      ENDIF
c
c
c
      Pnom = T1MEstor(iP+L1MEpren)        ! energy measured by Pretrigger
      Pmin = T1MEstor(iP+L1MEpreth)       ! we required this energy for the pretrigger
c
c For muons cut on momentum from upper side is high (1000GeV)
c
      IF(L1MEstor(iP+L1MEprid).eq.L1PREmuon.or.L1MEstor(iP+L1MEprid).eq
     $     .L1PREpxmuon) THEN
         pnom=1000.
      ENDIF

      IF( L1MEstor( iP + L1MEprid ) .EQ. L1PREpipi ) THEN
        pNom = 1000.0
        pMin = T1DEFmommin
      ENDIF

      Pmax = Pnom*T1DEFepfrac             ! multiply by safety factor

      Pmin = max(Pmin,T1DEFmommin)        ! minimal momentum required
c
      IF( L1MEstor( iP + L1MEprid ) .EQ. L1PREpipi ) THEN
       IF(     iCurSup .EQ. L1DEFsupPTL3 ) THEN
        iPoiPTextrapolation =  iP +
     &         L1MEpoint( L1MEstor( iP + L1MElast ) )
       ELSEIF( iCurSup .EQ. L1DEFsupTC02 ) THEN
        iPoiPTextrapolation =  iP +
     &         L1MEpoint( L1MEstor( iP + L1MElast ) )
       ELSEIF( iCurSup .EQ. L1DEFsupTC01 ) THEN
        iPoiPTextrapolation =  iP +
     &         L1MEpoint( L1MEstor( iP + L1MElast ) - 1 )
       ELSEIF( iCurSup .EQ. L1DEFsupPC04 ) THEN
        iPoiPTextrapolation =  iP +
     &         L1MEpoint( L1MEstor( iP + L1MElast ) - 2 )
       ELSEIF( iCurSup .EQ. L1DEFsupPC01 ) THEN
        iPoiPTextrapolation =  iP +
     &         L1MEpoint( L1MEstor( iP + L1MElast ) - 3 )
       ELSE
        WRITE(*,*)'L1MESUP==> Error in High PT part...'
       ENDIF
      ENDIF
c
c Muon pixel pretrigger should be treated in a different way in MXD4
c superlayer only. After that we switch to standard L1PREmuon definition
c (iCurSup=8 means we have processed MXD4)
c
      IF( iCurSup .EQ. L1DEFsupMU4 .AND.
     +    L1MEstor(iP+L1MEprid) .EQ. L1PREpxmuon )THEN
          L1MEstor(iP+L1MEprid) = L1PREmuon
      ENDIF


c
      IF( NextSup.gt.0 )THEN
          z = T1DETzSup(NextSup)     ! minimal z of all detectors in next SL
      ELSE
          z = T1DETmagz              ! magnet center (for TPM)
      END IF
c
c
      IF ( L1PARprnlev.ge.2 ) THEN
         WRITE(L1LUNprn,800) iP,Pmin,Pmax,z,NextSup
 800     FORMAT(1x,'L1MESUP==> message ',i4,',',f6.0,'<P<',f6.0,
     &             ' extrapolate to z=',f6.0,' SL ',i3)
      END IF
c
c     --- fill alpha bounds from last point to this
      IF ( L1MEstor(iP+L1MElast).eq.0 ) THEN ! first Point (in Pretrigger) ??
         T1MEstor(iP+L1POlALmax) = -99. ! initialixze
         T1MEstor(iP+L1POlALmin) =  99. !
         T1MEstor(iP+L1POlcogFactorX) = 0. ! initialixze
         T1MEstor(iP+L1POlcogFactorY) = 0. !
      END IF
c
c     --- in front of ECAL y,sy are determined by the ROI for the actual point
      IF( NextSup .LT. L1DEFsupTC02 )THEN
         iROIold = iP + L1MEroi(L1MEstor(iP+L1MElast)-1) + L1ROIreg ! last searched ROI
         scale = T1Mestor(iPoi2+L1POreg+L1GEOINFz)/                  ! y is projective
     &           T1MEstor(iROIold+L1GEOINFz)
         ymin = MAX(T1Mestor(iPoi2+L1POreg+L1GEOINFy0),  !Overlap ROI&reg
     &        T1MEstor(iROIold+L1GEOINFy0)*scale)
         ymax = MIN(T1Mestor(iPoi2+L1POreg+L1GEOINFy0)+
     &        T1Mestor(iPoi2+L1POreg+L1GEOINFsy),
     &        T1MEstor(iROIold+L1GEOINFy0)*scale+
     &        T1MEstor(iROIold+L1GEOINFsy)*scale)
         IF ( L1PARprnlev.ge.2 ) THEN
            WRITE(L1LUNprn,805)
     &           T1MEstor(iPoi2+L1POreg+L1GEOINFy0),
     &           T1MEstor(iPoi2+L1POreg+L1GEOINFsy),
     &           T1MEstor(iROIold+L1GEOINFy0)*scale,
     &           T1MEstor(iROIold+L1GEOINFsy)*scale,
     &           ymin,ymax-ymin,
     &           T1MEstor(iPoi2+L1POreg+L1GEOINFz)
 805        FORMAT(1x,'L1MESUP==>Found reg/Old ROI/Effective (y0,sy)',
     &           /10x,3(f9.2,':',f7.2),'  z=',f10.2)
         END IF
         IF(ymin.LT.ymax)    THEN
            T1Mestor(iPoi2+L1POreg+L1GEOINFy0) =  ymin ! fill y in point
            T1Mestor(iPoi2+L1POreg+L1GEOINFsy) =  ymax-ymin !
         ELSE                   ! reg&ROI do not intersect
            ierr = 1
            GOTO 997     ! exit
         ENDIF
      END IF
c
c     --- set fraction of needed CenterOfGravity (cog) region for e+,e-
      IF( NextSup .LT. L1DEFsupTC02 )THEN
      IF( L1MEstor(iP+L1MEprid).eq.L1PREelec ) THEN
c        --- check X-size only for SL3..SL1:
         IF( NextSup .LE. L1DEFsupPC04 )THEN
             IF( NextSup .EQ. L1DEFsupPC04 )
     +           T1MEstor(iP+L1POlcogFactorX)=-4. ! initialize
c        --- Use planes: COG, SL4, current
         width = T1MEstor(iP+L1POlcog+L1GEOINFsx)/2. ! width of cog/2
         x0cog = T1MEstor(iP+L1POlcog+L1GEOINFx0)+width
         scale1 = (T1MEstor(iP+L1POlcog+L1GEOINFz)-
     &               T1Mestor(iPoi2+L1POreg+L1GEOINFz))/
     &            (T1MEstor(iP+L1MEpoint(1)+L1POreg+L1GEOINFz)-
     &               T1Mestor(iPoi2+L1POreg+L1GEOINFz))
         scale2 = (T1MEstor(iP+L1POlcog+L1GEOINFz)-
     &               T1MEstor(iP+L1MEpoint(1)+L1POreg+L1GEOINFz))/
     &            (T1MEstor(iP+L1MEpoint(1)+L1POreg+L1GEOINFz)-
     &               T1Mestor(iPoi2+L1POreg+L1GEOINFz))
         dx = T1MEstor(iP+L1MEpoint(1)+L1POreg+L1GEOINFx0)*scale1- ! space free to left of point
     &        (T1Mestor(iPoi2+L1POreg+L1GEOINFx0)+
     &             T1Mestor(iPoi2+L1POreg+L1GEOINFsx))*scale2-x0cog
c            IF ( dx.gt.0. ) THEN                         ! some size needed
               T1MEstor(iP+L1POlcogFactorX) =
     &              MAX(dx/width,T1MEstor(iP+L1POlcogFactorX))
c            ENDIF
         dx = (T1MEstor(iP+L1MEpoint(1)+L1POreg+L1GEOINFx0)+
     &           T1MEstor(iP+L1MEpoint(1)+L1POreg+L1GEOINFsx)) *scale1- ! space free to right of point
     &        T1Mestor(iPoi2+L1POreg+L1GEOINFx0)*scale2-x0cog
c            IF ( dx.lt.0. ) THEN                         ! some size needed
               T1MEstor(iP+L1POlcogFactorX) =
     &              MAX(-dx/width,T1MEstor(iP+L1POlcogFactorX))
c            ENDIF
         ENDIF
c
c        --- check Y-size only for SL4...SL1:
         IF( NextSup .EQ. L1DEFsupTC01 )
     +       T1MEstor(iP+L1POlcogFactorY)=-4.              ! initialize
         width = T1MEstor(iP+L1POlcog+L1GEOINFsy)/2.         ! height of cog/2
         shift = T1MEstor(iP+L1POlcog+L1GEOINFy0)+width      ! center of cog
         scale = T1Mestor(iPoi2+L1POreg+L1GEOINFz)/          ! y is projective
     &           T1MEstor(iP+L1POlcog+L1GEOINFz)
         shift = shift * scale
         width = width * scale
         dy = T1Mestor(iPoi2+L1POreg+L1GEOINFy0)-shift       ! space needed above
c         IF ( dy.gt.0. ) THEN   ! some size needed
            T1MEstor(iP+L1POlcogFactorY) =
     &           MAX(dy/width,T1MEstor(iP+L1POlcogFactorY))
c         END IF
         dy = shift-(T1Mestor(iPoi2+L1POreg+L1GEOINFy0)+     ! space needed below
     &                 T1Mestor(iPoi2+L1POreg+L1GEOINFsy))
c         IF ( dy.gt.0. ) THEN   ! some size needed
            T1MEstor(iP+L1POlcogFactorY) =
     &           MAX(dy/width,T1MEstor(iP+L1POlcogFactorY))
c            if ( dy.gt.width )
c         END IF
         END IF
      END IF
c
      IF ( L1MEstor(iP+L1MElast).eq.0.or.
     &     ((L1MEstor(iP+L1MEprid).eq.L1PREmuon.or.L1MEstor(iP+L1MEprid) ! first Point (in Pretrigger) ??
     $     .eq.L1PREpxmuon).and.L1MEstor(iP+L1MElast).eq.1)) THEN
         IF ( L1MEstor(iP+L1MEprid).eq.L1PREmuon.or.       ! for muon pretrigger
     &        L1MEstor(iP+L1MEprid).eq.L1PREpxmuon ) THEN  ! we take the
                                                           ! oldest
                                                           ! message
         nROI=1
c            iPoi = iP + L1MEpoint(0)
         ROI(L1ROIreg+L1GEOINFx0,1) = T1MEstor(iPoi2+L1POreg+L1GEOINFx0)
         ROI(L1ROIreg+L1GEOINFsx,1) = T1MEstor(iPoi2+L1POreg+L1GEOINFsx)
         ROI(L1ROIreg+L1GEOINFy0,1) = T1MEstor(iPoi2+L1POreg+L1GEOINFy0)
         ROI(L1ROIreg+L1GEOINFsy,1) = T1MEstor(iPoi2+L1POreg+L1GEOINFsy)
         ROI(L1ROIreg+L1GEOINFz,1 ) = T1MEstor(iPoi2+L1POreg+L1GEOINFz)
         ROI(L1ROIdxdz,1) = 0.
         ROI(L1ROIdydz,1) = 0.
      ELSEIF( L1MEstor( iP + L1MEprid ) .EQ. L1PREpipi ) THEN ! Dr.P.Pakhlov PreTrigger
       PoPretrigger( L1GEOINFx0 ) =
     &  T1MEstor( iP + L1MEpreXpt ) - T1MEstor( iP + L1MEpreDXpt )
       PoPretrigger( L1GEOINFsx ) =
     &  T1MEstor( iP + L1MEpreDXpt ) * 2.0
       PoPretrigger( L1GEOINFz  ) =
     &  T1MEstor( iP + L1MEpreZpt  )
       PoPretrigger( L1GEOINFy0 ) =
     &  T1MEstor( iPoiPTextrapolation  +
     &  L1POreg + L1GEOINFy0 ) *
     &  ( PoPretrigger( L1GEOINFz ) + 2.5 ) /
     &  ( T1MEstor( iPoiPTextrapolation +
     &  L1POreg + L1GEOINFz  ) + 2.5 )
       PoPretrigger( L1GEOINFsy ) =
     &  T1MEstor( iPoiPTextrapolation  +
     &  L1POreg + L1GEOINFsy ) *
     &  ( PoPretrigger( L1GEOINFz ) + 2.5 ) /
     &  ( T1MEstor( iPoiPTextrapolation +
     &  L1POreg + L1GEOINFz  ) + 2.5 )
       CALL l1kine1( PoPretrigger ,
     &  T1Mestor( iPoiPTextrapolation + L1POreg + 1 ) ,
     &  Pmin , Pmax , z ,                 ! get new ROI
     &  nROI , ROI( 0 , 1 ) , ROI( 0 , 2 ) )
      ELSE
         Po1(L1GEOINFz) = -1.                              ! Point1 is invalid
         CALL l1kinex(iAlgo,Po1,T1Mestor(iPoi2+L1POreg+1),
     &        Pnom,Pmin,Pmax,z,  ! get new ROI
     &        nROI,ROI(0,1),ROI(0,2))
      ENDIF
         IF ( L1PARprnlev.ge.2 ) THEN
            WRITE(L1LUNprn,810) T1MEstor(iPoi2+L1POreg+L1GEOINFx0),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFsx),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFy0),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFsy),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFz)
 810        FORMAT(1x,'L1MESUP==> 1 point x,sx,y,sy,z:',5f8.2)
         END IF
      ELSE
c        --- second point is last or SL4 (in front of ECAL)

       do ibaseSL = L1MEstor(iP+L1MElast)-1,0,-1
        if (L1MEstor(iP+L1MEpoint(ibaseSL)+L1POsup).ge.L1DEFsupTC02)
     &       goto 100
       enddo
 100   continue
       iPoi = iP+L1MEpoint(ibaseSL)


c         IF( NextSup .LT. L1DEFsupTC01 )THEN         ! in front of ECAL ??
c            iPoi  = iP + L1MEpoint(L1MEstor(iP+L1MElast)-
c     &           L1DEFsupTC02+NextSup+1)     ! pointer to SL4
c         ELSE
c            iPoi  = iP + L1MEpoint(L1MEstor(iP+L1MElast)-1) ! pointer to last point
c         END IF


         IF( NextSup .EQ. L1DEFsupMU3 .AND. ! prediction to
     &        L1MESTOR(iP+L1MEprid) .EQ. L1PREmuon )THEN ! MU3
          iPoi = iP + L1MEpoint(1)
          nROI=1
          ROI(L1ROIreg+L1GEOINFx0,1) = T1MEstor(iPoi+L1POreg+L1GEOINFx0)
          ROI(L1ROIreg+L1GEOINFsx,1) = T1MEstor(iPoi+L1POreg+L1GEOINFsx)
          ROI(L1ROIreg+L1GEOINFy0,1) = T1MEstor(iPoi+L1POreg+L1GEOINFy0)
          ROI(L1ROIreg+L1GEOINFsy,1) = T1MEstor(iPoi+L1POreg+L1GEOINFsy)
          ROI(L1ROIreg+L1GEOINFz,1 ) = T1MEstor(iPoi+L1POreg+L1GEOINFz)
          ROI(L1ROIdxdz,1) = 0.
          ROI(L1ROIdydz,1) = 0.
         ELSEIF( NextSup. LT. L1DEFsupTC02 .AND.
     &    L1MEstor( iP + L1MEprid ) .EQ. L1PREpipi ) THEN ! Dr.P.Pakhlov Trigger
          PoPretrigger( L1GEOINFx0 ) =
     &     T1MEstor( iP + L1MEpreXpt ) - T1MEstor( iP + L1MEpreDXpt )
          PoPretrigger( L1GEOINFsx ) =
     &     T1MEstor( iP + L1MEpreDXpt ) * 2.0
          PoPretrigger( L1GEOINFz  ) =
     &     T1MEstor( iP + L1MEpreZpt  )
          PoPretrigger( L1GEOINFy0 ) =
     &     T1MEstor( iPoiPTextrapolation +
     &     L1POreg + L1GEOINFy0 ) *
     &     ( PoPretrigger( L1GEOINFz ) + 2.5 ) /
     &     ( T1MEstor( iPoiPTextrapolation +
     &     L1POreg + L1GEOINFz  ) + 2.5 )
          PoPretrigger( L1GEOINFsy ) =
     &     T1MEstor( iPoiPTextrapolation +
     &     L1POreg + L1GEOINFsy ) *
     &     ( PoPretrigger( L1GEOINFz ) + 2.5 )       /
     &     ( T1MEstor( iPoiPTextrapolation +
     &     L1POreg + L1GEOINFz  ) + 2.5 )
          IF(     NextSup .EQ. L1DEFsupTC01 ) THEN
           CALL l1kine1( PoPretrigger ,
     &     T1Mestor( iPoiPTextrapolation + L1POreg + 1 ) ,
     &     Pmin , Pmax , z ,           ! get new ROI
     &     nROI , ROI( 0 , 1 ) , ROI( 0 , 2 ) )
           ROI( L1ROIreg + L1GEOINFsin_al , 1 ) = 0.0
           ROI( L1ROIreg + L1GEOINFsin_al , 2 ) = 0.0
           ROI( L1ROIreg + L1GEOINFcos_al , 1 ) = 1.0
           ROI( L1ROIreg + L1GEOINFcos_al , 2 ) = 1.0
           IF ( L1PARprnlev.ge.2 ) THEN
            WRITE(L1LUNprn,820)
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFx0 ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFsx ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFy0 ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFsy ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFz  ) ,
     &       PoPretrigger( L1GEOINFx0 ) ,
     &       PoPretrigger( L1GEOINFsx ) ,
     &       PoPretrigger( L1GEOINFy0 ) ,
     &       PoPretrigger( L1GEOINFsy ) ,
     &       PoPretrigger( L1GEOINFz  )
           ENDIF
          ELSEIF( NextSup .EQ. L1DEFsupPC04
     &     .OR.   NextSup .EQ. L1DEFsupPC01 ) THEN
           CALL l1kine1( PoPretrigger ,
     &     T1Mestor( iPoiPTextrapolation + L1POreg + 1 ) ,
     &     Pmin , Pmax , z ,           ! get new ROI
     &     nROI , ROI( 0 , 1 ) , ROI( 0 , 2 ) )
           ROI( L1ROIreg + L1GEOINFsin_al , 1 ) = 0.0
           ROI( L1ROIreg + L1GEOINFsin_al , 2 ) = 0.0
           ROI( L1ROIreg + L1GEOINFcos_al , 1 ) = 1.0
           ROI( L1ROIreg + L1GEOINFcos_al , 2 ) = 1.0
           IF ( L1PARprnlev.ge.2 ) THEN
            WRITE(L1LUNprn,820)
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFx0 ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFsx ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFy0 ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFsy ) ,
     &       T1MEstor( iPoiPTextrapolation
     &         + L1POreg + L1GEOINFz  ) ,
     &       PoPretrigger( L1GEOINFx0 ) ,
     &       PoPretrigger( L1GEOINFsx ) ,
     &       PoPretrigger( L1GEOINFy0 ) ,
     &       PoPretrigger( L1GEOINFsy ) ,
     &       PoPretrigger( L1GEOINFz  )
           ENDIF
          ELSE
           CALL l1kinex(iAlgo, T1Mestor( iPoiPTextrapolation +
     &      L1POreg + 1 ) ,
     &      T1Mestor( iPoi2 + L1POreg + 1 ) ,
     &      Pnom, Pmin , Pmax , z , nROI ,
     &      ROI( 0 , 1 ) , ROI( 0 , 2 ) )
           IF ( L1PARprnlev.ge.2 ) THEN
            WRITE(L1LUNprn,820)
     &       T1MEstor( iPoiPTextrapolation  +
     &                         L1POreg + L1GEOINFx0 ) ,
     &       T1MEstor( iPoiPTextrapolation  +
     &                         L1POreg + L1GEOINFsx ) ,
     &       T1MEstor( iPoiPTextrapolation  +
     &                         L1POreg + L1GEOINFy0 ) ,
     &       T1MEstor( iPoiPTextrapolation  +
     &                         L1POreg + L1GEOINFsy ) ,
     &       T1MEstor( iPoiPTextrapolation  +
     &                         L1POreg + L1GEOINFz  ) ,
     &       T1MEstor( iPoi2 + L1POreg + L1GEOINFx0 ) ,
     &       T1MEstor( iPoi2 + L1POreg + L1GEOINFsx ) ,
     &       T1MEstor( iPoi2 + L1POreg + L1GEOINFy0 ) ,
     &       T1MEstor( iPoi2 + L1POreg + L1GEOINFsy ) ,
     &       T1MEstor( iPoi2 + L1POreg + L1GEOINFz  )
           ENDIF
          ENDIF

          IF(  ROI( L1ROIreg + L1GEOINFsx , 1 )
     &     .GT. 1.00  ) THEN
           ROI(  L1ROIreg + L1GEOINFx0 , 1 ) =
     &      ROI( L1ROIreg + L1GEOINFx0 , 1 ) -
     &      ROI( L1ROIreg + L1GEOINFsx , 1 ) * 0.05
           ROI(  L1ROIreg + L1GEOINFsx , 1 ) =
     &      ROI( L1ROIreg + L1GEOINFsx , 1 ) * 1.10
          ELSE
           ROI(  L1ROIreg + L1GEOINFx0 , 1 ) =
     &      ROI( L1ROIreg + L1GEOINFx0 , 1 ) -
     &      ROI( L1ROIreg + L1GEOINFsx , 1 ) * 0.15
           ROI(  L1ROIreg + L1GEOINFsx , 1 ) =
     &      ROI( L1ROIreg + L1GEOINFsx , 1 ) * 1.30
          ENDIF
         ELSE
          CALL l1kinex(iAlgo,T1Mestor(iPoi+L1POreg+1),
     &         T1Mestor(iPoi2+L1POreg+1),Pnom,Pmin,Pmax,z,
     &         nROI,ROI(0,1),ROI(0,2))
         ENDIF
         IF ( L1PARprnlev.ge.2 .and.
     &    L1MEstor( iP + L1MEprid ) .NE. L1PREpipi ) THEN ! already done for Dr.P.Pakhlov Trigger
            WRITE(L1LUNprn,820) T1MEstor(iPoi+L1POreg+L1GEOINFx0),
     &                          T1MEstor(iPoi+L1POreg+L1GEOINFsx),
     &                          T1MEstor(iPoi+L1POreg+L1GEOINFy0),
     &                          T1MEstor(iPoi+L1POreg+L1GEOINFsy),
     &                          T1MEstor(iPoi+L1POreg+L1GEOINFz),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFx0),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFsx),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFy0),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFsy),
     &                          T1MEstor(iPoi2+L1POreg+L1GEOINFz)
 820        FORMAT(1x,'L1MESUP==> 2 point x,sx,y,sy,z:',5f8.2/
     &             1x,'                               ',5f8.2)
         END IF
      END IF
c
      IF ( L1PARprnlev.ge.2 ) THEN
         IF ( nROI.gt.0 ) THEN
            WRITE(L1LUNprn,830) nROI,
     &         ROI(L1ROIreg+L1GEOINFx0,1),
     &         ROI(L1ROIreg+L1GEOINFsx,1),
     &         ROI(L1ROIreg+L1GEOINFy0,1),
     &         ROI(L1ROIreg+L1GEOINFsy,1),
     &         ROI(L1ROIreg+L1GEOINFz,1)
            IF ( nROI.eq.2 )
     &         WRITE(L1LUNprn,840)
     &         ROI(L1ROIreg+L1GEOINFx0,2),
     &         ROI(L1ROIreg+L1GEOINFsx,2),
     &         ROI(L1ROIreg+L1GEOINFy0,2),
     &         ROI(L1ROIreg+L1GEOINFsy,2),
     &         ROI(L1ROIreg+L1GEOINFz,2)
            CALL l1prtpo(L1MEstor(iPoi2+L1POtrk0),   ! print track point ar ROI z
     &                   L1MEstor(iPoi2+L1POtrkp),
     &                   L1MEstor(iPoi2+L1POtrkn),
     &                   ROI(L1ROIreg+L1GEOINFz,1))
         ELSE
            WRITE(L1LUNprn,*) 'L1MESUP==> no ROI found'
         END IF
 830     FORMAT(1x,'L1MESUP==> ',I1,' ROI''s ROIs:x,sx,y,sy,z:',5f8.2)
 840     FORMAT(1x,'                                    ',5f8.2)
      END IF
c
      nFou = 0               ! no processor to send ROI to found so far
      IF ( nROI.eq.0 ) THEN  ! no ROI found ?? -> error exit
         ierr = 1
         GO TO 997
      END IF
c
      L1MEstor(iP+L1MEnextPC) = 0                        ! no PC found so far
c
c     Find Processors to send message(s) to
c
c
c     --- loop over found ROI
      DO kROI = 1,nROI
c
c     --- ROI region has alpha = 0.
      ROI(L1ROIreg+L1GEOINFsin_al,kROI) = 0.
      ROI(L1ROIreg+L1GEOINFcos_al,kROI) = 1.
c
      DO iCon = 0,nCon-1
         next = L1PCstor(iPcLa+L1PCcons+iCon)            ! connected processor
         IF ( L1PCstor(next+L1PCtype).eq.L1PCttfu ) THEN ! is TFU
            iTFU = L1PCstor(next+L1PCnum)                ! number of TFU
            iDet(L1DETSPElayer) = L1DEFtfudef(L1TFUlaz,iTFU) ! axial layer of TFU
            nSecs = L1DEFtfudef(L1TFUnsec,iTFU)          ! number of connected sections
            DO kSec=1,nSecs                              ! loop over sections of TFU
               iCoPo = L1DETCONdetpo(kSec,iTFU)          ! pointer into connections
               iDet(L1DETSPEdet)     = L1DETCONstor(iCoPo+L1DETCONdet)
               iDet(L1DETSPEsection) = L1DETCONstor(iCoPo+L1DETCONsec)
c              --- obtain detector outline and restrict to range covered by TFU
               CALL l1detif(iDet,iGeo,iInf,iCell)
               IF ( iGeo.le.0 ) THEN
                  WRITE(L1LUNprn,*) 'L1MESUP ==> invlaid detector'
     $                 ,iDet(L1DETSPEdet),iDet(L1DETSPElayer)
     $                 ,iDet(L1DETSPEsection)
                  ierr = 2  ! fatal error
                  GO TO 997
               END IF
               CALL UCOPY(Q(iGEO+1),Geo(1),L1GEOINFlen)   ! copy detector geometry
c
c For muon pixel pretrigger in MX4 we have to take sections middle of which
c is on the same side of Y as the middle of ROI only
c
               IF(iPixelFlag.gt.0) THEN
                  IF((Geo(L1GEOINFy0)+Geo(L1GEOINFsy)/2.)*
     &                 (ROI(L1ROIreg+L1GEOINFy0,kROI)+ROI(L1ROIreg
     $                 +L1GEOINFsy,kROI)).lt.0) THEN
                     GO TO 555 ! jump out from loop over sections
                               ! belonging to current processor
                  ENDIF
               ENDIF
               Geo(L1GEOINFx0) = T1DETCONstor(iCoPo+L1DETCONx0)
               Geo(L1GEOINFsx) = T1DETCONstor(iCoPo+L1DETCONxs)
c              --- nominal z and z bounds for this detector plane:
               zNominal        = T1DETCONstor(iCoPo+L1DETCONz0)
               zMin            = T1DETCONstor(iCoPo+L1DETCONzF)
               zMax            = T1DETCONstor(iCoPo+L1DETCONzL)
c
c              ------- calculate ROI at z of actual detector:
               CALL UCOPY(ROI(0,kROI),ROIT(0),L1ROIlen)  ! copy ROI parameters
               dz = zMin-ROIT(L1ROIreg+L1GEOINFz)        ! distance to detector lower z
               ROIT(L1ROIreg+L1GEOINFx0) =               ! shift ROI x accordingly
     &              ROIT(L1ROIreg+L1GEOINFx0) +
     &              dz*ROIT(L1ROIdxdz)
c
               dz = zMax-zMin              ! z-length of detector
               dx = dz*ROIT(L1ROIdxdz)     ! enlarge x-ROI according to z-length of det.
               IF ( dx.lt.0. ) THEN        ! add enlargement on correct side of ROI
                  ROIT(L1ROIreg+L1GEOINFx0) =
     &                 ROIT(L1ROIreg+L1GEOINFx0) + dx
               END IF
               ROIT(L1ROIreg+L1GEOINFsx) =
     &              ROIT(L1ROIreg+L1GEOINFsx) + ABS(dx)
c
               dz = zNominal - ROIT(L1ROIreg+L1GEOINFz)     ! dist. to nominal z-plane
               ROIT(L1ROIreg+L1GEOINFy0) =                  ! shift y-ROI to nnom. z
     &              ROIT(L1ROIreg+L1GEOINFy0) +
     &              dz*ROIT(L1ROIdydz)
               ROIT(L1ROIreg+L1GEOINFz) = zNominal
c
c              --- does ROI overlap detector ??
               IF ( L1DETLP(Geo,ROIT(L1ROIreg+1)) ) THEN
c
                IF(iCurSup.EQ.L1DEFsupMXPRE.OR.
     &               iCurSup.EQ.L1DEFsupMUPRE)   THEN
c          Muon pretrigger may  be splitted in   Y
                 Nsplit = 0  ! nothing found yet
c
c                Look for destination in MU1
c
                 DO iTFU=1,L1DEFmaxtfu !  Look fot TFU serving MU1
                  IF(L1DEFTFUdef(L1TFUsup,iTFU).EQ.L1DEFsupMU1) THEN !found MU1
                   iDet(L1DETSPEdet) = L1DEFTFUdef(L1TFUdetsl,iTFU)
                   DO ic = 1,L1DEFTFUdef(L1TFUnsec,iTFU)  ! connections
                                                       ! served
                    iPo = L1DETCONdetpo(ic,iTFU) ! get pointer to
                                                   ! range info
                    iDet(L1DETSPEsection)=L1DETCONstor(iPo+L1DETCONsec)
                    iDet(L1DETSPElayer) = 1 !consider first layer
                    CALL l1detif(iDet,iGeo,iInf,iCell)
                    IF(IQ(iInf+L1DETINFwirepad).GT.1)  THEN ! pad
                                                            ! chamber
                     z = Q(iGeo+L1GEOINFz)  ! z of detector
c                     print *,' ncon/icon/zdet:',
c     &                    L1DEFTFUdef(L1TFUnsec,iTFU),ic,z
                     iAlgo = 1 ! extrapolation from MU3 to MU1
                     iPoi1 = iPme+L1MEpoint(0)+L1POreg ! pad in MU4
                     iPoi2 = iPme+L1MEpoint(1)+L1POreg ! pad in MU3
                     CALL l1kinex(iAlgo,T1MEstor(iPoi1+1),
     &                    T1MEstor(iPoi2+1),Pnom,Pmin,Pmax,z,
     &                    nROIsplit,ROIsplit(0,1),ROIsplit(0,2))
c                     print *, 'nroisplit:',nROIsplit
                     DO iROIsplit=1,nROIsplit ! over ROI found (1)
c                      print *,'looking for overlap:'
c                      print *,'det x/dx/y/dy/:',
c     &                      Q(iGeo+L1GEOINFx0),Q(iGeo+L1GEOINFsx),
c     &                      Q(iGeo+L1GEOINFy0),Q(iGeo+L1GEOINFsy)
c                      print *,'ROI x/dx/y/dy/:',
c     &                     ROIsplit(L1ROIreg+L1GEOINFx0,iROIsplit),
c     &                     ROIsplit(L1ROIreg+L1GEOINFsx,iROIsplit),
c     &                     ROIsplit(L1ROIreg+L1GEOINFy0,iROIsplit),
c     &                     ROIsplit(L1ROIreg+L1GEOINFsy,iROIsplit)
                      CALL l1geo2s(ROIsplit(L1ROIreg+1,iROIsplit),
     &                     Q(iGeo+1),OvLap(1)) ! ROI & det overlap
                      IF(OvLap(L1GEOINFsx).GT.0.)  THEN ! Overlap found
c                       print *,' overlap found x/xs/y/sy:',
c     &                      OvLap(L1GEOINFx0),OvLap(L1GEOINFsx),
c     &                      OvLap(L1GEOINFy0),OvLap(L1GEOINFsy)
                       irowF = (OvLap(L1GEOINFy0)-Q(iGeo+L1GEOINFy0))/
     &                      Q(iCell+L1GEOINFsy)+1 ! first row accepted
                       irowL = (OvLap(L1GEOINFy0)+OvLap(L1GEOINFsy)-
     &                      0.001-Q(iGeo+L1GEOINFy0))/
     &                      Q(iCell+L1GEOINFsy)+1 ! last row accepted
                       Nsplit = (irowL-irowF)/3+1 ! 3 row/message
                       IF(Nsplit.GT.MaxSplitNumber) THEN ! too many...
                        WRITE (L1LUNprn,*)
     &                       'L1MESUP==> too many splitted messages'
                        Nsplit = MaxSplitNumber
                       ENDIF
                       IF ( L1PARprnlev.ge.2 )  THEN
                        print *,
     &                       ' L1MESUP=> split message for MX1:',
     &                       ' First/Last/#:',
     &                       irowF,irowL,Nsplit
                       ENDIF
                       irow = irowF
                       DO isplit=1,Nsplit
c
c                       save information in HARD message part for ETA
c
                        iHardEta(isplit) = isplit*100+irow
c                        print *, 'ihardeta:',isplit,iHardEta(isplit)
                        irow = irow+3
                       ENDDO    !isplit
                      ENDIF     ! overlap found
                     ENDDO      ! over ROI found
                     IF(Nsplit.GT.0) GOTO 444   ! only one splitting is needed
                    ENDIF       ! pad chamber
                   ENDDO        ! over connections
                  ENDIF         ! MU1 SL
                 ENDDO          ! over all TFUs
c  we come here means no intersections with MX1. Store nothing in HardEta
                 Nsplit = 1
                 iHardEta(1) = 0 ! no reasonable information so far
                ELSE            ! not in MU pretrigger
                Nsplit = 1
                iHardEta(1) = 0 ! no reasonable information so far
                ENDIF
 444            CONTINUE
c
                DO isplit = 1,Nsplit
                 nFou = nFou + 1 ! increment number of found Cons
                 IF ( L1PARprnlev.ge.2 ) WRITE(L1LUNprn,860) nFou,next
c
                 IF ( nFou.gt.1 ) THEN ! message already used ??
                  CALL l1mesdp(iP,New) ! duplicate message
                  IF (New.gt.0) THEN ! success ??
                   iP      = New ! recalculate pointers
                   iRoi    = iP + iRoiRe
                   CALL l1jobsb(iP,iTime,job) ! submitt new job
                   IF ( job.le.0 ) THEN
                    CALL L1MESDE(iP,L1MEDEnousr)
                    nFou = nFou - 1
                    ierr = 2
                    GO TO 997
                   END IF
                  ELSE
                   WRITE (L1LUNprn,*)
     &                  'L1MESUP==> message storage exceeded'
                   ierr = 2
                   GO TO 997
                  END IF
                  L1MEstor(iP+L1MEcreated) = L1MEstor(iP+L1MElast) ! created here
                 END IF
c                 --- store ROI for actual detector in current message
                  CALL UCOPY(ROIT(0),T1MEstor(iRoi),L1ROIlen)
                  L1MEstor(iP+L1MEnextPC) = next ! store PC num
                  L1MEstor(iRoi+L1ROIprc) = next ! fill also in ROI
                  IF(iCurSup.NE.L1DEFsupMU4.AND.   ! No eta changes in MU3&MU4
     &                 iCurSup.NE.L1DEFsupMU3)  THEN
                   L1MEstor(iP+L1HAteta) = iHardEta(isplit) ! fill eta information
                  ENDIF
                 ENDDO
                 GO TO 555      ! send only once for each TFU
                END IF
               END DO           ! end of section loop
 555        CONTINUE
           ELSE IF( L1PCstor(next+L1PCtype).eq.L1PCttpm ) THEN ! connected to TPM ??
            nFou = nFou + 1                     ! increment number of found Cons
            IF ( L1PARprnlev.ge.2 ) WRITE(L1LUNprn,860) nFou,next
            IF ( nFou.gt.1 ) THEN               ! message already used ??
               CALL l1mesdp(iP,New)             ! duplicate message
               IF (New.gt.0) THEN               ! success ??
                  iP      = New                 ! maintain pointers
                  iRoi    = iP + iRoiRe
                  CALL l1jobsb(iP,iTime,job)    ! submitt new job
                  IF ( job.le.0 ) THEN
                     CALL L1MESDE(iP,L1MEDEnousr)
                     nFou = nFou - 1
                     ierr = 2
                     GO TO 997
                  END IF
               ELSE
                  WRITE (L1LUNprn,*)
     &                 'L1MESUP==> message storage exceeded'
                  ierr = 2
                  GO TO 997
               END IF
               L1MEstor(iP+L1MEcreated) = L1MEstor(iP+L1MElast) ! mess. was created here
            END IF
c           --- store ROI in current message
            CALL UCOPY(ROI(0,kROI),T1MEstor(iRoi),L1ROIlen)
            L1MEstor(iP+L1MEnextPC) = next      ! store PC num
            L1MEstor(iRoi+L1ROIprc) = next      ! fill also in ROI
         ELSE
            WRITE(l1LUNprn,*)
     &           'L1MESUP ==>no valid processor connected!'
            ierr = 2
            GO TO 997
         END IF
      END DO
c
      IF ( L1MEstor(iP+L1MEnextPC).eq.0 ) ierr = 1     ! no processor found for ROI
c
      END DO                    ! end of ROI loop
c
 997  CONTINUE
c
      IF ( ierr.eq.1 .and. nFou.ge.1 ) ierr = 0  ! clear ``not-found'' for many found
c
      IF (L1PARprnlev.ge.1 ) THEN
         WRITE(L1LUNprn,999)
 999     FORMAT(1x,'L1MESUP==> END ',60('+'))
      END IF
c
      RETURN
 860  FORMAT(1x,'L1MESUP==> ',i2,'''s found! PRC pointer :',i5)
c
      END
