*CMZ :  2.01/01 29/11/95  11.23.42  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE LIUNIT (LUN, CTPL)

************************************************************************
*
* Description: Print information on logical unit number LUN.
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   LUN    in     Logical unit number. If LUN = 0: all units
*   CTPL   in     Print destination (combination of 'TPL')
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"

      CHARACTER CTPL*(*)
      CHARACTER*1 CHS(7), CHF(3)
      CHARACTER C3*3, C4*4
      INTEGER ILINE, LUN, L, L0, L1, L2, LENOCC
      DATA CHS /' ','r','n','w','o','e','c'/, CHF /' ','b','f'/

#include "arte/Arte.ff"

      CALL UTPOPT (CTPL)

      L1 = 1
      L2 = 99
      IF (LUN .LT. 0 .OR. LUN .GE. 100)  THEN
        C78 = 'LIUNIT: logical unit'
        CALL CH78BI (LUN)
        CALL CH78BC ('is not in the range 1 ... 99')
        CALL ME78WC (7456745)
        L2 = 0
      ELSE IF (LUN .NE. 0)  THEN
        L1 = LUN
        L2 = LUN
        IF (IIOFLG(LUN) .LT. 0)  THEN
          C78 = 'LIUNIT: logical unit'
          CALL CH78BI (LUN)
          CALL CH78BC ('is unknown to Arte')
          CALL ME78SP (CTPL)
          GO TO 90
        END IF
      END IF

      CALL MESELP
     +  ('Lun Symb     IOS Flags  Recl   Nrec     Name', CTPL)
      ILINE = 0

      DO 30 L0 = L1, L2
        IF (IIOFLG(L0) .LT. 0)  GO TO 30
        L = L0
        WRITE (C3,'(I3)')  L0
 10     C4 = ' '
        IF (IIOCUR(L0) .EQ. L)  THEN
          IF (IIOFLG(L) .EQ. 1)  C4 = ' -- '
          IF (IIOFLG(L) .EQ. 2)  C4 = ' |< '
          IF (IIOFLG(L) .EQ. 3)  C4 = ' -> '
          IF (IIOFLG(L) .GT. 3)  THEN
            C4 = ' >| '
            IF (IIONXT(L) .EQ. 0)  C4 = ' || '
          END IF
        END IF
        WRITE (C78, 1001)  C3, CIOSYM(L0), IIOSTA(L), CHS(IIOFLG(L)+2),
     +    CHF(IIOFMT(L)+2), CIOZEB(L), CIOZFL(L), NIOLEN(L), NIOREC(L),
     +    C4
        IF (LENOCC(CIONAM(L)). LE. 37)  THEN
          C78(42:) = CIONAM(L)
        ELSE
          ILINE = ILINE + 1
          CALL ME78SP (CTPL)
          C78 = CIONAM(L)
          CALL CHRIGH (C78)
        END IF
        ILINE = ILINE + 1
        CALL ME78SP (CTPL)
        L = IIONXT(L)
        C3(1:1) = '+'
        IF (L .NE. 0)  GO TO 10
        IF (ILINE .GE. 5)  THEN
          ILINE = 0
          CALL MESELP (' ', CTPL)
        END IF
 30   CONTINUE

 1001 FORMAT (A,1X,A,I4,1X,4A,I5,I7,1X,A)

 90   END

************************************************************************
* End of LIUNIT
************************************************************************
