*-- Author :    Rainer Mankel   01/06/96

      subroutine di1mc(imc,islsta,islend,chopt)

*     **** display MC track
      implicit none
#include "arte/Arte.fi"

#include "pris/zgraf.fi"
      integer islsta, islend, iso, ipl, imc, indx_mimp, iso1, iso9, dso
      integer nsomax, nprim
      parameter (nsomax=900)
      integer isl, imim, npoint, segment, segment_begin(3),
     +     segment_size(3), v, gcode, magflag(nsomax), ipoint,
     +     startpoint, endpoint, last_mimp, mimp_prim_sort(nsomax)
      real xxx(nsomax), yyy(nsomax), wh(3), ltyp, xx, yy
      logical charged
      character*(*) chopt
      character*1 cgraph
      character*10 cnpart
      integer message_id_1
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"
#include "gean/ZGESL.fi"
      integer maxgcode
      parameter (maxgcode=60)
      character*8 cn(maxgcode)
      data cn / '[g]','e^+!','e^-!',' ','[m]^+!',
     +     '[m]^-!',' ','[p]^+!','[p]^-!','K^0!?L!',
     +     'K^+!','K^-!','n','p','p&^-!',
     +     'K^0!?S!',4*' ',
     +     4*' ','n&^-!',
     +     5*' ',
     +     2*' ','[t]^+!','[t]^-!','D^+!',
     +     'D^-!','D^0!','D&_^0','D?s!^+!','D?s!^-!',
     +     5*' ',
     +     3*' ','J/[y]',' ',
     +     'B^+!','B^-!','B^0!','B&_^0','B?s!',
     +     'B&_?s!',4*' '/
      data message_id_1 /1/
      save cn
      save message_id_1

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

*     **** polyline/curve option
      if (lsplinezg) then
         cgraph = 'C'
      else
         cgraph = 'L'
      endif

*     **** check id
      gcode = itopp_gean(omtra_topp(imc))

      if (
     +     (gcode.eq.8)  .or. (gcode.eq.9)
     +     .or. (gcode.eq.11) .or. (gcode.eq.12)
     +     .or. (gcode.eq.14) .or. (gcode.eq.15)
     +     .or. (gcode.eq.2)  .or. (gcode.eq.3)
     +     .or. (gcode.eq.5)  .or. (gcode.eq.6)
     +     ) then
         charged = .true.
         ltyp = 1.
      elseif (gcode.eq.1) then
         charged = .false.      ! gamma
         ltyp = 12.

      elseif (gcode.eq.10.or.gcode.eq.16) then
         charged = .false.      ! K0L, K0S
         ltyp = 15.

      elseif (gcode.eq.13 .or. gcode.eq.25) then
         charged = .false.      ! n, n~
         ltyp = 13.

      elseif (gcode.eq.53.or.gcode.eq.54 ! b0, b0=
     +        .or.gcode.eq.37.or.gcode.eq.38 ! d0, d0=
     +        .or.gcode.eq.49) then ! J/Psi
         charged = .false.
         ltyp = 14.
      else
         go to 999
      endif

      if ((.not.charged) .and. (.not.lneutzg)) go to 999

*     **** printing headline
      if (index(chopt,'P').gt.0) then
         write(*,'(2x,a6,a8  ,2a9  ,2a8  ,''('',a8  ,'')'',a8  )')
     +        'imim', ' z ', ' x0 ', ' y0 ', ' mx ', ' my ', ' myp ',
     +        ' p '
      endif


      npoint = 0
      last_mimp = 0

*     **** find vertex
      if (lmverzg) then
         if (omtrx_bver(imc).gt.0.and.omtrx_bver(imc).le.iq(jmver+2))
     +        then
            v = omtrx_bver(imc)
            npoint = npoint + 1

*           **** 3D point
            wh(1) = fmver_x(v)
            wh(2) = fmver_y(v)
            wh(3) = fmver_z(v)

*           **** projection
            call dipro(wh,xxx(npoint),yyy(npoint))
            magflag(npoint) = 0

            if (index(chopt,'P').gt.0) then
               write(*,'(2x,i6,3f9.3,i6)')
     +              v,fmver_x(v), fmver_y(v), fmver_z(v), omver_btra(v)
            endif
         else
            print *,' () di1mc: no vertex for mc=', imc
         endif
      endif

*     **** locate the mimps: 
*     **** use temporary array because we must revert the z order
      nprim = 0
      do 20 iso=1,nsomax
         if (iso.eq.1) then
            indx_mimp = pmtrx_mimp(imc)
         else
            indx_mimp = xmtrx_mimp(indx_mimp)
         endif
         if (indx_mimp.le.0) go to 21
         
         imim = mmtrx_mimp(indx_mimp)
         if (imim.le.0.or.imim.gt.iq(jmimp+2)) then
            print *,' () di1mc: invalid imim=',imim,' iq(jmimp+2)=',
     +           iq(jmimp+2)
            stop 'di1mc'
         endif

         ipl = imimp_gede(imim) ! prepare SL check
         if (ipl.gt.iq(jgede+2)) go to 20 ! avoid packed IPLs in ECAL
         isl = ogede_gesl(ipl)
         if (isl.lt.islsta.or.isl.gt.islend) go to 20
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 20
            if (.not.lscopzg(isl)) go to 20
         endif

         if (igesl_cmp(isl).eq.lgesl_ric) go to 20 ! no mimps from RICH

         if (omimp_mtra(imim).eq.0) go to 20 ! no merged points

         if (nprim.ge.nsomax) then
            print *,' () di1mc: overflowing nprim=', nprim,
     +           ' imc=', imc
            go to 999
         endif
         if (last_mimp.eq.0) last_mimp = imim

#ifdef MIMPPRT
         print '((a),i7,(a),f12.3,(a),a4)',
     +        ' mimp located=',imim,' z=',fmimp_z(imim),
     +        ' sl=',hgesl_name(ogede_gesl(imimp_gede(imim)))
#endif
         nprim = nprim + 1
         mimp_prim_sort(nprim) = imim 

 20   continue                     
      call mepric(message_id_1,1,
     +      'di1mc: overflowing nMimps, part of trajectory not drawn')

      
 21   continue

      if (nprim.le.0) go to 999
      if (fmimp_z(mimp_prim_sort(1))
     +     .gt.fmimp_z(mimp_prim_sort(nprim))) then ! must revert
         iso1 = nprim
         iso9 = 1
         dso  = -1
      else
         iso1 = 1
         iso9 = nprim
         dso  = 1
      endif
      last_mimp = mimp_prim_sort(iso9)

*     **** access the mimps in rising-z order
      do 30 iso=iso1,iso9,dso
         imim = mimp_prim_sort(iso)
         if (imim.le.0.or.imim.gt.iq(jmimp+2)) then
            print *,' () di1mc: invalid imim=',imim,' iq(jmimp+2)=',
     +           iq(jmimp+2)
            stop 'di1mc'
         endif

         ipl = imimp_gede(imim) ! prepare SL check
         isl = ogede_gesl(ipl)
         wh(1) = fmimp_x(imim)  ! 3D point
         wh(2) = fmimp_y(imim)
         wh(3) = fmimp_z(imim)

         call dipro(wh,xx,yy) ! projection

         if (npoint.ge.nsomax) then
            print *,' () di1mc: overflowing npoint=', npoint,
     +           ' imc=', imc
            go to 31
         endif
         npoint = npoint + 1

#ifdef SPLCUT
         if (.true.) then       ! check spline option (planned)
            if (npoint.ge.1) then ! avoid close mimps (precision probl)
               if (abs(xx-xxx(npoint)).lt.uxzg) print *,
     +              ' di1mc: x-skip mimp ',imim,' uxzg= ',uxzg
               if (abs(xx-xxx(npoint)).lt.uxzg) go to 30
               if (abs(yy-yyy(npoint)).lt.uyzg) print *,
     +              ' di1mc: y-skip mimp ',imim,' uyzg=',uyzg
               if (abs(yy-yyy(npoint)).lt.uyzg) go to 30
            endif
         endif
#endif


*         call dipro(wh,xxx(npoint),yyy(npoint)) ! projection
         xxx(npoint) = xx
         yyy(npoint) = yy


         magflag(npoint) = igesl_mfl(isl)

         if (index(chopt,'P').gt.0) then
            write(*,'(2x,i6,f8.2,2f9.3,2f8.5,''('',f8.5,'')'',f8.3)')
     +           imim,fmimp_z(imim), fmimp_x(imim), fmimp_y(imim),
     +           fmimp_tx(imim), fmimp_ty(imim),
     +           fmimp_ty(imim)/sqrt(1.+fmimp_tx(imim)**2),
     +           fmimp_p(imim)
         endif

 30   continue
 31   continue

      if (leverzg) then          ! look for end vertex
         if (pmtrx_ever(imc).gt.0) then
            if (.not.charged.or.(imtra_flag(imc).ne.5.and.
     +           imtra_flag(imc).ne.6)) then
               v = mmtrx_ever(pmtrx_ever(imc))
               if (v.le.0.or.v.gt.iq(jmver+2)) then
                  print *,' () di1mc: invalid ever=',v,
     +                 ' mtra=',imc,' flag=',imtra_flag(imc)
                  go to 39
               endif

               if (omver_btra(v).ne.imc) then
                  print *,' () di1mc: invalid vertex point-back ',
     +                 ' imc=', imc,' mver=', v
                  go to 39
               endif

*              **** the following solution is very dissatisfying:
*              **** it is still impossible to tell if a EVER vertex
*              **** is really the decay point of the particle.
*              **** Frequently it is just a point of radiation

               if (last_mimp.gt.0) then ! check if end vertex is really
     +                                  ! downstream of mimp
                  if (fmver_z(v).lt.fmimp_z(last_mimp)) go to 39
               endif

               if (npoint.ge.nsomax) then
                  print *,' () di1mc: overflowing npoint=', npoint,
     +                 ' imc=', imc
                  go to 999
               endif
               npoint = npoint + 1

*              **** 3D point
               wh(1) = fmver_x(v)
               wh(2) = fmver_y(v)
               wh(3) = fmver_z(v)

*              **** projection
               call dipro(wh,xxx(npoint),yyy(npoint))
 39            continue
            endif
         endif
      endif

*     **** invisible segments weedout
      startpoint = 0
      do 40 ipoint=1,npoint-1
         if (amax1(xxx(ipoint),xxx(ipoint+1)).lt.xminzg) go to 40
         if (amin1(xxx(ipoint),xxx(ipoint+1)).gt.xmaxzg) go to 40
         if (amax1(yyy(ipoint),yyy(ipoint+1)).lt.yminzg) go to 40
         if (amin1(yyy(ipoint),yyy(ipoint+1)).gt.ymaxzg) go to 40
         startpoint = ipoint
         go to 41
 40   continue
 41   continue
      if (startpoint.eq.0) go to 999 ! whole track invisible
      endpoint = startpoint +1
      do 50 ipoint=npoint-1,startpoint+1,-1
         if (amax1(xxx(ipoint),xxx(ipoint+1)).lt.xminzg) go to 50
         if (amin1(xxx(ipoint),xxx(ipoint+1)).gt.xmaxzg) go to 50
         if (amax1(yyy(ipoint),yyy(ipoint+1)).lt.yminzg) go to 50
         if (amin1(yyy(ipoint),yyy(ipoint+1)).gt.ymaxzg) go to 50
         endpoint = ipoint + 1
         go to 51
 50   continue
 51   continue

      if (startpoint.gt.(endpoint-1)) then
         print *,' () di1mc: startpoint,endpoint=',startpoint,endpoint
         go to 999
      endif

*     **** truncation of tracks leading outside frame
      if (xxx(startpoint).lt.xminzg) then
         yyy(startpoint) = yyy(startpoint) +
     +        (xminzg - xxx(startpoint)) *
     +        (yyy(startpoint+1)-yyy(startpoint)) /
     +        (xxx(startpoint+1)-xxx(startpoint))
         xxx(startpoint) = xminzg
      elseif (xxx(startpoint).gt.xmaxzg) then
         yyy(startpoint) = yyy(startpoint) +
     +        (xmaxzg - xxx(startpoint)) *
     +        (yyy(startpoint+1)-yyy(startpoint)) /
     +        (xxx(startpoint+1)-xxx(startpoint))
         xxx(startpoint) = xmaxzg
      endif

      if (xxx(endpoint).lt.xminzg) then
         yyy(endpoint) = yyy(endpoint) +
     +        (xminzg - xxx(endpoint)) *
     +        (yyy(endpoint-1)-yyy(endpoint)) /
     +        (xxx(endpoint-1)-xxx(endpoint))
         xxx(endpoint) = xminzg

      elseif (xxx(endpoint).gt.xmaxzg) then
         yyy(endpoint) = yyy(endpoint) +
     +        (xmaxzg - xxx(endpoint)) *
     +        (yyy(endpoint-1)-yyy(endpoint)) /
     +        (xxx(endpoint-1)-xxx(endpoint))
         xxx(endpoint) = xmaxzg
      endif


*     **** decompose track into three segments:
*     ****            1 - straight part in front of magnet area
*     ****            2 - curved part within magnet area
*     ****            3 - straight part beyond magnet area

      do segment=1,3            ! init segment pointers
         segment_begin(segment) = 0
         segment_size(segment) = 0
      enddo
      segment = 1
      segment_begin(1) = startpoint
      do ipoint=startpoint,endpoint
         if (charged.and.(segment.eq.1.and.magflag(ipoint).eq.1)) then
            segment_size(1) = segment_size(1) + 1 ! connect seg 1&2
            segment = 2
            segment_begin(segment) = ipoint
         elseif (segment.eq.2.and.magflag(ipoint).eq.0) then
            segment = 3
            segment_begin(segment) = ipoint - 1
            segment_size(3) = 1 ! connect 2 & 3
         endif
         segment_size(segment) = segment_size(segment) + 1
      enddo

*     **** draw the graph

*     **** set the variable drawing attributes
      call igset('LWID',widmczg)
      call igset('LTYP',ltyp)

      if ((endpoint-startpoint+1).ge.2) then
*        **** draw segment in front of magnet (polyline)
 111     format(a20/100(/e12.4,e12.4))
         if (segment_size(1).ge.2) call igraph(segment_size(1),
     +        xxx(segment_begin(1)),yyy(segment_begin(1)),'L')
*        **** draw segment inside magnet (spline if pz.gt.1)
         if (segment_size(2).ge.2) then
            if (abs(fmtra_pz(imc)).gt.1.) then
               call igraph(segment_size(2),
     +              xxx(segment_begin(2)),yyy(segment_begin(2)),cgraph)
            else
               call igraph(segment_size(2),
     +              xxx(segment_begin(2)),yyy(segment_begin(2)),'L')
            endif
         endif

*        **** draw segment beyond magnet (polyline)
         if (segment_size(3).ge.2) call igraph(segment_size(3),
     +        xxx(segment_begin(3)),yyy(segment_begin(3)),'L')

         if (ltypezg) then      ! particle label option
            if (gcode.ge.1.and.gcode.le.maxgcode) then
               cnpart = cn(gcode)
            else
               cnpart = ' '
            endif

*           **** draw name of particle right of largest-z mim
            call istxfp(0,2)
            call igset('TXAL',23.)
            call ischh(2.*uyzg)
            call igset('TXCI',comczg)
            call itx(xxx(endpoint)+2.*uxzg,
     +           yyy(endpoint)+2.*uyzg,cnpart)
         endif
      endif

 999  end
