*CMZ :  4.06/02 19/10/96  15.47.13  by  Rainer Mankel
*CMZ :  4.05/03 30/05/96  17.49.09  by  Rainer Mankel
*CMZ :  4.05/00 15/04/96  13.50.18  by  Rainer Mankel
*-- Author :    Rainer Mankel   14/04/96

      subroutine dimcal(sl,idmc,chopt)

*     **** display Monte Carlo impact points for ECAL
*     **** These are determined by cluster-COG
      implicit none
#include "pris/zmh.fi"
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

      character*(*) chopt
      real xxx(1), yyy(1), wc(3), zb, w, wtot, x, y
      integer sl, mcal, idmc, mc, ix, iy, block, cell, ii,
     +     jaux, nbl, iimark, gcode
#include "auto/GEO.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MCAL.fi"
#include "auto/TOPP.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MCAL.ff"
#include "auto/TOPP.ff"

      do 10 mc=1,nmtra()           ! consider all MC tracks
         if (idmc.ne.0.and.mc.ne.idmc) go to 10
         if (lb0zg) then        ! check B0 option
            if (.not.gold_mh(mc)) go to 10
         endif

         if (index(chopt,'R').gt.0) then ! check ref option
            if (mc.eq.0) go to 10
            if (.not.ref_mh(mc)) go to 10
         endif

         jaux = pmtrx_mcal(mc)  ! check if ecal entries
         if (jaux.eq.0) go to 10

         wtot = 0.
         wc(1) = 0.
         wc(2) = 0.
         wc(3) = 0.
         do 20 ii=1,999            ! loop over associated mcal's
            if (ii.gt.1) then
               jaux = xmtrx_mcal(jaux)
               if (jaux.eq.0) go to 21
            endif
            mcal = mmtrx_mcal(jaux)

            if (sl.gt.0) then   ! check SL
               if (ogcal_gesl(imcal_gcal(mcal)/100).ne.sl) go to 20
            endif


            w = fmcal_de(mcal)  ! energy deposition as weight
            block = imcal_gcal(mcal) / 100
            cell = mod(imcal_gcal(mcal),100)
            if (block.ge.1.and.block.le.ngcal()) then
               zb = fgcal_zmin(block)
            else
               print *,' () dimcal: block out of range, ', block
               zb = 1500.
            endif

*           **** determine x/y coordinates
            nbl = igcal_ncl(block) ! number of cells in row/col
            if (nbl.ne.1.and.nbl.ne.2.and.nbl.ne.5) then
               print *,' () dimcal: funny row length ', nbl
            endif
            ix = (cell-1) / nbl
            iy = mod(cell-1,nbl) +1
            if (ix.lt.1.or.ix.gt.nbl.or.iy.lt.1.or.iy.gt.nbl) then
               print *,' () dimcal: funny ix, iy, nbl=',
     +              ix, iy, nbl
               print *,'            mcal, block, cell=',
     +              mcal, block, cell
               go to 20
            endif
            x = fgcal_xmin(block)
     +           + (fgcal_xmax(block) - fgcal_xmin(block))
     +           * (float(ix)-0.5) / float(nbl)
            y = fgcal_ymin(block)
     +           + (fgcal_ymax(block) - fgcal_ymin(block))
     +           * (float(iy)-0.5) / float(nbl)
            wc(1) = wc(1) + w * x
            wc(2) = wc(2) + w * y
            wc(3) = wc(3) + w * zb
            wtot = wtot + w
 20      continue               ! mcal's
 21      continue

         if (wtot.ne.0.) then
            wc(1) = wc(1) / wtot
            wc(2) = wc(2) / wtot
            wc(3) = wc(3) / wtot
         else
            print *,' () dimcal: wtot=', wtot
            go to 10
         endif

*        **** projection
         call dipro(wc,xxx(1),yyy(1))

*        **** check if point is visible
         if (xxx(1).lt.xminzg.or.xxx(1).gt.xmaxzg) go to 10
         if (yyy(1).lt.yminzg.or.yyy(1).gt.ymaxzg) go to 10

*        **** check id
         gcode = itopp_gean(omtra_topp(mc))

         if (gcode.eq.2.or.gcode.eq.3) then ! e+/e-
            iimark = 28         ! plus sign
         elseif (gcode.eq.11.or.gcode.eq.12) then ! K+/K-
            iimark = 26         ! triangle
         elseif (gcode.eq.14.or.gcode.eq.15) then ! p,p=
            iimark = 25         ! square
         elseif (gcode.eq.8.or.gcode.eq.9) then ! pi+/pi-
            iimark = 24         ! circle
         elseif (gcode.eq.5.or.gcode.eq.6) then ! mu+/mu-
            iimark = 23
         elseif (gcode.eq.1) then ! photon
            iimark = 30         ! star
         else
            iimark = 27         !diamond
         endif

         call ismk(iimark)
         call ismksc(1.)
         call ipm(1,xxx,yyy)


 10   continue

      end
