*CMZ :  4.04/01 26/03/96  15.00.20  by  Rainer Mankel
*CMZ :  4.04/00 24/01/96  11.30.09  by  Rainer Mankel
*-- Author :    Rainer Mankel   16/12/95

      subroutine diplam(pl,chopt)

*     **** display detector plane body for plane "pl"
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

      character*(*) chopt
      real xxx(5), yyy(5), wc(3,4), tg
      integer ii, pl, isl, cmp
      logical llist

#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      llist   = index(chopt,'L').gt.0
      isl = ogede_gesl(pl)
      if (isl.le.0) print *,' () diplam: pl,isl=',pl,isl
      cmp = igesl_cmp(isl)


      if (llist) then
       print *,' diplam: display plane ',pl,
     +        ' cmp= ',cmp,
     +        ' isl=',isl
       print *,'            borders xmin/mx,ymin/mx=',
     +        fgede_sxmn(pl),
     +        fgede_sxmx(pl),fgede_symn(pl),fgede_symx(pl)
      endif

*     **** tan(stereo angle)
      if (fgede_cos(pl).ne.0.) then
       tg = fgede_sin(pl) / fgede_cos(pl)
      else
       tg = fgede_sin(pl) / 0.00001
      endif

      if (.not.lstereozg) then
*        **** bypass stereo planes
         if (cmp.ne.1) then
            if (abs(fgede_sin(pl)).gt.0.05
     +           .or.abs(fgede_rot(2,pl)).gt.0.05)
     +           go to 999
         endif
      endif

*     **** corners of plane (using world coordinates)
      call igset('PLCI',coplbzg)
      call isln(15)

      if (igede_shp(pl).eq.1.or.igede_shp(pl).eq.10) then
*        **** basic shape
         wc(1,1) = fgede_sxmn(pl)
         wc(2,1) = fgede_symn(pl)
         wc(3,1) = fgede_zmin(pl)
         wc(1,2) = fgede_sxmx(pl)
         wc(2,2) = fgede_symn(pl)
         wc(3,2) = fgede_zmin(pl)
         wc(1,3) = fgede_sxmx(pl)
         wc(2,3) = fgede_symx(pl)
         wc(3,3) = fgede_zmin(pl)
         wc(1,4) = fgede_sxmn(pl)
         wc(2,4) = fgede_symx(pl)
         wc(3,4) = fgede_zmin(pl)

*        **** shear shape for epiped
         if (igede_shp(pl).eq.10) then
            do ii=1,4
               wc(1,ii) = wc(1,ii) + tg * wc(2,ii)
            enddo
         endif
      else
         print *,' () diplam: unsupported shape, shp, pl=',
     +        igede_shp(pl), pl
         go to 999
      endif

      if (fgede_rot(1,pl).ne.1.) then
*        **** additional rotation
         do ii=1,4
*           **** use 2D rotation matrix
**            call diroxy(wc(1,ii),fgede_rot(1,pl),fgede_rot(2,pl))
            call diroxy(wc(1,ii),fgede_rot(1,pl),+fgede_rot(2,pl))
         enddo
      endif

*     **** projection
      do ii=1,4
         call dipro(wc(1,ii),xxx(ii),yyy(ii))
      enddo

*     **** close the parallelogram
      xxx(5) = xxx(1)
      yyy(5) = yyy(1)

*     **** draw plane
      call isplci(int(coplbzg))
      call igsg(1)
      call isln(1)

*     **** draw plane volume if opaque option active
      if (lopaquezg) then
         call igset('PLCI',coplvzg)
         call igset('FACI',coplvzg)
         call igset('FAIS',1.)
         call igset('BORD',0.)
         call ifa(5,xxx,yyy)
      endif
*     **** draw plane border
      call igset('PLCI',coplbzg)
      call igset('FAIS',0.)
      call igset('LWID',1.)
      call ipl(5,xxx,yyy)

      call isfaci(0)
      call isfais(0)

**    call iuwk(0,1)
**    call igsa(1)

 999  end


