*CMZ :  4.06/02 10/07/96  18.52.07  by  Rainer Mankel
*CMZ :  4.04/00 16/12/95  17.18.19  by  Rainer Mankel
*CMZ :  3.01/05 28/01/95  17.09.51  by  Rainer Mankel
*CMZ :  3.01/04 28/01/95  15.16.45  by  Rainer Mankel
*CMZ :  2.01/05 01/02/94  16.37.28  by  Rainer Mankel
*CMZU:  2.00/00 23/12/93  18.44.41  by  Rainer Mankel
*CMZU:  1.06/00 07/11/93  18.46.38  by  Rainer Mankel
*-- Author :    Rainer Mankel   02/11/93

      subroutine dipro(dc,xxx,yyy)

*     **** projects 3dim detector frame coordinates into
*     **** the world coordinates xxx and yyy
      implicit none
#include "pris/zgraf.fi"

      real dc(3), dcs(3), xxx, yyy
      real cp, sp, ct, st, radeg, yhyp
      integer ii
      data radeg /57.29578/

      if (iviewzg.eq.0) then
*      **** xy view
       xxx = dc(1)
       yyy = dc(2)
      elseif (iviewzg.eq.1) then
*      **** xz view
       xxx = dc(3)
       yyy = dc(1)
      elseif (iviewzg.eq.2) then
*      **** yz view
       xxx = dc(3)
       yyy = dc(2)
      elseif (iviewzg.ge.3.and.iviewzg.le.6) then
       if (iviewzg.eq.3) then
*       **** spatial view
        ct = cos(thetzg / radeg)
        st = sin(thetzg / radeg)
        cp = cos(phizg / radeg)
        sp = sin(phizg / radeg)
       elseif (iviewzg.eq.4) then
*       **** isometric view
        ct = sqrt(2./3.)
        st = sqrt(1./3.)
        cp = sqrt(0.5)
        sp = cp
       elseif (iviewzg.eq.5) then
*       **** dimetric view
        ct = sqrt(0.8)
        st = sqrt(0.2)
        cp = sqrt(0.75)
        sp = 0.5

       elseif (iviewzg.eq.6) then
*       **** trimetric view
        ct = sqrt(5./6.)
        st = sqrt(1./6.)
        cp = sqrt(0.7)
        sp = sqrt(0.3)
       endif

*      **** scale factors
       do 10 ii=1,3
 10    dcs(ii) = dc(ii) * fscalzg(ii)

       xxx =   cp * dcs(1)                    - sp * dcs(3)
       yyy = - st * sp * dcs(1) + ct * dcs(2) - st * cp * dcs(3)

      elseif (iviewzg.eq.7) then
*       **** x-stereo view (u)
       xxx = dc(3)
       yyy = ucoszg * dc(1) - usinzg * dc(2)
      elseif (iviewzg.eq.8) then
*      **** x-stereo view (v)
       xxx = dc(3)
       yyy = ucoszg * dc(1) + usinzg * dc(2)
      elseif (iviewzg.eq.9) then
*      **** cone-correction view
       xxx = dc(3)
       yyy = dc(1) * (1000.+10.) / (dc(3)+10.)
      elseif (iviewzg.eq.10) then
*      **** cone-correction view with hyperbolic blowup
       xxx = dc(3)
       yyy = dc(1) * (1000.+1.) / (dc(3)+1.)
*      **** log scale corr
       yhyp = abs(yyy)
       if (yhyp.gt.10.) then
        yyy = 100. * sign(alog(yhyp/10.)+1.,yyy)
       else
        yyy = 100. * yyy/10.
       endif

      else
       print *,' () dipro: invalid view, iviewzg=',iviewzg
      endif

      end










