*-- Author :    Rainer Mankel   12/12/95

      subroutine diwall(iwl,chopt)
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"

**     **** display wall "iwl" with wires hit
*     **** llist=1 triggers listing of wire coordinates
      character*(*) chopt
      real xxx(40), yyy(40)
      real border_col,volume_col,border_wid
      real wc(3,40), wccm(3,6), depth(6)
      real dphi
      integer ii, iwl, seq(6), nseq, iphi
      integer iface, corner, dim
      integer face(4,6)
#include "auto/GEO.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
      data face /
     +     1, 2, 3, 4,          ! front face
     +     1, 4, 8, 5,          ! right face
     +     2, 3, 7, 6,          ! left face
     +     1, 2, 6, 5,          ! top face
     +     3, 4, 8, 7,          ! bottom face
     +     5, 6, 7, 8 /         ! back face

      if (iwl.le.0.or.iwl.gt.iq(jgwal+2)) then
         print *,' () diwall: invalid wall iwl=', iwl
         stop 'diwall'
      endif

      if (igwal_shp(iwl).le.2  .or. igwal_shp(iwl).eq.10
     +.or.igwal_shp(iwl).eq.42 .or. igwal_shp(iwl).eq.34) then

*        **** corners of wall (using world coordinates)
         call igset('PLCI',cowabzg)
         call isln(15)

*        **** basic shape
         wc(1,1) = fgwal_xmin(iwl)
         wc(2,1) = fgwal_ymin(iwl)
         wc(3,1) = fgwal_zmin(iwl)
         wc(1,2) = fgwal_xmax(iwl)
         wc(2,2) = fgwal_ymin(iwl)
         wc(3,2) = fgwal_zmin(iwl)
         wc(1,3) = fgwal_xmax(iwl)
         wc(2,3) = fgwal_ymax(iwl)
         wc(3,3) = fgwal_zmin(iwl)
         wc(1,4) = fgwal_xmin(iwl)
         wc(2,4) = fgwal_ymax(iwl)
         wc(3,4) = fgwal_zmin(iwl)

         wc(1,5) = fgwal_xmin(iwl)
         wc(2,5) = fgwal_ymin(iwl)
         wc(3,5) = fgwal_zmax(iwl)
         wc(1,6) = fgwal_xmax(iwl)
         wc(2,6) = fgwal_ymin(iwl)
         wc(3,6) = fgwal_zmax(iwl)
         wc(1,7) = fgwal_xmax(iwl)
         wc(2,7) = fgwal_ymax(iwl)
         wc(3,7) = fgwal_zmax(iwl)
         wc(1,8) = fgwal_xmin(iwl)
         wc(2,8) = fgwal_ymax(iwl)
         wc(3,8) = fgwal_zmax(iwl)

*        **** modify shape if necessary

         if (fgwal_rot(1,iwl).ne.1.) then
*           **** additional rotation
            do ii=1,8
*              **** use rotation matrix
               call diroxy(wc(1,ii),fgwal_rot(1,iwl),-fgwal_rot(2,iwl))
            enddo
         endif

#ifdef OLDWALL
*        **** projection
         do ii=1,8
            call dipro(wc(1,ii),xxx(ii),yyy(ii))
         enddo

*        **** close the parallelogram
         xxx(5) = xxx(1)
         yyy(5) = yyy(1)

*        **** draw wall
         call isplci(int(cowabzg))
         call igsg(1)
         call isln(1)
         call igset('LWID',1.)
         call ipl(5,xxx,yyy)

*        **** clear wall area if opaque option active
         if (lopaquezg) then
            call igset('FACI',cowavzg)
            call igset('FAIS',1.)
            call ifa(5,xxx,yyy)
         endif
#endif


         border_col = cowabzg
         volume_col = cowavzg
         border_wid = 5.
         call dicube(wc,border_col,volume_col,border_wid)


      elseif (igwal_shp(iwl).eq.3) then
*        **** trapezoid (trd2), define the eight corners
         wc(1,1) = fgwal_xmin(iwl)
         wc(2,1) = fgwal_ymin(iwl)
         wc(3,1) = fgwal_zmin(iwl)
         wc(1,2) = -fgwal_xmin(iwl)
         wc(2,2) = fgwal_ymin(iwl)
         wc(3,2) = fgwal_zmin(iwl)
         wc(1,3) = -fgwal_xmin(iwl)
         wc(2,3) = -fgwal_ymin(iwl)
         wc(3,3) = fgwal_zmin(iwl)
         wc(1,4) = fgwal_xmin(iwl)
         wc(2,4) = -fgwal_ymin(iwl)
         wc(3,4) = fgwal_zmin(iwl)
         wc(1,5) = fgwal_xmax(iwl)
         wc(2,5) = fgwal_ymax(iwl)
         wc(3,5) = fgwal_zmax(iwl)
         wc(1,6) = -fgwal_xmax(iwl)
         wc(2,6) = fgwal_ymax(iwl)
         wc(3,6) = fgwal_zmax(iwl)
         wc(1,7) = -fgwal_xmax(iwl)
         wc(2,7) = -fgwal_ymax(iwl)
         wc(3,7) = fgwal_zmax(iwl)
         wc(1,8) = fgwal_xmax(iwl)
         wc(2,8) = -fgwal_ymax(iwl)
         wc(3,8) = fgwal_zmax(iwl)

         if (iviewzg.eq.0) then
            seq(1) = 1          ! draw front only
            nseq   = 1
         elseif (iviewzg.eq.1) then
            seq(1) = 4          ! draw top side only
            nseq   = 1
         elseif (iviewzg.eq.2) then
            seq(1) = 2          ! draw left side only
            nseq   = 1
         elseif (iviewzg.ge.3.or.iviewzg.le.10) then
            do iface=1,6
               do dim=1,3
                  wccm(dim,iface) = 0.
               enddo
               do corner=1,4
                  do dim=1,3
                     wccm(dim,iface) = wccm(dim,iface)
     +                    + wc(dim,face(corner,iface))
                  enddo
               enddo
               do dim=1,3
                  wccm(dim,iface) = wccm(dim,iface) / 6. ! luxury
               enddo
               call didepth(wccm(1,iface),depth(iface))
               depth(iface) = depth(iface) * idirzg ! view direction
            enddo
            nseq = 6
            call sortzv(depth,seq,6,+1,1,0) ! sort decr depth
         else
            print *,' () diwall: unsupported view', iviewzg
         endif
         call isplci(int(coribzg)) ! set graphics style
         call igsg(1)
         call isln(1)
         call igset('FACI',corivzg)
         call igset('FAIS',1.)

         do ii=1,nseq
            iface = seq(ii)     ! faces in sorted order
**            print *,' diwall: draw face ', iface
            do corner=1,4
               call dipro(
     +              wc(1,face(corner,iface)),xxx(corner),yyy(corner))
            enddo

            xxx(5) = xxx(1) ! close the parallelogram
            yyy(5) = yyy(1)

            call igset('PLCI',corivzg)
            call igset('FACI',corivzg)
            call igset('FAIS',1.)
            call igset('BORD',0.)
            call ifa(5,xxx,yyy) ! draw volume

            call igset('PLCI',coribzg) ! draw border
            call igset('FAIS',0.)
            call igset('LWID',7.)
            call ipl(5,xxx,yyy)
         enddo
      elseif (igwal_shp(iwl).eq.5) then
*        **** hollow cylinder - ignore delta-z
         dphi = 6.28 / 19
         do iphi=1,19
            wc(1,iphi) = fgwal_xmin(iwl) * cos((iphi-1)*dphi)
            wc(2,iphi) = fgwal_xmin(iwl) * sin((iphi-1)*dphi)
            wc(3,iphi) = 0.5 * (fgwal_zmin(iwl)+fgwal_zmax(iwl))
            wc(1,iphi+20) = fgwal_xmax(iwl) * cos((iphi-1)*dphi)
            wc(2,iphi+20) =-fgwal_xmax(iwl) * sin((iphi-1)*dphi)
            wc(3,iphi+20) = 0.5 * (fgwal_zmin(iwl)+fgwal_zmax(iwl))
         enddo
         wc(1,20) = wc(1,1)
         wc(2,20) = wc(2,1)
         wc(3,20) = wc(3,1)
         wc(1,40) = wc(1,21)
         wc(2,40) = wc(2,21)
         wc(3,40) = wc(3,21)
         do iphi=1,40
            call dipro(wc(1,iphi),xxx(iphi),yyy(iphi))
         enddo
         call igset('PLCI',cowavzg)
         call igset('FACI',cowavzg)
         call igset('FAIS',1.)
         call igset('BORD',0.)
         call ifa(40,xxx,yyy)    ! draw volume

         call igset('PLCI',cowabzg) ! draw border
         call igset('FAIS',0.)
         call igset('LWID',7.)
         call ipl(20,xxx,yyy)
         call ipl(20,xxx(21),yyy(21))
      else
         print *,' () diwall: unsupported shape, shp, iwl=',
     +        igwal_shp(iwl), iwl
         go to 999
      endif

      call igset('LWID',1.)     ! reset
      call isfaci(0)
      call isfais(0)

      call iuwk(0,1)
      call igsa(1)

 999  end
