#!/usr/local/bin/wish


#                  *****************************
#                  * Program "Prism Commander" *
#                  *****************************

#Font Setup
set times    {*-times-bold-r-normal--*-180-*-*-*-*-*-*}
set times1  {*-times-bold-r-normal--*-100-*-*-*-*-*-*}
set headline {-*-courier-bold-r-normal-*-*-180-*-*-*-*-*-*}


#Color Setup
set framebg1 grey50
set framebg2 grey60
set framebg3 grey50
set framebg4 grey60
set framebg5 grey50
set Pcommbg  white
set Parbg white


#Variables
global ScopeStatus ScopeVar
global StyleStatus StyleVar
global pipe
set StyleVar "cross opaque header frame axis type stereo mc b0 rc mimps \
	       quant wire aspect wall sens plan mver neut chain"
set ScopeVar "imag omag sivd ipat opat itrig otrig pt trd rich ecal muon"
set ViewModi "xy zx zy 3D isometric dimetric trimetric u v con log-con"
set ParamVar "mc rc cmp layer sector ctopp"
set ParticleVar "e- mu- gamma p  pi- pi. K- K_S B. B_s Jpsi"  
 
#HelpTexts for Main Window widgets
    set HelpText(.draw.1) "Draw event with current settings."
    set HelpText(.draw.2) "Reset frame parameter and redraw event." 
    set HelpText(.draw.3) "Simulate next Monte Carlo event."
    set HelpText(.draw.4) "Zoom half/double and free zoom."
    set HelpText(.draw.5) "Pick an object."
    set HelpText(.draw.6) "Quit the Prism Commander."
    
    set HelpText(.view.vbutton) "Select view mode."
    set HelpText(.view.angle) "Select 3D angles. (Only in 3D view mode!)"
    set HelpText(.view.style) "Open the style selection window."
    set HelpText(.view.scope) "Open the scope selection window."
    
    set HelpText(.param.mc.value) "Restrict to MC track.\
	                           (Insert mc number !)"
    set HelpText(.param.rc.value) "Restrict to RC track."
    set HelpText(.param.cmp.value) "Restrict to component."
    set HelpText(.param.layer.value) "Restrict to layer."
    set HelpText(.param.sector.value) "Restrict to sector."
    set HelpText(.param.ctopp.value) "Restrict to particle name."
    set HelpText(.param.ok) "Apply all changed parameters."
    set HelpText(.param.reset) "Set default parameter values."
    
    set HelpText(.comm.comm.entry) "Send a prism command.( Finish\
	                            with <Return> ! )"
#HelpText for Style Window widgets

    #HelpTexts for StFrame = selec1
    set HelpText(.style.selec1.cross) "Draw crosses at rhit position."
    set HelpText(.style.selec1.opaque) "Draw opaque detector planes."
    set HelpText(.style.selec1.header) "Draw header."
    set HelpText(.style.selec1.frame) "Draw frame."
    set HelpText(.style.selec1.axis) "Draw axes."
    set HelpText(.style.selec1.type) "Draw particle type strings."
    set HelpText(.style.selec1.stereo) "Show stereo plane."
    set HelpText(.style.selec1.mc) "Show MC tracks."
    set HelpText(.style.selec1.b0) "Restrict to golden B0 daughters."
    set HelpText(.style.selec1.rc) "Show RC tracks."
    set HelpText(.style.selec1.mimps) "Show MIMPS."
    set HelpText(.style.selec1.quant) "Show QUANTITY"
    
    #HelpTexts for $StFrame = selec2
    set HelpText(.style.selec2.wire) "Show wires/hits."
    set HelpText(.style.selec2.aspect) "Force conserved aspect ratio."
    set HelpText(.style.selec2.wall) "Draw walls."
    set HelpText(.style.selec2.sens) "Use sensitive areas for drawing planes."
    set HelpText(.style.selec2.plan) "Draw planes."
    set HelpText(.style.selec2.mver) "Draw MC vertices." 
    set HelpText(.style.selec2.neut) "Show neutral particles.\
	                              ( mc must be active ! )"
    set HelpText(.style.selec2.chain) "Show whole decay chain."
    set HelpText(.style.selec2.apply) "Apply all changes."
    set HelpText(.style.selec2.default) "Set default Style values."
    set HelpText(.style.selec2.close) "Close Style Selection Window."

#HelpTexts for Scope Window widgets

    #HelpTexts for $ButFram = selec1
    set HelpText(.scope.selec1.imag) "Show inner magnet tracker."
    set HelpText(.scope.selec1.omag) "Show outer magnet tracker."
    set HelpText(.scope.selec1.sivd) "Show silicon vertex detector."
    set HelpText(.scope.selec1.ipat) "Show inner pattern tracker."
    set HelpText(.scope.selec1.opat) "Show outer pattern tracker."
    set HelpText(.scope.selec1.itrig) "Show inner trigger chambers."
    set HelpText(.scope.selec1.otrig) "Show outer trigger chambers."
    set HelpText(.scope.selec1.pt) "Show high pt trigger chambers."

    #HelpTexts for $ButFram = selec2
    set HelpText(.scope.selec2.trd) "Show transition radiation detector."
    set HelpText(.scope.selec2.rich) "Show RICH."
    set HelpText(.scope.selec2.ecal) "Show electromagnetic calorimeter."
    set HelpText(.scope.selec2.muon) "Show muon system."
    set HelpText(.scope.selec2.apply) "Apply all changes."
    set HelpText(.scope.selec2.default) "Set default Scope values."
    set HelpText(.scope.selec2.close) "Close Scope Selection Window."

#Style Setup
proc StyleSetup {} {
    global StyleStatus
    set StyleStatus(cross) n
    set StyleStatus(opaque) n
    set StyleStatus(header) y
    set StyleStatus(frame) y
    set StyleStatus(axis) y
    set StyleStatus(type) n
    set StyleStatus(stereo) n
    set StyleStatus(mc) y
    set StyleStatus(b0) n
    set StyleStatus(rc) n
    set StyleStatus(mimps) n
    set StyleStatus(quant) n
    set StyleStatus(wire) n
    set StyleStatus(aspect) y
    set StyleStatus(wall) n
    set StyleStatus(sens) n
    set StyleStatus(plan) y
    set StyleStatus(mver) y
    set StyleStatus(neut) n
    set StyleStatus(chain) n
}

StyleSetup


#Scope Setup
proc ScopeSetup {} {
    global ScopeStatus
    set ScopeStatus(imag) I
    set ScopeStatus(omag) I
    set ScopeStatus(sivd) I
    set ScopeStatus(ipat) I
    set ScopeStatus(opat) I
    set ScopeStatus(itrig) I
    set ScopeStatus(otrig) I
    set ScopeStatus(pt) O
    set ScopeStatus(trd) O
    set ScopeStatus(rich) I
    set ScopeStatus(ecal) O
    set ScopeStatus(muon) O
}

ScopeSetup


#Parameter Setup
proc ParSetup {} {
    global ParStatus
    set ParStatus(mc) 0
    set ParStatus(rc) 0
    set ParStatus(cmp) 0
    set ParStatus(layer) 0
    set ParStatus(sector) 0
    set ParStatus(ctopp) ""
}

ParSetup


# Open process pipeline
if {$argv == ""} {set pipe "stdout"} else {
    set pipe [open "|$argv" w]
    puts stdout $argv
}


# Main Window Config
wm title . " Prism Commander "
wm  geometry . 600x265+0+635
wm maxsize . 600 265
wm minsize . 600 265
tk_focusFollowsMouse
. config -bg $framebg4

#Creating Parent Frames in MainWindow ( . )
frame .draw -borderwidth 14 -width 600 -height 50 -bg $framebg1 
frame .view -borderwidth 9 -width 600 -height 50 -bg $framebg2
frame .param -borderwidth 9 -width 600 -height 80 -bg $framebg3
frame .comm -borderwidth 5 -width 600 -height 50 -bg $framebg4
frame .comm.comm  -width 320 -bg $framebg4
frame .comm.help  -width 280 -bg $framebg4 
pack .draw .view .param .comm -side top -fill x
pack .comm.comm .comm.help -side left
pack .comm.help -fill x


#Creating the DRAW-buttons
button .draw.1 -text Draw -command "Prism {display/draw}" 
button .draw.2 -text "Frame Reset" -command "Prism {display/frame -r}"
button .draw.3 -text "Next Event"  -command "Prism {run}"

menubutton .draw.4 -text Zoom \
    -menu .draw.4.zmenu -relief groove
    set zm [menu .draw.4.zmenu -tearoff 0 ]
    $zm add command -label x2 -command "Prism {display/frame -i}"
    $zm add command -label x1/2 -command "Prism {display/frame -o}"
    $zm add command -label "Free Zoom" -command "Prism {display/frame}"

menubutton .draw.5 -text Pick -menu .draw.5.pmenu -relief groove
    set pm [menu .draw.5.pmenu -tearoff 0]
    set subpath .draw.5.pmenu.sub1
    $pm add cascade -label Particle -menu $subpath
    set subm [menu $subpath -tearoff 0]
    foreach particle $ParticleVar {
	$subm add check -label $particle -variable ParStatus(ctopp) \
		-offvalue "" -onvalue $particle \
		-command "SetParam {ctopp}"
    }
    $pm add separator
    $pm add command -label MC -command "Pick {mc}"
    $pm add command -label RC -command "Pick {rc}"
    $pm add command -label Mimp -command "Pick {mimp}"
    $pm add command -label Hit -command "Pick {hit}"
    $pm add command -label Plane -command "Pick {plane}"
    
    

button .draw.6 -text Quit -command "Quit"


#Arranging the Draw Frame
foreach b {1 2 3 4 5} {pack .draw.$b -side left}
pack .draw.6 -side right
for {set i 1} {$i <= 6} {incr i} {
    bind .draw.$i <Motion> "HelpLine {.draw.$i}"
}


#Creating the VIEW and 3D-Angels Menus
label .view.label -text "View Mode : " -font $times -bg $framebg2
menubutton .view.vbutton -text "xy" \
	-menu .view.vbutton.vmenu -relief groove
    set vm [menu .view.vbutton.vmenu -tearoff 0]
    set i 0
    foreach item $ViewModi {
    $vm add command -label "$item" -command " .view.vbutton configure \
	-text $item ; Prism {display/view $i} ; ActivAngle {$item} "
    incr i
    }
frame .view.space -width 35 -bg $framebg2
button .view.angle -text "3D Angles" -state disabled \
    -command "AngleWindow"


#Creating the Scope and Style Buttons
label .view.optionlabel -text "Options : " -font $times -bg $framebg2
button .view.scope -text "Scope" -relief groove -command "ScopeWindow"
button .view.style -text "Style" -relief groove -command "StyleWindow" 


#Arranging the View Frame
pack .view.label .view.vbutton  -side left
pack .view.scope .view.style .view.optionlabel\
     .view.space .view.angle -side right
foreach item {vbutton angle style scope} {
    bind .view.$item <Motion> "HelpLine {.view.$item}"
}

#Creating the Parameter Entries
label .param.label -text "Parameters :" -font $times -bg $framebg3
pack .param.label -anchor nw
foreach item $ParamVar {
    frame .param.$item -bg $framebg3 -borderwidth 5
    label .param.$item.label -text "$item\:" -bg $framebg3
    entry .param.$item.value -width 4 -relief sunken \
        -textvariable ParStatus($item) -bg $Parbg
    bind .param.$item.value <Motion> "HelpLine {.param.$item.value}"
    bind .param.$item.value <Return> "SetParam {$item}"
    pack .param.$item.label -anchor nw
    pack .param.$item.value -anchor sw
    pack .param.$item -side left
}
button .param.ok -text "Apply All" -command "SetAllParam" 
bind .param.ok <Motion> "HelpLine {.param.ok}"
button .param.reset -text "Reset" -command "ResetAllParam"
bind .param.reset <Motion> "HelpLine {.param.reset}"
pack .param.ok .param.reset -anchor e


#Creating the Command line
set prismCmd "" ; set LastCommand ""
label .comm.comm.label -text "Command : " -width 10 -font $times -bg $framebg4
entry .comm.comm.entry -relief sunken -textvar prismCmd \
    -bg $Pcommbg -highlightbackground $Pcommbg
pack .comm.comm.label .comm.comm.entry -side left
bind .comm.comm.entry <Motion> "HelpLine {.comm.comm.entry}"
bind .comm.comm.entry <Return> "ExecPcmd"
bind .comm.comm.entry <Up> "Last"

#Creating the HelpLine
message .comm.help.msg -justify left -padx 5 -width 280 \
	-bg $framebg4 -relief groove \
	-text "Welcome to the Prism Commander."
pack .comm.help.msg -side top -fill x

#Prism Command
proc Prism {cmd} {
    global pipe
    puts $pipe "$cmd"
    flush $pipe
}

proc Pick {cmd} {
    global pipe taucher
    Prism "pick $cmd"
    #set input [open "|$argv" r]
    #set taucher  [read $pipe]
    #puts $pipe $taucher
    #return taucher
}

#3D Angle Selection Window
proc "AngleWindow" {} {
    global framebg1 framebg4 
    .view.angle config -state disabled
    toplevel .angle
    wm geometry .angle 300x240+200+640
    wm title .angle "3D Angles"
    bind .angle <Destroy> {.view.angle config -state normal}
    frame .angle.slide -width 200 -height 180 \
	    -bg $framebg1 -borderwidth 10 
    frame .angle.buttons -width 200 -height 50 \
	    -bg $framebg1 -borderwidth 10
    scale .angle.slide.theta -from -90 -to 90 -length 300 \
	    -variable theta -orient horizontal -label "3D Theta" \
	    -tickinterval 30 -showvalue true \
	    -bg $framebg1 -highlightbackground $framebg4 

    scale .angle.slide.phi -from -180 -to 180 -length 300 \
	    -variable phi -orient horizontal -label "3D Phi" \
	    -tickinterval 60 -showvalue true \
	    -bg $framebg1 -highlightbackground $framebg4
    set theta 70 
    set phi 0
    button .angle.buttons.ok -text "Ok" -command "SetAngles" \
	    -bg $framebg1 -highlightbackground $framebg1 
    button .angle.buttons.close -text "Close" -command "destroy .angle ;\
            .view.angle config -state normal" \
	    -bg $framebg1 -highlightbackground $framebg1 
    pack .angle.buttons.ok -side left -padx 20
    pack .angle.buttons.close -side right -padx 20 
    pack .angle.slide.theta -side top 
    pack .angle.slide.phi   -side top
    pack .angle.buttons .angle.slide -side top -fill x
}


#Scope Selection Window
proc ScopeWindow {} {
    global framebg1 ScopeStatus ScopeVar
    .view.scope config -state disabled
    list $ScopeVar
    set Scopelen [llength $ScopeVar]
    set a [expr int( $Scopelen / 2 ) + 2 ] 
    set winheight [expr 23*$a + 40]
    toplevel .scope
    wm title .scope "Scope"
    wm geometry .scope 200x$winheight+830+635
    wm maxsize .scope 200 $winheight
    wm minsize .scope 200 $winheight
    bind .scope <Destroy> {.view.scope config -state normal}
    frame .scope.selec1 -bg grey85 -borderwidth 5
    frame .scope.selec2 -bg grey85 -borderwidth 5
    pack .scope.selec1 .scope.selec2 -side left
    set j 0
    foreach item $ScopeVar {
	if {$j<$a} {set ButFram ".scope.selec1"} else {
	    set ButFram ".scope.selec2"
	}
      checkbutton $ButFram.$item -text "$item" -variable ScopeStatus($item)\
      -onvalue I -offvalue O -command "SetScope {$item}"    
	bind $ButFram.$item <Motion> "HelpLine {$ButFram.$item}"
      pack  $ButFram.$item -anchor nw
      incr j
      }
      button .scope.selec2.apply -text Apply -command "Prism {display/draw}"
      bind .scope.selec2.apply <Motion> "HelpLine {.scope.selec2.apply}"
      button .scope.selec2.default -text Default -command {
	  ScopeSetup
	  set a ""
	  foreach Var $ScopeVar {set a "$a $Var -$ScopeStatus($Var)"}
	  Prism "display/scope $a"
	  Prism {display/draw}
      }
      bind .scope.selec2.default <Motion> "HelpLine {.scope.selec2.default}"
      button .scope.selec2.close -text Close -command "destroy .scope"
      bind .scope.selec2.close <Motion> "HelpLine {.scope.selec2.close}"
  pack .scope.selec2.apply .scope.selec2.default \
	  .scope.selec2.close -anchor nw
}



#Style Selection Window
proc StyleWindow {} {
global framebg1 StyleVar StyleStatus
  .view.style config -state disabled
  list $StyleVar
  set Stylelen [llength $StyleVar]
  set c [expr int( $Stylelen / 2 ) + 2 ] 
  set winheight [expr 23*$c + 40 ]
  toplevel .style 
  wm title .style "Style"
  wm geometry .style 200x$winheight+615+635
  wm maxsize .style 200 $winheight 
  wm minsize .style 200 $winheight
  bind .style <Destroy> {.view.style config -state normal}
  frame .style.selec1 -bg grey85 -borderwidth 5
  frame .style.selec2 -bg grey85 -borderwidth 5
  pack .style.selec1 .style.selec2 -side left
  list $StyleVar
  set Stylelen [llength $StyleVar]
  set c [expr int( $Stylelen / 2 ) + 2 ] 
  set b 0
  foreach item $StyleVar {
	    if {$b<$c} {set StFrame ".style.selec1"} else {
	    set StFrame ".style.selec2"
	  }
	  checkbutton $StFrame.$item -text $item -variable StyleStatus($item) \
	  -onvalue y -offvalue n -command "SetStyle {$item}" 
	  bind $StFrame.$item <Motion> "HelpLine {$StFrame.$item}"
	  pack $StFrame.$item -anchor nw
  	  incr b
      }
  button .style.selec2.apply -text Apply -command "Prism {display/draw}"    
  bind .style.selec2.apply <Motion> "HelpLine {.style.selec2.apply}"
  button .style.selec2.default -text Default -command {
      StyleSetup
      set a ""
      foreach Var $StyleVar {set a "$a $Var=$StyleStatus($Var)"}
      Prism "display/style $a"
      Prism {display/draw}
  }
  bind .style.selec2.default <Motion> "HelpLine {.style.selec2.default}"
  button .style.selec2.close -text Close -command "destroy .style" 
  bind .style.selec2.close <Motion> "HelpLine {.style.selec2.close}"
  pack .style.selec2.apply .style.selec2.default \
	  .style.selec2.close -anchor nw
}


#3D-Angle Set
proc SetAngles {} {
    global theta phi 
    set pcmd "display/angles $theta $phi"
    Prism "$pcmd"
}


#Activate 3D-Angles Menu
proc ActivAngle {item} {
    if {$item == "3D"} {
    .view.angle config -state normal} else {
    .view.angle config -state disabled
	catch {
	    destroy .angle
	    .view.angle config -state disabled
	}	
    }	   
}   


#Quit Program
proc Quit {} {
    global pipe
    Prism {exit}
    Prism {y}
    Prism {  }
    catch (close $pipe)
    set d [exec sleep 1]
    exit
}


#Execute Prism Command-Line
proc ExecPcmd {} {
    global prismCmd LastCommand
    Prism "$prismCmd"
    #Delete Entry after pressing Return
    set a [string length $prismCmd]
    set LastCommand $prismCmd
    for {set i 0} {$i <= $a} {incr i} {.comm.comm.entry delete 0}
}


#Last Command again
proc Last {} {
    global LastCommand prismCmd
    if {$LastCommand != $prismCmd} {
	.comm.comm.entry insert 0 $LastCommand
    }
}


# Asyncronous host pager
Prism {HOST_PAGER 'xterm -e less &'}
Prism {prism events.ps}

#Main Window Bindings
bind . <Unmap> "catch {wm iconify .scope; wm iconify .style}"
bind . <Map> "catch {wm deiconify .scope; wm deiconify .style}"

#Set Scope
proc SetScope {item} {
    global ScopeStatus 
    set pcmd "display/scope $item -$ScopeStatus($item)"
    Prism "$pcmd"
}

#Set Style 
proc SetStyle {item} {
    global StyleStatus  
    set pcmd "display/style $item=$StyleStatus($item)"
    Prism "$pcmd"
}

#Parameter Procedures

#Single Parameter Set
proc SetParam {item} {
    global ParStatus 
    set pcmd "display/param $item=$ParStatus($item)"
    Prism "$pcmd"
    Prism {display/draw}
}

#Set all Parameters
proc SetAllParam {} {
    global ParStatus 
    set p1 "mc=$ParStatus(mc)"
    set p2 "rc=$ParStatus(rc)"
    set p3 "cmp=$ParStatus(cmp)"
    set p4 "layer=$ParStatus(layer)"
    set p5 "sector=$ParStatus(sector)"
    set p6 "ctopp=$ParStatus(ctopp)"
    set pcmd "display/param $p1 $p2 $p3 $p4 $p5 $p6"
    Prism "$pcmd"
    Prism {display/draw}
}

# Reset all Param
proc ResetAllParam {} {
    global ParStatus 
    foreach item    { mc rc cmp layer sector } { 
	set ParStatus($item) 0
    }
    set ParStatus(ctopp) " "
    SetAllParam
}


#Set Help-Message 
proc HelpLine {widget} {
    global HelpText
    set space "  "
    #.comm.help.msg config -text ""
    if {[string length $HelpText($widget)] < 50} {
	set HelpText($widget) "$HelpText($widget) $space"
    } 
    .comm.help.msg config -text "$HelpText($widget)"
}
