*-- Author :    Rainer Mankel   19/05/95

      subroutine tulocb0()

*     **** locate golden B0s & their daughters & store into /zpstat/
      implicit none
#include "arte/Arte.fi"

#include "pris/zpstat.fi"
#include "pris/zmh.fi"
      integer mc_b, mc_k0s, mc_lplus, mc_lminus, mc_piplus, mc_piminus,
     +    mc_jpsi, mc_other, mc, ndaught, tpname
      integer code_b0, code_b0b, code_jpsi, code_k0s, code_eplus,
     +     code_eminus, code_muplus, code_muminus, code_piplus,
     +     code_piminus

      logical init
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"
      data init /.false./
      save init, code_b0, code_b0b, code_jpsi, code_k0s, code_eplus,
     +     code_eminus, code_muplus, code_muminus, code_piplus,
     +     code_piminus
#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

      if (.not.init) then
         code_b0      = tpname('B.')
         code_b0b     = tpname('B~')
         code_jpsi    = tpname('Jpsi')
         code_k0s     = tpname('K_S')
         code_eplus   = tpname('e+')
         code_eminus  = tpname('e-')
         code_muplus  = tpname('mu+')
         code_muminus = tpname('mu-')
         code_piplus  = tpname('pi+')
         code_piminus = tpname('pi-')
         init = .true.
      endif

*     **** clear golden B buffer
      pstat_ngold = 0

*     **** loop over MC buffer, find B0, B0=
      do 10 mc_b=1,iq(jmtra+2)
         if (omtra_topp(mc_b).eq.code_b0
     +        .or.omtra_topp(mc_b).eq.code_b0b) then
*           **** look for daughters
            ndaught = 0
            mc_jpsi = 0
            mc_k0s = 0
            mc_other = 0

*           **** search for B0 daughter particles
            do 30 mc=mc_b+1,iq(jmtra+2)
               if (omtrx_btra(mc).eq.mc_b) then
                  ndaught = ndaught + 1
                  if (omtra_topp(mc).eq.code_jpsi) then
                     mc_jpsi = mc
                  elseif (omtra_topp(mc).eq.code_k0s) then
                     mc_k0s = mc
                  else
                     mc_other = mc
                  endif
               endif
 30         continue            ! b0 daughters

            if (ndaught.ne.2.or.mc_jpsi.eq.0 ! reject other B0 decays
     +           .or.mc_k0s.eq.0.or.mc_other.ne.0) go to 10

*           **** check J/Psi
            ndaught = 0
            mc_lplus = 0
            mc_lminus = 0
            mc_other = 0
*           **** search for J/Psi daughter particles
            do 50 mc=mc_jpsi+1,iq(jmtra+2)
               if (omtrx_btra(mc).eq.mc_jpsi) then
                  ndaught = ndaught + 1
                  if (omtra_topp(mc).eq.code_eplus
     +                 .or.omtra_topp(mc).eq.code_muplus) then
                     mc_lplus = mc
                  elseif (omtra_topp(mc).eq.code_eminus
     +                    .or.omtra_topp(mc).eq.code_muminus) then
                     mc_lminus = mc
                  else
                     mc_other = mc
                  endif
               endif
 50         continue            ! J/Psi daughters

            if (ndaught.ne.2.or.mc_lplus.eq.0 ! reject other J/Psi decs
     +           .or.mc_lminus.eq.0.or.mc_other.ne.0) go to 10

*           **** check K0S
            ndaught = 0
            mc_piplus = 0
            mc_piminus = 0
            mc_other = 0
*           **** search for K0S daughter particles
            do 70 mc=mc_k0s+1,iq(jmtra+2)
               if (omtrx_btra(mc).eq.mc_k0s) then
                  ndaught = ndaught + 1
                  if (omtra_topp(mc).eq.code_piplus) then
                     mc_piplus = mc
                  elseif (omtra_topp(mc).eq.code_piminus) then
                     mc_piminus = mc
                  else
                     mc_other = mc
                  endif
               endif
 70         continue            ! K0S daughters

            if (ndaught.ne.2.or.mc_piplus.eq.0 ! reject other K0S decays
     +           .or.mc_piminus.eq.0.or.mc_other.ne.0) go to 10

*           **** B0 -> J/Psi K0S -> (l+l-)(pi+pi-) decay found!
            if (pstat_ngold.lt.maxgold) then
               pstat_ngold = pstat_ngold + 1
               pstat_gold(1,pstat_ngold) = mc_lplus
               pstat_gold(2,pstat_ngold) = mc_lminus
               pstat_gold(3,pstat_ngold) = mc_piplus
               pstat_gold(4,pstat_ngold) = mc_piminus
               pstat_gold(5,pstat_ngold) = mc_jpsi
               pstat_gold(6,pstat_ngold) = mc_k0s
               pstat_gold(7,pstat_ngold) = mc_b

               gold_mh(mc_lplus) = .true.
               gold_mh(mc_lminus) = .true.
               gold_mh(mc_piplus) = .true.
               gold_mh(mc_piminus) = .true.

               gold_mh(mc_jpsi) = .true.
               gold_mh(mc_k0s) = .true.
               gold_mh(mc_b) = .true.

            else
               print *,' () tulocb0: golden B overflow '
            endif
         endif                  ! B0s
 10   continue                  ! mc loop

      end



