C23456789012345678901234567890123456789012345678901234567890123456789012
C        |         |         |         |         |         |         | |
C       10        20        30        40        50        60        7072
*
*CMZ :          01/11/96  13.41.45  by  T. Oest
*-- Author :    T. Oest   30/05/96
* new versionn: 14.4.97 T. Kuhn-Sander
*
      SUBROUTINE RKDERI (UPDATE, H, EC, RKH)
*
************************************************************************
*
* Description: returns the derivatives for fixed tracking length H
*
* Called from:
*
* External references:
*
* Argument in/out description
* UPDATE   in      = .TRUE. the derivatives will be updated
* H        in      step size
* FAC      in      Qc/p*sign(cos gamma)
* RKH      in/out  derivatives d POUT(5) / d PIN(5)
*
************************************************************************
*
      IMPLICIT NONE
*
#include "arte/Arte.fi"
*
      DOUBLE PRECISION H, RKH(5,5), A
      DOUBLE PRECISION RKWORK(5,5), DKDP(6,5,5), DFDP(5,5), RKCO(5,5)
      DOUBLE PRECISION SUM, EC, FAC, HEC
      INTEGER          I, J, L, M, N, II, IC
      LOGICAL          IFIRST, UPDATE
*
COME: common block from rkstep.
      DOUBLE PRECISION B(15), C(6), CST(6), PSTEPS(6,6), K(6,5)
      DOUBLE PRECISION BFIELD(6,3), FSTEPS(6,2)
*
      SAVE   RKWORK, RKCO, DFDP
*
      COMMON /CRKUT2/  PSTEPS, B, C, CST, K, BFIELD, FSTEPS
#include "arte/Arte.ff"
*
*
COME: set the values of the constant field-elements.
*
      DATA RKWORK(1,1), RKWORK(1,2) /1.0D0, 0.0D0/
      DATA RKWORK(2,1), RKWORK(2,2) /0.0D0, 1.0D0/
      DATA RKWORK(3,1), RKWORK(3,2) /0.0D0, 0.0D0/
      DATA RKWORK(4,1), RKWORK(4,2) /0.0D0, 0.0D0/
      DATA RKWORK(5,1), RKWORK(5,2) /0.0D0, 0.0D0/
      DATA RKWORK(5,3), RKWORK(5,4) /0.0D0, 0.0D0/
      DATA RKWORK(5,5) /1.0D0/
*
      DATA RKCO(1,1), RKCO(2,2), RKCO(5,5) /1.0D0, 1.0D0, 1.0D0/
*
      DATA DFDP /25*0.0D0/, DKDP /150*0.0D0/
*
************************************************************************
COME:   comparation of the variables with the text
COME:   ------------------------------------------
COME:DFDP(5,5)   = DFDP(L,J)   : L = component of the function vector f
COME:                            J = component of the vector xi
COME:                                DFDP(1,1) = df_2/dxi_2
COME:                                DFDP(1,5) = df_2/dxi_6
COME:                                DFDP(5,1) = df_6/dxi_2
COME:                                DFDP(5,5) = df_6/dxi_6
COME:
COME:DKDP(6,5,5) = DKDP(M,L,J) : M = sum limit of vector phi
COME:                            L = component of the function vector f
COME:                            J = component of the vector xi
COME:                                DKDP(1,1,1) = dk^1_2/dxi_2
COME:                                DKDP(6,1,1) = dk^6_2/dxi_2
COME:                                DKDP(1,5,1) = dk^1_6/dxi_2
COME:                                DKDP(1,1,5) = dk^1_6/dxi_6
COME:
COME:RKH(5,5) = RKH(L,J)       : L = component of the function vector f
COME:                            J = component of the vector xi
COME:                                RKH(1,1) = dxi_2,n+1/dxi_2,n
COME:                                RKH(1,5) = dxi_2,n+1/dxi_6,n
COME:                                RKH(5,1) = dxi_6,n+1/dxi_2,n
COME:                                RKH(5,5) = dxi_6,n+1/dxi_6,n
************************************************************************
*
COME: get DFDP and DKDP.
*
*
      DFDP(1,3) = H
      DFDP(2,4) = H
c
      HEC = H * EC
      FAC = PSTEPS(1,6)*HEC
*
      DO I=1,6
*
         IC  = (I-1)*(I-2)/2
*
         A   = 1.+PSTEPS(I,4)**2+PSTEPS(I,5)**2
*
COME: df_4/dphi_4, df_4/dphi_5, df_4/dphi_6.
         DFDP(3,3) =  FAC*FSTEPS(I,1) * PSTEPS(I,4) / A + 
     &                FAC*SQRT(A)*(PSTEPS(I,5)*BFIELD(I,1) - 
     &                2.00*PSTEPS(I,4)*BFIELD(I,2))
         DFDP(3,4) =  FAC*FSTEPS(I,1) * PSTEPS(I,5) / A + 
     &                FAC*SQRT(A)*(PSTEPS(I,4)*BFIELD(I,1) + 
     &                BFIELD(I,3))
         DFDP(3,5) =  HEC*FSTEPS(I,1)
*
COME: df_5/dphi_4, df_5/dphi_5, df_5/dphi_6.
         DFDP(4,3) =  FAC*FSTEPS(I,2) * PSTEPS(I,4) / A - 
     &                FAC*SQRT(A)*(PSTEPS(I,5)*BFIELD(I,2) + 
     &                BFIELD(I,3))
         DFDP(4,4) =  FAC*FSTEPS(I,2) * PSTEPS(I,5) / A + 
     &                FAC*SQRT(A)*(2.00*PSTEPS(I,5)*BFIELD(I,1) - 
     &                PSTEPS(I,4)*BFIELD(I,2))
         DFDP(4,5) =  HEC*FSTEPS(I,2)
*
         DO J=1,4
            DO L=3,5
               DKDP(I,J,L) = 0.0D0
COME:          DFDP(J,M)=0 for M=1,6
               DO M=3,5
                  SUM = 0.0D0
                  DO N=1,I-1
                     II  = IC + N
                     SUM = SUM + B(II) * DKDP(N,M,L)
                  ENDDO
                  IF (M.EQ.L) SUM = SUM + 1.0D0
*
                  DKDP(I,J,L) = DKDP(I,J,L) + DFDP(J,M) * SUM
*
               ENDDO
            ENDDO
         ENDDO
         goto 1234
c J=1     --> M=3
            DO L=3,5
                  SUM = 0.0D0
                  DO N=1,I-1
                     II  = IC + N
                     SUM = SUM + B(II) * DKDP(N,3,L)
                  ENDDO
                  IF (3.EQ.L) SUM = SUM + 1.0D0
*
                  DKDP(I,1,L) = H * SUM
*
            ENDDO
c J=2     --> M=4
            DO L=3,5
                  SUM = 0.0D0
                  DO N=1,I-1
                     II  = IC + N
                     SUM = SUM + B(II) * DKDP(N,4,L)
                  ENDDO
                  IF (4.EQ.L) SUM = SUM + 1.0D0
*
                  DKDP(I,2,L) = H * SUM
*
            ENDDO
c J=3,4   --> M=3,4
         DO J=3,4
            DO L=3,5
               DKDP(I,J,L) = DFDP(J,L)
               DO M=3,4
                  SUM = 0.0D0
                  DO N=1,I-1
                     II  = IC + N
                     SUM = SUM + B(II) * DKDP(N,M,L)
                  ENDDO
                  DKDP(I,J,L) = DKDP(I,J,L) + DFDP(J,M) * SUM
*
               ENDDO
            ENDDO
         ENDDO
 1234    continue
*
      ENDDO
*
************************************************************************
*
COME: functional matrix for this step.
*
      DO I=1,4
         DO J=3,5
            RKWORK(I,J) = C(1) * DKDP(1,I,J) + C(3) * DKDP(3,I,J) +
     &                    C(4) * DKDP(4,I,J) + C(6) * DKDP(6,I,J) 
            if (I .eq. J) RKWORK(I,J) = RKWORK(I,J) + 1
         ENDDO
      ENDDO
*
C      write(7,*) ' *** RKWORKT(I,J) = '
C      write(7,'(T2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3)') 
C     &      RKWORK(1,1),RKWORK(1,2),RKWORK(1,3),RKWORK(1,4),
C     &      RKWORK(1,5)
C      write(7,'(T2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3)') 
C     &      RKWORK(2,1),RKWORK(2,2),RKWORK(2,3),RKWORK(2,4),
C     &      RKWORK(2,5)
C      write(7,'(T2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3)') 
C     &      RKWORK(3,1),RKWORK(3,2),RKWORK(3,3),RKWORK(3,4),
C     &      RKWORK(3,5)
C      write(7,'(T2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3)') 
C     &      RKWORK(4,1),RKWORK(4,2),RKWORK(4,3),RKWORK(4,4),
C     &      RKWORK(4,5)
C      write(7,'(T2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3,TR2,E9.3)') 
C     &      RKWORK(5,1),RKWORK(5,2),RKWORK(5,3),RKWORK(5,4),
C     &      RKWORK(5,5)
*
************************************************************************
*
COME: matrix multiplication to update the error matrix.
*
      IF (UPDATE) THEN
*
         DO I=1,4
            DO J=3,5
               RKCO(I,J) = RKH(I,J)
            ENDDO
         ENDDO
      
*
         RKH(1,3) =               RKCO(1,3) + 
     &              RKWORK(1,3) * RKCO(3,3) + 
     &              RKWORK(1,4) * RKCO(4,3)
         RKH(1,4) =               RKCO(1,4) + 
     &              RKWORK(1,3) * RKCO(3,4) + 
     &              RKWORK(1,4) * RKCO(4,4)
         RKH(1,5) =               RKCO(1,5) + 
     &              RKWORK(1,3) * RKCO(3,5) + 
     &              RKWORK(1,4) * RKCO(4,5) +
     &              RKWORK(1,5)
*
         RKH(2,3) =               RKCO(2,3) + 
     &              RKWORK(2,3) * RKCO(3,3) + 
     &              RKWORK(2,4) * RKCO(4,3)
         RKH(2,4) =               RKCO(2,4) + 
     &              RKWORK(2,3) * RKCO(3,4) + 
     &              RKWORK(2,4) * RKCO(4,4)
         RKH(2,5) =               RKCO(2,5) + 
     &              RKWORK(2,3) * RKCO(3,5) + 
     &              RKWORK(2,4) * RKCO(4,5) +
     &              RKWORK(2,5)
*
         RKH(3,3) = RKWORK(3,3) * RKCO(3,3) + 
     &              RKWORK(3,4) * RKCO(4,3)
         RKH(3,4) = RKWORK(3,3) * RKCO(3,4) + 
     &           RKWORK(3,4) * RKCO(4,4)
         RKH(3,5) = RKWORK(3,3) * RKCO(3,5) + 
     &              RKWORK(3,4) * RKCO(4,5) +
     &              RKWORK(3,5)
*
         RKH(4,3) = RKWORK(4,3) * RKCO(3,3) + 
     &              RKWORK(4,4) * RKCO(4,3)
         RKH(4,4) = RKWORK(4,3) * RKCO(3,4) + 
     &              RKWORK(4,4) * RKCO(4,4)
         RKH(4,5) = RKWORK(4,3) * RKCO(3,5) + 
     &              RKWORK(4,4) * RKCO(4,5) +
     &              RKWORK(4,5)
*
      ELSE
*
         DO I=1,4
            DO J=3,5
               RKH(I,J) = RKWORK(I,J)
            ENDDO
         ENDDO

      ENDIF
*
*
************************************************************************
*
COME: End of RKDERI
*
      END
*
************************************************************************
