
*-- Author :    Rainer Mankel   04/12/94

      subroutine tffilm(ih,dlnext,jpl,ift,izf,izfnew,istat)

*     **** absorb the next hit (3D version)
      implicit none
#include "rang/zseed.fi"

#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
      integer ih, jpl, izf, izfnew, xsig_min, xsig_max, del_xsig, xsig,
     +        jzf, ift, jft, ii, jj, kk, istat, tumchit, jmc,
     +        mimp, nnmimp, dlnext, target_domain, cmp
      integer message_id_1, message_id_2
      double precision dz, du, cs_thetu, xm_p, xr_p,
     +        cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum, f(5,5)
      real wc(3), xxx(2), yyy(2), qptmax, x_border, y_border,
     +     x_margin, y_margin
      parameter (qptmax=2.)  ! max q/pt (0.5 GeV)
      logical lshould
      character*1 tfcsig
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"

      save    message_id_1, message_id_2
      data    message_id_1 /1/,message_id_2 /2/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"

      if (.not.l_mag.and..not.l_svd) then
       print *,' () tffilm: 3d only!'
       stop 'tffilm'
      endif

      if (diag_level.ge.5)
     +  print *,' tffilm: absorb ih, jpl, imc=', ih, jpl, tumchit(ih)

*     **** check if this is a "should" hit
      lshould = .false.
      if (badhits_ft(ift).eq.0.and.badsigs_ft(ift).eq.0) then
       if (tumchit(ih).eq.mc_zf(first_ft(ift))) then
        lshould = .true.
       endif
      endif

      izfnew = 0

      if (igede_cmp(jpl).eq.2) then
       xsig_min = -1
       xsig_max = +1
       del_xsig = +2
      else
       xsig_min = 0
       xsig_max = 0
       del_xsig = +2
      endif

      dz = fhitb_z(ih) - z_zf(izf)

*     **** loop over L/R signs
      do 10 xsig=xsig_min,xsig_max,del_xsig
       istat = 0
       if (n_zf.ge.nzfmx) then
        istat = -10
        call mepric(message_id_1,3,
     +       'tffilm: ranger buffer at limit, track aborted')
        go to 999
       endif
       jzf = n_zf + 1

*      **** Kalman filter prediction
       target_domain = laydom_dl(dlnext)
       if (.not.l_homog.and.filled_db(target_domain)) then
          call tftranF(target_domain,dz,izf,jzf,istat) ! short cut
       else
          call tftran(dz,izf,jzf,istat)
       endif

       if (istat.lt.0) then
        print *,' tffilm: transport was impossible, abort sign,',
     +         ' ih,ift,izf=',ih,ift,izf
        go to 10
       endif

#ifdef HISTFILM
       call hfill(6201,sngl(dz),0.,1.)
       call hfill(6202,z_zf(izf),fhitb_z(ih),1.)
       if (fault_zf(izf).eq.0) then
          call hfill(6203,sngl(dz),0.,1.)
       elseif (fault_zf(izf).eq.1) then
          call hfill(6204,sngl(dz),0.,1.)
       elseif (fault_zf(izf).eq.2) then
          call hfill(6205,sngl(dz),0.,1.)
       elseif (fault_zf(izf).eq.3) then
          call hfill(6206,sngl(dz),0.,1.)
       endif
#endif
**       call tftrans(dz,izf,jzf,f,-1,0,istat)

       if (diag_level.ge.5) then
        print *,' tffilm: start was xx(4), sq(cx(4))=',
     +            xx_zf(4,izf), dsqrt(cx_zf(4,4,izf))
        print *,' tffilm: pred=', xp_zf(2,jzf),
     +         ' error ', dsqrt( cp_zf(2,2,jzf) ), 'dz=', dz
        print *,' cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)=',
     +           cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)
       endif

*      **** projection
       if (igede_cmp(jpl).eq.2) then
        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
*       **** tan(track angle) in uz-plane
        m_u = xp_zf(3,jzf) * fgede_cos(jpl)
     +                                  - xp_zf(4,jzf) * fgede_sin(jpl)
        cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*       **** distance from projection to wire (along u)
        du = xp_zf(1,jzf) * fgede_cos(jpl)
     +     - xp_zf(2,jzf) * fgede_sin(jpl) - fhitb_x(ih)
        xm_p      = du * cs_thetu
*       **** difference to signed drift distance
        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        h_zf(1,1,jzf) =   fgede_cos(jpl) * cs_thetu
        h_zf(1,2,jzf) = - fgede_sin(jpl) * cs_thetu
        h_zf(1,3,jzf) = - du * m_u * cs_thetu**3 * ( fgede_cos(jpl))
        h_zf(1,4,jzf) = - du * m_u * cs_thetu**3 * (-fgede_sin(jpl))
        h_zf(1,5,jzf) = 0.
        hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +      +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +      +  h_zf(1,3,jzf)**2 * cp_zf(3,3,jzf)
     +      +  h_zf(1,4,jzf)**2 * cp_zf(4,4,jzf)
     +      + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) * cp_zf(1,2,jzf)
     +               + h_zf(1,1,jzf) * h_zf(1,3,jzf) * cp_zf(1,3,jzf)
     +               + h_zf(1,1,jzf) * h_zf(1,4,jzf) * cp_zf(1,4,jzf)
     +               + h_zf(1,2,jzf) * h_zf(1,3,jzf) * cp_zf(2,3,jzf)
     +               + h_zf(1,2,jzf) * h_zf(1,4,jzf) * cp_zf(2,4,jzf)
     +               + h_zf(1,3,jzf) * h_zf(1,4,jzf) * cp_zf(3,4,jzf) )

        cr_p = fhitb_r(ih)**2 + hch
       elseif (igede_cmp(jpl).eq.3) then
        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        xm_p = xp_zf(1,jzf) * fgede_rot(1,jpl)
     +       - xp_zf(2,jzf) * fgede_rot(2,jpl)
        xr_p = fhitb_x(ih) - xm_p

        h_zf(1,1,jzf) =  fgede_rot(1,jpl)
        h_zf(1,2,jzf) = -fgede_rot(2,jpl)
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        h_zf(1,5,jzf) = 0.
        hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +    + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +    + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch
       elseif (igede_cmp(jpl).eq.1) then
        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        xm_p = xp_zf(1,jzf) * fgede_cos(jpl)
     +       - xp_zf(2,jzf) * fgede_sin(jpl)
        xr_p = fhitb_x(ih) - xm_p

        h_zf(1,1,jzf) =  fgede_cos(jpl)
        h_zf(1,2,jzf) = -fgede_sin(jpl)
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        h_zf(1,5,jzf) = 0.
        hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +    + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +    + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch
       else
        print *,' tffilm: non-supported type for jpl=', jpl
       endif

       if (cr_p.lt.0.d0) then
        print *,' () tffilm: cr_p, jzf=', cr_p, jzf
        cr_p = 0.d0   ! try fix, track should not be continued
       endif

       if (diag_level.ge.5) then
               print *,' tffilm: fhitb_x(ih), xm_p, xr_p, er_p=',
     +         fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
       endif

*      **** decision
       if (dabs(xr_p).gt.dsqrt(16.d0*cr_p)) then
        if (diag_level.ge.5) then
         print *,' tffilm: hit dropped due to nsigma,',
     +       ' dabs(xr_p), dsqrt(16.d0*cr_p)=',
     +       dabs(xr_p), dsqrt(16.d0*cr_p)
        endif
        go to 10
       endif

*      **** filter point
       do ii=1,5
        kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                 + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +                 + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +                 + cp_zf(ii,4,jzf) * h_zf(1,4,jzf)
     +                 + cp_zf(ii,5,jzf) * h_zf(1,5,jzf) ) / cr_p
       enddo

*      **** updated x value
       do ii=1,5
        xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
       enddo

*      **** check curvature
       if (abs(sngl(xx_zf(5,jzf))).gt.qptmax) then
          call mepric(message_id_2,1,'tffilm: curvature limit exceeded')
       endif

*      **** updated cov matrix
       do ii=1,5
        do jj=1,5
         cx_zf(ii,jj,jzf) = 0.
        enddo
       enddo

       do ii=1,5
        do jj=ii,5
         sum = 0.
         do kk=1,5
          if (ii.eq.kk) then
           sum = sum +
     +       (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) * cp_zf(kk,jj,jzf)
          else
           sum = sum - kalman(ii,1) * h_zf(1,kk,jzf) * cp_zf(kk,jj,jzf)
          endif
         enddo
         cx_zf(ii,jj,jzf) = sum
         if (ii.ne.jj) cx_zf(jj,ii,jzf) = sum
        enddo
       enddo

*      **** updated residual
       ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +          - h_zf(1,2,jzf) * kalman(2,1)
     +          - h_zf(1,3,jzf) * kalman(3,1)
     +          - h_zf(1,4,jzf) * kalman(4,1)
     +          - h_zf(1,5,jzf) * kalman(5,1)

       xr_zf(1,jzf) = xr_p * ihk
       cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*      **** updated chi2 contribution
       ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

       if (diag_level.ge.5) then
        print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch2=',
     +            ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch_zf(jzf)
       endif

*      **** cut on chi**2 contribution
       if (ch_zf(jzf).gt.chmax_mag_zfpar) then
        if (lshould.and.tfcsig(ih,xsig).ne.'-') then
         print *,' ***'
         print *,' *** tffilm: should hit dropped due to ch_zf(jzf)=',
     +           ch_zf(jzf)
         print *,' ***'
         call tfwait()
        endif
        go to 10
       endif

#ifndef OLDCHECK
*      **** check if hit is really inside plane
       x_margin = 2.
       y_margin = 2.
       y_border = xx_zf(1,jzf) * fgede_rot(2,jpl)
     +      + xx_zf(2,jzf) * fgede_rot(1,jpl)
       if (y_border.lt.(fgede_symn(jpl)-y_margin)) go to 10
       if (y_border.gt.(fgede_symx(jpl)+y_margin)) go to 10
       x_border = xx_zf(1,jzf) * fgede_rot(1,jpl)
     +      - xx_zf(2,jzf) * fgede_rot(2,jpl)
       if (igede_shp(jpl).eq.10) x_border = x_border 
     +      - y_border * fgede_sin(jpl) / fgede_cos(jpl)
       if (x_border.lt.(fgede_sxmn(jpl)-x_margin)) go to 10
       if (x_border.gt.(fgede_sxmx(jpl)+x_margin)) go to 10
#endif

*      **** cut on 1/r
**       if (dabs(xx_zf(5,jzf)).gt.0.01....) go to 10

*      **** accept hit
       hit_zf(jzf)   = ih
       nhit_zf(jzf) = nhit_zf(izf) + 1
       plane_zf(jzf) = ihitb_gede(ih)
       cmp = igede_cmp(plane_zf(jzf))
       if (cmp.le.maxcmp_zfpar) then
          whit_zf(jzf) = whit_zf(izf) + whit_cmp_zfpar(cmp)
       else
          whit_zf(jzf) = whit_zf(jzf) + 1.
       endif
       domlay_zf(jzf) = dlnext
       z_zf(jzf) = fhitb_z(ih)
       cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
       sign_zf(jzf) = xsig
       prev_zf(jzf) = izf
       fault_zf(jzf) = 0
       pfault_zf(jzf) = fault_zf(izf)
       mc_zf(jzf) = tumchit(ih)
       call tuhmimp(ih,jmc,mimp,nnmimp)
       if (nnmimp.eq.1) then
        mimp_zf(jzf) = mimp
       else
        mimp_zf(jzf) = 0
       endif
       dim_zf(jzf) = 1
       shadow_zf(jzf) = 0
       n_zf = n_zf + 1

       izfnew = jzf

*      **** fill candidate info
       if (nca_ft.ge.ncamx) then
        print *,' () tffilm: candidate overflow, nca_ft=', nca_ft
        stop 'tffilm'
       endif
       nca_ft = nca_ft + 1
       jft = nca_ft
       first_ft(jft) = first_ft(ift)
       if (diag_level.ge.5) print *,' clone candidate, jft=', jft
       nhit_ft(jft)     = nhit_zf(jzf)
       last_ft(jft)     = jzf
       prev_ft(jft)     = prev_ft(ift)
       gen_ft(jft)      = gen_ft(ift) + 1
       nfault_ft(jft)   = nfault_ft(ift)
       quality_ft(jft)  = quality_ft(ift)
     +                    + 1.               ! bonus for new hit
     +                    - wchi_mag_zfpar * ch_zf(jzf) ! malus for chi2

       badhits_ft(jft) = badhits_ft(ift)
       badsigs_ft(jft) = badsigs_ft(ift)
       if (mc_zf(jzf).ne.mc_zf(first_ft(jft))) then
        badhits_ft(jft) = badhits_ft(jft) + 1
       else
        if (igede_cmp(jpl).eq.2) then
         if (sign_zf(jzf)*fhitb_q(hit_zf(jzf)).lt.0.)
     +                            badsigs_ft(jft) = badsigs_ft(jft) + 1
        endif
       endif
       alive_ft(jft)    = .true.
       mature_ft(jft)   = .false.
       stat_ft(jft) = stat_ft(ift)

#ifdef RGRAF
*      **** draw
       if (l_graf) then
*       **** draw markers
        call igset('LWID',1.)
        call ismk(2)
        wc(1) = xx_zf(1,izf)
        wc(2) = xx_zf(2,izf)
        wc(3) = z_zf(izf)
        call dipro(wc,xxx(1),yyy(1))
**      call ipm(1,xxx,yyy)
        wc(1) = xx_zf(1,jzf)
        wc(2) = xx_zf(2,jzf)
        wc(3) = z_zf(jzf)
        call dipro(wc,xxx(2),yyy(2))
        call ipl(2,xxx,yyy)
        call ipm(2,xxx,yyy)
        call iuwk(0,1)
       endif
#endif

 10   continue

      istat = 0

 999  end







