*CMZ :  4.04/00 02/09/96  13.15.37  by  Rainer Mankel
*CMZ :  4.02/00 19/07/96  13.56.45  by  Rainer Mankel
*CMZ :  4.01/00 03/10/95  14.36.31  by  Rainer Mankel
*CMZ :  4.00/02 27/09/95  13.28.17  by  Rainer Mankel
*CMZ :  4.00/01 04/08/95  11.05.35  by  Rainer Mankel
*CMZ :  4.00/00 04/07/95  18.26.56  by  Rainer Mankel
*CMZ :  3.04/01 07/03/95  14.46.14  by  Rainer Mankel
*-- Author :    Rainer Mankel   14/02/95

      subroutine tfidea(imc,zmin,zmax)

*     **** track fit using hits from MC ("ideal P.R.")
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"

      integer nzfmx_s, nmx
      parameter (nzfmx_s=300, nmx=20)
      integer ind_s(nzfmx_s), hit_s(nzfmx_s), nzf_s, iizf, ift, izf,
     +  jpl, xsig, ii, jj, kk, jzf, ih, istat, imc, iso, nso, gcode,
     +  mimp_s(nzfmx_s), mimp, iih, hit_array(nmx), nhits, jmc, nnmimp
      double precision dz, du, cs_thetu, xm_p, xr_p,
     +        cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum

      real xyfac, z_s(nzfmx_s), tfmitoqpt, zmin, zmax, tg, xwire
      parameter (xyfac=1.)
      logical lsmoo
      parameter (lsmoo=.true.)

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"


      ift = 1

      if (l_diag) then
       print *,' tfidea starting for imc=', imc
       call tfwait()
      endif

*     **** get izf of hits, sorted after decreasing z
      nzf_s = 0

*     **** initialize /zmh/ if needed
      call tusomh()

*     **** check id
      gcode = itopp_gean(omtra_topp(imc))

      if (.not.(
     +               (gcode.eq.8)  .or. (gcode.eq.9)
     +       .or.    (gcode.eq.11) .or. (gcode.eq.12)
     +       .or.    (gcode.eq.14) .or. (gcode.eq.15)
     +       .or.    (gcode.eq.2)  .or. (gcode.eq.3)
     +       .or.    (gcode.eq.5)  .or. (gcode.eq.6)
     +                                                 )) go to 999

*     **** loop over hits in sorted order
      if (imc.gt.nmc_mx) then
       print *,' () tfidea: too large imc=', imc
       return
      endif
      nso = nmimmh(imc)
      do 30 iso=nso,1,-1
       mimp = imimmh( istamh(imc) + iso )
*      **** get hits associated with mimp
       call tumimph(mimp,nmx,hit_array,nhits)
*      **** loop over associated hits
       do iih=1,nhits
        ih = hit_array(iih)
        if (ih.le.0.or.ih.gt.iq(jhitb+2)) then
         print *,' () tfidea: invalid ih=',ih,' at iih,mimp=',iih,mimp
         stop 'tfidea'
        endif

*       **** no merged points
        call tuhmimp(ih,jmc,mimp,nnmimp)
        if (nnmimp.gt.1) go to 30

*       **** check z
        if (fhitb_z(ih).lt.zmin.or.fhitb_z(ih).gt.zmax) go to 30

*       **** only 1 hit per plane
        if (iso.ne.nso.and.ihitb_gede(ih).eq.
     +           imimp_gede(imimmh( istamh(imc) + iso + 1 ))) go to 30

        if (nzf_s.ge.nzfmx_s) then
         print *,' () tfidea: overflowing nzf_s=', nzf_s
         go to 30
        endif
        nzf_s = nzf_s + 1
        z_s(nzf_s) = fhitb_z(ih)
        hit_s(nzf_s) = ih
        mimp_s(nzf_s) = mimp
       enddo
 30   continue

*     **** sort again (to be sure)
      call sortzv(z_s,ind_s,nzf_s,+1,1,0)

*     **** print
      if (diag_level.ge.5) then
       write(*,'(2x,4a6,a8  ,2a9  ,2a8  ,''('',a8  ,'')'',a8  )')
     +   'ihit', 'isl', 'mimp', ' imc ',' z ', ' x0 ', ' y0 ', ' mx ',
     +   ' my ', ' myp ', ' p '

       do ii=1,nzf_s
        ih = hit_s(ind_s(ii))
        mimp = mimp_s(ind_s(ii))
        write(*,'(2x,4i6,f8.2,2f9.3,2f8.5,''('',f8.5,'')'',f8.3)')
     +  ih, ogede_gesl(ihitb_gede(ih)), mimp, omimp_mtra(mimp),
     +  fmimp_z(mimp), fmimp_x(mimp), fmimp_y(mimp),
     +  fmimp_tx(mimp), fmimp_ty(mimp),
     +  fmimp_ty(mimp)/sqrt(1.+fmimp_tx(mimp)**2),
     +  fmimp_p(mimp)
       enddo
      endif

*     **** load the points
      do jzf=1,nzf_s
       ih = hit_s(ind_s(jzf))
       mimp = mimp_s(ind_s(jzf))
       hit_zf(jzf) = ih
       if (ih.lt.1.or.ih.gt.iq(jhitb+2)) then
        print *,' () tfidea: jzf,nzf_s,ih,iq(jhitb+2)=',
     +                       jzf,nzf_s,ih,iq(jhitb+2)
       endif
       jpl = ihitb_gede(ih)
       plane_zf(jzf) = jpl
       mimp_zf(jzf) = mimp
       if (diag_level.ge.5) then
        print *,' *******************'
        print *,' * tfidea: ih, jpl,isl,mimp=',
     +       ih, jpl,ogede_gesl(jpl),mimp
        print *,' *******************'
       endif
       if (igede_cmp(jpl).eq.2) then
        if (fhitb_q(hit_zf(jzf)).ge.0.) then
         xsig = +1
        else
         xsig = -1
        endif
       else
        xsig = 0
       endif
       z_zf(jzf) = fhitb_z(ih)

       sign_zf(jzf) = xsig

       if (jzf.eq.1) then
*       **** initialize prediction with MC values
        dz = fhitb_z(ih) - fmimp_z(mimp)
        xp_zf(1,jzf) = fmimp_x(mimp) + dz * fmimp_tx(mimp)
        xp_zf(2,jzf) = fmimp_y(mimp) + dz * fmimp_ty(mimp)
        xp_zf(3,jzf) = fmimp_tx(mimp)
        xp_zf(4,jzf) = fmimp_ty(mimp)
        xp_zf(5,jzf) = tfmitoqpt(mimp)

        do ii=1,5
         do jj=1,5
          cp_zf(ii,jj,jzf) = 0.
         enddo
        enddo
        cp_zf(1,1,jzf)  = 16.
        cp_zf(2,2,jzf)  = 50.
        cp_zf(3,3,jzf) = 1.
        cp_zf(4,4,jzf) = 1.
        cp_zf(5,5,jzf) = 1.7389
       else
        izf = jzf - 1
        dz = z_zf(jzf) - z_zf(izf)
*       **** Kalman filter prediction
        call tftran(dz,izf,jzf,istat)

        if (istat.lt.0) then
         print *,' tfidea: transport was impossible, abort fit for ',
     +           'imc=', imc,' z1=', z_zf(izf), ' z2=', z_zf(jzf),
     +           ' px,py,pz=', fmtra_px(imc), fmtra_py(imc),
     +                         fmtra_pz(imc)
         go to 999
        endif
       endif

*      **** projection
       if (igede_cmp(jpl).eq.2) then
        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
*       **** tan(track angle) in uz-plane
        m_u = xp_zf(3,jzf) * fgede_cos(jpl)
     +      - xp_zf(4,jzf) * fgede_sin(jpl)
        cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*       **** distance from projection to wire (along u)
**        xwire = fhitb_x(ih) + fgede_sxmn(jpl)
        xwire = fhitb_x(ih) / fgede_cos(jpl)
        du = (xp_zf(1,jzf) - xwire) * fgede_cos(jpl)
     +                      - xp_zf(2,jzf) * fgede_sin(jpl)
        xm_p      = du * cs_thetu
*       **** difference to signed drift distance
        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        h_zf(1,1,jzf) =   fgede_cos(jpl) * cs_thetu
        h_zf(1,2,jzf) = - fgede_sin(jpl) * cs_thetu
        h_zf(1,3,jzf) = - du * m_u * cs_thetu**3 * ( fgede_cos(jpl))
        h_zf(1,4,jzf) = - du * m_u * cs_thetu**3 * (-fgede_sin(jpl))
        h_zf(1,5,jzf) = 0.
        hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +      +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +      +  h_zf(1,3,jzf)**2 * cp_zf(3,3,jzf)
     +      +  h_zf(1,4,jzf)**2 * cp_zf(4,4,jzf)
     +      + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) * cp_zf(1,2,jzf)
     +               + h_zf(1,1,jzf) * h_zf(1,3,jzf) * cp_zf(1,3,jzf)
     +               + h_zf(1,1,jzf) * h_zf(1,4,jzf) * cp_zf(1,4,jzf)
     +               + h_zf(1,2,jzf) * h_zf(1,3,jzf) * cp_zf(2,3,jzf)
     +               + h_zf(1,2,jzf) * h_zf(1,4,jzf) * cp_zf(2,4,jzf)
     +               + h_zf(1,3,jzf) * h_zf(1,4,jzf) * cp_zf(3,4,jzf)
     +                                                             )

        cr_p = xyfac * fhitb_r(ih)**2 + hch
       elseif (igede_cmp(jpl).eq.3) then
*       **** warning: must care better for local coordinates!
        xwire = fhitb_x(ih) / fgede_rot(1,jpl)
        tg = fgede_rot(2,jpl) / fgede_rot(1,jpl)
        xm_zf(1,jzf)   = xwire
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2 / fgede_rot(1,jpl)**2
        xm_p = xp_zf(1,jzf) - xp_zf(2,jzf) * tg
        xr_p = xwire - xm_p

        h_zf(1,1,jzf) = 1.
        h_zf(1,2,jzf) = - tg
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        h_zf(1,5,jzf) = 0.
        hch = cp_zf(1,1,jzf) + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,2,jzf)
     +                       + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch
       elseif (igede_cmp(jpl).eq.1) then
*       **** warning: must care better for local coordinates!
**        xwire = fhitb_x(ih) + fgede_sxmn(jpl)
        xwire = fhitb_x(ih) / fgede_cos(jpl)
        tg = fgede_sin(jpl) / fgede_cos(jpl)
        xm_zf(1,jzf)   = xwire
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2 / fgede_cos(jpl)**2
**        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
**        xm_p = xp_zf(1,jzf) - xp_zf(2,jzf) * tg
**     +                                             - fgede_sxmn(jpl)
        xm_p = xp_zf(1,jzf) - xp_zf(2,jzf) * tg
        xr_p = xwire - xm_p

        h_zf(1,1,jzf) = 1.
        h_zf(1,2,jzf) = - tg
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        h_zf(1,5,jzf) = 0.
        hch = cp_zf(1,1,jzf) + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,2,jzf)
     +                       + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch
       else
        print *,' tfidea: non-supported type for jpl=', jpl
       endif

       if (diag_level.ge.5) then
               print *,' tfidea: fhitb_x(ih), xm_p, xr_p, er_p=',
     +         fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
       endif


*      **** filter point
       do ii=1,5
        kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                 + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +                 + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +                 + cp_zf(ii,4,jzf) * h_zf(1,4,jzf)
     +                 + cp_zf(ii,5,jzf) * h_zf(1,5,jzf) ) / cr_p
       enddo

*      **** updated x value
       do ii=1,5
        xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
       enddo

*      **** updated cov matrix
       do ii=1,5
        do jj=1,5
         cx_zf(ii,jj,jzf) = 0.
        enddo
       enddo

       do ii=1,5
        do jj=ii,5
         sum = 0.
         do kk=1,5
          if (ii.eq.kk) then
           sum = sum +
     +       (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) * cp_zf(kk,jj,jzf)
          else
           sum = sum -kalman(ii,1) * h_zf(1,kk,jzf) * cp_zf(kk,jj,jzf)
          endif
         enddo
         cx_zf(ii,jj,jzf) = sum
         if (ii.ne.jj) cx_zf(jj,ii,jzf) = sum
        enddo
       enddo

*      **** updated residual
       ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +          - h_zf(1,2,jzf) * kalman(2,1)
     +          - h_zf(1,3,jzf) * kalman(3,1)
     +          - h_zf(1,4,jzf) * kalman(4,1)
     +          - h_zf(1,5,jzf) * kalman(5,1)

       xr_zf(1,jzf) = xr_p * ihk
       cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*      **** updated chi2 contribution
       ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

*      **** integer values
       if (jzf.eq.1) then
        nhit_zf(jzf) = 1
        cht_zf(jzf) = ch_zf(jzf)
        prev_zf(jzf) = 0
       else
        nhit_zf(jzf) = nhit_zf(izf) + 1
        cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
        prev_zf(jzf) = izf
       endif
       fault_zf(jzf) = 0
       pfault_zf(jzf) = fault_zf(izf)
       mc_zf(jzf) = omimp_mtra(mimp)
       dim_zf(jzf) = 1
       shadow_zf(jzf) = 0
       n_zf = jzf

*      **** fill candidate info
       if (jzf.eq.1) then
        nca_ft = 1
        ift = 1
        first_ft(ift) = 1
        prev_ft(ift) = 0
        nhit_ft(ift) = 1
        gen_ft(ift) = 1
        nfault_ft(ift)   = 0
        quality_ft(ift) = 1 - 0.05 * ch_zf(jzf)
        badhits_ft(ift) = 0
        badsigs_ft(ift) = 0
        alive_ft(ift)    = .true.
        mature_ft(ift)   = .true.
        stat_ft(ift) = 2
       else
        nhit_ft(ift) = nhit_ft(ift) + 1
        last_ft(ift)     = jzf
        gen_ft(ift)      = gen_ft(ift) + 1
        quality_ft(ift)  = quality_ft(ift) + 1 - 0.05 * ch_zf(jzf)
       endif
       if (diag_level.ge.6) then
        call tfl()
        call tfwait()
       endif
       if (jzf.eq.nzf_s) then
        if (diag_level.ge.5) call tfl()
        if (diag_level.ge.2) then
         if (zmin.lt.400.) then
          call tfparm(last_ft(ift))
         else
          call tfpar2(last_ft(ift))
         endif
        endif
       endif
      enddo

      call tfstor(ift)
      if (l_diag) call tfwait()

 999  end




