*-- Author :    Rainer Mankel   16/07/96

      subroutine tfinit()

*     **** initialize the ranger parameters
*     **** to be called by atinit
      implicit none
      integer ii
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zfout.fi"

      call tfversion()          ! print version #
      call dmdef()              ! define default domain table

      dlevel_zfpar = 9          ! will be checked in tfrinit

      rlevel_zfpar = 2          ! default run level
      smooth_zfpar = 1          ! smoothing in ranger fit
      niter_zfpar  = 1          ! # iterations in ranger fit
      msmode_zfpar = 3          ! mode for mult scat correction
      max_plpick_zfpar = 199    ! max #planes picked up in ms corr
      maxflt_patx_zfpar = 2     ! max #faults in sequence (pat area,x)
      maxflt_paty_zfpar = 2     ! max #faults in sequence (pat area,y)
      maxflt_3d_zfpar   = 3     ! max N_faults in sequence (3D)
      maxflt_mag_zfpar = 1      ! max #faults in sequence (mag area)

      rmax_x_zfpar = 5          ! max rank x tracking
      rmax_y_zfpar = 5          ! max rank y tracking

      minmimp_pref_zfpar = 18   ! min #mimps for pat ref track

      cxxrf_zfpar   = 16.       ! initial cov matrix elements
      cyyrf_zfpar   = 50.       !              in ranger fit
      ctxtxrf_zfpar = 1.        !
      ctytyrf_zfpar = 1.        !
      cqqrf_zfpar   = 1.738     !

      f_moliere_zfpar = 2.9     ! m.s. correction from moliere scat

      f_cov_zfpar(1) = 1.       ! fudge factors for covariance matrix
      f_cov_zfpar(2) = 1.
      f_cov_zfpar(3) = 1.
      f_cov_zfpar(4) = 1.
      f_cov_zfpar(5) = 1.

      wchi_x_zfpar = .1    ! quality function chi**2 weight x tracking
      wchi_y_zfpar = .05   ! quality function chi**2 weight y tracking
      wchi_3d_zfpar = .1   ! quality function chi**2 weight 3d tracking
      wchi_mag_zfpar = .05 ! quality function chi**2 weight mag tracking

      do ii=1,maxcmp_zfpar
         whit_cmp_zfpar(ii) = 1. ! hit weight according to cmp
      enddo
      whit_cmp_zfpar(3) = 2.     ! hit weight according to cmp

      chmax_x_zfpar   = 8.  ! max chi**2 in filter step x tracking
      chmax_y_zfpar   = 16. ! max chi**2 in filter step y tracking
      chmax_3d_zfpar  = 8.  ! max chi**2 in filter step 3d tracking
      chmax_mag_zfpar = 16. ! max chi**2 in filter step mag tracking

      whitmin_x_zfpar   = 9. ! minimal whit for maturity x tracking
      whitmin_y_zfpar   = 9. ! minimal whit for maturity y tracking
      whitmin_3d_zfpar  = 9. ! minimal whit for maturity 3d tracking
      whitmin_mag_zfpar = 9. ! minimal whit for maturity mag tracking

      
      qplimit_zfpar = 4.17
      zmin_ec_zfpar = 250.      ! lower z bound for energy loss corr
      zmax_ec_zfpar = 650.      ! upper z bound for energy loss corr

      zmin_mag_zfpar = 100.     ! lower z bound for magnet-type tracking
      zmax_mag_zfpar = 700.     ! upper z bound for magnet-type tracking

      dzpara_mag_zfpar = 20.    ! max dz for parabolic expansion

      segstor_zfpar = .false.   ! store in track table

      llog_zfout = .false.      ! initial output levels
      lref_zfout = .false.
      lrec_zfout = .false.
      leff_zfout = .false.

      l_rinit = .false.         ! mark rinit as not yet done

      end





