
*-- Author :    Rainer Mankel   27/07/95

      subroutine tfsegfill(iseg,x,cx,x_zmax,cx_zmax)

*     **** fill track parameters into segment table entry iseg
      implicit none
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/RSEG.fi"

#include "rang/zfpar.fi"
      double precision x(5), cx(5,5), d_mx, d_my, d_qpt, sq,
     +     x_zmax(5),cx_zmax(5,5),sq_zmax
      integer iseg, i_pack, i, j
#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/RSEG.ff"


*     **** fill track parameters for first point
      sq = 1.d0/ dsqrt(1.d0 + x(4)**2 / (1.d0 + x(3)**2))

      q(qrseg_xf(iseg))  = x(1)
      q(qrseg_yf(iseg))  = x(2)
      q(qrseg_txf(iseg)) = x(3)
      q(qrseg_tyf(iseg)) = x(4)
      q(qrseg_pf(iseg))  = sq * x(5)

*      **** covariance of track parameters
      do i=1,5
         do j=i,5               ! packing
            i_pack = matrix_pack(i,j)
            q(qrseg_cvf(i_pack,iseg)) =  
     +           f_cov_zfpar(i) * f_cov_zfpar(j) * cx(i,j)
         enddo
      enddo

*     **** derivatives of q/p
      d_qpt = sq
      d_mx = x(5) * sq**3 * x(3) * x(4)**2
     +                                     / (1.d0 + x(3)**2)**2
      d_my = - x(5) * sq**3 * x(4) / (1.d0 + x(3)**2)

      i=5
      do j=1,4
         i_pack = matrix_pack(i,j)
         q(qrseg_cvf(i_pack,iseg)) =
     +        f_cov_zfpar(i) * f_cov_zfpar(j) 
     +        * (d_mx * cx(3,j) + d_my * cx(4,j) + d_qpt * cx(5,j))
      enddo
      i_pack = matrix_pack(5,5)
      q(qrseg_cvf(i_pack,iseg)) =
     +     f_cov_zfpar(5) * f_cov_zfpar(5) 
     +     * (d_mx**2 * cx(3,3) + d_my**2 * cx(4,4) + d_qpt**2 * cx(5,5)
     +     + 2. * d_mx * d_my * cx(3,4)
     +     + 2. * d_mx * d_qpt * cx(3,5)
     +     + 2. * d_my * d_qpt * cx(4,5))



*     **** fill track parameters for last point
      sq = 1.d0/ dsqrt(1.d0 + x_zmax(4)**2 / (1.d0 + x_zmax(3)**2))
      q(qrseg_xe(iseg))  = x_zmax(1)
      q(qrseg_ye(iseg))  = x_zmax(2)
      q(qrseg_txe(iseg)) = x_zmax(3)
      q(qrseg_tye(iseg)) = x_zmax(4)
      q(qrseg_pe(iseg))  = sq * x_zmax(5)

*      **** covariance of track parameters
      do i=1,5
         do j=i,5               ! packing
            i_pack = matrix_pack(i,j)
            if (dabs(cx_zmax(i,j)).gt.1.d-30) then ! avoid underflow
               q(qrseg_cve(i_pack,iseg)) = sngl( cx_zmax(i,j) )
            else
               q(qrseg_cve(i_pack,iseg)) = 0.
            endif
         enddo
      enddo

*     **** derivatives of q/p
      d_qpt = sq
      d_mx = x_zmax(5) * sq**3 * x_zmax(3) * x_zmax(4)**2
     +                                     / (1.d0 + x_zmax(3)**2)**2
      d_my = - x_zmax(5) * sq**3 * x_zmax(4) / (1.d0 + x_zmax(3)**2)

      i=5
      do j=1,4
         i_pack = matrix_pack(i,j)
         q(qrseg_cve(i_pack,iseg)) =
     +        d_mx * cx_zmax(3,j) + d_my * cx_zmax(4,j) 
     +        + d_qpt * cx_zmax(5,j)
      enddo
      i_pack = matrix_pack(5,5)
      q(qrseg_cve(i_pack,iseg)) =
     +     d_mx**2 * cx_zmax(3,3) + d_my**2 * cx_zmax(4,4) 
     +     + d_qpt**2 * cx_zmax(5,5)
     +     + 2. * d_mx * d_my * cx_zmax(3,4)
     +     + 2. * d_mx * d_qpt * cx_zmax(3,5)
     +     + 2. * d_my * d_qpt * cx_zmax(4,5)


      end
