*CMZ :          11/01/95  15.44.36  by  Rainer Mankel

      subroutine tfsmfi(ift)

*     **** 3D construction of candidate (outside magnet!)
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "rang/zplx.fi"

      integer nzfmx_s
      parameter (nzfmx_s=300)
      integer ind_s(nzfmx_s), nzf_s, iizf, iseg, ift, jft, izf, jpl,
     +        xsig, ii, jj, kk, jzf, jzf_ylast, ih, ifail, jzf_xlast
      double precision dz, du, cs_thetu, dnoise, xm_p, xr_p,
     +        cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum, dppi(4,4),
     +        ak(4,4)

      integer kkzf, kzf, ihkk, tfmitoqpt, imc, mimp, nnmimp, imcass
      real fracmc
      character*1 csig

      real pnoise, xyfac, tupmc
      integer ll, mm, seg_first(2), seg_last(2)
      double precision f(4,4)
      parameter (xyfac=1.)
      logical lsmoo
      parameter (lsmoo=.true.)

#include "arte/Arte.fi"

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"

      if (l_diag) then
       print *,' tfsmfi starting for ift=', ift
       call tfwait()
      endif

*     **** get izf of hits
      nzf_s = 0
      do iseg=1,2
       if (iseg.eq.1) then
        jft = ift
       else
        jft = prev_ft(jft)
        if (jft.le.0) then
         print *,' () tfsmfi: missing segment iseg=', iseg
         stop 'tfsmfi'
        endif
       endif

       do iizf=1,nhit_ft(jft)
        if (iizf.eq.1) then
         izf = last_ft(jft)
         seg_first(iseg) = izf
        else
         izf = prev_zf(izf)
         seg_last(iseg) = izf
        endif
        if (izf.le.0) then
           print *,' tfsmfi: izf=', izf
           stop 'tfsmfi'
        endif
        if (nzf_s.ge.100) then
           if (nzf_s.eq.100) print *,' () tfsmfi: nzf_s=',nzf_s
           if (nzf_s.ge.nzfmx_s) then
              print *,' () tfsmfi: nzf_s=',nzf_s
              stop 'tfsmfi'
           endif
        endif
        nzf_s = nzf_s + 1
        ind_s(nzf_s) = izf
       enddo
      enddo

*     **** sort according to decreasing z
      call sortzv(z_zf,ind_s,nzf_s,+1,+1,+1)

*     **** first vertical hit
**      jzf_vert = last_ft( prev_ft(ift) )

*     **** printout
      if (diag_level.ge.3) then
       print *,' tfsmfi (t): hits to be fitted:'
       do iizf=1,nzf_s
        izf = ind_s(iizf)
        ih = hit_zf(izf)
        print '((a),4i6, f10.4,2f7.3)',
     +  ' izf, ih, imc, z, MC=', izf, hit_zf(izf), plane_zf(izf),
     +                              mc_zf(izf),
     +                               z_zf(izf),sign_zf(izf),
     +                               fhitb_q(hit_zf(izf))
       enddo
      endif
      if (l_diag) call tfwait()

*     **** get pnoise
      call tfremcs(ind_s,nzf_s,imcass,fracmc)
      pnoise = sqrt(fmtra_px(imcass)**2 + fmtra_py(imcass)**2
     +     + fmtra_pz(imcass)**2)
*      print *,' tfsmfi: imcass,fracmc,pnoise=',imcass,fracmc,pnoise

*     **** filter points
      do iizf=1,nzf_s
       jzf = ind_s(iizf)

       jpl = plane_zf(jzf)
       xsig = sign_zf(jzf)
       ih = hit_zf(jzf)

       if (iizf.eq.1) then
*       **** get horizontal tp, init pred
        if (z_zf(seg_first(2)).gt.z_zf(seg_last(2))) then
           jzf_xlast = seg_first(2)
        else
           jzf_xlast = seg_last (2)
        endif
        if (z_zf(seg_first(1)).gt.z_zf(seg_last(1))) then
           jzf_ylast = seg_first(1)
        else
           jzf_ylast = seg_last (1)
        endif

        xp_zf(1,jzf) = xx_zf(1,jzf_xlast)
     +            + (z_zf(jzf) - z_zf(jzf_xlast)) * xx_zf(3,jzf_xlast)
        xp_zf(2,jzf) = xx_zf(2,jzf_ylast)
     +            + (z_zf(jzf) - z_zf(jzf_ylast)) * xx_zf(4,jzf_ylast)
        xp_zf(3,jzf) = tx_dlx(dlx1_dlx)
        xp_zf(4,jzf) = xx_zf(4,jzf_ylast)
        xp_zf(5,jzf) = 0.

        if (diag_level.ge.3) then
           print '((a),4f10.3)', ' pred init:', (xp_zf(ii,jzf),ii=1,4)
           print *,' jzf_xlast, jzf_ylast=',jzf_xlast,jzf_ylast
           call tfwait()
        endif

        do ii=1,dimp
         do jj=1,dimp
          cp_zf(ii,jj,jzf) = 0.
         enddo
        enddo
        cp_zf(1,1,jzf) = 100.
        cp_zf(2,2,jzf) = 1000.
        cp_zf(3,3,jzf) = 1.
        cp_zf(4,4,jzf) = 1.
        cp_zf(5,5,jzf) = 0.
       else
        izf = ind_s(iizf-1)
        dz = z_zf(jzf) - z_zf(izf)

*       **** Kalman filter prediction
        xp_zf(1,jzf) = xs_zf(1,izf) + dz * xs_zf(3,izf)
        xp_zf(2,jzf) = xs_zf(2,izf) + dz * xs_zf(4,izf)
        xp_zf(3,jzf) = xs_zf(3,izf)
        xp_zf(4,jzf) = xs_zf(4,izf)

*        pnoise = amax1(abs(tupmc(hit_zf(jzf))),1.)
*        dnoise = 3.d0 * fgede_ms(jpl) / pnoise**2
        dnoise = 1.d0 * fgede_ms(jpl) / pnoise**2

        cp_zf(1,1,jzf) = cs_zf(1,1,izf) + 2.d0 * cs_zf(1,3,izf) * dz
     +                                  + cs_zf(3,3,izf) * dz**2
        cp_zf(1,3,jzf) = cs_zf(1,3,izf) + cs_zf(3,3,izf) * dz
        cp_zf(3,1,jzf) = cp_zf(1,3,jzf)
        cp_zf(3,3,jzf) = cs_zf(3,3,izf) + dnoise

        cp_zf(2,2,jzf) = cs_zf(2,2,izf) + 2.d0 * cs_zf(2,4,izf) * dz
     +                                  + cs_zf(4,4,izf) * dz**2
        cp_zf(2,4,jzf) = cs_zf(2,4,izf) + cs_zf(4,4,izf) * dz
        cp_zf(4,2,jzf) = cp_zf(2,4,jzf)
        cp_zf(4,4,jzf) = cs_zf(4,4,izf) + dnoise

        cp_zf(1,2,jzf) = cs_zf(1,2,jzf)
     +                 + (cs_zf(1,4,jzf) + cs_zf(2,3,jzf)) * dz
     +                 + cs_zf(3,4,jzf) * dz**2
        cp_zf(1,4,jzf) = cs_zf(1,4,jzf) + cs_zf(3,4,jzf) * dz
        cp_zf(2,3,jzf) = cs_zf(2,3,jzf) + cs_zf(3,4,jzf) * dz
        cp_zf(3,4,jzf) = cs_zf(3,4,jzf)
        cp_zf(2,1,jzf) = cp_zf(1,2,jzf)
        cp_zf(4,1,jzf) = cp_zf(1,4,jzf)
        cp_zf(3,2,jzf) = cp_zf(2,3,jzf)
        cp_zf(4,3,jzf) = cp_zf(3,4,jzf)

*       **** test: overlay matrix form
        do ii=1,4
         do jj=1,4
          if (ii.eq.jj) then
           f(ii,jj) = 1.
          elseif ((ii.eq.1.and.jj.eq.3).or.(ii.eq.2.and.jj.eq.4)) then
           f(ii,jj) = dz
          else
           f(ii,jj) = 0.
          endif
         enddo
        enddo

        do ii=1,4
         do jj=1,4
          sum = 0.
          do ll=1,4
           do mm=1,4
            sum = sum + f(ii,ll) * cs_zf(ll,mm,izf) * f(jj,mm)
           enddo
          enddo
          cp_zf(ii,jj,jzf) = sum
         enddo
        enddo

        cp_zf(3,3,jzf) = cp_zf(3,3,jzf) + dnoise
        cp_zf(4,4,jzf) = cp_zf(4,4,jzf) + dnoise

        if (diag_level.ge.5) then
         print *,' tfsmfi: pred=', xp_zf(1,jzf),xp_zf(2,jzf),
     +          ' error ', dsqrt( cp_zf(1,1,jzf) ),
     +                     dsqrt( cp_zf(2,2,jzf) ),
     +          'dz=', dz
         print *,' cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)=',
     +            cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)
        endif
       endif

*      **** projection
       if (igede_cmp(jpl).eq.2) then
        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
*       **** tan(track angle) in uz-plane
        m_u = xp_zf(3,jzf) * cstot_plx(jpl)
     +      - xp_zf(4,jzf) * sntot_plx(jpl)
        cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*       **** distance from projection to wire (along u)
        du = xp_zf(1,jzf) * cstot_plx(jpl)  - fhitb_x(ih)
     +                                   - xp_zf(2,jzf) * sntot_plx(jpl)
        xm_p      = du * cs_thetu
*       **** difference to signed drift distance
        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
        h_zf(1,2,jzf) = - sntot_plx(jpl) * cs_thetu
        h_zf(1,3,jzf) = - du * m_u * cs_thetu**3 * ( cstot_plx(jpl))
        h_zf(1,4,jzf) = - du * m_u * cs_thetu**3 * (-sntot_plx(jpl))
        hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +      +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +      +  h_zf(1,3,jzf)**2 * cp_zf(3,3,jzf)
     +      +  h_zf(1,4,jzf)**2 * cp_zf(4,4,jzf)
     +      + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) * cp_zf(1,2,jzf)
     +               + h_zf(1,1,jzf) * h_zf(1,3,jzf) * cp_zf(1,3,jzf)
     +               + h_zf(1,1,jzf) * h_zf(1,4,jzf) * cp_zf(1,4,jzf)
     +               + h_zf(1,2,jzf) * h_zf(1,3,jzf) * cp_zf(2,3,jzf)
     +               + h_zf(1,2,jzf) * h_zf(1,4,jzf) * cp_zf(2,4,jzf)
     +               + h_zf(1,3,jzf) * h_zf(1,4,jzf) * cp_zf(3,4,jzf) )

        cr_p = fhitb_r(ih)**2 + hch
       elseif (igede_cmp(jpl).eq.3) then
*       **** warning: must care better for local coordinates!
        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
        xm_p = xp_zf(1,jzf) * cstot_plx(jpl)
     +       - xp_zf(2,jzf) * sntot_plx(jpl)

        xr_p = fhitb_x(ih) - xm_p

        h_zf(1,1,jzf) = cstot_plx(jpl)
        h_zf(1,2,jzf) = - sntot_plx(jpl)
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        hch =         cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +       + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +              + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch
       else
        print *,' tfsmfi: non-supported type for jpl=', jpl
       endif

       if (diag_level.ge.5) then
               print *,' tfsmfi: fhitb_x(ih), xm_p, xr_p, er_p=',
     +         fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
       endif

*      **** filter point
       do ii=1,4
        kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                 + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +                 + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +                 + cp_zf(ii,4,jzf) * h_zf(1,4,jzf) ) / cr_p
       enddo

*      **** updated x value
       do ii=1,4
        xs_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
       enddo
       xs_zf(5,jzf) = 0.

*      **** updated cov matrix
       do ii=1,5
        do jj=1,5
         cs_zf(ii,jj,jzf) = 0.
        enddo
       enddo

       do ii=1,4
        do jj=ii,4
         sum = 0.
         do kk=1,4
          if (ii.eq.kk) then
           sum = sum +
     +       (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) * cp_zf(kk,jj,jzf)
          else
           sum = sum - kalman(ii,1) * h_zf(1,kk,jzf) * cp_zf(kk,jj,jzf)
          endif
         enddo
         cs_zf(ii,jj,jzf) = sum
         if (ii.ne.jj) cs_zf(jj,ii,jzf) = sum
        enddo
       enddo

       if (diag_level.ge.5) then
        print *,' cp_zf(2,2,jzf)...cp_zf(4,4,jzf)=',
     +     cp_zf(2,2,jzf), cp_zf(4,2,jzf), cp_zf(2,4,jzf),
     +     cp_zf(4,4,jzf)

        print '((a),4f10.3)',' kalman=', (kalman(ii,1),ii=1,4)

        print *,' xr_p=', xr_p
       endif

       if (diag_level.ge.5) then
        print '((a)/4(f10.3,3x,4f10.3/))',
     +     ' xs_zf(,), cs_zf(1,1,jzf)...cs_zf(4,4,jzf)=',
     +     (xs_zf(jj,jzf),(cs_zf(ii,jj,jzf),ii=1,4),jj=1,4)
       endif

*      **** updated residual
       ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +          - h_zf(1,2,jzf) * kalman(2,1)
     +          - h_zf(1,3,jzf) * kalman(3,1)
     +          - h_zf(1,4,jzf) * kalman(4,1)

       xr_zf(1,jzf) = xr_p * ihk
       cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*      **** updated chi2 contribution
       ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

       if (diag_level.ge.5) then
        print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch2=',
     +            ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch_zf(jzf)
        print *,' h_zf(1,2,jzf), h_zf(1,4,jzf), cr_zf(1,1,jzf)=',
     +            h_zf(1,2,jzf), h_zf(1,4,jzf), cr_zf(1,1,jzf)
       endif

       if (diag_level.ge.3)
     +  print '(i3,4f10.3,4f10.3)',
     +  iizf, (xs_zf(ii,jzf),ii=1,4), (dsqrt(cs_zf(ii,ii,jzf)),ii=1,4)

*      **** smoothed zf info
       if (iizf.eq.1) then
        cht_zf(jzf) = ch_zf(jzf)
        prevs_zf(jzf) = 0
       else
        cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
        prevs_zf(jzf) = izf
       endif
      enddo    ! filter loop

      first_ft(ift) = ind_s(1)
      last_ft(ift)  = ind_s(nzf_s)
      nhit_ft(ift)  = nzf_s
      prev_ft(ift)  = 0
      stat_ft(ift)  = 3

*     **** backward-smoother
      if (lsmoo) then
       if (diag_level.ge.3)
     +   print *,' start smoothing ----------------------------->'
       do iizf=nzf_s-1,1,-1
        jzf = ind_s(iizf+1)
        izf = ind_s(iizf)

*       **** transport distance
        dz = z_zf(jzf) - z_zf(izf)
**        if (dz.ge.0.d0) then
**         print *,' tfsmfi: dz=', dz,' planes=', plane_zf(izf),
**     +           plane_zf(jzf)
**        endif

*       **** construct transport matrix F_(k+1) = f
        do ii=1,4
         do jj=1,4
          if (ii.eq.jj) then
           f(ii,jj) = 1.
          elseif ((ii.eq.1.and.jj.eq.3).or.(ii.eq.2.and.jj.eq.4)) then
           f(ii,jj) = dz
          else
           f(ii,jj) = 0.
          endif
         enddo
        enddo

*       **** construct gain matrix ak
        do ii=1,4
         do jj=1,4
          dppi(ii,jj) = cp_zf(ii,jj,jzf)
         enddo
        enddo
        call dsinv(4,dppi,4,ifail)
        if (ifail.ne.0) then
**         call tfls()
         print *,' tfsmfi: smoothing status:'
         print '(a5,a6,a5,a4,a5,1x,2a4,2a6,10a10)',
     +         'izf', 'hit', 'pla', 'pre', 'mc', 'nh', 'fau',
     +         'ch2', 'z', 'x', 'mx', 'y', 'my', 'cu',
     +         'xmc', 'mxmc', 'ymc', 'mymc', 'cumc'

         do kkzf=1,nzf_s
          kzf = ind_s(kkzf)
*         **** sign
          call tfsign(kzf,csig)

          ihkk = hit_zf(kzf)
          call tuhmimp(ihkk,imc,mimp,nnmimp)
          if (mimp.lt.0.or.mimp.gt.iq(jmimp+2)) stop '() tfsmfi'
          print '(i5,i6,i5,i4,i5,a1, 2i4,2f8.2,10f10.5)', kzf,
     +     ih,
     +     plane_zf(kzf), prev_zf(kzf), mc_zf(kzf), csig, nhit_zf(kzf),
     +     fault_zf(kzf),
     +     ch_zf(kzf), z_zf(kzf), xs_zf(1,kzf), xs_zf(3,kzf),
     +       xs_zf(2,kzf), xs_zf(4,kzf), xs_zf(5,kzf),
     +     fmimp_x(mimp) + (z_zf(kzf)-fmimp_z(mimp)) * fmimp_tx(mimp),
     +     fmimp_tx(mimp),
     +     fmimp_y(mimp) + (z_zf(kzf)-fmimp_z(mimp)) * fmimp_ty(mimp),
     +     fmimp_ty(mimp), tfmitoqpt(mimp)
         enddo


         print *,' () tfsmfi: ifail=',ifail
         print *,'           matrix=',((dppi(ii,jj),ii=1,4),jj=1,4)
         print *,'    skip smoothing for ift=', ift,' jzf=', jzf
         call tfwait()
         stat_ft(ift) = 2
         go to 999
**         stop 'tfsmfi'
        endif

        do ii=1,4
         do jj=1,4
          sum = 0.
          do kk=1,4
           do ll=1,4
            sum = sum + cs_zf(ii,kk,izf) * f(ll,kk) * dppi(ll,jj)
           enddo
          enddo
          ak(ii,jj) = sum
         enddo
        enddo

*       **** calculate smoothed parameters
        do ii=1,4
         sum = 0.
         do jj=1,4
          sum = sum + ak(ii,jj) * (xs_zf(jj,jzf) - xp_zf(jj,jzf))
         enddo
         xs_zf(ii,izf) = xs_zf(ii,izf) + sum
        enddo

*       **** cov matrix of smoothed parameters
        do ii=1,4
         do jj=1,4
          sum = 0.
          do kk=1,4
           do ll=1,4
            sum = sum + ak(ii,kk)
     +                * (cs_zf(kk,ll,jzf) - cp_zf(kk,ll,jzf))
     +                            * ak(jj,ll)
           enddo
          enddo
          cs_zf(ii,jj,izf) = cs_zf(ii,jj,izf) + sum
         enddo
        enddo

*       **** no smoothed update of residuals etc yet!
        if (diag_level.ge.3) then
         print '(i3,4f10.3,4f10.3)',
     +   iizf, (xs_zf(ii,jzf),ii=1,4), (dsqrt(cs_zf(ii,ii,jzf)),ii=1,4)
        endif

       enddo ! loop over hits
      endif ! smoother option

*     **** smoothed candidate info
      first_ft(ift) = ind_s(1)
      last_ft(ift)  = ind_s(nzf_s)
      nhit_ft(ift)  = nzf_s
      prev_ft(ift)  = 0
      stat_ft(ift)  = 3

      if (diag_level.ge.5) then
       call tfls()
       call tfwait()
      endif

 999  end


