*-- Author :    Rainer Mankel   19/05/95

      subroutine tfstam()

*     **** pattern recognition efficiencies etc (here: magnet)


#include "pris/zpstat.fi"
#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/RTRX.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/TOPP.fi"
      integer ncounter, code_eplus, code_eminus, code_muplus,
     +        code_muminus, max_t, tpname
      parameter (ncounter=10)
                 ! counter=1  for e+-
                 !         2  for mu+-
                 !         3  for l+-
                 !         4  for pi+-
                 !         5  for J/Psi
                 !         6  for K0S
                 !         7  for B0
                 !         8  for charged tracks
                 !         9  for charged non-e+-
                 !        10  for ghosts

      parameter (max_t=300)

      integer counter_mc_evt(ncounter), ! reference mc objects per evt
     +        counter_mc_all(ncounter), !           ||        (all evts)
     +        counter_rc_evt(ncounter), ! reference rc objects per evts
     +        counter_rc_all(ncounter), !           ||        (all evts)
     +        counter_ef_all(ncounter)  ! defined efficiency evts
      real    counter_evtef (ncounter), ! current evt efficiencies
     +        counter_allef (ncounter), ! current run efficiencies
     +        accumul_ef_all(ncounter)  ! summed efficiency   (all evts)
      integer counter, ii, mc, ind_rt, rc, nrc, iirt, it, gold, jgold,
     +        mcgold, counter_lep, lepton, imc, n_events, OK
      integer magref_nrc(maxref)
      character*20 cname
      real mass, charge, pmc, fracmc
      character*20 counter_name(ncounter) ! name of counter
      logical lrefpat(7,maxgold), lrc(7,maxgold), lrec_t(max_t)

      data n_events /0/

      data counter_name / 'golden e+-', 'golden mu+-', 'golden l+-',
     +      'golden pi+-', 'golden J/Psi', 'golden K0S', 'golden B0',
     +      'charged tracks', 'charged non-e+-', 'ghosts' /

      data counter_mc_evt /ncounter*0/,
     +     counter_mc_all /ncounter*0/,
     +     counter_rc_evt /ncounter*0/,
     +     counter_rc_all /ncounter*0/,
     +     counter_ef_all /ncounter*0/,
     +     accumul_ef_all /ncounter*0./

      save n_events, counter_mc_evt, counter_mc_all, counter_rc_evt,
     +  counter_rc_all, counter_ef_all, accumul_ef_all, counter_name

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RTRX.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/TOPP.ff"

      if (n_events.eq.0) then
         code_eplus  = tpname('e+')
         code_eminus = tpname('e-')
         code_muplus = tpname('mu+')
         code_muminus = tpname('mu-')
      endif

      n_events = n_events + 1

      do counter=1,ncounter         ! reset event scope counters
       counter_mc_evt(counter) = 0
       counter_rc_evt(counter) = 0
      enddo

      do it=1,max_t
       lrec_t(it) = .false.
      enddo

      if (.true.) then
       print *,' '
       print *,' R e f e r e n c e     T r a c k s  (M) :'
       print *,' '
       print '(3a5,a6,a20)',  ! headline
     +        'mc','rc','nrc','pmc','name'
      endif

      do ii=1,pstat_nrefmag  ! loop over reference tracks
       mc = pstat_refmag(ii)
*      **** check if reconstructed
       nrc = 0
       rc = 0

       do 10 iirt=1,20          ! locate tracks
          if (iirt.eq.1) then
             ind_rt = pmtrx_rtra(mc)
          else
             ind_rt = xmtrx_rtra(ind_rt)
          endif
          if (ind_rt.eq.0) go to 11
          rc = mmtrx_rtra(ind_rt)
          call tfremcn(rc,imc,fracmc) ! locate MC particle again
          call tfmtch(imc,rc,OK) ! check if low z reached
          if (fracmc.ge.0.7.and.irtra_fit(rc).ge.2.and.OK.eq.1) then
             nrc = nrc + 1
          endif
 10    continue
 11    continue

       magref_nrc(ii) = nrc

       if (.true.) then
        call tupaty(omtra_topp(mc),cname,charge,mass,'G')
        pmc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
        print '(3i5,f6.2,1x,a19)',
     +        mc,rc,nrc,pmc,cname
       endif


       counter = 8  ! charged particles
       counter_mc_evt(counter) = counter_mc_evt(counter) + 1
       if (nrc.gt.0) then
        counter_rc_evt(counter) = counter_rc_evt(counter) + 1
       endif

       counter = 9  ! charged non-e+-
       if (omtra_topp(mc).ne.code_eplus
     +      .and.omtra_topp(mc).ne.code_eminus) then
          counter_mc_evt(counter) = counter_mc_evt(counter) + 1
          if (nrc.gt.0) then
             counter_rc_evt(counter) = counter_rc_evt(counter) + 1
          endif
       endif

      enddo ! reference tracks

      counter = 10  ! ghosts
      do it=1,iq(jrtra+2)  ! loop over reconstructed tracks
       if (prtrx_mtra(it).eq.0) then  ! check if no corresponding MC
        counter_rc_evt(counter) = counter_rc_evt(counter) + 1
       endif
      enddo  ! RC tracks
      counter_mc_evt(counter) = counter_mc_evt(8)  ! normalize to ref tr

*     **** loop over golden Bs
      do gold=1,pstat_ngold
       do jgold=1,4  ! loop over stable golden particles
        mcgold = pstat_gold(jgold,gold)
        lrefpat(jgold,gold) = .false.  ! initialize ref track flag
        lrc    (jgold,gold) = .false.  ! initialize reco flag
        do 20 ii=1,pstat_nrefmag  ! gold part occurs in ref tracks ?
         mc = pstat_refmag(ii)
         if (mc.eq.mcgold) then
          lrefpat(jgold,gold) = .true.
          if (magref_nrc(ii).gt.0) lrc(jgold,gold) = .true.
          go to 21
         endif
 20     continue ! mc ref loop
 21     continue
*       **** check if reconstructed
******* lrc(jgold,gold) = pmtrx_rtra(mcgold).gt.0
       enddo
       lrefpat(5,gold) = lrefpat(1,gold).and.lrefpat(2,gold) ! J/Psi
       lrefpat(6,gold) = lrefpat(3,gold).and.lrefpat(4,gold) ! K0S
       lrefpat(7,gold) = lrefpat(5,gold).and.lrefpat(6,gold) ! B0
       lrc(5,gold) = lrc(1,gold).and.lrc(2,gold) ! J/Psi
       lrc(6,gold) = lrc(3,gold).and.lrc(4,gold) ! K0S
       lrc(7,gold) = lrc(5,gold).and.lrc(6,gold) ! J/Psi
      enddo


      counter = 3 ! l+-
      do gold=1,pstat_ngold
       do jgold=1,2
        if (lrefpat(jgold,gold)) then
         counter = 3 ! l+-
         lepton = omtra_topp(pstat_gold(jgold,gold))
         if (lepton.eq.code_eplus.or.lepton.eq.code_eminus) then
          counter_lep = 1
         elseif (lepton.eq.code_muplus.or.lepton.eq.code_muminus) then
          counter_lep = 2
         else
          print *,' () tfstam: invalid lepton: ', lepton
          counter_lep = 2
         endif
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         counter_mc_evt(counter_lep) = counter_mc_evt(counter_lep) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
          counter_rc_evt(counter_lep) = counter_rc_evt(counter_lep) + 1
         endif
        endif
       enddo
      enddo

      counter = 4 ! pi+-
      do gold=1,pstat_ngold
       do jgold=3,4
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
         endif
        endif
       enddo
      enddo

      do counter=5,7
       do gold=1,pstat_ngold
        jgold=counter
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
         endif
        endif
       enddo
      enddo

      do counter=1,ncounter
*      **** event-based efficiencies
       if (counter_mc_evt(counter).gt.0) then
        counter_ef_all(counter) = counter_ef_all(counter) + 1
        counter_evtef(counter) = float(counter_rc_evt(counter))
     +                         / float(counter_mc_evt(counter))
        accumul_ef_all(counter) = accumul_ef_all(counter)
     +                                 + counter_evtef(counter)
       else
        counter_evtef(counter) = 0.
       endif
*      **** update all counters
       counter_mc_all(counter) = counter_mc_all(counter)
     +                         + counter_mc_evt(counter)
       counter_rc_all(counter) = counter_rc_all(counter)
     +                         + counter_rc_evt(counter)

       if (counter_mc_all(counter).gt.0) then
        counter_allef(counter) = float(counter_rc_all(counter))
     +                         / float(counter_mc_all(counter))
       else
        counter_allef(counter) = 0.
       endif
      enddo ! updating of counters

*     **** print reconstructed tracks
      if (.true.) then
       print *,' '
       print *,' R e c o n s t r u c t e d     T r a c k s :'
       print *,' '
       print '(a4,a5,a6,2a5,a8)',  ! headline
     +       ' trk','mc','frac','hou','fit','chi'
       do it=1,iq(jrtra+2)
        call tfremcn(it,mc,fracmc)
        print '(i4,i5,f6.2,2i5,f8.2)',
     +   it,mc,fracmc,irtra_hou(it),irtra_fit(it),frtra_chi(it)
       enddo

       print *,' '
       print *,' G o l d e n     T r a c k s :'
       print *,' '

       do gold=1,pstat_ngold
        print '(''---'',4(i5,1x,a4,1x,l1,''---''))',
     +         (pstat_gold(jgold,gold),
     +         htopp_name(1,omtra_topp(pstat_gold(jgold,gold))),
     +         lrefpat(jgold,gold),jgold=1,4)
       enddo
        
      endif

*     **** printout
      if (.true.) then
       print 101, n_events,
     +            (counter_name(counter),counter_mc_evt(counter),
     +            counter_rc_evt(counter),100.*counter_evtef(counter),
     +            counter_mc_all(counter),
     +            counter_rc_all(counter),100.*counter_allef(counter),
     +                               counter=1,ncounter)

 101   format(//
     + ' |=============',
     + '====================================================| '/
     + ' |       statis',
     + 'tics from tfstam      nevents=',i6,'                |'/
     + ' |=============',
     + '====================================================|'/
     + ' | Counter     ',
     + '    MC(evt) RC(evt) ef(evt)  MC(run) RC(run) ef(run)|'/
     + 10(' | ',a15,2i7,f7.2,5x,2i7,f7.2,'  |'/),
     + ' |=============',
     + '====================================================| ')
      endif

 999  end







