
*-- Author :    Rainer Mankel   18/02/97


      subroutine tfstseg(ift)

*     **** take track candidate ift from ranger buffer
*     **** store in segment table
      implicit none
#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"
#include "auto/MTRA.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"
#include "auto/RPNT.fi"
#include "auto/RTRX.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zcut.fi"

      integer nzfmx_s
      parameter (nzfmx_s=300)

*     Integer i,j
      integer izf, ift, ih, ii,
     +     jft, iift, ihf, izf_s(nzfmx_s),
     +     nzf_s, iizf, iseg, imc

      real fracmc

      logical lchi2,llsmoo,smoothed(nzfmx_s),init

      integer maxpnt
      parameter (maxpnt=4)
      integer zfPnt(maxpnt),ipnt,jpnt,rp
      real zPnt(maxpnt),zlow,zhigh
      character*4 cc
      integer indrp

#include "pris/zmpack.fi"

      save init,zpnt,zlow,zhigh
      data init /.false./

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
#include "auto/MTRA.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"
#include "auto/RPNT.ff"
#include "auto/RTRX.ff"

*********************************************************
*
*     Meaning of the candidate flag stat_ft:
*
*        stat_ft = 1   x candidate
*                  2   y candidate
*                  3   3D, smoothed
*                  4   momentum information
*                  5   momentum information,, smoothed
*
*********************************************************

*      lsmoo = stat_ft(ift).eq.3.or.stat_ft(ift).eq.5

      if (.not.init) then 
         init = .true.
*        **** default positions
         zpnt(1) = 854.         ! begin of RICH
         zpnt(2) = 1174.        ! end   of RICH
         zpnt(3) = 1214.        ! begin of TRD
         zpnt(4) = 1290.        ! end   of TRD

         do ii=1,iq(jgesl+2)    ! look at real superlayers
            write(cc,'(a4)') hgesl_name(ii)
            if (cc.eq.'RICH') then
               zpnt(1) = fgesl_z1(ii)
               zpnt(2) = fgesl_z2(ii)
               print *,' tfsttra: RICH start/end=',zpnt(1),zpnt(2)
            elseif (cc.eq.'TRSL') then
               zpnt(3) = fgesl_z1(ii)
               zpnt(4) = fgesl_z2(ii)
               print *,' tfsttra: TRD  start/end=',zpnt(3),zpnt(4)
            endif
         enddo
         zlow = zpnt(1) - 50.
         zhigh = zpnt(4) + 50.
      endif

      if (diag_level.ge.5) call tfl()

*     **** create vector of hits
      nzf_s = 0
*     **** loop over segments in ranger buffer
      do 10 iift=1,3
       if (iift.eq.1) then
        jft = ift
       elseif (prev_ft(jft).gt.0) then
        jft = prev_ft(jft)
       else
        go to 11
       endif

       llsmoo = stat_ft(jft).eq.3.or.stat_ft(jft).eq.5
       do iizf=1,nhit_ft(jft)

        if (iizf.eq.1) then
         izf = last_ft(jft)
        else
         if (.not.llsmoo) then
          izf = prev_zf(izf)
         else
*         **** smoothed ordering
          izf = prevs_zf(izf)
         endif
        endif
        if (izf.eq.0) then
         print *,' () tfstseg: izf=', izf,
     +           ' iift,iizf,ift,jft,stat_ft,nhit_ft,llsmoo=',
     +             iift,iizf, ift, jft, stat_ft(ift), nhit_ft(jft),
     +             llsmoo
         call tfwait()
         stop 'tfstseg'
        endif
        if (hit_zf(izf).eq.0) go to 31 ! skip dummy hit
        if (nzf_s.lt.nzfmx_s) then
         nzf_s = nzf_s + 1
         izf_s(nzf_s) = izf
         smoothed(nzf_s) = llsmoo
        else
         print *,' () tfstseg: overflowing nzf_s=', nzf_s
         stop ' tfstseg '
        endif
       enddo
 31    continue
 10   continue
 11   continue

      if (diag_level.gt.0) then
       print *,' tfstseg: nzf_s=', nzf_s
       print *,'         izf_s=', (izf_s(iizf),iizf=1,nzf_s)
      endif

*      **** security check
      ih = hit_zf(izf_s(1))
      if (nzf_s.eq.0.or.ih.le.0.or.ih.gt.iq(jhitb+2)) then
         print *,' () tfstseg: nzf_s,ii,ih,iq(jhitb+2),ift,nhit_ft =',
     +        nzf_s,ii,ih,iq(jhitb+2),ift,
     +        nhit_ft(ift)
         call tfwait()
         go to 999
**        stop 'tfstseg'
      endif

      call mmbook(jrseg,1)      ! increase row counter
      iseg = nrseg()

      lchi2 = .true.

*     **** take impact parameter of lowest-z point
      izf = izf_s(1)

      q(qrseg_zf_l()) = z_zf(izf)
      q(qrseg_ze_l()) = z_zf(izf_s(nzf_s))

      

*     **** fill track parameters
      if (.not.smoothed(1)) then ! first point segment not smoothed
         if (smoothed(nzf_s)) then 
            call tfsegfill(iseg,xx_zf(1,izf),cx_zf(1,1,izf),
     +           xs_zf(1,izf_s(nzf_s)),cs_zf(1,1,izf_s(nzf_s)))
         else
            call tfsegfill(iseg,xx_zf(1,izf),cx_zf(1,1,izf),
     +           xx_zf(1,izf_s(nzf_s)),cx_zf(1,1,izf_s(nzf_s)))
         endif
      else                      ! first point segment smoothed
         if (smoothed(nzf_s)) then
            call tfsegfill(iseg,xs_zf(1,izf),cs_zf(1,1,izf),
     +           xs_zf(1,izf_s(nzf_s)),cs_zf(1,1,izf_s(nzf_s)))
         else
            call tfsegfill(iseg,xs_zf(1,izf),cs_zf(1,1,izf),
     +           xx_zf(1,izf_s(nzf_s)),cx_zf(1,1,izf_s(nzf_s)))
         endif
      endif

*     **** set segment flag
      if (stat_ft(ift).le.3) then
         iq(iqrseg_fit_l()) = 1
      else
         iq(iqrseg_fit_l()) = 2
      endif
      q (qrseg_chi_l()) = cht_zf(izf_s(1))

      iq(iqrseg_cmp_l()) = 6    ! flag magnet & pattern tracker

      do 20 ii=nzf_s,1,-1       ! decreasing z order
         izf = izf_s(ii)
         ih = hit_zf(izf)
         if (ih.le.0.or.ih.gt.nhitb()) then
            print *,' () tfstseg: izf, nzf_s, ii, ih, iq(jhitb+2)=',
     +           izf, nzf_s, ii, ih, iq(jhitb+2)
            go to 20
         endif
*        **** allocate row for new hit in hfit table
         call mmbook(jrhit,1)
         ihf = nrhit()

         if (.not.smoothed(ii)) then
            q(qrhit_x_l())  = xx_zf(1,izf)
            q(qrhit_y_l())  = xx_zf(2,izf)
            q(qrhit_tx_l()) = xx_zf(3,izf)
            q(qrhit_ty_l()) = xx_zf(4,izf)
            q(qrhit_p_l())  = xx_zf(5,izf)
         else
            q(qrhit_x_l())  = xs_zf(1,izf)
            q(qrhit_y_l())  = xs_zf(2,izf)
            q(qrhit_tx_l()) = xs_zf(3,izf)
            q(qrhit_ty_l()) = xs_zf(4,izf)
            q(qrhit_p_l())  = xs_zf(5,izf)
         endif

         if (igede_cmp(plane_zf(izf)).eq.2) then ! set quantity in RHIT
            q(qrhit_q_l()) = abs(fhitb_q(ih)) * sign_zf(izf)
         else
            q(qrhit_q_l()) = 0.
         endif

**       iq(iqrhit_rtra_l()) = it  ! track
         call mmbrel(jhirh,ih,ihf) ! relation hitb <-> rhit

         call mmbrel(jrsrh,iseg,ihf) ! relation rseg <-> rhit

*        **** set track assignment in zhitb
         if (ih.gt.0.and.ih.le.nhitb()) then
            call mmbrel(jrshi,iseg,ih)
         else
            print *,' () tfstseg: invalid ih=', ih
         endif

 20   continue   ! hitf loop

*     **** MC owned  ?
      call tfremcs(izf_s,nzf_s,imc,fracmc)

      if (imc.ne.0.and.fracmc.gt.0.7) then
*        **** set relation rseg <-> mtra
         call mmbrel(jrsmt,iseg,imc)
      endif

*     **** produce RPNTs
*     **** ipnt = 1      before RICH
*     ****        2      after  RICH
*     ****        3      before TRD
*     ****        4      after  TRD

      do ipnt=1,maxpnt
         zfPnt(ipnt) = 0
      enddo

*     **** locate the proper points
      do 40 ii=1,nzf_s       ! loop over hits
         izf = izf_s(ii)
         ih = hit_zf(izf)
         if (ih.le.0) go to 40
         if (z_zf(izf).lt.zlow.or.z_zf(izf).gt.zhigh) go to 40
         
         ipnt = 1
         if (z_zf(izf).le.zPnt(ipnt).and.z_zf(izf).gt.(zPnt(ipnt)-50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).lt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

         ipnt = 2
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

         ipnt = 3
         if (z_zf(izf).le.zPnt(ipnt).and.z_zf(izf).gt.(zPnt(ipnt)-50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).lt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

         ipnt = 4
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+50.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
            endif
         endif

 40   continue

*     **** weedout the duplicates
      do ipnt=1,maxpnt
         do jpnt=ipnt+1,maxpnt
            if (zfPnt(jpnt).eq.zfPnt(ipnt)) zfPnt(jpnt) = 0
         enddo
      enddo

*     **** store the RPNTs
      do ipnt=maxpnt,1,-1
         if (zfPnt(ipnt).gt.0) then
            izf = zfPnt(ipnt)
            call mmbook(jrpnt,1)
            rp = nrpnt()
            q(qrpnt_zf_l()) = z_zf(izf)
            if (.not.smoothed(1)) then ! for tracks without smoothing
               call tfpnfill(rp,xx_zf(1,izf),cx_zf(1,1,izf))
            else                ! for tracks with smoothing
               call tfpnfill(rp,xs_zf(1,izf),cs_zf(1,1,izf))
            endif

            call mmbrel(jrsrp,iseg,rp) ! set relation
         endif
      enddo

 50   if (diag_level.ge.1) then
       print *,' **************************************************'
       print *,' *    track stored, current number=',iseg
       print *,' *                             ift=',ift
       print *,' *                  number of hits=',nzf_s
       print *,' *                    total chi**2=',frseg_chi(iseg)
       print *,' **************************************************'
      endif

 999  end




