*-- Author :    Rainer Mankel   25/02/96

      subroutine tftpar2(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)

*     **** check reconstructed track parameters against MC
      implicit none
      double precision covi(4,4)
      real pa(4), pamc(4), dpa(4), ch2mc, ex(4), dpanorm(4), zref
      integer i, j, ndf, ifail, mimp, jaux, assmimp, istat, i_pack, ii,
     +     it, imc, ih, icode
      real charge, mass, corc(4,4), cms, tx, ty
      character*20 cname
#include "arte/Arte.fi"
#include "rang/zfpar.fi"
#include "rang/zrtdir.fi"

#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MIMX.fi"
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/MTRA.fi"
#include "auto/RTRX.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MIMX.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/MTRA.ff"
#include "auto/RTRX.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

      istat = 0
      ndf = 4
      zref = frtra_zf(it)

*     **** get first hit...
      ih = 0	
      if (prtrx_hitb(it).gt.0) then
         ih = mrtrx_hitb(prtrx_hitb(it))
      endif

      if (ih.eq.0) then
         print *,' tftpar2: missing HITB'
         istat = -1
         go to 999
      endif

*     **** get mimp
      mimp = 0
      do 10 ii=1,99
         if (ii.eq.1) then
            jaux = phitb_mimp(ih)
         else
            jaux = xhitb_mimp(jaux)
         endif
         if (jaux.eq.0) go to 11
         assmimp = mhitb_mimp(jaux)
         if (omimp_mtra(assmimp).eq.imc) then
            mimp = assmimp
            go to 11
         endif
 10   continue
      istat = -1
      print *,' () tftpar2: loop ended!'
      stop 'tftpar2'
 11   continue

      if (mimp.eq.0) then
         istat = -1
         print *,' () tftpar2: no valid mimp found for hit=',ih
         go to 999
      endif

      if (abs(fmimp_z(mimp)-zref).gt.50.) then
         print *,' () tftpar2: funny z ', fmimp_z(mimp), zref,
     +        ' abort tftpar2'
         print *,'             hit=',ih,' mimp=',mimp
         istat = -1
         go to 999
      endif

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
       if (mimp.eq.0) then
        print *,' tftpar2: mimp=', mimp  ! mimp ambiguous (allowed)
        istat = -1
        go to 999
       else
        print *,' () tftpar2: mimp=', mimp  ! mimp invalid
        stop 'tftpar2'
       endif
      endif

      icode = omtra_topp( omimp_mtra(mimp) )
      call tupaty(icode,cname,charge,mass,'G')

      tx = fmimp_tx(mimp)
      ty = fmimp_ty(mimp)

      pamc(1) = fmimp_x(mimp)
     +        + tx * (zref - fmimp_z(mimp))
      pamc(2) = fmimp_y(mimp)
     +        + ty * (zref - fmimp_z(mimp))
      pamc(3) = tx
      pamc(4) = ty

      pa(1) = frtra_xf(it)
      pa(2) = frtra_yf(it)
      pa(3) = frtra_txf(it)
      pa(4) = frtra_tyf(it)

      do i=1,4
         do j=1,4
            i_pack = matrix_pack(i,j)
            corc(i,j) = frtra_cvf(i_pack,it)
         enddo
      enddo

*     **** add last M.S.
      if (.false.) then
         cms = fgede_ms(imimp_gede(mimp)) / fmimp_p(mimp)**2
         corc(3,3) = corc(3,3) + cms
         corc(4,4) = corc(4,4) + cms
      endif

      do i=1,4
         dpa(i) = pa(i) - pamc(i)
         ex(i)  = sqrt(corc(i,i))
         dpanorm(i) = dpa(i) / ex(i)
      enddo

*     **** MC chi2
      ch2mc = 0.
      do i=1,ndf
         do j=1,ndf
            covi(i,j) = corc(i,j)
         enddo
      enddo

**      write(*,'((a),4(/4e11.3))') 'before inv:',covi
      call dsinv(ndf,covi,4,ifail)
      if (ifail.ne.0) then
         print *,' () tftpar2: mx inversion fails'
         print '(10x,(a)/4(12x,4e14.5/))',
     +        ' matrix was ',
     +        ((corc(i,j),i=1,4),j=1,4)
         istat = -1
         go to 999
      endif
**      write(*,'((a),4(/4e11.3))') 'after  inv:',covi
      do i=1,ndf
         do j=1,ndf
            ch2mc = ch2mc + dpa(i) * dpa(j) * covi(i,j)
**          print *,' chi2 contr, i,j,contr=',
**     +            i,j,dpa(i) * dpa(j) * covi(i,j)
         enddo
      enddo
      if (ifail.ne.0) print *,' =====> ifail,chi2=',ifail,ch2mc





 999  end





