*CMZ :  4.04/01 15/10/96  19.02.14  by  Rainer Mankel
*-- Author :    Rainer Mankel   15/10/96

      subroutine tftpara(ndim,x_in,z_in,z_out,x_out,f,istat)

*     **** parabolic expansion of magnet propagator in d_z
      implicit none
      double precision fTx,fTy,Ax,Ay,dAx_dTx,dAy_dTx,dAx_dTy,dAy_dTy,
     +     Tx,Ty,z_in,z_out,f(5,5),d_z,c,x_in(5),x_out(5)
      real H(3),X(3)
      integer ndim,istat

      d_z = z_out - z_in
      c = 0.00029975d0          ! assume field in kG

      X(1) = x_in(1)
      X(2) = x_in(2)
      X(3) = z_in
      call utfeld(X,H)

      Tx = x_in(3)
      Ty = x_in(4)
      fTx = dsqrt(1.d0+Tx**2)
      fTy = dsqrt(1.d0+Ty**2)
      Ax  = - fTx
     +     * (H(2) * fTx - H(3) * Ty - H(1) * Tx * Ty)
      Ay  = - fTx
     +     * (H(3) * Tx + H(2) * Tx * Ty - H(1) * fTy)

      x_out(1) = x_in(1) + Tx * d_z
     +     + 0.5 * Ax * x_in(5) * c * d_z**2
      x_out(2) = x_in(2) + Ty * d_z
     +     + 0.5 * Ay * x_in(5) * c * d_z**2
      x_out(3) = Tx + Ax * x_in(5) * c * d_z
      x_out(4) = Ty + Ay * x_in(5) * c * d_z
      x_out(5) = x_in(5)

      dAx_dTx = -(3.d0 * H(2) * Tx * (1.d0 + Tx**2)
     +     - H(1) * Ty * (1.d0 + 2.d0 * Tx**2)
     +     - H(3) * Tx * Ty) / fTx

      dAy_dTx = -((H(3) + H(2) * Ty) * (1.d0 + 2.d0 * Tx**2)
     +     - H(1) * Tx * (1.d0 + Ty**2)) / fTx

      dAx_dTy = (H(3) + H(1) * Tx) * fTx

      dAy_dTy = (-H(2) * Tx + 2.d0 * H(1) * Ty) * fTx

      f(1,1) = 1.d0
      f(1,2) = 0.d0
      f(1,3) = d_z + 0.5 * dAx_dTx * x_in(5) * c * d_z**2
      f(1,4) =       0.5 * dAx_dTy * x_in(5) * c * d_z**2
      f(1,5) =       0.5 * Ax * c * d_z**2

      f(2,1) = 0.d0
      f(2,2) = 1.d0
      f(2,3) =       0.5 * dAy_dTx * x_in(5) * c * d_z**2
      f(2,4) = d_z + 0.5 * dAy_dTy * x_in(5) * c * d_z**2
      f(2,5) =       0.5 * Ay * c * d_z**2

      f(3,1) = 0.d0
      f(3,2) = 0.d0
      f(3,3) = 1.d0 + dAx_dTx * x_in(5) * c * d_z
      f(3,4) =        dAx_dTy * x_in(5) * c * d_z
      f(3,5) =        Ax * c * d_z

      f(4,1) = 0.d0
      f(4,2) = 0.d0
      f(4,3) =        dAy_dTx * x_in(5) * c * d_z
      f(4,4) = 1.d0 + dAy_dTy * x_in(5) * c * d_z
      f(4,5) =        Ay * c * d_z

      f(5,1) = 0.d0
      f(5,2) = 0.d0
      f(5,3) = 0.d0
      f(5,4) = 0.d0
      f(5,5) = 1.d0

      istat = 0

      end
