*-- Author :    Rainer Mankel   15/01/95

      subroutine tftran(dz,izf,jzf,istat)

*     **** construct transport matrix for any case
      implicit none
#include "arte/Arte.fi"
      integer izf, jzf, npoints, ifstart, ifend, istat, ii, jj, kk, ll,
     +        mm,iii,jjj,ndimmag,ipl,imc,mimp,nnmimp
      parameter (ndimmag=5)
      double precision dz, z_target, rrstart
      real entry_pt(3), exit_pt(3), pnoise, dnoise
      double precision entry_z, exit_z, sum
#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zcut.fi"

#include "pris/hgmagnhelp.fi"

#include "rang/zma.fi"
      double precision f (ndimmag,ndimmag), f1(ndimmag,ndimmag),
     +       f2(ndimmag,ndimmag)
      double precision x_border(ndimmag)

#include "auto/HITB.fi"
#include "auto/GEDE.fi"
#include "auto/GESL.fi"
#include "auto/MIMP.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEDE.ff"
#include "auto/GESL.ff"
#include "auto/MIMP.ff"

*     **** local statement functions
      entry_z() = dble( entry_pt(3) )
      exit_z()  = dble( exit_pt (3) )

      istat = 0
      ipl = plane_zf(izf)

      z_target = z_zf(izf) + dz

*     **** step 1: determine case flags
*            ifstart=0 : Runge-Kutta transport
*            ifstart=1 : starting point outside magnet
*                    2 :    ||          inside    ||
*            ifend  =1 : exit     point outside   ||
*                    2 :    ||          inside    ||

      if (.not.l_homog) then    ! inhomogeneous field
         if (amax1(z_zf(izf),sngl(z_target)).lt.zmin_mag_zfpar
     +        .or.amin1(z_zf(izf),sngl(z_target)).gt.zmax_mag_zfpar)
     +                                                            then
            ifstart = 1
            ifend   = 1
         else
            ifstart = 0
            ifend = 0
         endif

      else                      ! homogeneous field

         if (z_zf(izf).gt.(zposmg+rmag)
     +        .and.z_target.gt.(zposmg+rmag)) then
            ifstart = 1
            ifend   = 1
         else
*           **** check more precisely if starting point is inside magnet
            rrstart = (z_zf(izf) - zposmg)**2 + xx_zf(1,izf)**2
*           **** start flag
            if (rrstart.gt.dble(rmag**2)) then
               ifstart = 1
            else
               ifstart = 2
            endif
*           **** search intersection
            call tfmgl(ifstart,izf,npoints,entry_pt,exit_pt)
*           **** check endpoint
            if (npoints.gt.0) then
               if (ifstart.eq.1) then
                  if (z_target.gt.entry_z()
     +                 .or.z_zf(izf).lt.entry_z()) then
                     ifend= 1
*     *          print *,' tftran: end point outside magnet'
                  else
                     ifend = 2
*     *          print *,' tftran: end point inside magnet'
                  endif
               else
                  if (z_target.lt.exit_z()) then
                     ifend= 1
**          print *,' tftran: end point outside magnet'
                  else
                     ifend = 2
**          print *,' tftran: end point inside magnet'
                  endif
               endif
            else
*              **** no further intersection with magnet path
*              **** assume track stays in medium
               ifend = ifstart
            endif
         endif
      endif

*     **** step 2: transport vector & fill derivative matrix f
      if (ifstart.eq.0) then

         if (abs(sngl(dz)).gt.dzpara_mag_zfpar) then
            call tftrkut(ndimmag,xx_zf(1,izf),dble(z_zf(izf)),z_target,
     +           xp_zf(1,jzf),f,istat)
         else
            call tftpara(ndimmag,xx_zf(1,izf),dble(z_zf(izf)),z_target,
     +           xp_zf(1,jzf),f,istat)
         endif
         if (istat.lt.0) then
            print *,' tftran: transport impossible (rk) '
            go to 999
         endif

      elseif (ifstart.eq.1.and.ifend.eq.1) then
*      **** start/end outside magnet
*      **** ignore possibility of WHOLE MAGNET in between
       xp_zf(1,jzf) = xx_zf(1,izf) + dz * xx_zf(3,izf)
       xp_zf(2,jzf) = xx_zf(2,izf) + dz * xx_zf(4,izf)
       xp_zf(3,jzf) = xx_zf(3,izf)
       xp_zf(4,jzf) = xx_zf(4,izf)
       xp_zf(5,jzf) = xx_zf(5,izf)

*      **** f matrix
       do ii=1,5
        do jj=1,5
         if (ii.eq.jj) then
          f(ii,jj) = 1.
         elseif ((ii.eq.1.and.jj.eq.3).or.(ii.eq.2.and.jj.eq.4)) then
          f(ii,jj) = dz
         else
          f(ii,jj) = 0.
         endif
        enddo
       enddo
      elseif (ifstart.eq.2.and.ifend.eq.2) then
*      **** track fully contained in magnet
       call tfthel(ndimmag,xx_zf(1,izf),dz,xp_zf(1,jzf),f,istat)
       if (istat.lt.0) then
        print *,' tftran: transport impossible (hel) '
        go to 999
       endif
      else
*      **** split transport into inside & outside pieces
       if (ifstart.eq.1.and.ifend.eq.2) then
*       **** from outside to inside
        call tftlin(ndimmag,xx_zf(1,izf),entry_z()-z_zf(izf),
     +             x_border,f1)
        call tfthel(ndimmag,x_border,z_target-entry_z(),
     +             xp_zf(1,jzf),f2,istat)
        if (istat.lt.0) then
         print *,' tftran: transport impossible (lin/hel) '
         go to 999
        endif

       elseif (ifstart.eq.2.and.ifend.eq.1) then
*       **** from inside to outside
        call tfthel(ndimmag,xx_zf(1,izf),exit_z()-z_zf(izf),
     +             x_border,f1,istat)
        if (istat.lt.0) then
         print *,' tftran: transport impossible (hel/lin) '
         go to 999
        endif

        call tftlin(ndimmag,x_border,z_target-exit_z(),
     +             xp_zf(1,jzf),f2)

       endif

*      **** combine derivative matrices
       do ii=1,ndimmag
        do jj=1,ndimmag
         sum = 0.
         do kk=1,ndimmag
          sum = sum + f2(ii,kk) * f1(kk,jj)
         enddo
         f(ii,jj) = sum
        enddo
       enddo
      endif

*     **** step 3: propagate cov matrix
      if (hit_zf(izf).gt.0) then
         call tuhmimp(hit_zf(izf),imc,mimp,nnmimp)
         pnoise = amax1(abs( fmimp_p(mimp) ),1.)
      else                      ! dummy hit
         pnoise = 5.
      endif
      if (fgede_ms(ipl).gt.0.) then
       dnoise = 1.d0 * (fault_zf(izf) + 1) * fgede_ms(ipl) / pnoise**2
      elseif (igede_cmp(ipl).eq.3) then
*      **** temporary: use old MSGC value until new value available
       dnoise = 1.d0 * (fault_zf(izf) + 1) * 0.6750e-6 / pnoise**2
      else
       print *,' () tftran: no fgede_ms for ipl=', ipl
       dnoise = 0.
      endif
**      print *,' tftran: izf, ih, fgede_ms, pnoise, dnoise=',
**     +          izf, hit_zf(izf), fgede_ms(ipl), pnoise, dnoise

      do ii=1,5
       do jj=ii,5
        sum = 0.
        do ll=1,5
         do mm=1,5
          if (ll.eq.mm.and.(ll.eq.3.or.ll.eq.4)) then
           sum = sum + f(ii,ll) * (cx_zf(ll,mm,izf)+dnoise) * f(jj,mm)
          else
           sum = sum + f(ii,ll) * cx_zf(ll,mm,izf) * f(jj,mm)
          endif
         enddo
        enddo
        cp_zf(ii,jj,jzf) = sum
        cp_zf(jj,ii,jzf) = sum
       enddo
      enddo

      if (diag_level.ge.6) then
       print *,' tftran: dz, izf=',dz,izf
       print *,' tftran: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
       print *,' tftran: cx_zf(,,izf)',
     +     ((cx_zf(iii,jjj,izf),iii=1,5),jjj=1,5)
       print *,' tftran: xp_zf=',(xp_zf(iii,jzf),iii=1,5)
       print *,' tftran: cp_zf=',
     +     ((cp_zf(iii,jjj,jzf),iii=1,5),jjj=1,5)
      endif

 999  end



