#include "rich/PhotonDetection.h"

extern int RICHdebug;


//=========================================================================
//
//   initialisation of class PMType and input/output
//
/*
PMType::PMType() {
  CPMT d;
  a=ArtePointer<CPMT>::append(d);
  }
*/  
PMType::PMType(ArtePointer<CPMT> aa) {
  int i;
  
  a    =aa;
  nnx  =aa->nx;
  xxdiv=aa->xdiv;
  nny  =aa->ny;
  yydiv=aa->ydiv;
  
  for (i=sizeof(a->type)-1;i>=0;i--) if (a->type[i]!=' ') break;
  ttype=(char*) malloc(i+2);
  memcpy(ttype,a->type,i+1);
  ttype[i+1]='\0';
 
  eff=Table(a->ieff,a->neff);
  
  xxmin=-(nnx*xxdiv)/2.;
  yymin=-(nny*yydiv)/2.;  

  numchan=nnx*nny;

  }

//
//  initialize from ascii file
//
PMType::PMType(ScriptFile& f) {
  char n[256],tag[256];
  CPMT pmt;


  if (RICHdebug) printf("HAllo\n");
  f.getline(n);
  sscanf(n,"%s",tag);
  if (RICHdebug) printf("%s\n",tag);
  ttype=strdup(tag);

  while (f.getline(n)) {
    char *s=n;
    sscanf(s,"%s",tag);s+=f.itemlength(s,1);
    int err=0;
    if      (!strcmp(tag,"numchannel"))   err=(sscanf(s,"%d",&numchan)!=1);
    else if (!strcmp(tag,"numchannel_x")) err=(sscanf(s,"%d",&nnx)    !=1);
    else if (!strcmp(tag,"numchannel_y")) err=(sscanf(s,"%d",&nny)    !=1);
    else if (!strcmp(tag,"division_x"))   err=(sscanf(s,"%lf",&xxdiv)  !=1);
    else if (!strcmp(tag,"division_y"))   err=(sscanf(s,"%lf",&yydiv)  !=1);
    else if (!strcmp(tag,"quantum_efficiency")) eff=Table(f);
    else if (!strcmp(tag,"end"))  break;
    else {
      fprintf(stderr,"PMType(ScriptFile):  Unknown tag: %s %d\n",tag,err);
      exit(0);
      }
    }

  pmt.nx  =nnx;
  pmt.xdiv=xxdiv;
  pmt.ny  =nny;
  pmt.ydiv=yydiv; 
  pmt.ny  =nny;
  pmt.ieff=eff.firstpoint();
  pmt.neff=eff.numpoints();

  xxmin=-(nnx*xxdiv)/2.;
  yymin=-(nny*yydiv)/2.;
 
  size_t i,l=sizeof(pmt.type);
  for (i=0;i<l;i++) pmt.type[i]=' ';
  if (l>strlen(name())) l=strlen(name());
  memcpy(pmt.type,name(),l);
  a=ArtePointer<CPMT>::append(pmt);
  }


// 
//  print data
//
void PMType::print(FILE* fp) {
  fprintf(fp,"#\n#\n");
  fprintf(fp,"pmtype %s\n",name());
  fprintf(fp,"  numchannel    %d\n",numchannel());
  fprintf(fp,"  numchannel_x  %d\n",numcol());
  fprintf(fp,"  numchannel_y  %d\n",numrow());
  fprintf(fp,"  division_x    %f\n",xxdiv);
  fprintf(fp,"  division_y    %f\n",yydiv);
  fprintf(fp,"#\n");
  fprintf(fp,"#    Table with wavelength dependent detection efficiencies\n");
  fprintf(fp,"#    with intervalls of equal sizeof equal size\n");
  fprintf(fp,"  quantum_efficiency\n");
  eff.print(fp,0);
  fprintf(fp,"  end\n");
  }

PMType::~PMType() {
  if (ttype) delete ttype;
  }


