#include "rich/PhotonDetection.h"

extern int RICHdebug;

// ==========================================================================
//    
//    get the hit channel 
//

int PhotonDetectorCell::dodetect(const Photon& p,int *id) {
  int k;
//
//
  double x,y;
  int ret=0;
  if (pm().Collector()) {
    if((ret=pm().Collector()->trace(p,&x,&y))) return ret;
    }
  else {
    x=p.x().x();
    y=p.x().y();
    }
  if ((k=pm().channelindex(x,y))>=0&&(ret=pm().dodetect(k,p))==NO_LOSS) {
    *id=ID(k);
    return NO_LOSS;
    }
  else if (k<0) {
    return CEL_LOSS_OUTOFPMTAREA;
    }
  return ret;
  } 


Vec3 PhotonDetectorCell::pos(int channel,double costhein,double phiin) {
  Vec3 ret;
  if (pm().Collector()) 
    ret=pm().Collector()->inversetrace(
       pm().type().x(channel),pm().type().y(channel),costhein,phiin);
  else
    ret=Vec3(pm().type().x(channel),pm().type().y(channel),0);
  return ret;
  }
  
PhotonDetectorCell::PhotonDetectorCell(PM* pppm) {
  ppm=pppm; 
  id=new int[pm().numchannel()];
  int i;
  for (i=0;i<pm().numchannel();i++) {
    id[i]=ChannelID(pm().SuperModule(),pm().Row(),pm().Col(),i);
    }
  }
PhotonDetectorCell::~PhotonDetectorCell() { 
  delete id;
  }

