#include "rich/PhotonDetection.h"
#include "rich/vessel.h"

extern "C" {

void F77NAME(traceupper)(float *x,float *n,float *path) {
  Photon p;
  p.x()=Vec3(x);p.x()*=10;
  p.n()=Vec3(n);
  double l,ll;

  RICH_Vessel->track_upper(&p,&l);
  RICH_Detector->intersection(p,&ll);
  Vec3 xx=RICH_Detector->hitpos();

  *path=(l+ll)/10.;
  x[0]=xx[0]*0.1;
  x[1]=xx[1]*0.1;
  x[2]=xx[2]*0.1;
  }

void F77NAME(tracelower)(float *x,float *n,float *path) {
  Photon p;
  p.x()=Vec3(x);p.x()*=10;
  p.n()=Vec3(n);
  double l,ll;

  RICH_Vessel->track_lower(&p,&l);
  RICH_Detector->intersection(p,&ll);
  Vec3 xx=RICH_Detector->hitpos();

  *path=(l+ll)/10.;
  x[0]=xx[0]*0.1;
  x[1]=xx[1]*0.1;
  x[2]=xx[2]*0.1;
  }

float F77NAME(geomeff)(float *x,float *p,float *costhe,int *n) {
//
// init coordinates: z-axis parallel to particle momentum
//                   x-axis arbitrary in plane vertical to momentum
//
  CoordinateSystem A;
  A.setrotation(Vec3(p)); // x,y arbitrary, but perpendicular to \vec{p}.
  A.x0()=10*Vec3(x);

  Photon pp;
  int i;
  double eff=0;
  for (i=0;i<*n;i++) { 
    double phi=2*M_PI*rnd_normal();
  
    pp.n()     = A.RotateToOld(FromPolar(1,*costhe,phi));
    pp.x()     = A.x0();
    
    int r1=RICH_Vessel->geometry_trace(&pp);
    int r2=RICH_Detector->hit_in_acceptance(pp);
    if (!r1&&r2 ) eff++;
    }
  eff/= *n;
  return eff;
  }

} // extern "C"
