
      SUBROUTINE TRACKPAR(IRTRA,R0,PR,OK)

************************************************************************
*
* Created: October 1997 by Ignacio Arinyo
*
* Description: Finds the entry point of the track to the RICH and its momentum.
*
* Called from: ricrec.F
*
* Arguments:
*  IN    IRTRA   Row in table RTRA.
*  OUT   R0(3)   Entry point to the RICH.
*  OUT   PR(3)   Momentum at entry point.
*  OUT   OK      Returns .false. if there is any problem.
*
************************************************************************


      implicit none

#include "arte/Arte.fi"
#include "auto/EV.fi"
#include "auto/CON.fi"
#include "auto/GEO.fi"

#include "rire/ricpar.fi"

c variable declaration

      REAL R0(3),PR(3)
      REAL X,Y,Z,X2,Y2,Z2,TX,TY,zhit,p

      INTEGER I,I2,J,J2,irtra,irow,irowlast,irowrhit
      LOGICAL OK

#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/CON.ff"
#include "auto/GEO.ff"

      
      OK=.TRUE.

      X=0.
      Y=0.
      Z=0.
      x2=9999.
      y2=9999.
      z2=9999.
      

      I=PRTRX_HITB(IRTRA)
      J=0
      j2=0
 10   IF(I.NE.0) THEN
           
         irow=MRTRX_HITB(I)
         ZHIT=FHITB_Z(IROW)

         IF(ZHIT.GE.Z.AND.ZHIT.LE.ZRICHMIN) THEN
            Z=ZHIT
            X=FHITB_X(IROW)
            Y=FHITB_Y(IROW)
            J=J+1
            IROWLAST=IROW
         ENDIF

         I=XRTRX_HITB(I)
         GOTO 10
      ENDIF

      I2=PHITB_RHIT(IROWLAST)
 20   IF(I2.NE.0) THEN
c        IROWRHIT is row in table RHIT

         IROWRHIT=MHITB_RHIT(I2)
c        IRTRA is reconstructer track,IRHIT_RTRA(IROWRHIT) is 
c        track number for RTRA

         IF(IRHIT_RTRA(IROWRHIT).EQ.IRTRA) THEN
            X2=FRHIT_X(IROWRHIT)
            Y2=FRHIT_Y(IROWRHIT)
            TX=FRHIT_TX(IROWRHIT)
            TY=FRHIT_TY(IROWRHIT)
            P=ABS(1./FRHIT_P(IROWRHIT))
            J2=J2+1


         ENDIF

         I2=XHITB_RHIT(I2)
         GOTO 20
      ENDIF

      if(j.le.0) then
         C78='RICH reconstruction: track without link from table 
     &        RTRA to HITB'
         call me78wa
         OK=.FALSE.
         RETURN
      endif

      if(j2.le.0) then
         C78='RICH reconstruction: track without link from table 
     &        HITB to RHIT'
         call me78wa

         OK=.FALSE.
         RETURN
      endIF

      if(p.eq.0) then
         C78='RICH reconstruction: track with momentum equal zero'
         call me78wa

         OK=.FALSE.
         RETURN
      endIF

      R0(1)=X2
      R0(2)=Y2
      R0(3)=Z

      PR(3)=P/SQRT(TX**2+TY**2+1.)
      PR(1)=TX*PR(3)
      PR(2)=FRTRA_TYF(IRTRA)*PR(3)

      if(R0(1).eq.0..and.R0(2).eq.0..and.R0(3).eq.0.) then
         C78='RICH reconstruction: entry point at RICH (0,0,0)'
         call me78wa

         OK=.FALSE.
         RETURN
      endif
      if(pR(1).eq.0..and.pR(2).eq.0..and.pR(3).eq.0.) then
         C78='RICH reconstruction: track momentum (0,0,0)'
         call me78wa

         OK=.FALSE.
      endif

      RETURN
      END










