#ifndef __RingSearchARTE_H__
#define __RingSearchARTE_H__
// -------------------------------------------------------------------//

#include "rise/phila.h"
#include "rise/ring.h"
extern "C"
{
  void rcrings_ ();
}
class RingSearchARTE {
  PhiLambda phila;
  Hits h;
  DualSpace d;
  void FillRSEG();
  void makeHitMap();
public:
  RingSearchARTE(char *path);
  void getrings();
  void getrings(double radius);
  inline int    numrings()    const { return d.numring();  }
  // correction for bending
  inline double phi(int i)    const { 
    double phi=d.x0refit(i);
    //cout<<"phi="<<phi;
    phi+=0.0100*phi+1.5e-12*phi*phi*phi;
    //cout<<" newphi="<<phi<<endl;
    return phi;
  }//@@@
  inline double lambda(int i) const { return d.y0refit(i); }
  inline double tx(int i)     const { 
    return d.tx(i)*1.0156;      
  }
  inline double ty(int i)     const { return d.ty(i);      }
  inline double radius(int i) const { return d.radius(i);  }
  inline Ring   getRing(int i)const { return d.getRing(i); }
  inline int    imtra(int i)  const { return d.mctrack(i); }


  /*@@@
  inline double covar(int i,int j)  const { return d.covar(i,j); }
  inline double sigma(int i)        const { return d.sigma(i);    }
  inline int    rec_photons(int i)  const {return d.rec_photons(i);}
  inline int    bg_photons(int i)   const {return d.bg_photons(i);}
  inline double hitphi(int i,int j) const {return d.hitphi(i,j);}
  inline double hitlambda(int i,int j)   const {return d.hitlambda(i,j);}
  inline double hitassigned(int i,int j) const {return d.hitassigned(i,j);}
  */

  };

extern RingSearchARTE *RICH_Search;
#endif
