//-----------------------------------------------------------------------//
//
//  phila.C : Program for stand alone RICH reconstruction, 
//            required by RingSearchARTE
//
//  Author: Denis Dujmic
//
//  Created: May-98
//
//  All Files: RingSearchARTE.C, RingSearchARTE.h, ring.C, ring.h,
//             phila.C,  phila.h    
//
//-----------------------------------------------------------------------//

#include "rise/phila.h"

//-----------------------------------------------------------------//
SinglePhiLambda::SinglePhiLambda(ScriptFile &f) {

  char n[256],tag[256];

  while (f.getline(n)) {
    char *s=n;
    sscanf(s,"%s",tag);s+=f.itemlength(s,1);
    int err=0;
    //if      (!strcmp(tag,"Supermodule")) continue;  
    if (!strcmp(tag,"lambda0"))   
      err=(sscanf(s,"%lf",&lambda0)!=1);
    else if (!strcmp(tag,"dlam/dR")) 
      err=(sscanf(s,"%lf",&dldr)!=1);
    else if (!strcmp(tag,"dlam/dC"))   
      err=(sscanf(s,"%lf",&dldc)!=1);
    else if (!strcmp(tag,"phi0"))   
      err=(sscanf(s,"%lf",&phi0)  !=1);
    else if (!strcmp(tag,"dphi/dR")) 
      err=(sscanf(s,"%lf",&dpdr)!=1);
    else if (!strcmp(tag,"dphi/dC"))   
      err=(sscanf(s,"%lf",&dpdc)  !=1);
    else if (!strcmp(tag,"d2phi/dRdC")) 
      err=(sscanf(s,"%lf",&d2pdrdc)!=1);
    else if (!strcmp(tag,"R0"))
      err=(sscanf(s,"%lf",&row0)!=1);
    else if (!strcmp(tag,"C0"))
      err=(sscanf(s,"%lf",&col0)!=1);
    else if (!strcmp(tag,"end"))  break;
    else {
      fprintf(stderr,
	     "PhiLambda(ScriptFile):  Unknown tag: %s %d\n",tag,err);
      exit(0);
    }
  } 
}

//-----------------------------------------------------------------//

PhiLambda::PhiLambda(char *path) {
    char n[256],tag[256];
    int num,row,col;

    strcpy(n,path);
    strcat(n,"/phila.dat");
    ScriptFile fpl(n);
    while (fpl.getline(n)) {
      char *s=n;
      sscanf(s,"%s",tag);s+=fpl.itemlength(s,1);
      if (!strcmp(tag,"PhiLambdaConversion")) continue;
      else if (!strcmp(tag,"NumberOfSupermodules")) {
	sscanf(s,"%d",&numsm);
	spl=new SinglePhiLambda* [numsm];
      }
      else if (!strcmp(tag,"Supermodule")) {
	sscanf(s,"%d%d",&row,&col);
	if (row==0) num=13-col;
	else if (row==1) num=col;
	else { 
	  fprintf(stderr,"\n Error in phi-lambda.dat\n\n");
	  exit(1);
	}
	spl[num]=new SinglePhiLambda(fpl);
      }
      else {
        fprintf(stderr,"phila.dat: Unknown tag: %s\n",n);
        exit(1);
      }
    }
}

// -------------------------------------------------------------------//
