*CMZ :  1.00/01 02/08/96  18.10.08  by   Ivan Belyaev
*CMZ :  1.04/11 11/12/95  14.25.56  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.28.12  by  joerg f. rieling
*CMZ :  1.04/07 10/08/95  15.20.38  by  joerg f. rieling
*CMZ :  1.04/06 15/06/95  15.23.22  by  joerg f. rieling
*CMZ :  1.04/05 06/06/95  13.53.56  by  joerg f. rieling
*CMZ :  1.04/04 23/05/95  16.30.34  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.50.56  by  joerg f. rieling
*-- Author :

c     ------------------------------------------------------------
      subroutine SGETPRTRK
c
c     -- fills common block ZSIPRTRK with data of reconstructable
c     -- tracks. Is called every event.
c
c     ------------------------------------------------------------

      implicit none

      intrinsic atan, abs, sqrt,len

c     --- common blocks

#include "arte/Arte.fi"
#include "auto/EV.fi"
#include "auto/SI.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

#include "susi/zsiconst.fi"
#include "susi/zsiprtrk.fi"
#include "gean/ZGESL.fi"

c     --- local variables
      INTEGER      iMTRA,iHITB,iMIMP,i,NSL,ISL,KSL,jAUX,jAUX1
      PARAMETER(   NSL=20 )
      REAL         PX,PY,PZ,P,TX,TY,XIP,YIP
      REAL         SL(NSL)
      CHARACTER*12 CNAME
* 
      INTEGER    LENOCC
      EXTERNAL   LENOCC 

c     --- bank d''s, statement functions

#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/SI.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

C*

      IF( JSPAR .LE. 0 )THEN
       C78='SUSi Error! SUSi Parameters are not defined Yet!'
       CALL MEMESC(12479028,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       CALL SUSIDEFV
      ENDIF 


C*    No PROPER TRACK business 
      IF( ISPAR_PROP(NSPAR()) .EQ. 0 )RETURN 

c     --- init counters in zsiprtks
      n_0  = 0
      n_1  = 0
      n_2  = 0
      n_3  = 0
      n_4  = 0
      n_x  = 0
      n_p  = 0
      n_ip = 0
      n_SL = 0
c     --- test all mc tracks in this event

C*    Reset buffer:
      IF( JSTPR .NE. 0 )CALL MMDROP(JSTPR) 

      CALL MMBWRK(JTEMP,100,1,10)

      DO iMTRA  = 1 , NMTRA()
C*     Charged only 
       IF(ITOPP_CHRG(OMTRA_TOPP(iMTRA)).EQ.0)GO TO 10
C*     Reset the working space
       IQ( JTEMP + 2 ) = 0 
       PX = FMTRA_PX( iMTRA ) 
       PY = FMTRA_PY( iMTRA ) 
       PZ = FMTRA_PZ( iMTRA )
       P  = SQRT( PX * PX + PY * PY + PZ * PZ ) 
       IF( P .LT. FSPAR_PMIN(NSPAR()) )GO TO 10  
       IF( ABS( PZ ) .LE. 1.0E-15 )THEN 
        C78='SUSi warning! Particle P='
        CALL CH78AF(P*1.0E+15,-5)
        CALL CH78CC( 'PZ=' ) 
        CALL CH78AF(PZ*1.0E+15,-5)
        CALL CH78AC( '(in 1e-15)')
        CALL CH78CC( 'skip it!')
        CALL MEMESC(1471987,0,ILARGEST,C78(1:LENOCC(C78)))
        GO TO 10 
       ENDIF 
C*     Select only "stable" particles 
       CALL CHHTOC(IQ(HQTOPP_NAME(1,
     &                 OMTRA_TOPP(iMTRA))),CNAME)
       IF( CNAME(1:LENOCC(CNAME)) .NE. 'pi+' .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'pi-' .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'K+'  .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'K-'  .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'e+'  .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'e-'  .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'mu+' .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'mu-' .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'p'   .AND. 
     &     CNAME(1:LENOCC(CNAME)) .NE. 'p~' )GO TO 10  
       N_P = N_P + 1 
       TX  = PX/P 
       XIP = FMVER_X(OMTRX_BVER(iMTRA)) - 
     &       TX*FMVER_Z(OMTRX_BVER(iMTRA))
       TY  = PY/P 
       YIP = FMVER_Y(OMTRX_BVER(iMTRA)) - 
     &       TY*FMVER_Z(OMTRX_BVER(iMTRA))
       IF( ABS( XIP ) .GT. FSPAR_TWIN(NSPAR()) .OR. 
     &     ABS( YIP ) .GT. FSPAR_TWIN(NSPAR()) )GO TO 10 
       N_IP = N_IP + 1 
C*     Collect HITS in SiVD for the particle iMTRA 
       DO ISL=1,NSL
        SL(ISL)=0
       ENDDO 
       jAUX = PMTRX_MIMP( iMTRA ) 
       DO WHILE( jAUX .NE. 0 )
        iMIMP = MMTRX_MIMP( jAUX ) 
        IF( iMIMP .LE. 0 .OR. iMIMP .GT. NMIMP())THEN
         C78='SUSi Error! Wrong MIMP='
         CALL CH78AI( iMIMP )
         CALL CH78BC( 'for MTRA=' )
         CALL CH78AI( iMTRA ) 
         CALL CH78CC( 'skip it!' ) 
         CALL MEMESC(7562379,0,ILARGEST,C78(1:LENOCC(C78)))
         GO TO 20
        ENDIF 
        IF(IGEDE_CMP(IMIMP_GEDE(iMIMP)).NE.LGESL_SIL)GO TO 20 
        jAUX1 = PMIMX_HITB( iMIMP ) 
        DO WHILE( jAUX1 .NE. 0 ) 
         iHITB = MMIMX_HITB( jAUX1 ) 
         IF( iHITB .LE. 0 .OR. iHITB .GT. NHITB())THEN
          C78='SUSi Error! Wrong HITB='
          CALL CH78AI( iHITB )
          CALL CH78BC( 'for MIMP=' )
          CALL CH78AI( iMIMP ) 
          CALL CH78BC( 'for MTRA=' )
          CALL CH78AI( iMTRA ) 
          CALL CH78CC( 'skip it!' ) 
          CALL MEMESC(327597,0,ILARGEST,C78(1:LENOCC(C78)))
          GO TO 20
         ENDIF 
         CALL MMBOOK(JTEMP,1) 
         IQ(L_L(1,JTEMP))=iHITB
         ISL     = IGESL_NSL(OGEDE_GESL(IMIMP_GEDE(iMIMP)))
         SL(ISL) = SL(ISL)+1  
         jAUX1 = XMIMX_HITB( jAUX1 ) 
        ENDDO 
 20     CONTINUE
        jAUX  = XMTRX_MIMP( jAUX ) 
       ENDDO
       KSL = 0  
       DO ISL=1,NSL 
        IF(SL(ISL).NE.0)KSL=KSL+1
       ENDDO       
       IF( KSL .EQ. 0 ) N_0 = N_0 + 1
       IF( KSL .EQ. 1 ) N_1 = N_1 + 1
       IF( KSL .EQ. 3 ) N_2 = N_2 + 1
       IF( KSL .EQ. 3 ) N_3 = N_3 + 1
       IF( KSL .EQ. 4 ) N_4 = N_4 + 1
       IF( KSL .GE. 5 ) N_X = N_X + 1
       IF( KSL .LT. ISPAR_MHSL(NSPAR()) )GO TO 10 
C*     Remove gamma''s daughters
       CALL CHHTOC(IQ(HQTOPP_NAME(1,
     &                 OMTRA_TOPP(
     &                 OMVER_BTRA(
     &                 OMTRX_BVER(iMTRA))))),CNAME)
       IF(CNAME(1:LENOCC(CNAME)).EQ.'gamma')GO TO 10 
C*     Book the Proper Track
       CALL MMBOOK(JSTPR,1)
       IQ(IQSTPR_MTRA_L())  = iMTRA 
       IQ(IQSTPR_NHIT_L())  = N_U(JTEMP)
       DO i = 1 , N_U(JTEMP)
        CALL MMBOOK(JSHPR,1)
        IQ(IQSHPR_HITB_L()) = I_V(1,i,JTEMP)
C*      Book relation STPR<-->SHPR 
        CALL MMBREL(JSPSH,NSTPR(),NSHPR())
       ENDDO  
 10    CONTINUE
      ENDDO 


      IF(JSSTA    .LE. 0 )CALL SUSISTAT 
      IF( NSSTA() .NE. 1 )CALL SUSISTAT
 
      IQ(IQSSTA_NSTP_L())=ISSTA_NSTP(NSSTA())+NSTPR()
      IF( NSTPR() .LT. ISSTA_MNPF(NSSTA()))THEN
       IQ(IQSSTA_MNPF_L())=NSTPR()
      ENDIF
      IF( NSTPR() .GT. ISSTA_MXPF(NSSTA()))THEN
       IQ(IQSSTA_MXPF_L())=NSTPR()
      ENDIF
       Q( QSSTA_YSTP_L()) =FSSTA_YSTP(NSSTA())+NSTPR()**2      

      RETURN 
      END 




