
      SUBROUTINE SKAPARA

************************************************************************
*
* $Source: /afs/desy.de/group/hera-b/repository/ARTE/susi/skapara.F,v $
* $Revision: 1.4 $
* $Author: hbcvs $
* $Date: 1998/09/03 08:28:56 $
*
* Created: Feb 30, 1991 by The Unknown Hacker
*
* Description: 
* KUIP SUSIPARAMETERS command
*
* Called from: KUIP
*
* Arguments:
* name       in/out/update Argument description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"

      CHARACTER *12 KEY 
      INTEGER       L ,IPAR
      LOGICAL       FIRST 
      REAL          PAR 

      INTEGER       LENOCC 
      EXTERNAL      LENOCC 
      
      SAVE          FIRST
      DATA          FIRST / .TRUE. /  

#include "arte/Arte.ff"
#include "auto/SI.ff"

      IF( JSUSI .LE. 0 )THEN
       C78='SUSi Warning!No SUSI table in memory, command ignored!'
       CALL MEMESC(19649164,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       RETURN
      ENDIF 

      IF( FIRST )THEN 
       C78='SUSi warning!The default values will be activated!' 
       CALL ME78AP 
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       FIRST = .FALSE. 
      ENDIF 

      IF( JSPAR .LE. 0 )THEN
       C78='SUSi warning!The default values will be activated !' 
       CALL ME78AP 
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ENDIF 

      CALL KUGETC(KEY,L)
      IF( L .LE. 0 )THEN
       C78='SUSi warning!The default values will be activated  !' 
       CALL ME78AP 
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       RETURN 
      ENDIF 

      KEY = KEY(1:LENOCC(KEY))
      L   = LENOCC(KEY)
      IF(      L.GE.3 .AND. KEY(1:3).EQ.'DEF')THEN
       C78='SUSi warning!The default values will be activated!' 
       CALL MEMESC(2037420,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       RETURN 
      ELSEIF(  L.GE.3 .AND. KEY(1:3).EQ.'QUA')THEN
       CALL KUGETR(PAR)
       C78='SUSi Minimal Track quality Parameters is changed from'
       CALL CH78BF(FSPAR_QUAL(NSPAR()),-5) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-3)
       CALL CH78CC('(default is' )
       CALL CH78BF( MIN_QUAL , -3 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(24904,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_QUAL_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.3 .AND. KEY(1:3).EQ.'PER')THEN
       CALL KUGETR(PAR)
       C78='SUSi Minimal HIT-Percentage Parameters is changed from'
       CALL CH78BF(FSPAR_PERC(NSPAR()),-4) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-4)
       CALL CH78CC('(default is' )
       CALL CH78BF( 0.7 , -3 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(237356,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_PERC_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'WMIS')THEN
       CALL KUGETR(PAR)
       C78='SUSi Weighting Parameters for Missing Hits is changed from'
       CALL CH78BF(FSPAR_WMIS(NSPAR()),-5) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-5)
       CALL CH78CC('(default is' )
       CALL CH78BF( WEIGHT_MISS , -3 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(253934,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_WMIS_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'WCHI')THEN
       CALL KUGETR(PAR)
       C78='SUSi Weighting Parameters for Chi2 is changed from'
       CALL CH78BF(FSPAR_WCH2(NSPAR()),-3) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-3)
       CALL CH78CC('(default is' )
       CALL CH78BF( WEIGHT_CHI2 , -3 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(875028,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_WCH2_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'MINT')THEN
       CALL KUGETR(PAR)
       C78='SUSi Minimal Tolerance Parameter is changed from'
       CALL CH78BF(FSPAR_MNTO(NSPAR()),-5) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-5)
       CALL CH78CC('(default is' )
       CALL CH78BF( MIN_TOL , -5 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(879879,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_MNTO_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'MAXT')THEN
       CALL KUGETR(PAR)
       C78='SUSi Maximal Tolerance Parameter is changed from'
       CALL CH78BF(FSPAR_MXTO(NSPAR()),-5) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-5)
       CALL CH78CC('(default is' )
       CALL CH78BF( MAX_TOL , -5 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(4972,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_MXTO_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'ANTT')THEN
       CALL KUGETR(PAR)
       C78='SUSi Angular Tolerance Parameter is changed from'
       CALL CH78BF(FSPAR_ANTO(NSPAR()),-5) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-5)
       CALL CH78CC('(default is' )
       CALL CH78BF( TOL_ANGLE , -5 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(49722983,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_ANTO_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.3 .AND. KEY(1:3).EQ.'TWI')THEN
       CALL KUGETR(PAR)
       C78='SUSi TARGET_WINDOW Parameter is changed from'
       CALL CH78BF(FSPAR_TWIN(NSPAR()),-5) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-5)
       CALL CH78CC('(default is' )
       CALL CH78BF( TARGET_WINDOW , -5 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(508098,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_TWIN_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.3 .AND. KEY(1:3).EQ.'PMI')THEN
       CALL KUGETR(PAR)
       C78='SUSi P_MIN Parameter is changed from'
       CALL CH78BF(FSPAR_PMIN(NSPAR()),-3) 
       CALL CH78BC( 'to' )
       CALL CH78BF(PAR,-3)
       CALL CH78CC('(default is' )
       CALL CH78BF( P_MIN , -3 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(53045,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        Q( QSPAR_PMIN_L()) = PAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.3 .AND. KEY(1:3).EQ.'MHS')THEN
       CALL KUGETR(PAR)
       IPAR = PAR
       C78='SUSi MIN_HITSL Parameter is changed from'
       CALL CH78BI( ISPAR_MHSL(NSPAR())) 
       CALL CH78BC( 'to' )
       CALL CH78BI(IPAR)
       CALL CH78CC('(default is' )
       CALL CH78BI( MIN_HITSL ) 
       CALL CH78AC( ')' )
       CALL MEMESC(30570252,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       IQ(IQSPAR_MHSL_L()) = IPAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'PROP')THEN
       CALL KUGETR(PAR)
       IPAR = PAR
       IF( IPAR .NE. 0 )IPAR=1 
       C78='SUSi Attention! The PROPER TRACK is chandged from'
       CALL CH78BI( ISPAR_PROP(NSPAR())) 
       CALL CH78BC( 'to' )
       CALL CH78BI(IPAR)
       CALL CH78CC('(default is' )
       CALL CH78BI( 1 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(347237959,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       IQ(IQSPAR_PROP_L()) = IPAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       IF( ISPAR_PROP(NSPAR()) .EQ. 0 )THEN
        C78='SUSi Warning! PROPER Tracks  are OFF!'
        CALL MEMESC(21357208,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ENDIF 
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'ALGO')THEN
       CALL KUGETR(PAR)
       IPAR = PAR
       IF( IPAR .NE. 0 .AND. 
     &     IPAR .NE. 1 .AND. 
     &     IPAR .NE. 2       )THEN 
        IPAR = 1 
       ENDIF 
       C78='SUSi Attention! The Algorithm is chandged from'
       CALL CH78BI( ISPAR_ALGO(NSPAR())) 
       CALL CH78BC( 'to' )
       CALL CH78BI(IPAR)
       CALL CH78CC('(default is' )
       CALL CH78BI( 1 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(3102470,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       IQ(IQSPAR_ALGO_L()) = IPAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       IF(     ISPAR_ALGO(NSPAR()) .EQ. 0 )THEN
        C78='SUSi Warning! Refit algorithm is OFF!'
        CALL MEMESC(17498,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ELSEIF( ISPAR_ALGO(NSPAR()) .EQ. 1 )THEN 
        C78='SUSi Warning! Refit algorithm is KALMAN Smoother'
        CALL MEMESC(34598,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ELSEIF( ISPAR_ALGO(NSPAR()) .EQ. 2 )THEN 
        C78='SUSi Warning! Refit algorithm is KALMAN Refit'
        CALL MEMESC(342798,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ELSE 
        C78='SUSi SKAPARA Error! Algorith has a wrong value!'
        CALL MEMESC(98742,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ENDIF 
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'RPNT')THEN
       CALL KUGETR(PAR)
       IPAR = PAR
       IF( IPAR .NE. 0 )IPAR=1 
       C78='SUSi Attention! The Rec.Points is changed from'
       CALL CH78BI( ISPAR_RPNT(NSPAR())) 
       CALL CH78BC( 'to' )
       CALL CH78BI(IPAR)
       CALL CH78CC('(default is' )
       CALL CH78BI( 1 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(3102473,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       IQ(IQSPAR_RPNT_L()) = IPAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       IF( ISPAR_RPNT(NSPAR()) .EQ. 0 )THEN
        C78='SUSi Warning!The Reconstrcted Points will be no booked!'
        CALL MEMESC(17493228,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ENDIF 
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'ANGU')THEN
       CALL KUGETR(PAR)
       IPAR = PAR
       IF( IPAR .NE. 0 )IPAR=1 
       C78='SUSi Attention! The ANGU is changed from'
       CALL CH78BI( ISPAR_ANGU(NSPAR())) 
       CALL CH78BC( 'to' )
       CALL CH78BI(IPAR)
       CALL CH78CC('(default is' )
       CALL CH78BI( 1 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(45742,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       IQ(IQSPAR_ANGU_L()) = IPAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       IF( ISPAR_ANGU(NSPAR()) .EQ. 0 )THEN
        C78='SUSi WArning! The Minimal DZ algorithm will be used!'
        CALL MEMESC(43729387,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ELSE
        C78='SUSi WArning! The Minimal Angle algorithm will be used!'
        CALL MEMESC(412347,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ENDIF 
       CALL SUSISTAT
      ELSEIF(  L.GE.4 .AND. KEY(1:4).EQ.'SEED')THEN
       CALL KUGETR(PAR)
       IPAR = PAR
       IF( IPAR .NE. 2 .AND. IPAR .NE. 4)THEN
        C78='SUSi Error! Unexpected value of SEED Parameter!'
        CALL MEMESC(92384,ILARGEST,iLARGEST,C78(1:LENOCC(C78)))
        C78='SUSi==> Switch to 2-plane SEEDing scheme!'
        CALL MEMESC(3258878,ILARGEST,iLARGEST,C78(1:LENOCC(C78)))
        IPAR = 2 
       ENDIF 
       C78='SUSi Attention! The SEED is changed from'
       CALL CH78BI( ISPAR_SEED(NSPAR())) 
       CALL CH78BC( 'to' )
       CALL CH78BI(IPAR)
       CALL CH78CC('(default is' )
       CALL CH78BI( 2 ) 
       CALL CH78AC( ')' )
       CALL MEMESC(247023,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       IQ(IQSPAR_SEED_L()) = IPAR  
       IQ(IQSPAR_DFLA_L()) = -1 
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
       IF( ISPAR_SEED(NSPAR()) .EQ. 2 )THEN
        C78='SUSi WArning! The 2-plane Seeding algorith used!'
        CALL MEMESC(14124387,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ELSE
        C78='SUSi WArning! The 4-plane seeding algorith used!'
        CALL MEMESC(15414,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       ENDIF 
       CALL SUSISTAT
      ELSE 
       C78='SUSi warning! Unknown KEY='
       CALL CH78AC(KEY)  
       CALL CH78CC('activate the default values!')
       CALL MEMESC(234772,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ENDIF 

      RETURN
      END






