*CMZ :  1.00/01 11/07/96  16.22.48  by   Ivan Belyaev
*CMZ :  1.04/11 11/12/95  14.25.57  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.38.45  by  joerg f. rieling
*-- Author :    joerg f. rieling   14/11/95

c     ------------------------------------------

      subroutine srevfil

c     -- performs a Kalman filter go  in reverse
c     -- direction for all rec tracks.

c     ------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/EV.fi"
#include "auto/SI.fi"

c     -- local variables
      REAL      Cin  ( 4 , 4 ) , Pin  ( 4 )
      REAL      Cpre ( 4 , 4 ) , Ppre ( 4 )
      REAL      Cout ( 4 , 4 ) , Pout ( 4 )

      INTEGER   iSTRC , iSHRC , jAUX 
      REAL      MEAS , Zin , Zmea , DZ , dchi2 

      LOGICAL   DOWNSTREAM 

      INTEGER   LENOCC 
      EXTERNAL  LENOCC 


c     -- common blocks / def''s / statement functions
#include "susi/zsiconst.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsitrhist.fi"
#include "susi/zsigeo.fi"
C

#include "susi/zsimtrx44.fi"

C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/EV.ff"
#include "auto/SI.ff"

#include "susi/zsigeo.ff"

 1     CONTINUE 
       IF( JSPAR   .LE. 0 ) CALL SUSIDEFV
       IF( NSPAR() .NE. 1 ) CALL SUSIDEFV
       IF( ISPAR_ALGO(NSPAR()) .NE. 2 )RETURN 
       IF(     ISPAR_SEED(NSPAR()) .EQ. 4 )THEN
        DOWNSTREAM = .TRUE. 
       ELSEIF( ISPAR_SEED(NSPAR()) .EQ. 2 )THEN
        DOWNSTREAM = .FALSE. 
       ELSE 
        C78='SUSi error!Unknown value for SEED Parameter='
        CALL CH78AI( ISPAR_SEED(NSPAR()) )
        CALL MEMESC(9847198,1,ILARGEST,C78(1:LENOCC(C78)))
        GO TO 1 
       ENDIF 

c     -- loop over all rec tracks
      DO iSTRC = 1, NSTRC()
       IF( ISTRC_AC(iSTRC) .EQ. 0)GO TO 10 
C*     Fill initial values and initial cov.matrix 
       Zin = FSTRC_Z( iSTRC ) 
       DO i1 = 1 , 4
        Pin( i1 ) = FSTRC_P(i1,iSTRC)
        DO i2 = 1 , 4 
         Cin(i1,i2) = 0.0 
        ENDDO 
        Cin(i1,i1) = 0.1 
       ENDDO 
       Cin(3,3) = 0.001
       Cin(4,4) = 0.001
C*     Loop over the measured points 
       jAUX = PSTRC_SHRC( iSTRC ) 
       DO WHILE( jAUX .NE. 0 ) 
        iSHRC = MSTRC_SHRC( jAUX  ) 
        MEAS  = FSHRC_MEAS( iSHRC )
        Zmea  = FHITB_Z(ISHRC_HITB(iSHRC))
        DZ    = Zmea - Zin 
        IF(    DZ  .LT. 0 .AND. DOWNSTREAM )THEN
         C78='SUSi warning! SREVFIL,DZ<0!DZ='
         CALL CH78AF( DZ , -10 ) 
         CALL MEMESC(928747,1,ILARGEST,C78(1:LENOCC(C78))) 
        ELSEIF( DZ. GT. 0 .AND. .NOT. DOWNSTREAM )THEN
         C78='SUSi warning! SREVFIL,DZ>0!DZ='
         CALL CH78AF( DZ , -10 ) 
         CALL MEMESC(92185739,1,ILARGEST,C78(1:LENOCC(C78))) 
        ENDIF 
C*      Predict
        CALL SKLMPRE(Pin ,  Cin , Dz , Ppre, Cpre ) 
C*      Filter 
        CALL SKLMFIL(Ppre, Cpre , MEAS , 
     &           plcsr(ISHRC_PLAN(iSHRC)),
     &           plsnr(ISHRC_PLAN(iSHRC)), 0.0012 , 
     &           Pout, Cout, dchi2 ) 
        Zin = Zmea 
        DO i1 = 1, 4
         Pin( i1 ) = Pout( i1 ) 
          Q( QSHRC_P(i1,iSHRC))=Pout(i1) 
         DO i2 = 1 , 4 
          Cin(i1,i2) = Cout(i1,i2) 
           Q( QSHRC_C(MATRIX_PACK(i1,i2),iSHRC)) = 
     &       Cout(i1,i2)
         ENDDO 
        ENDDO 
C*        
        jAUX  = XSTRC_SHRC( jAUX  ) 
       ENDDO 
C*
       IF( .NOT. DOWNSTREAM )THEN
         Q( QSTRC_Z(iSTRC)) = Zin
        DO i1=1,4
          Q( QSTRC_P(i1,iSTRC))=Pin(i1)
         DO i2=1,4
           Q( QSTRC_C(MATRIX_PACK(i1,i2),iSTRC))=Cin(i1,i2)
         ENDDO 
        ENDDO
       ENDIF          
C*
 10    CONTINUE
      ENDDO 

      RETURN 
      END 


