*CMZ :  1.00/01 02/08/96  19.27.02  by   Ivan Belyaev
*CMZ :  1.04/03 22/05/95  15.51.11  by  joerg f. rieling
*-- Author :
c     -------------------------------------------------
      subroutine sseebld4 (n_pass, n_seed, m, p)
c
c     -- builds the primary parameter vector depending
c     -- on m, cr, sr, z by direct using the predefined
c     -- translation matrix M^-1.
c     -- input parameters: n_pass: # of recent pass
c     --                   n_seed: # of recent seed in n_pass
c     --                   m     : 4-dim meas. vector
c     -- output parameter: p     : parameter vector.
c     --
c     -- inverse matrix (c) by MATHEMATICA
c     -------------------------------------------------

      implicit none

c     --- const. / matrix common block
#include "susi/zsiconst.fi"
#include "susi/zsitrnsm.fi"

c     --- formal parameters
      integer n_pass, n_seed
      real    m(4), p(4)

c     --- p = M^-1 * m
      p(1)=
     & ZSIa(n_pass,n_seed,1,1)*m(1) +
     & ZSIa(n_pass,n_seed,1,2)*m(2) +
     & ZSIa(n_pass,n_seed,1,3)*m(3) +
     & ZSIa(n_pass,n_seed,1,4)*m(4)
      p(2)=
     & ZSIa(n_pass,n_seed,2,1)*m(1) +
     & ZSIa(n_pass,n_seed,2,2)*m(2) +
     & ZSIa(n_pass,n_seed,2,3)*m(3) +
     & ZSIa(n_pass,n_seed,2,4)*m(4)
      p(3)=
     & ZSIa(n_pass,n_seed,3,1)*m(1) +
     & ZSIa(n_pass,n_seed,3,2)*m(2) +
     & ZSIa(n_pass,n_seed,3,3)*m(3) +
     & ZSIa(n_pass,n_seed,3,4)*m(4)
      p(4)=
     & ZSIa(n_pass,n_seed,4,1)*m(1) +
     & ZSIa(n_pass,n_seed,4,2)*m(2) +
     & ZSIa(n_pass,n_seed,4,3)*m(3) +
     & ZSIa(n_pass,n_seed,4,4)*m(4)

      return
      end

