*CMZ :          09/08/96  15.55.11  by   Ivan Belyaev
*CMZ :  1.00/01 02/08/96  18.35.29  by   Ivan Belyaev
*CMZ :  1.04/08 07/11/95  11.48.43  by  joerg f. rieling
*CMZ :  1.04/06 28/06/95  16.15.29  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------
      subroutine ssettrnsm
c
c     -- calculates the translation matrix A = M^-1
c     -- for every seed.
c     -- Requires that the seeding tables and the
c     -- silicon geometry are already initialized.
c
c     -----------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/SI.fi"
#include "auto/GEO.fi"
c     --- common translation matrix

#include "susi/zsiconst.fi"
#include "susi/zsigeo.fi"
#include "susi/zsitrnsm.fi"

c     --- local variables
      integer n_seed, n_pass, i, j
      real dz(4,4), b(4,4), quo
      real cr(4), sr(4), z(4)

      INTEGER jAUX,iAUX

#include "arte/Arte.ff"
#include "auto/SI.ff"
#include "auto/GEO.ff"
#include "susi/zsigeo.ff"

c     --- loop over all passes and seeds & calc A.

      do n_pass  = 1 , NSPAS()
        jAUX     = PSPAS_SSEE( n_pass )
         n_seed  = 0
         DO WHILE( jAUX .GT. 0 )
          n_seed = n_seed + 1
          iAUX   = MSPAS_SSEE( jAUX )
          jAUX   = XSPAS_SSEE( jAUX )

          CR(1)  = plcsr( ISSEE_PLN1( iAUX ) )
          CR(2)  = plcsr( ISSEE_PLN2( iAUX ) )
          CR(3)  = plcsr( ISSEE_PLN3( iAUX ) )
          CR(4)  = plcsr( ISSEE_PLN4( iAUX ) )

          SR(1)  = plsnr( ISSEE_PLN1( iAUX ) )
          SR(2)  = plsnr( ISSEE_PLN2( iAUX ) )
          SR(3)  = plsnr( ISSEE_PLN3( iAUX ) )
          SR(4)  = plsnr( ISSEE_PLN4( iAUX ) )

          Z (1)  = plz  ( ISSEE_PLN1( iAUX ) )
          Z (2)  = plz  ( ISSEE_PLN2( iAUX ) )
          Z (3)  = plz  ( ISSEE_PLN3( iAUX ) )
          Z (4)  = plz  ( ISSEE_PLN4( iAUX ) )

c           --- preparation
            dz (1, 1) = z(1) - z(1)
            dz (2, 1) = z(2) - z(1)
            dz (3, 1) = z(3) - z(1)
            dz (4, 1) = z(4) - z(1)
            dz (1, 2) = z(1) - z(2)
            dz (2, 2) = z(2) - z(2)
            dz (3, 2) = z(3) - z(2)
            dz (4, 2) = z(4) - z(2)
            dz (1, 3) = z(1) - z(3)
            dz (2, 3) = z(2) - z(3)
            dz (3, 3) = z(3) - z(3)
            dz (4, 3) = z(4) - z(3)
            dz (1, 4) = z(1) - z(4)
            dz (2, 4) = z(2) - z(4)
            dz (3, 4) = z(3) - z(4)
            dz (4, 4) = z(4) - z(4)

c           --- common denominator
            quo=cr(1)*cr(2) * sr(3)*sr(4) * dz(1,2)*dz(4,3)
     &         +cr(1)*cr(3) * sr(2)*sr(4) * dz(1,3)*dz(2,4)
     &         +cr(1)*cr(4) * sr(2)*sr(3) * dz(1,4)*dz(3,2)
     &         +cr(2)*cr(3) * sr(1)*sr(4) * dz(2,3)*dz(4,1)
     &         +cr(2)*cr(4) * sr(1)*sr(3) * dz(2,4)*dz(1,3)
     &         +cr(3)*cr(4) * sr(1)*sr(2) * dz(3,4)*dz(2,1)
            quo = -quo

c           --- elements
            b(1,1)=+cr(3) * sr(2)*sr(4) * z(3) * dz(2,4)
     &       +cr(2) * sr(3)*sr(4) * z(2) * dz(4,3)
     &       +cr(4) * sr(2)*sr(3) * z(4) * dz(3,2)
            b(1,2)=+cr(1) * sr(3)*sr(4) * z(1) * dz(3,4)
     &       +cr(4) * sr(1)*sr(3) * z(4) * dz(1,3)
     &       +cr(3) * sr(1)*sr(4) * z(3) * dz(4,1)
            b(1,3)=+cr(2) * sr(1)*sr(4) * z(2) * dz(1,4)
     &       +cr(1) * sr(2)*sr(4) * z(1) * dz(4,2)
     &       +cr(4) * sr(1)*sr(2) * z(4) * dz(2,1)
            b(1,4)=+cr(1) * sr(2)*sr(3) * z(1) * dz(2,3)
     &       +cr(3) * sr(1)*sr(2) * z(3) * dz(1,2)
     &       +cr(2) * sr(1)*sr(3) * z(2) * dz(3,1)

            b(2,1)=-(+cr(2)*cr(4) * sr(3) * z(3) * dz(2,4)
     &         +cr(3)*cr(4) * sr(2) * z(2) * dz(4,3)
     &         +cr(2)*cr(3) * sr(4) * z(4) * dz(3,2))
            b(2,2)=-(+cr(3)*cr(4) * sr(1) * z(1) * dz(3,4)
     &         +cr(1)*cr(3) * sr(4) * z(4) * dz(1,3)
     &         +cr(1)*cr(4) * sr(3) * z(3) * dz(4,1))
            b(2,3)=-(+cr(1)*cr(4) * sr(2) * z(2) * dz(1,4)
     &         +cr(2)*cr(4) * sr(1) * z(1) * dz(4,2)
     &         +cr(1)*cr(2) * sr(4) * z(4) * dz(2,1))
            b(2,4)=-(+cr(2)*cr(3) * sr(1) * z(1) * dz(2,3)
     &        +cr(1)*cr(2) * sr(3) * z(3) * dz(1,2)
     &        +cr(1)*cr(3) * sr(2) * z(2) * dz(3,1))

            b(3,1)=+cr(4) * sr(2)*sr(3) * dz(2,3)
     &       +cr(2) * sr(3)*sr(4) * dz(3,4)
     &       +cr(3) * sr(2)*sr(4) * dz(4,2)
            b(3,2)=+cr(3) * sr(1)*sr(4) * dz(1,4)
     &       +cr(4) * sr(1)*sr(3) * dz(3,1)
     &       +cr(1) * sr(3)*sr(4) * dz(4,3)
            b(3,3)=+cr(4) * sr(1)*sr(2) * dz(1,2)
     &       +cr(1) * sr(2)*sr(4) * dz(2,4)
     &       +cr(2) * sr(1)*sr(4) * dz(4,1)
            b(3,4)=+cr(2) * sr(1)*sr(3) * dz(1,3)
     &       +cr(3) * sr(1)*sr(2) * dz(2,1)
     &       +cr(1) * sr(2)*sr(3) * dz(3,2)

            b(4,1)=-(+cr(2)*cr(4) * sr(3) * dz(4,2)
     &         +cr(2)*cr(3) * sr(4) * dz(2,3)
     &         +cr(3)*cr(4) * sr(2) * dz(3,4))
            b(4,2)=-(+cr(1)*cr(4) * sr(3) * dz(1,4)
     &         +cr(1)*cr(3) * sr(4) * dz(3,1)
     &         +cr(3)*cr(4) * sr(1) * dz(4,3))
            b(4,3)=-(+cr(1)*cr(2) * sr(4) * dz(1,2)
     &         +cr(2)*cr(4) * sr(1) * dz(2,4)
     &         +cr(1)*cr(4) * sr(2) * dz(4,1))
            b(4,4)=-(+cr(1)*cr(3) * sr(2) * dz(1,3)
     &         +cr(1)*cr(2) * sr(3) * dz(2,1)
     &         +cr(2)*cr(3) * sr(1) * dz(3,2))

c           --- "correction"
            b(1,1) = b(1,1)/quo
            b(1,2) = b(1,2)/quo
            b(1,3) = b(1,3)/quo
            b(1,4) = b(1,4)/quo
            b(2,1) = b(2,1)/quo
            b(2,2) = b(2,2)/quo
            b(2,3) = b(2,3)/quo
            b(2,4) = b(2,4)/quo
            b(3,1) = b(3,1)/quo
            b(3,2) = b(3,2)/quo
            b(3,3) = b(3,3)/quo
            b(3,4) = b(3,4)/quo
            b(4,1) = b(4,1)/quo
            b(4,2) = b(4,2)/quo
            b(4,3) = b(4,3)/quo
            b(4,4) = b(4,4)/quo

c           --- fill common block
            do i=1,4
               do j=1, 4
                  ZSIa(n_pass, n_seed, i, j) = b(i,j)
               end do
            end do

         end do ! n_seed
      end do ! n_pass

      return
      end
