*CMZ :          16/08/96  12.58.23  by   Ivan Belyaev
*CMZ :  1.00/01 03/08/96  20.16.43  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  09.24.56  by  joerg f. rieling
*CMZ :  1.04/10 23/11/95  15.04.41  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  11.38.11  by  joerg f. rieling
*CMZ :  1.04/07 23/08/95  12.03.41  by  joerg f. rieling
*CMZ :  1.04/06 14/06/95  18.44.40  by  joerg f. rieling
*CMZ :  1.04/05 29/05/95  17.06.53  by  joerg f. rieling
*CMZ :  1.04/04 23/05/95  17.47.25  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.50.56  by  joerg f. rieling
*-- Author :

c     ---------------------------------------------------------
      subroutine sstat
c
c     -- tests if the active tracks in ZSIRCTRK are "the
c     -- same" as a certain mc track or if they are ghosts:
c     -- fills the array rc_mc in ZSIRCTRK,
c     -- does the performance bookkeeping and fills hists.
c
c     ---------------------------------------------------------

      implicit  none

c     --- common blocks

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/GEO.fi"
#include "auto/EV.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsiprtrk.fi"
#include "susi/zsigeo.fi"
#include "susi/zsihitmark.fi"
        
      INTEGER i,iPR,iSHRC,iHITB,iMIMP,iMTRA,jAUX,jAUX1
      INTEGER iMC,nMC,iTMP
      INTEGER NT_REC,NT_PRO,NT_EXT,NT_GHO
      INTEGER NCALL,NCALL1
      SAVE    NCALL,NCALL1
      REAL    E_PRO, E_EXT, E_GHO
      REAL    EM_PRO,EM_EXT,EM_GHO
      SAVE    EM_PRO,EM_EXT,EM_GHO

      INTEGER  LENOCC
      EXTERNAL LENOCC 

#include "susi/zsimtrx44.fi"

      DATA    EM_PRO / 0.0 /       
      DATA    EM_EXT / 0.0 /       
      DATA    EM_GHO / 0.0 /
      DATA    NCALL  /0/
      DATA    NCALL1 /0/

c     --- statement functions

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/EV.ff"
#include "auto/SI.ff"
#include "susi/zsihitmark.ff"

      NCALL  = NCALL  + 1
      NCALL1 = NCALL1 + 1


      IF( JSSTA .NE. 0)THEN
       IF(NSSTA().NE.1)CALL MMDROP(JSSTA)
      ENDIF 

      IF( JSSTA .EQ. 0 )CALL SUSISTAT
 
      NT_REC = 0 
      NT_PRO = 0 
      NT_EXT = 0 
      NT_GHO = 0 
      DO i=1,NSTRC()
       IF( ISTRC_AC(i) .NE. 0)THEN
        NT_REC = NT_REC + 1 
        IF( ISTRC_MTRA(i).LE.0)THEN
C*       Ghost Track! 
         NT_GHO=NT_GHO+1
        ELSE 
         DO iPR = 1,NSTPR()
          IF( ISTPR_MTRA(iPR).EQ.ISTRC_MTRA(i))THEN
C**         Proper Track is reconstructed!
           NT_PRO = NT_PRO + 1
           GO TO  60 
          ENDIF  
         ENDDO  
C*       Extra Track! 
         NT_EXT = NT_EXT + 1 
        ENDIF 
 60     CONTINUE
       ENDIF 
      ENDDO     

C*    The above definition of NT_PRO is slightly incorrect,
C*    Now define it correctly.. 

      NT_PRO = 0 
      DO iPR = 1 , NSTPR()
       iMTRA = ISTPR_MTRA( iPR )
       DO i=1,NSTRC()
        IF( ISTRC_AC(i) .NE. 0 )THEN
         IF( ISTRC_MTRA(i).EQ.  iMTRA)THEN
          NT_PRO = NT_PRO + 1 
          GO TO 80 
         ENDIF 
        ENDIF 
       ENDDO 
 80    CONTINUE 
      ENDDO 

C*    Calculate Efficiencies
C*    Proper Tracks:
      IF( NSTPR() .NE. 0 )THEN
       E_PRO = 100.0*FLOAT(NT_PRO)/NSTPR()
      ELSE
       E_PRO = 0.0 
      ENDIF 
      
C*    Extra Tracks:
      IF( NT_REC .NE. 0 )THEN 
       E_EXT = 100.0*FLOAT(NT_EXT)/FLOAT(NT_REC)
      ELSE 
       E_EXT = 0.0
      ENDIF 

C*    Ghost Tracks:
      IF( NT_REC .NE. 0 )THEN 
       E_GHO = 100.0*FLOAT(NT_GHO)/FLOAT(NT_REC)
      ELSE 
       E_GHO = 0.0
      ENDIF 


C*    Fill SSTA bank 

      IQ(IQSSTA_LAST_L()) = NEVENTS

      IF(NSTRC().LT.ISSTA_MNPR(NSSTA()))
     &          IQ(IQSSTA_MNPR_L()) = NSTRC()           
      IF(NSTRC().GT.ISSTA_MXPR(NSSTA()))
     &          IQ(IQSSTA_MXPR_L()) = NSTRC()           
      IQ(IQSSTA_NPRE_L()) = ISSTA_NPRE(NSSTA())+NSTRC()
       Q( QSSTA_YPRE_L()) = FSSTA_YPRE(NSSTA())+NSTRC()**2

      IF(NT_REC .LT.ISSTA_MNRE(NSSTA()))
     &          IQ(IQSSTA_MNRE_L()) = NT_REC           
      IF(NT_REC .GT.ISSTA_MXRE(NSSTA()))
     &          IQ(IQSSTA_MXRE_L()) = NT_REC           
      IQ(IQSSTA_NREC_L()) = ISSTA_NREC(NSSTA())+NT_REC
       Q( QSSTA_YREC_L()) = FSSTA_YREC(NSSTA())+NT_REC**2

      IF(NT_PRO .LT.ISSTA_MNPT(NSSTA()))
     &          IQ(IQSSTA_MNPT_L()) = NT_PRO           
      IF(NT_PRO .GT.ISSTA_MXPT(NSSTA()))
     &          IQ(IQSSTA_MXPT_L()) = NT_PRO
           
      IF(NT_EXT .LT.ISSTA_MNEX(NSSTA()))
     &          IQ(IQSSTA_MNEX_L()) = NT_EXT           
      IF(NT_EXT. GT.ISSTA_MXEX(NSSTA()))
     &          IQ(IQSSTA_MXEX_L()) = NT_EXT

      IF(NT_GHO .LT.ISSTA_MNGH(NSSTA()))
     &          IQ(IQSSTA_MNGH_L()) = NT_GHO          
      IF(NT_GHO .GT.ISSTA_MXGH(NSSTA()))
     &          IQ(IQSSTA_MXGH_L()) = NT_GHO
      IQ(IQSSTA_NGHO_L()) = ISSTA_NGHO(NSSTA())+NT_GHO
       Q( QSSTA_YGHO_L()) = FSSTA_YGHO(NSSTA())+NT_GHO**2


       Q( QSSTA_EPRO_L()) = 
     &    FSSTA_EPRO(NSSTA()) + E_PRO
       Q( QSSTA_APRO_L()) = 
     &    FSSTA_APRO(NSSTA()) + E_PRO**2
       
       Q( QSSTA_EEXT_L()) = 
     &    FSSTA_EEXT(NSSTA()) + E_EXT
       Q( QSSTA_AEXT_L()) = 
     &    FSSTA_AEXT(NSSTA()) + E_EXT**2

       Q( QSSTA_EGHO_L()) = 
     &    FSSTA_EGHO(NSSTA()) + E_GHO
       Q( QSSTA_AGHO_L()) = 
     &    FSSTA_AGHO(NSSTA()) + E_GHO**2

      RETURN
      END





