*CMZ :  1.00/01 03/08/96  17.14.44  by   Ivan Belyaev
*CMZ :  1.04/08 03/11/95  14.33.33  by  joerg f. rieling
*CMZ :  1.04/06 27/06/95  15.06.31  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.51.11  by  joerg f. rieling
*-- Author :


c     ------------------------------------------------------
      real function strkqual (chi2, n_hit, n_miss)
c     -- evaluates the quality of a candidate.
c     -- The chi2 is weighted * .1 .
c
c     -- input parameters: chi2  : total chi^2 of this cand
c     --                   n_hit : # of hits
c     --                   n_miss: # of missing hits
c     -- return value    : -999. if cand is not acceptable
c     --                 : a value > 0 in units of hits.
c     ------------------------------------------------------

      implicit none

c     --- constants

#include "arte/Arte.fi"

#include "susi/zsiconst.fi"
c     ---  formal parameters
      real    chi2
      integer n_hit, n_miss
      integer n_maxmiss ( N_MINHITS : N_MAXHITS )
      data    n_maxmiss / 2, 2, 2, 3, 3, 3, 3, 3,
     &                    3, 3, 4, 4, 4, 4, 4, 4,
     &                    4, 4, 4, 4, 5, 5, 5, 5,
     &                    5 /

c     --- local variables

#include "arte/Arte.ff"

      if (n_hit.gt.N_MAXHITS) then
        C78='SUSi==>STRKQUAL ERROR:too many hits'
        CALL CH78BI(n_hit)
        CALL CH78BC('for track!')
        CALL ME78AP
        C78='SUSi==>STRKQUAL : number of hits is set to'
        CALL CH78BI( N_MAXHITS-1)
        CALL MEMESC(7834879,ILARGEST,ILARGEST,
     &  C78(1:LEN(C78)))
        n_hit = N_MAXHITS-1
      end if

c     --- apply absolute cuts
      if (n_hit  .lt. N_MINHITS) then
         strkqual = -999.
         goto 999
      end if
      if (n_miss .gt. n_maxmiss(n_hit + n_miss)) then
         strkqual = -999.
         goto 999
      end if

c     --- calculate quality
      strkqual = n_hit - WEIGHT_MISS*n_miss - WEIGHT_CHI2*chi2

 999  continue
      end









