*CMZ :          11/11/96  16.08.38  by  T. Oest
*-- Author :    T. Oest   30/05/96

      SUBROUTINE RKDER2 (UPDATE, H, EC, RKD)

************************************************************************
*
* Description: returns the derivatives for fixed POUT(1)
*
* Called from:
*
* External references:
*
* Argument in/out description
* UPDATE   in      = .TRUE. the derivatives will be updated
* H        in      step size
* FAC      in      Qc/p*sign(cos gamma)
* RKD      in/out  derivatives d POUT / d PIN
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      DOUBLE PRECISION H, RKD(6,6)
      LOGICAL          UPDATE
      DOUBLE PRECISION RKWORK(6,6), DKDP(6,6,6), DFDP(6,6), RKCO(6,6)
      DOUBLE PRECISION SUM, EC, FAC, A
      INTEGER I, J, L, M, N, II, M1, M2


      DOUBLE PRECISION B(15), C(6), CST(6), PSTEPS(6,6), K(6,5)
      DOUBLE PRECISION BFIELD(6,3), FSTEPS(6,2)
      COMMON /CRKUT2/  PSTEPS, B, C, CST, K, BFIELD, FSTEPS

#include "arte/Arte.ff"

      DATA DFDP /36*0.0D0/
************************************************************************
* get DKDP
************************************************************************
      DFDP(2,4) = 1.0D0
      DFDP(3,5) = 1.0D0

      II  = 0
      FAC = PSTEPS(1,6)*EC
      DO I=1,6

       A   = 1.+PSTEPS(I,4)**2+PSTEPS(I,5)**2

       DFDP(4,4) =  FAC*FSTEPS(I,1) * PSTEPS(I,4) / A + FAC*SQRT(A)*
     +           (PSTEPS(I,5)*BFIELD(I,1) - 2.*PSTEPS(I,4)*BFIELD(I,2))
       DFDP(4,5) =  FAC*FSTEPS(I,1) * PSTEPS(I,5) / A + FAC*SQRT(A)*
     +           (PSTEPS(I,4)*BFIELD(I,1) + BFIELD(I,3))
       DFDP(4,6) =  EC*FSTEPS(I,1)


       DFDP(5,4) =  FAC*FSTEPS(I,2) * PSTEPS(I,4) / A - FAC*SQRT(A)*
     +           (PSTEPS(I,5)*BFIELD(I,2) + BFIELD(I,3))
       DFDP(5,5) =  FAC*FSTEPS(I,2) * PSTEPS(I,5) / A + FAC*SQRT(A)*
     +           (2.*PSTEPS(I,5)*BFIELD(I,1) - PSTEPS(I,4)*BFIELD(I,2))
       DFDP(5,6) =  EC*FSTEPS(I,2)


c dkdp =0  for J=6
       DO J=1,5
       DO L=1,6
        IF (L.NE.1) THEN
         DKDP(I,J,L) = 0.0D0
        ELSE
         IF     (J.EQ.1) THEN
          DKDP(I,J,L) = -1.0D0
         ELSE
          DKDP(I,J,L) = -K(I,J) / H
         ENDIF
        ENDIF

c DFDP(J,M)=0 for J=6,  , (J=1,2,3 M=1,4,5,6)
        IF (J.GT.1) THEN

        IF (J.EQ.2) THEN
         M1 = 4
         M2 = 4
        ELSEIF (J.EQ.3) THEN
         M1 = 5
         M2 = 5
        ELSE
         M1 = 4
         M2 = 6
        ENDIF
        
        DO M=M1,M2
         IF (M.EQ.L) THEN
          SUM = 1.0D0
         ELSE
          SUM = 0.0D0
         ENDIF
          II  = (I-1)*(I-2)/2
          DO N=1,I-1
           II = II + 1
           SUM = SUM + B(II) * DKDP(N,M,L)
          ENDDO
         DKDP(I,J,L) = DKDP(I,J,L) + H * DFDP(J,M) * SUM
        ENDDO

        ENDIF

        ENDDO
        ENDDO

       ENDDO
************************************************************************
* derivartive matrix for this step
************************************************************************
       DO I=1,6
       DO J=1,6
        RKWORK(I,J) = 0.0D0
       ENDDO
        RKWORK(I,I) = 1.0D0
       ENDDO

c DKDP=0 for i=6

       DO I=1,5
c       DO I=1,6
       DO J=1,6
       DO L=1,6
        RKWORK(I,J) = RKWORK(I,J) + C(L) * DKDP(L,I,J)
       ENDDO
       ENDDO
       ENDDO

************************************************************************
* UPDATE MATRIX
************************************************************************

       IF (UPDATE) THEN

        DO I=1,6
        DO J=1,6
         RKCO(I,J) = RKD(I,J)
         RKD (I,J) = 0.0D0
        ENDDO
        ENDDO
        DO I=1,6
        DO J=1,6
        DO L=1,6
         RKD(I,J) = RKD(I,J) + RKWORK(I,L) * RKCO(L,J)
        ENDDO
        ENDDO
        ENDDO

       ELSE

        DO I=1,6
        DO J=1,6
         RKD(I,J) = RKWORK(I,J)
        ENDDO
        ENDDO

       ENDIF




      END

************************************************************************
* End of RKDERI
************************************************************************
