*CMZ :          08/11/96  16.07.32  by  T. Oest
*-- Author :    T. Oest   20/03/96

      SUBROUTINE V0B0

************************************************************************
*
* Description: B0 reconstruction, only one solution is stored
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/EV.fi"
#include "auto/CON.fi"
#include "auto/GEO.fi"


      INTEGER          IT1, IT2, ITERA1, ITERA2, IRET, I
      INTEGER          NTRACK, FLAG, IRET1
      INTEGER          TOPP0, TOPP1, TOPP2
      DOUBLE PRECISION PAR(9),  WPAR(9,9), VPAR(9,9),  CH1, CHT1
      DOUBLE PRECISION PAR2(9), WPAR2(9,9),VPAR2(9,9), CH2, CHT2
      DOUBLE PRECISION E1, E2, MV0, PTRK(7), VTRK(7,7)
      DOUBLE PRECISION PI1(4), PI2(4), PV0(4), MK0S, MPSI, MB0

      LOGICAL          SELECT
      REAL*4           CHIMAX, PMIN, DMASS, TX, TY

      INTEGER          TPNAME

#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/CON.ff"
#include "auto/GEO.ff"

      DATA MB0    /5.2792D0/,  MPSI   /3.09688D0/, MK0S/0.497672D0/
      DATA CHIMAX /100./, PMIN /10./, DMASS /0.3/
************************************************************************
C
C-----------------------------------------------------------------
C  reconstruct K0s, Jpsi
C-----------------------------------------------------------------
c       print*,' start psi search '
       CALL V0PSI
c       print*,' start k0s  search '
       CALL V0K0S
c       print*,' start b0 search '
C-----------------------------------------------------------------
C  loop over track pairs
C-----------------------------------------------------------------

       NTRACK = NRTRA()

       DO IT1=1,NTRACK
c        print*,' track1 ',IRTRA_FIT(IT1)
        IF (IRTRA_FIT(IT1).EQ.110) THEN
       DO IT2=IT1+1,NTRACK
c        print*,' track2 ',IRTRA_FIT(IT2)
        IF (IRTRA_FIT(IT2).EQ.100) THEN

C-----------------------------------------------------------------
C  momentum, angle cuts for tracks in front of magnet
C-----------------------------------------------------------------
         PI1(4) = DBLE(1./ABS(FRTRA_PF(IT1)))
         PI2(4) = DBLE(1./ABS(FRTRA_PF(IT2)))
         PI1(3) = PI1(4)/SQRT(1.+FRTRA_TXF(IT1)**2+FRTRA_TYF(IT1)**2)
         PI1(1) = FRTRA_TXF(IT1)*PI1(3)
         PI1(2) = FRTRA_TYF(IT1)*PI1(3)
         PI2(3) = PI2(4)/SQRT(1.+FRTRA_TXF(IT2)**2+FRTRA_TYF(IT2)**2)
         PI2(1) = FRTRA_TXF(IT2)*PI2(3)
         PI2(2) = FRTRA_TYF(IT2)*PI2(3)
         DO I=1,3
          PV0(I) = PI1(I) + PI2(I)
         ENDDO
         PV0(4)  = SQRT(PV0(1)**2+PV0(2)**2+PV0(3)**2)
         TX      = SNGL(PV0(1)/PV0(3))
         TY      = SNGL(PV0(2)/PV0(3))
         E1  = SQRT(PI1(4)**2+MPSI**2)
         E2  = SQRT(PI2(4)**2+MK0S**2)
         MV0 = SQRT(MPSI**2 + MK0S**2 + 2.*(E1*E2 - PI1(1)*PI2(1)
     +            - PI1(2)*PI2(2)- PI1(3)*PI2(3)))

c        print*,' b0 track pair ',it1,it2,SNGL(PV0(4)),SNGL(MV0)

         IF (PV0(4).GT.PMIN .AND. ABS(TX).LT.0.2 .AND. ABS(TY).LT.0.2
     +       .AND. ABS(MV0-MB0).LT.DMASS) THEN
          SELECT = .TRUE.
         ELSE
          SELECT = .FALSE.
         ENDIF


        IF (SELECT) THEN
C-----------------------------------------------------------------
C  V0 fit
C-----------------------------------------------------------------
        CALL V0FIT (IT1, IT2, PAR, VPAR, WPAR, CH1, CHT1,
     +              PAR2, VPAR2, WPAR2, CH2, CHT2,
     +              ITERA1, ITERA2, IRET)

c        print*,' B0fit ',iret,ch1
        IF (IRET.GE.0 .AND. CH1.LT.CHIMAX) THEN
C-----------------------------------------------------------------
C  select and store B0S (first solution)
C    cuts applied: chi < chimax
C                  z(vertex) > 3*sig(z)
C                  |mv0-mks| < dmass
C-----------------------------------------------------------------
        CALL V0TRK(MPSI,MK0S, PAR, VPAR, PTRK, VTRK)
c        print*,' mass ',sngl(ptrk(7))
C-----------------------------------------------------------------
C  mass constraint
C-----------------------------------------------------------------
        CALL V0MASS(MB0, PTRK, VTRK, IRET)
        IF (IRET.EQ.0) THEN

        IF (ABS(1./PTRK(6)).GT.PMIN               .AND. 
     +      ABS(PTRK(7)-MB0).LT.DMASS) THEN

C-----------------------------------------------------------------
C  store psi vertex
C-----------------------------------------------------------------
         TOPP0 = TPNAME('B.      ')
         TOPP1 = TPNAME('Jpsi    ')
         TOPP2 = TPNAME('K_S     ')
         FLAG = 120
         CALL V0STOR(FLAG, IT1, IT2, CH1, PTRK, VTRK, TOPP0, 
     +               TOPP1, TOPP2)

        ENDIF

        ENDIF

        ENDIF

        ENDIF
        ENDIF
       ENDDO
       ENDIF
       ENDDO


 9000 END

************************************************************************
* End
************************************************************************
