*-- Author :    T. Oest   24/10/96

      SUBROUTINE V0SELT(ITK,IRET)

************************************************************************
*
* Description: track selection
*
* Called from:
*
* External references:
*
* Argument in/out description
* ITK      in     track row in RTRA bank
* IRET     out    = 0  track accepted
*
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"

      INTEGER          ITK, IRET

      INTEGER          IERR, IVER
      DOUBLE PRECISION Z, PTRK(5), VTRK(5,5), CHI, V(2,2), W(2,2)
      REAL*4           CHIMAI

      INTEGER          NHITS

#include "arte/Arte.ff"
#include "auto/EV.ff"

      DATA CHIMAI /10./
*-----------------------------------------------------------------------
* initialization
*-----------------------------------------------------------------------
      IRET = 0
*-----------------------------------------------------------------------
* charged track
*-----------------------------------------------------------------------
      IF (PRTRX_HITB(ITK).EQ.0) THEN
       IRET = -1
       GOTO 9000
      ENDIF
*-----------------------------------------------------------------------
*  select track from secondary vertices.
*-----------------------------------------------------------------------
      DO IVER=1,NMVER()
       IF (IMVER_FLAG(IVER).LE.1) THEN

       Z  =  DBLE(FMVER_Z(IVER))
       CALL V0SWIM(.FALSE.,ITK, Z, PTRK, VTRK, IERR)
       IF (IERR.EQ.0) THEN
        V(1,1) = VTRK(1,1)
        V(1,2) = VTRK(1,2)
        V(2,1) = VTRK(2,1)
        V(2,2) = VTRK(2,2)
        CALL V0INV2(V,W,IERR)
        IF (IERR.EQ.0) THEN
         CHI =   (FMVER_X(IVER)-PTRK(1))**2 * W(1,1)
     +         + (FMVER_Y(IVER)-PTRK(2))**2 * W(2,2)
     +   + 2.*(FMVER_X(IVER)-PTRK(1)) *W(1,2)* (FMVER_Y(IVER)-PTRK(2))

         IF (CHI.LT.CHIMAI) THEN
          IRET = -2
          GOTO 9000
         ENDIF

        ENDIF
       ENDIF

       ENDIF
      ENDDO
*-----------------------------------------------------------------------
*  ztrk         < 700 cm
*  p            > 2. GeV (for z<450)
*  nhits        > 20
*-----------------------------------------------------------------------
      NHITS = IRTRA_HSI(ITK) + IRTRA_HIN(ITK) + IRTRA_HOU(ITK)

      IF (FRTRA_ZF(ITK).GT.700. .OR. NHITS.LT.20 .OR.
     +    (FRTRA_ZF(ITK).LT.450. .AND. ABS(FRTRA_PF(ITK)).GT.0.5 ))THEN
       IRET = -3
       GOTO 9000
      ENDIF
*-----------------------------------------------------------------------
* the end
*-----------------------------------------------------------------------
 9000 END
