*CMZ :          21/07/97  18.49.06  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       function:   VTDTP(iv,it)                         R*8
c
c       input:    iv       vertex index                  Int
c                 it       track index                   Int
c
c       output:   spatial distance vertex -- track in cm
c
c-------------------------------------------------------------
c
      double precision 
     1  function VTDTP(iv,it)

      implicit none

#include "vt/vtdat.fi"

      integer iv,it
      double precision 
     1  xn, yn, zn, xnor, dx, dy, dz, hesse(3)

c---> get unit vector along track

      xnor = 1.d0 + p(1,it)**2 + p(2,it)**2
      xnor = 1.d0/sqrt(xnor)
      xn = p(1,it)*xnor
      yn = p(2,it)*xnor
      zn = xnor

c---> get distance vector vertex--->track origin

      dx = p(3,it) - xvs(1,iv)
      dy = p(4,it) - xvs(2,iv)
      dz = -xvs(3,iv)

c---> get cross product of Hesse normal form

      hesse(1) =  yn*dz - zn*dy
      hesse(2) =  zn*dx - xn*dz
      hesse(3) =  xn*dy - yn*dx

c---> get distance

      VTDTP = sqrt(hesse(1)**2 + hesse(2)**2 + hesse(3)**2)

      return
      end
