*CMZ :          21/07/97  18.49.06  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       function:   VTDVW(iv,iw)                         R*8
c
c       input:    iv        vertex index                 Int
c                 iw        wire index                   Int
c
c       output:   distance vertex -- wire (chi**2, NDF=2)
c
c-------------------------------------------------------------
c
      double precision 
     1  function VTDVW(iv,iw)

      implicit none
#include "vt/vtdat.fi"
#include "vt/vtwire.fi"

      integer iv,iw

      double precision 
     1  cov1(3,3), cov2(3,3), Cmat(3,3)
      double precision 
     1  xv1(3), xv2(3), x1(3), x2(3), xav(3), dx1(3), dx2(3)
      double precision 
     1  sum

      integer i,j,l,ifail


      do  i = 1, 3
        xv1(i) = xw(i,iw)
        do  j = 1, 3
          cov1(i,j) = Cw(i,j,iw)
        enddo
      enddo
      call DSINV(3,cov1,3,ifail)
      if (ifail.eq.-1) then
        VTDVW = 1000.
        goto   50
      endif

      do  i = 1, 3
        xv2(i) = xvs(i,iv)
        do  j = 1, 3
          cov2(i,j) = CINV(i,j,iv,ntr(iv))
        enddo
      enddo

      do  j = 1, 3
        do  l = j, 3
          Cmat(j,l) = cov1(j,l)+cov2(j,l)
          Cmat(l,j) = Cmat(j,l)
        enddo
      enddo
      call DSINV(3,Cmat,3,ifail)
      if (ifail.eq.-1) then
        VTDVW = 1000.
        goto 50
      endif
      do  i = 1, 3
        x1(i) = 0.
        x2(i) = 0.
        do  j = 1, 3
          x1(i) = x1(i) + cov1(i,j)*xv1(j)
          x2(i) = x2(i) + cov2(i,j)*xv2(j)
        enddo
      enddo
      do  i = 1, 3
        xav(i) = 0.
        do  j = 1, 3
          xav(i) = xav(i) + Cmat(i,j)*(x1(j)+x2(j))
        enddo
      enddo
      do  i = 1, 3
        dx1(i) = xav(i) - xv1(i)
        dx2(i) = xav(i) - xv2(i)
      enddo
c
c--->   get a chi**2 value
c
      do  i = 1, 3
        x1(i) = 0.
        x2(i) = 0.
        do  j = 1, 3
          x1(i) = x1(i) + cov1(i,j)*dx1(j)
          x2(i) = x2(i) + cov2(i,j)*dx2(j)
        enddo
      enddo
      sum = 0.
      do  i = 1, 3
        sum = sum + dx1(i)*x1(i) + dx2(i)*x2(i)
      enddo

      VTDVW = sum

   50 continue

      return
      end
